
from xml.sax import ContentHandler, make_parser
import string
from relational import *

class ReadHandler(ContentHandler):
  "Document Handler personnel"
  def __init__(self):
    "initialisation"
    
    self.current_elem = []
    self.current_rel = None

  def getCurrentElem(self):
    return self.current_elem[len(self.current_elem)-1]
    
  def getCurrentElemName(self):
    return str(self.getCurrentElem().__class__.__name__)

  def popCurrentElem(self):
    self.current_elem.pop()

  def pushCurrentElem(self,elem):
    self.current_elem.append(elem)  

  def removeNS(self,name):
    liste = string.split(name,":")
    return liste[len(liste) -1]
    
  def startDocument(self):
    "fonction appelee lorsque le parser rencontre le premier element"
    print "start doc"
    
  def startElement(self, name, attrs):
    "fonction appelee lorsque le parser rencontre une balise ouvrante"
    name = self.removeNS(name)
    if string.upper(name[0]) == name[0]:
      print "start elem " + name
      if (hasattr(self, "start"+name)):
        getattr(self,"start" + name)(name,attrs)
      else:
        print "Missing implementation for " + name + " type"
    else:
      if (hasattr(self, "start"+self.getCurrentElemName() +"_" + name)):
        getattr(self,"start"+self.getCurrentElemName() +"_" + name)(name,attrs)
      else:
        print "Missing implementation for " + name + " in "  + self.getCurrentElemName()
        self.popCurrentElem()
      
    
  def endElement(self, name):
    "fonction appelee lorsque le parser rencontre une balise fermante"
    name = self.removeNS(name)
    if not string.upper(name[0]) == name[0]:
      self.popCurrentElem()
    
  def characters(self, chrs, offset=None, length=None):
    "fonction appelee lorsque le parser rencontre des donnees dans un element"
    pass

  def endDocument(self):
    "fonction appelee lorsque le parser rencontre le dernier element"
    pass
  
  def isAReference(self,name):
    if hasattr(self.getCurrentElem(), name):
      if isinstance(getattr(self.getCurrentElem(), name),list):
       return True
    return False

  def setAttributes(self,attrs):
    result = []
    for at in attrs.keys():
      if not ':' in at:
        result.append(at)
    for at in result:
      if not self.isAReference(at):
        setattr(self.getCurrentElem(),at,attrs[at])
      else:
        print "INFO : Should resolve link for reference " + at + "target:" + attrs[at]
    return result
    

  def startDatabase(self,name,attrs):
    print "startDatabase"
    self.current_elem.append(Database())
    self.setAttributes(attrs)

  def startDatabase_ownedSchemas(self,name,attrs):
    newobj = Schema()  
    self.getCurrentElem().ownedSchemas.append(newobj)
    self.pushCurrentElem(newobj)
    self.setAttributes(attrs)

  def startSchema_ownedTables(self,name,attrs):
    newobj = Table()  
    self.getCurrentElem().ownedTables.append(newobj)
    self.pushCurrentElem(newobj)
    self.setAttributes(attrs)
    
  def startTable_ownedColumns(self,name,attrs):
    newobj = Column()  
    self.getCurrentElem().ownedColumns.append(newobj)
    self.pushCurrentElem(newobj)
    self.setAttributes(attrs)

  def startTable_ownedForeignKeys(self,name,attrs):
    newobj = ForeignKey()  
    self.getCurrentElem().ownedForeignKeys.append(newobj)
    self.pushCurrentElem(newobj)
    self.setAttributes(attrs)

doc = ReadHandler()
saxparser = make_parser()
saxparser.setContentHandler(doc)

def load(filename):
  print "loading..."
  datasource = open(filename,"r")
  saxparser.parse(datasource)
 
def dump(root,filename):
  pass


import unittest

class TestParser(unittest.TestCase):
  def testLoading(self):
      pass

if __name__ == '__main__':
    load("data/test.xmi")