<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore

import org.acceleo.module.pim.ecore.gen.python.services.EcoreServices
import org.acceleo.module.pim.ecore.gen.python.common.name
%>

<%script type="EPackage" name="packageToPythonFactoryFile" file="<%ModuleFactory%>"%>
"""

"""

<%for (eClassifiers.filter("EClass")[!abstract]){%>
from <%current("EPackage").moduleName%>	import <%ClassName%>
<%}%>

<%packageToPythonFactoryClass%>

<%packageToPythonFactoryTests%>

<%script type="EPackage" name="packageToPythonFactoryTests" %>
import unittest

class Test_<%moduleName%>_factory(unittest.TestCase):  
<%for (eClassifiers.filter("EClass")[!abstract]){%>
  def test<%ClassName%>Creation(self):
    """
    Test the direct instanciation of a <%ClassName%>.
    """ 
    d = <%ClassName%>()
    self.assertTrue(d!=None)
    
  def test<%ClassName%>CreationFactory(self):
    """
    Test the instanciation of a <%ClassName%> through the factory.
    """
    factory = <%current("EPackage").factoryClassName%>()
    d = factory.create("<%ClassName%>")
    self.assertTrue(d != None)
    self.assertTrue(isinstance(d, <%ClassName%>))

<%}%>  
    
if __name__ == '__main__':
    unittest.main()



<%script type="EPackage" name="packageToPythonFactoryClass" %>

class <%factoryClassName%>:  
  """ Factory to create elements from <%name%>
  """  
  
  def create(self,name):
    """ generic method to create elements.
        This method is able to create:
<%for (eClassifiers.filter("EClass")[!abstract]){%>
			<%ClassName%>
<%}%>
        
    """
    f = getattr(self,"create%s" % name)
    return f()
    
<%for (eClassifiers.filter("EClass")[!abstract]){%>
  def create<%ClassName%>(self):
    """
    Create an instance of <%ClassName%>.
    """
    instance = <%ClassName%>()
    #<%startUserCode%> <%ClassName%> create
    # type here special initialization code
    #<%endUserCode%>
    return instance
  	  	
<%}%>
    
  #<%startUserCode%> <%name%> factory methods
  #<%endUserCode%>


  

  
