<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore
import org.acceleo.module.pim.ecore.gen.python.common.name
import org.acceleo.module.pim.ecore.gen.python.common.types
import org.acceleo.module.pim.ecore.gen.python.common.filter
import org.acceleo.module.pim.ecore.gen.python.test
import org.acceleo.module.pim.ecore.gen.python.relation
import org.acceleo.module.pim.ecore.gen.python.__init__
import org.acceleo.module.pim.ecore.gen.python.common.documentation
import org.acceleo.module.pim.ecore.gen.python.operation
import org.acceleo.module.pim.ecore.gen.python.services.EcoreServices
%>

<%script  type="ecore.EPackage" name="generateFile" file="<%ModulePath%>.py"%>
<%toPython%>
<%toModuleInit%>

<%script  type="EPackage" name="toPython"%>
#encoding...
""" 
<%documentation%>
"""
#importing the relations
<%eClassifiers.filter("EClass")[hasRelations].eReferences.toRelationImport%>
#Import common base class
from __common__ import <%baseClass%>

<%eClassifiers.filter("EClass").minimize.sortEClasses().toPython%>
#Enumerations
<%eClassifiers.filter("EEnum").toPython%>


<%toPythonTest%>

<%script  type="ecore.EReference" name="toRelationImport" %>
from __rels__ import <%ReferenceTypeName%> 


<%script  type="ecore.EClassifier" name="toPython" %>
class <%ClassName%>:
  """ <%documentation%>
  """

<%script  type="ecore.EClassifier" name="documentation" %>
<%annotedDocumentation%>

<%script  type="ecore.EClass" name="documentation" %>
<%annotedDocumentation%>

 Container(s)  : <%findContainers().filter("EClass"). ClassName.sep(",").toString%>
<%sampleClassUsage%>

<%script type="EClass" name="findContainers"%>
<%getRootContainer().eAllContents("EReference").select("containment").select("eType.name == '" + name + "'").eContainingClass%>

<%script  type="ecore.EClass" name="toPython" %>
<%if (eSuperTypes.nSize() == 0){%>
class <%ClassName%>(<%eContainer("EPackage").baseClass%>):
<%}else{%>
class <%ClassName%>(<%(eSuperTypes.ClassName + eContainer("EPackage").baseClass).sep(",")%>):
<%}%>
  """ <%documentation%>
  """

  def __init__(self):
    <%eContainer("EPackage").baseClass%>.__init__(self)
    self._parent_ = None
    self._meta_ = self.__class__
<%if (eSuperTypes.nSize() > 0){%>
<%eSuperTypes.toConstructorCall%>
<%}%>
<%eAttributes.toAttributeDeclaration%>
<%eReferences.toReferenceDeclaration%>
<%if (needReflexiveHack){%>
<%if (eReferences.eOpposite){%>
<%}else{%>
<%}%>
<%}%>

<%for (eOperations){%>
<%toPythonInstanceMethod%>
<%}%>


<%script type="EEnum" name="toPython"%>
"""
<%documentation%>
"""
class <%ClassName%>:
<%if (eLiterals){%>
	<%for (eLiterals.sort){%>	
	"""
	<%documentation%>
	"""
	<%enumLiteralName%> = <%i%>
	<%}%>
<%}else{%>
  pass
<%}%>

<%script  type="ecore.EClass" name="toConstructorCall" %>
    <%ClassName%>.__init__(self)

<%script  type="ecore.EAttribute" name="toAttributeDeclaration" %>
    self.<%AttributeName%> = <%eType.typeInitialisation%>


<%script  type="ecore.EReference" name="toReferenceDeclaration" %>
    self.<%ReferenceName%> = <%ReferenceTypeName%>(parent=self)
    self.<%ReferenceName%>._parent_ = self


<%script  type="ecore.EClass" name="needReflexiveHack" %>
<%eReferences.eOpposite.nSize()>0%>

<%script  type="ecore.EClass" name="hasContent" %>
<%(eAttributes + eReferences + eSuperTypes).nSize()>0%>

<%script  type="ecore.EClass" name="needConstructor" %>
<%(eAttributes + eReferences).nSize()>0%>
