<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore
import org.acceleo.module.pim.ecore.gen.python.common.name
import org.acceleo.module.pim.ecore.gen.python.common.types
import org.acceleo.module.pim.ecore.gen.python.common.filter
%>



<%script type="EPackage" name="toPythonRelations" file="<%ModuleRelations%>"%>
""" This module is used to represents the relations between entities and 
their cardinalities
"""
<%eAllContents("EClass").select("hasRelations").eReferences.toRelationClass%>

<%script  type="ecore.EReference" name="toRelationClass" %>
class <%ReferenceTypeName%>(list):
  """ Class used to represent the relation between <%eContainingClass.ClassName%>
      and <%eType.ClassName%>"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = <%upperBound.toU1Case()%>
    self.lower_bound = <%lowerBound.toU1Case()%>
    self.is_unique = <%unique.toU1Case()%>
    self._parent_ = parent

    
<%if (upperBound != -1 || unique){%>    
  def append(self,<%eType.name.toLowerCase%>,stopcycle=False):
<%if (upperBound != -1){%>
    if len(self) == <%upperBound%>:
      raise Exception("The relation upper bound is caught")
<%}%>
<%if (unique){%>
    if <%eType.name.toLowerCase%> in self:
      raise Exception("Element is already in the set")
<%}%>
<%if (containment){%>
    <%eType.name.toLowerCase%>._parent_ = self._parent_
<%}else{%>
   <%-- if elem._parent_ == None:
      raise Exception("Element should be contained")--%>
<%}%>
    list.append(self,<%eType.name.toLowerCase%>)
<%if (eOpposite.nSize() != 0){%>
    if not stopcycle:
      <%eType.name.toLowerCase%>.<%eOpposite.name%>.append(self,stopcycle=True)
<%}%>
    
<%}%>
<%if (lowerBound != 0){%>
  def remove(self,<%eType.name.toLowerCase%>):
    if len(self) == <%lowerBound%>:
      raise Exception("The relation lower bound is caught")
    list.remove(self,<%eType.name.toLowerCase%>)
<%}%>
    
       

  
