/**
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.

@author  Cédric Brun <cedric.brun@obeo.fr>
 **/
package org.acceleo.module.pim.ecore.gen.python.services;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnumLiteral;
import org.eclipse.emf.ecore.EOperation;

public class EcoreServices {

	public List sortEClasses(List input) throws Exception {
		List result = new ArrayList();
		int inputSize = input.size();
		List stillToProcess = new ArrayList();
		stillToProcess.addAll(input);

		// init with no dependancies classes
		Iterator initIt = stillToProcess.iterator();
		while (initIt.hasNext()) {
			Object obj = initIt.next();
			if (obj instanceof EClass) {
				if (((EClass) obj).getEAllSuperTypes().size() == 0) {
					result.add(obj);
				}
			}
		}
		int lastSize = 0;
		int nbTry = input.size();
		while (result.size() != inputSize
				&& ((result.size() > lastSize) && nbTry != 0)) {
			if ((result.size() > lastSize))
				nbTry--;
			Iterator stillIterator = stillToProcess.iterator();
			while (stillIterator.hasNext()) {
				Object obj = stillIterator.next();
				if (obj instanceof EClass) {
					if (!hasDependencies((EClass) obj, result)
							&& !result.contains(obj)) {
						result.add(obj);
					}
				}

				lastSize = result.size();
			}

		}
		// input.removeAll(result);
		/*
		 * Iterator it2 = input.iterator(); while (it2.hasNext()) { Object obj =
		 * it2.next(); if (obj instanceof EClass &&
		 * !hasDependencies((EClass)obj, result)) { result.add(obj); }else if
		 * (obj instanceof EClass) { System.err.println("marche po : " + obj +
		 * "dep ? " +hasDependencies((EClass)obj, result)); } }
		 */
		if (result.size() != inputSize) {
			input.removeAll(result);
			result.addAll(input);
		}

		return result;
	}

	private boolean hasDependencies(EClass class1, List result) {
		List superClasses = class1.getEAllSuperTypes();
		if (superClasses.size() == 0)
			return false;
		if (result.containsAll(superClasses))
			return false;
		return true;
	}

	public String javaMethodToPythonMethod(String javaName) {
		// TODOCBR use StringBuffer
		if (javaName != null) {
			String result = "";
			for (int i = 0; i < javaName.length(); i++) {
				String character = javaName.substring(i, i + 1);
				if (!character.toLowerCase().equals(character)) {
					result += "_" + character.toLowerCase();
				} else {
					result += character;
				}
			}
			return result;
		}
		return "no_name";
	}

}
