<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: DomainModel
  This template generates a C# domain class for each UML class
  stereotyped as "valueObject" (ref. "Domain Driven Design" - Eric Evans), 
  that is located in a package that is stereotyped as "domainModule".
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.StringService
import com.yellowtail.uml14.gen.csharp.services.ClassService
import com.yellowtail.uml14.gen.csharp.services.NamespaceService
import com.yellowtail.uml14.gen.csharp.services.AssociationService
import com.yellowtail.uml14.gen.csharp.services.AttributeService
import com.yellowtail.uml14.gen.csharp.services.OperationService
import com.yellowtail.uml14.gen.csharp.services.Uml14TypeResolver
import com.yellowtail.uml14.gen.csharp.services.Uml14Service
%>

<%-- TO DO: containsCollectionRef around using System.Collection: get it to work for associationEnds as well, Abstract keyword --%>
<%script type="core.Class" name="filename"%>
<%if (hasStereotype("valueObject")){%>
<%getRootContainer().name%>/DomainModel/<%XLevelAndDownClassPath(2,"/")%>/<%name%>.cs
<%}%>

<%script type="core.Class" name="domain-class-value-object" file="<%filename%>"%>
using System;
using System.Text;
<%--if (containsACollectionRef){--%>
using System.Collections.Generic;
using Iesi.Collections.Generic;
<%--}--%>
<%for (referencedNamespaces(namespace)){%>
using <%getRootContainer().name%>.DomainModel.<%XLevelAndDownNamespacePath(2,".")%>;
<%}%>

namespace <%getRootContainer().name%>.DomainModel.<%XLevelAndDownClassPath(2,".")%>
{
    public <%abstractClause%>class <%name%> <%inheritanceClause%>
    { 
		<%-- ASSUMPTIONS: THE VALUE OBJECT HAS NO IDENTIFIER & IT HAS NO ASSOCIATIONS --%>
		<%for (attribute){%>
		private <%resolveTypeAndMultiplicity%> <%name.firstLower()%>;
        <%}%>

		<%for (attribute){%>
		public virtual <%resolveTypeAndMultiplicity%> <%name.firstUpper()%> 
		{
			get { return <%name.firstLower()%>; }
			set { <%name.firstLower()%> = value; }
		}
		
		<%}%>
		
		<%-- Simple mock operation to enable generation of simple string input. --%>
		public static <%name%> Parse(string value)
		{
			// <%startUserCode%>: place your code below this line
			// To be implemented
			return new <%name%>();
			// <%endUserCode%>: place your code above this line
		}

		<%-- GENERATE OPERATIONS --%>
		<%for (feature.filter("Operation")){%>
		<%visibilityName%> <%typeName%> <%name%>(<%parameterDeclarations%>)
		{
			// <%startUserCode%>: place your code below this line
			
			// <%endUserCode%>: place your code above this line
		}
		<%}%>
	}
}

<%script type="core.Attribute" name="resolveTypeAndMultiplicity"%>
<%if (attributeUpperBound==-1){%>ISet<<%type.resolveToCSharp()%>><%}else{%>
<%type.resolveToCSharp()%><%}%>

<%script type="core.Operation" name="parameterDeclarations"%>
<%for (parameter){%>
<%if (i>0){%><%if (i>1){%>, <%}%><%type.resolveToCSharp%> <%name%><%}%>
<%}%>

<%script type="core.Operation" name="typeName"%>
<%parameter.nGet(0).type.resolveToCSharp%>
<%script type="core.Class" name="abstractClause"%>
<%if (isAbstract){%>abstract <%}%>

<%script type="core.Class" name="inheritanceClause"%>
<%if (parent!=null){%>: <%parent.name%> <%}%>