<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: DomainModelPersistenceImpl
  This template generates a basic factory implementation for each domain class 
  stereotyped as "entityObject" and whose tagged value "isAggregateRoot" equals "true".
  Its only operation creates new a domain aggregate based on a prototype aggregate.
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.ClassService
import com.yellowtail.uml14.gen.csharp.services.AttributeService
import com.yellowtail.uml14.gen.csharp.services.NamespaceService
%>

<%script type="core.Class" name="filename"%>
<%if (isAggregateRoot){%>
<%namespace.getRootContainer().name%>/DomainPersistenceImpl/<%namespace.name%>/<%name%>Factory.cs
<%}%>

<%script type="core.Class" name="factory-impl-domain-class" file="<%filename%>"%>
using System;
using System.Collections.Generic;
using System.Text;
using <%namespace.getRootContainer().name%>.DomainModel.<%namespace.name%>;

namespace <%namespace.getRootContainer().name%>.DomainPersistenceImpl.<%namespace.name%>
{
    public class <%name%>Factory
    {
        public static <%name%> Create<%name%>(<%name%> prototype<%name%>)
        {
            <%name%> new<%name%> = new <%name%>();
			<%for (attribute){%>
			<%if (!isIdentifier()){%>
            new<%owner.className()%>.<%propertyName%> = prototype<%owner.className()%>.<%propertyName%>;
			<%}%>
			<%}%>

            return new<%name%>;
        }
    }
}
