<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: DomainModelPersistenceImpl
  This template generates a basic implementation of the repository interfaces 
  of each domain class stereotyped as "entityObject" and whose tagged value 
  "isAggregateRoot" equals "true".
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.ClassService
import com.yellowtail.uml14.gen.csharp.services.NamespaceService
%>

<%script type="core.Class" name="filename"%>
<%if (isAggregateRoot){%>
<%namespace.getRootContainer().name%>/DomainPersistenceImpl/<%namespace.name%>/<%name%>Repository.cs
<%}%>

<%script type="core.Class" name="repository-impl-domain-class" file="<%filename%>"%>
using System;
using System.Collections.Generic;
using System.Text;
using <%namespace.getRootContainer().name%>.DomainModel.<%namespace.name%>;
using <%namespace.getRootContainer().name%>.DomainModel.<%namespace.name%>.DomainPersistence;
using <%namespace.getRootContainer().name%>.DomainPersistenceImpl.Common;
using NHibernate;
using NHibernate.Cfg;

namespace <%namespace.getRootContainer().name%>.DomainPersistenceImpl.<%namespace.name%>
{
    public class <%name%>Repository: Repository, I<%name%>Repository
    {
        public <%name%>Repository(ISession newSession) : base(newSession) { }

        public virtual <%name%> Get(int id)
        {
            return (<%name%>)base.Get(typeof(<%name%>), id);
        }

        public virtual IList<<%name%>> GetAll<%pluralName%>()
        {
            ICriteria criteria = this.Session.CreateCriteria(typeof(<%name%>));
            return criteria.List<<%name%>>();
        }
    }
}
