<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: <ModelName>PresentationConsoleUI
  This template generates a .NET application configuration file, 
  with the configurations of NHibernate and log4net. 
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.utils.config
%>

<%script type="uml14.Model" name="app.config" file="<%name%>/Presentation/ConsoleUI/App.config"%>
<?xml version="1.0" encoding="utf-8" ?>
<configuration>
  <configSections>
    <section
      name="nhibernate" 
      type="System.Configuration.NameValueSectionHandler, System, Version=1.2.0.1001, Culture=neutral, PublicKeyToken=b77a5c561934e089" 
    />
    <section name="log4net" type="log4net.Config.Log4NetConfigurationSectionHandler,log4net" />
  </configSections>

  <nhibernate>
    <add 
      key="hibernate.connection.provider"
      value="NHibernate.Connection.DriverConnectionProvider"
    />
    <add
      key="hibernate.dialect"
      value="NHibernate.Dialect.MsSql2000Dialect"
    />
    <add
      key="hibernate.connection.driver_class"
      value="NHibernate.Driver.SqlClientDriver"
    />
    <add
      key="hibernate.connection.connection_string"
	  <%-- Load the database connection string from config.mt --%>
      value="<%dbConnectionString%>"
    />
  </nhibernate>

  <!-- This section contains the log4net configuration settings -->
  <log4net debug="false">

    <!-- Define some output appenders -->
    <appender name="trace" type="log4net.Appender.TraceAppender, log4net">
      <layout type="log4net.Layout.PatternLayout,log4net">
        <param name="ConversionPattern" value="%d [%t] %-5p %c - %m%n" />
      </layout>
    </appender>

    <appender name="console" type="log4net.Appender.ConsoleAppender, log4net">
      <layout type="log4net.Layout.PatternLayout,log4net">
        <param name="ConversionPattern" value="%d [%t] %-5p %c - %m%n" />
      </layout>
    </appender>

    <appender name="rollingFile" type="log4net.Appender.RollingFileAppender,log4net" >

      <param name="File" value="log.txt" />
      <param name="AppendToFile" value="true" />
      <param name="RollingStyle" value="Date" />
      <param name="DatePattern" value="yyyy.MM.dd" />
      <param name="StaticLogFileName" value="true" />

      <layout type="log4net.Layout.PatternLayout,log4net">
        <param name="ConversionPattern" value="%d [%t] %-5p %c - %m%n" />
      </layout>
    </appender>

    <!-- Setup the root category, add the appenders and set the default priority -->

    <root>
      <priority value="INFO" />
      <appender-ref ref="console" />
    </root>
  </log4net>
</configuration>


