<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
--%>
<%--
  Target project: <ModelName>PresentationConsoleUI
  This template generates a helper file for NHibernate. This allows the client program of
  the domain model to abstract a little from the actual NHibernate interfaces.
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14
%>

<%script type="uml14.Model" name="nhibernate-util" file="<%name%>/Presentation/ConsoleUI/NHibernateUtil.cs"%>
using System;
using System.Text;
using NHibernate;
using NHibernate.Cfg;

namespace <%name%>.Presentation.ConsoleUI
{
    public class NHibernateUtil
    {
        private static ISessionFactory sessionFactory;
        private static ISession session;
        
        static NHibernateUtil()
        {
            Configuration cfg = new Configuration();
            cfg.AddAssembly("<%name%>DomainModel");
            sessionFactory = cfg.BuildSessionFactory();
        }

        // Session returns an open NHibernate session
        public static ISession Session
        {
            get
            {
                if (session == null)
                {
                    session = sessionFactory.OpenSession();
                }

                if (!session.IsOpen)
                {
                    session = sessionFactory.OpenSession();
                }

                return session;
            }
        }
    }
}