<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: <ModelName>PresentationConsoleUI
  This template generates a basic program with an "Add" and "Show" function
  for each domain class of stereotype "entityObject" and a tagged value "isAggregateRoot"
  equalling "true". Each of these functions maps a console command line to an 
  attribute of the domain class. The main body of the program is empty and
  can be filled manually after generation with calls to the "Add"- and "Show"-functions
  to be tested. Note that this is a very basic setup: e.g. the generated console 
  commandline is currently mapped bluntly to the attributes, no matter what their type is.
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.AttributeService
import com.yellowtail.uml14.gen.csharp.services.ClassService
import com.yellowtail.uml14.gen.csharp.services.NamespaceService
import com.yellowtail.uml14.gen.csharp.services.Uml14Service
import com.yellowtail.uml14.gen.csharp.services.Uml14TypeResolver
import com.yellowtail.uml14.gen.csharp.services.StringService
%>

<%script type="uml14.Model" name="program" file="<%name%>/Presentation/ConsoleUI/Program.cs"%>

using System;
using System.Collections.Generic;
using System.Text;
using <%getRootContainer().name%>.DomainModel.Common;
using <%getRootContainer().name%>.DomainPersistenceImpl.Common;
<%for (eAllContents("Package")){%>
<%if (hasStereotype("domainModule")){%>
using <%getRootContainer().name%>.DomainModel.<%name%>;
<%}%>
<%}%>
<%for (eAllContents("Package")){%>
<%if (hasStereotype("domainModule")){%>
using <%getRootContainer().name%>.DomainModel.<%name%>.DomainPersistence;
<%}%>
<%}%>
<%for (eAllContents("Package")){%>
<%if (hasStereotype("domainModule")){%>
using <%getRootContainer().name%>.DomainPersistenceImpl.<%name%>;
<%}%>
<%}%>

<%-- Shortcut to account for generation of all common-type namespaces
     in the model. 
--%>
<%for (eAllContents("Package")){%>
<%if (!hasStereotype("domainModule") && containsClassesInTargetEnvironment()){%>
using <%getRootContainer().name%>.DomainModel.<%XLevelAndDownNamespacePath(2,".")%>;
<%}%>
<%}%>

namespace <%name%>.Presentation.ConsoleUI
{
    class Program
    {
        static void Main(string[] args)
        {
            String keyboardInput;
            Console.WriteLine("Please compile the program flow here");
            keyboardInput = Console.ReadLine();
        }

	  	<%for (eAllContents("Class")){%>
		<%if (isAggregateRoot()){%>
		static void Add<%name%>()
		{
            <%name%>Repository <%name.firstLower()%>Repository = new <%name%>Repository(NHibernateUtil.Session);
            <%name%> <%name.firstLower()%> = new <%name%>();
            String keyboardInput;

            Console.WriteLine("New <%name%>");
			<%for (attribute){%>
			<%if (!isIdentifier()){%>
            Console.Write("Enter <%propertyName%>: ");
            keyboardInput = Console.ReadLine();
            <%if (type.resolveToCSharp()=="string"){%>
	            <%owner.className().firstLower()%>.<%propertyName%> = keyboardInput;
	        <%}else{%>
	            <%owner.className().firstLower()%>.<%propertyName%> = <%type.resolveToCSharp()%>.Parse(keyboardInput);
	        <%}%>
			<%}%>
			<%}%>
            <%name.firstLower()%>Repository.SaveOrUpdate(<%name.firstLower()%>);

            Console.WriteLine("Saved <%name%>");
            keyboardInput = Console.ReadLine();
		}
		
		static void Show<%name%>()
		{
            <%name%>Repository <%name.firstLower()%>Repository = new <%name%>Repository(NHibernateUtil.Session);
            <%name%> <%name.firstLower()%>;
            String keyboardInput;

            Console.WriteLine("Show <%name%>");
            Console.Write("Enter id of the <%name%> to be shown: ");
            keyboardInput = Console.ReadLine();
            <%name.firstLower()%> = <%name.firstLower()%>Repository.Get(int.Parse(keyboardInput));
            
            if (<%name.firstLower()%> == null){
            	Console.WriteLine("<%name%> with id " + keyboardInput + " was not found.");
            }else{
				<%for (attribute){%>
		        Console.WriteLine("<%propertyName%> = " + <%owner.className().firstLower()%>.<%propertyName%>.ToString());
				<%}%>
			}
            keyboardInput = Console.ReadLine();
		}
		
		<%}%>
		<%}%>

    }
}
