/*
 * Author     Pascal Lindelauf
 * E-Mail     plindelauf@yellowtail.nl
 * Copyright  2007 Yellowtail
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the GNU Public License v2.0 or any later version
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.txt
 */
/*
 * This class contains operations that simplify access to the  
 * UML namespace element.
 */
package com.yellowtail.uml14.gen.csharp.services;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.ecore.factories.FactoryException;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;

/**
 * @author pli
 *
 */

public class NamespaceService {	
	Uml14Service uml14Service = new Uml14Service();

	public String XLevelAndDownNamespacePath(Namespace currentNamespace, int level, String seperator) throws ENodeCastException{
		Namespace namespace = currentNamespace;
		ArrayList packages = new ArrayList();
		int numberOfPackages = 1;
		int i;
		String classPath = "";
		//Ugly workaround for backslash problem in template
		if (seperator.equals("/")){ seperator = "\\"; }
		
		while (namespace.getNamespace() != null){
			packages.add(namespace);
			namespace = namespace.getNamespace();
			numberOfPackages++;
		}
		packages.add(namespace);
		
		i = numberOfPackages - level;
		while (i >= 0){
			classPath += ((Namespace)packages.get(i)).getName();
			i--;
			if (i >= 0){classPath += seperator;}
		}
		
		return classPath;
	}
	
	public boolean containsClassesInTargetEnvironment(EObject namespace) throws ENodeCastException, FactoryException {
		boolean foundClassThatOccursInTarget = false;
		EObject ownedElement;
	
		for (Iterator i = namespace.eContents().iterator(); i.hasNext() && !foundClassThatOccursInTarget;){
			ownedElement = (EObject)(i.next());
			
			foundClassThatOccursInTarget = (uml14Service.hasStereotype(ownedElement, "domainObject") || 
											uml14Service.hasStereotype(ownedElement, "valueObject") || 
											uml14Service.hasStereotype(ownedElement, "enumeration"));
		}
		return foundClassThatOccursInTarget;
	}
}