package fr.obeo.weblog.dao.blog.api;

// Start of user code for import
import java.util.Collection;
import java.util.List;

import fr.obeo.fwk.dao.exception.DaoException;
import fr.obeo.weblog.business.blog.BlogEntry;
// End of user code for import

/**
 * This class provides the data access layer to the BlogEntry entity class.<br/>
 * This is the interface which represent the contrat of the DAO access.
 */
public interface IBlogEntryDao {

	/**
	 * Create a new element
	 * @param blogEntry Element to create.
	 */
	public void createBlogEntry(BlogEntry blogEntry) throws DaoException;

	/**
	 * Update an existing element
	 * @param blogEntry Element to update. If the element has an id, it may use it.
	 */
	public void updateBlogEntry(BlogEntry blogEntry) throws DaoException;

	/**
	 * Delete an element
	 * @param blogEntry Element which will be delete. 
	 * Only id can be used to find which element must be deleted.
	 */
	public void deleteBlogEntry(BlogEntry blogEntry) throws DaoException;

	/**
	 * Find all elements.
	 * @return A list with all elements, without any filter.
	 */
	public Collection<BlogEntry> findAllBlogEntrys() throws DaoException;

	/**
	 * Find one entity by its primary key.
	 * @return The entity found.
	 */
	public BlogEntry findBlogEntryById(String id) throws DaoException;

	//Start of user code for technicals dao access api
	//End of user code
}