package fr.obeo.weblog.ui.main.actions;

// Start of user code for import
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import fr.obeo.fwk.dao.exception.DaoException;
import fr.obeo.weblog.business.blog.BlogEntry;
import fr.obeo.weblog.business.blog.User;
import fr.obeo.weblog.dao.WeblogDaoFactory;
import fr.obeo.weblog.dao.blog.api.IBlogEntryDao;
import fr.obeo.weblog.ui.UiConstants;
import fr.obeo.weblog.ui.main.forms.CreateLogForm;
// End of user code for import

/**
 * Implementation of <strong>CreateLog Action</strong>
 * Scenario : main
 *
 */
public class CreateLogAction extends org.apache.struts.actions.DispatchAction {
    /**
     * Commons Logging instance.
     */
	private static final Log log = LogFactory.getLog(CreateLogAction.class);

    /**
     * Forward codes.
     */
	public final static String PAGE_SELF = "self"; //$NON-NLS-1$
	public final static String PAGE_VIEWLOGS = "viewLogs"; //$NON-NLS-1$

    /**
     * Process the specified HTTP request for <strong>init</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward init(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		CreateLogForm createLogForm = (CreateLogForm)form;

		//Start of user code method init
		// TODO Write here the action code for init
		//bla bal
		//End of user code
	
		return mapping.findForward(returnCode);
	} 

    /**
     * Process the specified HTTP request for <strong>validate</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward validate(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		CreateLogForm createLogForm = (CreateLogForm)form;
		//Start of user code method validate
		User user = (User)request.getSession().getAttribute(UiConstants.CURRENT_USER);
		BlogEntry newLog = new BlogEntry();
		newLog.setTitle(createLogForm.getTitle());
		newLog.setCreationDate(new Date());
		newLog.setContent(createLogForm.getContent());

		newLog.setAuthorUser(user);
		
		try {
			// Recuperation DAO sur table Users
			IBlogEntryDao dao = WeblogDaoFactory.getBlogEntryDao();

			dao.createBlogEntry(newLog);

		} catch (DaoException e) {
			//TODO Gestion des exceptions techniques
			log.error(e);
		}

		
		returnCode = PAGE_VIEWLOGS;
		//End of user code
		return mapping.findForward(returnCode);
	}

//Start of user code user methods
//End of user code

}