package fr.obeo.weblog.ui.users.actions;

// Start of user code for import
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import fr.obeo.fwk.dao.exception.DaoException;
import fr.obeo.weblog.business.blog.User;
import fr.obeo.weblog.dao.WeblogDaoFactory;
import fr.obeo.weblog.dao.blog.api.IUserDao;
import fr.obeo.weblog.ui.users.forms.CreateAccountForm;
// End of user code for import

/**
 * Implementation of <strong>CreateAccount Action</strong>
 * Scenario : users
 *
 */
public class CreateAccountAction extends org.apache.struts.actions.DispatchAction {
    /**
     * Commons Logging instance.
     */
	private static final Log log = LogFactory.getLog(CreateAccountAction.class);

    /**
     * Forward codes.
     */
	public final static String PAGE_SELF = "self"; //$NON-NLS-1$
	public final static String PAGE_LOGIN = "login"; //$NON-NLS-1$

    /**
     * Process the specified HTTP request for <strong>init</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward init(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		CreateAccountForm createAccountForm = (CreateAccountForm)form;

		//Start of user code method init
		// TODO Write here the action code for init
		//End of user code
	
		return mapping.findForward(returnCode);
	} 

    /**
     * Process the specified HTTP request for <strong>validate</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward validate(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		CreateAccountForm createAccountForm = (CreateAccountForm)form;
		//Start of user code method validate
		User user = new User();
		//TODO : utiliser un beanUtils
		user.setFirstName(createAccountForm.getFirstName());
		user.setLastName(createAccountForm.getLastName());
		user.setEmail(createAccountForm.getEmail());
		user.setLogin(createAccountForm.getLogin());
		user.setPassword(createAccountForm.getPassword());
		
		try {
			// Recuperation DAO sur table Users
			IUserDao dao = WeblogDaoFactory.getUserDao();

			dao.createUser(user);

		} catch (DaoException e) {
			//TODO Gestion des exceptions techniques
			log.error(e);
		}

		//TODO : gestion du login dj existant
		
		returnCode = PAGE_LOGIN;
		//End of user code
		return mapping.findForward(returnCode);
	}

//Start of user code user methods
//End of user code

}