/**
 * <copyright>
 *
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   IBM - Initial API and implementation
 *
 * </copyright>
 *
 * $Id$
 */

package org.acceleo.demo.jee.weblog.plugin.wizard;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.acceleo.demo.jee.weblog.plugin.WeblogDemoPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;



public class WeblogDemoWizard
	extends AbstractExampleWizard {
	
	protected Collection getProjectDescriptors() {
		// We need the workspace example to be unzipped along with the
		// EMF library example model, edit and editor examples
		List projects = new ArrayList(1);
		projects.add(new ProjectDescriptor("org.acceleo.demo.jee.weblog.plugin", "zips/fr.obeo.sample.demo.weblog.struts-hibernate.zip", "fr.obeo.sample.demo.weblog.struts-hibernate"));  //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$
		
		return projects;
	}
	
	protected void log(Exception e) {
		if (e instanceof CoreException) {
			WeblogDemoPlugin.getDefault().getLog().log(((CoreException)e).getStatus());
		} else {
			WeblogDemoPlugin.getDefault().getLog().log(new Status(IStatus.ERROR, WeblogDemoPlugin.getDefault().getBundle().getSymbolicName(),IStatus.ERROR, e.getMessage(),e));
		}
	}
}
