<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%> 
<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Entity"))){%>
/<%entityPackage.toPath()%>/<%name%>.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
package <%entityPackage%>;

// <%startUserCode%> for import
import java.io.Serializable;

<%if (classAttributes.select("(upper == -1 || upper > 1)").nSize() > 0){%>
	<%if (classAttributes.select("(upper == -1 || upper > 1) && isOrdered").nSize() > 0){%>
import java.util.List;
import java.util.ArrayList;
	<%}%>
	<%if ( classAttributes.select("(upper == -1 || upper > 1) && isUnique && !isOrdered").nSize() > 0){%>
import java.util.Set;
import java.util.HashSet;
	<%}%>
	<%if ( classAttributes.select("(upper == -1 || upper > 1) && !isUnique && !isOrdered").nSize() > 0){%>
import java.util.Collection;
		<%if (classAttributes.select("(upper == -1 || upper > 1) && isOrdered").nSize() == 0){%>
import java.util.HashSet;
		<%}%>
	<%}%>	
<%}%>

<%if (attribute.type.select("name == 'Date'").nSize() > 0){%>
import java.util.Date;
<%}%>

<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
import <%type.entityPackage%>.<%type.name%>;
<%}%>
<%if (!superClass.isEmpty){%> 
import <%entityPackage%>.<%superClass.name%>;
<%}%>

// <%endUserCode%>

/**
 * <%ownedComment.body%>
 */
public class <%name%><%extensions%> implements Serializable {

	// serialVersionUID is used for serialization.
	private static final long serialVersionUID = 1L;

	public final static String PROP_ID = "id";
	<%for (classAttributes){%>
	public final static String PROP_<%name.toUpperCase()%> = "<%name%>";
	<%}%>

	private String id;
	<%for (classAttributes){%>
	protected <%convertToJavaType%> <%name%>;
	<%}%>

	/**
	 * Default constructor 
	 */
	public <%name%>() {
		super();
		<%for (classAttributes){%>
			<%if (upper != 1){%>
			<%if (isOrdered){%>
		this.<%name%> = new ArrayList<<%type.name%>>();
			<%}else{%>
		this.<%name%> = new HashSet<<%type.name%>>();
			<%}%>			
			<%}%>
		<%}%>
	}
	
	/**
	 * Return the identifier
	 * @return Id
	 */
	public String getId() {
		return this.id;
	}

	/**
	 * Set a value to parameter Id
	 * @param id Value of the identifier
	 */
	public void setId(String id) {
		this.id = id;
	}
	
<%if (!classAttributes.isEmpty){%>

	/**
	 * Constructor with all parameters initialized
<%for (classAttributes){%>
	 * @param <%name%> <%ownedComment.body%>
<%}%>
	 */
	public <%name%>(<%classAttributes.asParameter.sep(", ")%>) {
<%for (classAttributes){%>
		this.<%name%> = <%name%>;
<%}%>
	}	
<%}%>

<%for (classAttributes){%>
	/**
	 * Return <%name%>
	 * @return <%ownedComment.body%>
	 */
	public <%convertToJavaType%> get<%name.firstUpper()%>() {
	<%if (isDerived){%>
		// <%startUserCode%> of derived <%name%> attribute
		// TODO Logic to calculate <%name%>
		return <%name%>;
		// <%endUserCode%>
	<%}else{%>
		return <%name%>;
	<%}%>
	}

	<%if (!isReadOnly && !isDerived){%>
	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> <%ownedComment.body%>
	 */
	public void set<%name.firstUpper()%>(<%convertToJavaType%> <%name%>) {
		this.<%name%> = <%name%>;
	}
	<%}%>

	<%if (upper == -1 || upper > 1){%>
	/**
	 * Add a <%name%> to the <%name%> Collection.
	 <%if (opposite != null){%>
	 * Birectionnal association : add the current <%class.name%> instance to given <%name%> parameter.
	 <%}%>
	 * @param <%name%>Elt Element to add
	 */
	 public void add<%name.firstUpper()%>(<%type.convertToJavaType%> <%name%>Elt) {
	 	this.<%name%>.add(<%name%>Elt);
	 	<%if (opposite != null){%>
	 		<%if (opposite.upper == 1){%>
	 	<%name%>Elt.set<%opposite.name.firstUpper()%>(this);
	 		<%}else{%>
	 	<%name%>Elt.get<%opposite.name.firstUpper()%>().add(this);
	 		<%}%>
	 	<%}%>
	 }
	 
	/**
	 * Remove a <%name%> to the <%name%> Collection.
	 <%if (opposite != null){%>
	 * Birectionnal association : remove the current <%class.name%> instance to given <%name%> parameter.
	 <%}%>
	 * @param <%name%>Elt Element to remove
	 */
	 public void remove<%name.firstUpper()%>(<%type.convertToJavaType%> <%name%>Elt) {
	 	this.<%name%>.remove(<%name%>Elt);
	 	<%if (opposite != null){%>
	 		<%if (opposite.upper == 1){%>
 		<%name%>Elt.set<%opposite.name.firstUpper()%>(null);
	 		<%}else{%>
	 	<%name%>Elt.get<%opposite.name.firstUpper()%>().remove(this);
	 		<%}%>
	 	<%}%>
	 }
	 <%}%>
<%}%>

<%for (ownedOperation.select("!hasStereotype(getProperty('find'))")){%>	
<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) {
		// <%startUserCode%> of <%name%>
		// TODO implement <%name%>
		throw new UnsupportedOperationException("Method not yet implemented");
		// <%endUserCode%>
	}
	
<%}%>
	
	/** 
	 * Equality test based attributes values
	 * @param value Value to compare
	 */
	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if ( ! (other instanceof <%name%>)) {
			return false;
		}
		
		final <%name%> castedOther = (<%name%>) other;
		
		if ( id != null && castedOther.getId() != null ) {
			return id.equals( castedOther.getId() );
		}
		
		<%for (classAttributes) {%>
			<%if (type.isJavaPrimitiveType() == "true"){%>
		if ( <%name%> != castedOther.get<%name.firstUpper()%>()  ) return false;
			<%}else{%>
		if ( (	<%name%> == null && castedOther.get<%name.firstUpper()%>() != null) || 
			 (	<%name%> != null && !<%name%>.equals(castedOther.get<%name.firstUpper()%>()) ) 
		   ) return false;
			<%}%>
		<%}%>
		
		return true;
	}

	/** 
	 * HashTable code based on attributes hashcodes
	 * @return hash value
	 */
	public int hashCode() {
		int result = 0;
		if (id != null) result = id.hashCode();
		<%for (attribute.filterExistProperty("association",false)) {%>
			<%if (type.name == "Boolean"){%>
		if (<%name%>) result++;
			<%}else if (type.name == "Integer"){%>
		result = 29 * result + <%name%>;
			<%}else if (type.name == "Float"){%>
		 if (<%name%> != null) result = (int) (29 * result + <%name%>.hashCode());
			<%}else{%>
		if (<%name%> != null) result = 29 * result + <%name%>.hashCode();
			<%}%>
		<%}%>
		return result;
	}
   
	// <%startUserCode%> for private methods
	// <%endUserCode%>
   
}

<%script type="Class" name="extensions"%>
<%if (!superClass.isEmpty){%> extends <%superClass.name%><%}%>

<%script type="StructuralFeature" name="asParameter"%>
<%convertToJavaType%> <%name%>

<%script type="Class" name="classAttributes"%>
<%attribute + getAssociations().oppositeAttributeOf(current())[isNavigable]%>
