<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%-- 
This template generate Data Transfert Objects.
It is used for data exchange between UI and Persistence layers
--%>


<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Dto"))){%>
/<%dtoPackage.toPath()%>/<%dtoName%>.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- DTO class generation--%>
package <%dtoPackage%>;

// <%startUserCode%>
import java.io.Serializable;
import java.util.*;
// <%endUserCode%>

/**
 * <%ownedComment.body%>
 */
 public class <%dtoName%><%extensions%> implements Serializable {

	// serialVersionUID is used for serialization.
	private static final long serialVersionUID = 1L;

<%-- Generate attributes --%>
<%for (attribute){%>
	protected <%convertDtoToJavaType%> <%name%>;
<%}%>

	/**
	 * Default constructor 
	 */
	public <%dtoName%>() {
		super();
	}

<%if (!attribute.isEmpty){%>
	/**
	 * Constructor with all parameters initialized
	<%for (attribute){%>
	 * @param <%name%> <%ownedComment.body%>
	<%}%>
	 */
	public <%dtoName%>(<%attribute.asParameter.sep(", ")%>) {
	<%for (attribute){%>
		this.<%name%> = <%name%>;
	<%}%>
	}	
<%}%>

<%-- Generate getters and setters --%>
<%for (attribute) {%>

<%-- Deals with Lists --%>
	<%if (upper == -1){%>
		<%generateOpForList%>
	<%}else{%>
		<%generateOp%>
	<%}%>
	
<%}%>

}

<%script type="Class" name="extensions"%>
<%-- Manage extensions --%>
<%if (!general.isEmpty){%> extends <%general.name%>Dto<%}else{%> <%}%>

<%script type="Property" name="asParameter"%>
<%-- Used to render an attribute as a parameter of a method --%>
<%convertDtoToJavaType%> <%name%>

<%script type="Property" name="generateOp"%>
<%-- Manage Getters and Setters --%>
	/**
	 * Return <%name%>
	 * @return <%ownedComment.body%>
	 */
	public <%convertDtoToJavaType%> get<%name.firstUpper()%>() {
		return <%name%>;
	}

	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> <%ownedComment.body%>
	 */
	public void set<%name.firstUpper()%>(<%convertDtoToJavaType%> <%name%>) {
		this.<%name%> = <%name%>;
<%if (opposite != null){%>
		this.<%name%>.set<%featuringClassifier.name%>(this);
<%}%>
	}

<%script type="Property" name="generateOpForList"%>
<%-- Manage Getters and Setters fir List objects --%>
	/**
	 * Return <%name%>
	 * @return A list of <%type%>. <%ownedComment.body%>
	 */
	public <%convertDtoToJavaType%> get<%name.firstUpper()%>() {
		return Collections.unmodifiableList(<%name%>);
	}

	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> A list of <%type%>. <%ownedComment.body%>
	 */
	public void set<%name.firstUpper()%>(<%convertDtoToJavaType%> <%name%>) {
		this.<%name%> = <%name%>;
	}
	
	/**
	 * Add an element to the list <%name%>.
	 * @param elementToAdd Element of type <%type%> to add
	 */
	public void add<%name.firstUpper()%>(<%type.convertDtoToJavaType%> elementToAdd) {
		this.<%name%>.add(elementToAdd);
		<%if (opposite != null){%>
			<%if (upper != 1){%>
		elementToAdd.add<%owner%>(this);
			<%}else{%>
		elementToAdd.set<%owner%>(this);
			<%}%>
		<%}%>
	}
	
	/**
	 * Remove an element to the list <%name%>.
	 * @param elementToRevmoe Element of type <%type%> to add
	 */
	public void remove<%name.firstUpper()%>(<%type.convertDtoToJavaType%> elementToRemove) {
		this.<%name%>.remove(elementToRemove);
<%if (opposite != null){%>
			<%if (upper != 1){%>
		elementToAdd.remove<%owner%>(this);
			<%}else{%>
		elementToAdd.set<%owner%>(null);
			<%}%>
		<%}%>
	}
	

<%script type="Property" name="convertDtoToJavaType"%>
<%-- Manage return type for attributes --%>
<%if (upper == -1){%>List<<%type.convertDtoToJavaType%>><%}else{%><%type.convertDtoToJavaType%><%}%>

<%script type="Type" name="convertDtoToJavaType"%>
<%if ( hasStereotype("Dto") ){%><%name%>Dto<%}else{%>
<%convertToJavaType%><%}%>	
