/**
 * Copyright  2007 - Obeo
 * All rights reserved.  This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 1.0
 * 
 * You can apply any license to the files generated with this template
 * and Acceleo.
 *
 * @author  www.obeo.fr
 * 
 **/
package org.acceleo.module.pim.uml21.services;

import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.ecore.factories.EFactory;
import fr.obeo.acceleo.ecore.factories.FactoryException;
import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;
import fr.obeo.acceleo.gen.template.eval.ENodeIterator;
import fr.obeo.acceleo.gen.template.eval.ENodeList;


public class ListServices {

	/**
	 * Return only Nodes which have the specified property setted.
	 * @param nodes
	 * @param property
	 * @param exist
	 * @return
	 * @throws ENodeCastException
	 */
	public ENodeList filterExistProperty(ENodeList nodes, String property, boolean exist) throws ENodeCastException {
		ENodeList result = new ENodeList();
		ENodeIterator it = nodes.iterator();
		while (it.hasNext()){
			ENode node = it.next();
			if (node.isEObject()){
				if (!exist && !EFactory.eExist(node.getEObject(),property)){
					result.add(node);
				}else if (exist && EFactory.eExist(node.getEObject(),property)){
					result.add(node);
				}
			}else{
				result.add(node);
			}
		}
		return result;
	}

	/**
	 * Return all instances of specified type contained inside the root node.
	 * Use a deep search.
	 * @param root
	 * @param type
	 * @return
	 * @throws ENodeCastException
	 * @throws FactoryException
	 */
	public ENodeList getAllInstances(ENode root, String type) throws ENodeCastException, FactoryException {
		ENodeList result = new ENodeList();
		if (root.eInstanceof(type)){
			result.add(root);
		}
		if (root.isEObject()){
			Iterator eContents = root.getEObject().eContents().iterator();
			while (eContents.hasNext()){
				result.addAll(getAllInstances(new ENode((EObject)eContents.next(),root),type));
			}
		}
		return result;
	}
	
	/**
	 * Verify if a ENodeList is empty or not.
	 * @param nodes
	 * @return
	 * @throws ENodeCastException
	 */
	public boolean isEmpty(ENodeList nodes) throws ENodeCastException {
		if (nodes.size() > 0)
			return false;
		else
			return true;
	}

/*	public int size(ENodeList nodes) throws ENodeCastException {
		return nodes.size();
	}
*/
}
