<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%-- 
This template generate Data Objects Access Factory abstract class as recommended in the Sun BluePrint pattern..
--%>

<%script type="Model" name="fullFilePath"%>
/<%daoInterfacePackage.toPath()%>/<%projectName.firstUpper()%>DaoFactory.java

<%script type="Model" name="generate" file="<%fullFilePath%>"%>
<%-- DAOFactory abstract class generation--%>
package <%daoInterfacePackage%>;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import fr.obeo.fwk.dao.exception.DaoException;
<%for (eAllContents("Class")[hasStereotype(getProperty("Entity")) || hasStereotype(getProperty("Dao"))]){%><%if (nGet("import." + name) == null){%>
<%nPut("import." + name)%>import <%baseImports%>.<%projectName%>.dao.<%package.normalizedName%>.api.I<%name%>Dao;
<%}%><%}%>

public class <%projectName.firstUpper()%>DaoFactory {
	
	private final static String FILE_DAO_MAPPING = "dao";
	private static ResourceBundle bundle = ResourceBundle.getBundle(FILE_DAO_MAPPING);

<%-- All Entity class and DAO customized class are gatherd here --%>
<%for (getAllInstances("Class")){%><%if (hasStereotype(getProperty("Entity")) || hasStereotype(getProperty("Dao"))){%>
	public static <%packageDeclaration%>I<%name%>Dao get<%getterPrefix%><%name%>Dao() throws DaoException {

		try {
			String className = bundle.getString(<%packageDeclaration%>I<%name%>Dao.class.getName());

			// Cast and instanciate with JDK 1.5 control
			Class<? extends <%packageDeclaration%>I<%name%>Dao> daoClass = 
				Class.forName(className).asSubclass(<%packageDeclaration%>I<%name%>Dao.class);
			return daoClass.newInstance();

		} catch (MissingResourceException e) {
			throw new DaoException("Key " + <%packageDeclaration%>I<%name%>Dao.class.getName() + " not found in " + FILE_DAO_MAPPING + ".properties", e);
		} catch (ClassNotFoundException e) {
			throw new DaoException("DAO implementation not found for " + <%packageDeclaration%>I<%name%>Dao.class.getName(), e);
		} catch (InstantiationException e) {
			throw new DaoException(e);
		} catch (IllegalAccessException e) {
			throw new DaoException(e);
		}
		
	}
	
<%}%><%}%>
}

<%script type="Model" name="daoInterfacePackage"%>
<%baseImports%>.<%projectName%>.dao

<%script type="Class" name="packageDeclaration" description="write explicit package declaration if many entities have the same name"%>
<%if (nGet("daogetter." + name) != null){%><%baseImports%>.<%projectName%>.dao.<%package.normalizedName%>.api.<%}%>

<%script type="Class" name="getterPrefix" description="manage getter name if many entities have the same name"%>
<%if (nGet("daogetter." + name) != null){%><%package.normalizedName.firstUpper%><%}%>
