<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Dao")) {%>
/<%daoInterfacePackage.toPath()%>/I<%name%>Dao.java
<%}%>

<%script type="Class" name="generateDao" file="<%fullFilePath%>"%>
package <%daoInterfacePackage%>;

// <%startUserCode%> for import
import java.util.List;

import fr.obeo.fwk.dao.exception.DaoException;
<%for (clientDependency.target.filter("Class")){%>
import <%baseImports%>.<%projectName%>.business.<%package.normalizedName%>.<%name%>;
<%}%>

// <%endUserCode%> for import

public interface I<%name%>Dao {

<%ownedOperation.generate%>
<%for (clientDependency.target.filter("Class")){%>

	// Data Access Operations for <%name%>
	
	/**
	 * Create a new element
	 * @param <%name.firstLower()%> Element to create.
	 */
	public void create<%name%>(<%name%> <%name.firstLower()%>) throws DaoException;

	/**
	 * Update an existing element
	 * @param <%name.firstLower()%> Element to update. If the element has an id, it may use it.
	 */
	public void update<%name%>(<%name%> <%name.firstLower()%>) throws DaoException;

	/**
	 * Delete an element
	 * @param <%name.firstLower()%> Element which will be delete. 
	 * Only id can be used to find which element must be deleted.
	 */
	public void delete<%name%>(<%name%> <%name.firstLower()%>) throws DaoException;

	/**
	 * Find all elements.
	 * @return A list with all elements, without any filter.
	 */
	public List<<%name%>> findAll<%name%>s() throws DaoException;

<%}%>
}

<%script type="Class" name="daoInterfacePackage"%>
<%daoPackage%>.api

<%script type="Operation" name="generate"%>
<%if (hasStereotype("create")){%>
<%create%>
<%}%>
<%if (hasStereotype("update")){%>
<%update%>
<%}%>
<%if (hasStereotype("delete")){%>
<%delete%>
<%}%>
<%if (hasStereotype("find")){%>
<%find%>
<%}%>

<%script type="Operation" name="create"%>
	/**
	 * Create a new element
	 * @param <%ownedParameter.name%> Element to create.
	 */
	public void <%name%>(<%generateParameters%>) throws DaoException;
	

<%script type="Operation" name="update"%>
	/**
	 * Update an existing element
	 * @param <%ownedParameter.name%> Element to update. If the element has an id, it may use it.
	 */
	public void <%name%>(<%generateParameters%>) throws DaoException;
	

<%script type="Operation" name="delete"%>
	/**
	 * Delete an element
	 * @param <%ownedParameter.name%> Element which will be delete.
	 */
	public void <%name%>(<%generateParameters%>) throws DaoException;
	

<%script type="Operation" name="find"%>	
	<%generateJavadoc%>
	public <%type.name%><%type.suffixe%> <%name%>(<%generateParameters%>) throws DaoException;


<%script type="Parameter" name="genDeclare"%>
<%type.name%><%type.suffixe%> <%name%>

<%script type="Type" name="suffixe"%>
<%if (hasStereotype("Dto")){%>
Dto<%}else{%>
<%if (hasStereotype(getProperty("Entity"))){%>
Entity<%}%><%}%>

