<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
%>

<%-- 
This template generate Data Objects Access Interfaces as recommended in the Sun BluePrint pattern..
--%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Entity"))) {%>
/<%daoInterfacePackage.toPath()%>/I<%name%>Dao.java
<%}%>

<%script type="Class" name="generateDao" file="<%fullFilePath%>"%>
<%-- DAO interface generation --%>
package <%daoInterfacePackage%>;

// <%startUserCode%> for import
import java.util.Collection;

import fr.obeo.fwk.dao.exception.DaoException;
import <%baseImports%>.<%projectName%>.business.<%package.normalizedName%>.<%name%>;

// <%endUserCode%> for import

/**
 * This class provides the data access layer to the <%name%> entity class.<br/>
 * This is the interface which represent the contrat of the DAO access.
 */
public interface I<%name%>Dao {

	/**
	 * Create a new element
	 * @param <%name.firstLower()%> Element to create.
	 */
	public void create<%name%>(<%name%><%suffixe%> <%name.firstLower()%>) throws DaoException;

	/**
	 * Update an existing element
	 * @param <%name.firstLower()%> Element to update. If the element has an id, it may use it.
	 */
	public void update<%name%>(<%name%><%suffixe%> <%name.firstLower()%>) throws DaoException;

	/**
	 * Delete an element
	 * @param <%name.firstLower()%> Element which will be delete. 
	 * Only id can be used to find which element must be deleted.
	 */
	public void delete<%name%>(<%name%><%suffixe%> <%name.firstLower()%>) throws DaoException;

	/**
	 * Find all elements.
	 * @return A list with all elements, without any filter.
	 */
	public Collection<<%name%><%suffixe%>> findAll<%name%>s() throws DaoException;

	/**
	 * Find one entity by its primary key.
	 * @return The entity found.
	 */
	public <%name%> find<%name%>ById(String id) throws DaoException;

<%-- Generate additional methods d�claration --%>
<%for (ownedOperation){%>
	<%-- Generate methods with find stereotypes --%>
	<%if (hasStereotype(getProperty("find"))){%>
<%generateJavadoc%>
	public <%returnResult.convertToJavaType%> <%name%>(<%generateParameters%>) throws DaoException;

	<%}%>
<%}%>
	//<%startUserCode%> for technicals dao access api
	//<%endUserCode%>
}

<%script type="Class" name="daoInterfacePackage"%>
<%daoPackage%>.api

<%script type="Type" name="suffixe"%>
<%if (hasStereotype("Dto")){%>
Dto<%}%>
<%-- <%}else{%>
<%if (hasStereotype("Entity")){%><%}%> --%>
	
