<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.sql.services.SqlTypeServices
%>

<%-- 
This template generate Data Objects Access Implementation as recommended in the Sun BluePrint pattern..
--%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Entity"))) {%>
/<%jdbcPackage.toPath()%>/Jdbc<%name%>Dao.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- DAO implementation generation --%>
package <%jdbcPackage%>;

// <%startUserCode%> for import 
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;

import fr.obeo.fwk.dao.exception.DaoException;
import <%baseImports%>.<%projectName%>.fwk.dao.jdbc.<%projectName.firstUpper()%>ConnectionUtils;
import <%baseImports%>.<%projectName%>.business.<%package.normalizedName%>.<%name%>;
<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
import <%baseImports%>.<%projectName%>.business.<%type.package.normalizedName%>.<%type.name%>;
<%}%>

import <%baseImports%>.<%projectName%>.dao.<%package.normalizedName%>.api.I<%name%>Dao;

// <%endUserCode%> for import 

/**
 * This class provides the data access layer to the <%name%> entity class.
 * This is the JDBC implementation.
 */
public class Jdbc<%name%>Dao implements I<%name%>Dao {

<%-- Generates static declaration for database fields --%>
	protected final static String TABLE_NAME = "<%name.toSqlNotation()%>";

<%for (attribute.filterExistProperty("association", false)){%>
	<%if (!isDerived){%>
	protected final static String <%name.toUpperCase()%> = "<%name.toSqlNotation()%>";
	<%}%>
<%}%>
<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
	protected final static String <%name.toUpperCase()%> = "<%name.toSqlNotation()%>_ID";
<%}%>
	
	// <%startUserCode%> specifics queries
	protected static final String CREATE_QUERY = 
		"INSERT INTO " + TABLE_NAME + 
		" (<%attribute.name.toSqlNotation().sep(", ")%>) VALUES ( <%for (attribute){%>? <%}%>)";
		
	protected static final String UPDATE_QUERY = 
		"UPDATE " + TABLE_NAME + 
		" SET  <%attribute.filterWithOutStereotype("id").genComparator.sep(", ")%>" +
		" WHERE <%attribute.filterWithStereotype("id").genComparator.sep(" and ")%>";
	
	protected static final String DELETE_QUERY = 
		"DELETE FROM " + TABLE_NAME + 
		" WHERE <%attribute.filterWithStereotype("id").genComparator.sep(" and ")%>";
		
	protected static final String FIND_ALL_QUERY = 
		"SELECT * FROM " + TABLE_NAME;
		
	protected static final String FIND_BY_ID = 
		"SELECT * FROM " + TABLE_NAME +
		" WHERE ID = ?";
		
	<%if (attribute.filterWithStereotype("id").nSize() > 1){%>
		<%for (attribute.filterWithStereotype("id").filter("Property")){%>
	protected static final String FIND_BY_<%name.toSqlNotation()%> = 
		"SELECT * FROM " + TABLE_NAME +
		" WHERE <%name.toSqlNotation()%> = ?";
		<%}%>
	<%}%>
	// <%endUserCode%>

	protected Collection<<%name%>> createList(ResultSet rs) throws SQLException {
		Collection<<%name%>> result = new ArrayList<<%name%>>();
		<%name%> <%name.firstLower()%> = null;
		while (rs.next()) {
			<%name.firstLower()%> = new <%name%>();
<%for (attribute.filterExistProperty("association", false)){%>
	<%if (!isDerived){%>
		<%if (upper == 1){%>
			<%class.name.firstLower()%>.set<%name.firstUpper()%>( rs.get<%genRsType%>(<%name.toUpperCase()%>) );
		<%}%>
	<%}%>
<%}%>
<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>

			<%type.name%> <%name%> = new <%type.name%>();
			<%name%>.setId( rs.getString(<%name.toUpperCase()%>) );
	<%if (upper == 1){%>	
			<%association.oppositeAttributeOf(current().type).type.name.firstLower()%>.set<%name.firstUpper()%>( <%name%> );
	<%}else{%>	
			<%association.oppositeAttributeOf(current().type).type.name.firstLower()%>.get<%name.firstUpper()%>().add( <%name%> );
	<%}%>
<%}%>

			result.add(<%name.firstLower()%>);
		}
		return result;
	}

	public void create<%name%>(<%name%> element) throws DaoException {
		Connection cnx = null;
		PreparedStatement statement = null;

		try {
			cnx = <%projectName.firstUpper()%>ConnectionUtils.getInstance().getConnection();
			statement = cnx.prepareStatement(CREATE_QUERY);

			// <%startUserCode%> create
			<%for (attribute){%>
				<%if (!isDerived){%>
					<%if (upper == 1){%>
						<%if (type.name == "String"){%>
			statement.setString(<%i()+1%>, element.get<%name.firstUpper()%>());
						<%}else if(type.name == "Date"){%>
			statement.setDate(<%i()+1%>, new Date(element.get<%name.firstUpper()%>().getTime()));
						<%}else if(type.name == "Integer"){%>
			statement.setInt(<%i()+1%>, element.get<%name.firstUpper()%>());
						<%}%>
					<%}%>
				<%}%>
			<%}%>
			// <%endUserCode%>

			statement.executeUpdate();
		} catch (SQLException e) {
			throw new DaoException("Erreur requete", e);
		} finally {
			try {
				if(statement!=null){statement.close();}
				if(cnx!=null){cnx.close();}
			} catch (SQLException e) {
				throw new DaoException("Erreur de fermeture JDBC", e);
			}
		}
	}
	
	public void update<%name%>(<%name%> element) throws DaoException {
		Connection cnx = null;
		PreparedStatement statement = null;

		try {
			cnx = <%projectName.firstUpper()%>ConnectionUtils.getInstance().getConnection();
			statement = cnx.prepareStatement(UPDATE_QUERY);
			// <%startUserCode%> update
			<%for (attribute){%>
				<%if (!isDerived){%>
					<%if (upper == 1){%>
						<%if (type.name == "String"){%>
			statement.setString(<%i()+1%>, element.get<%name.firstUpper()%>());
						<%}else if(type.name == "Date"){%>
			statement.setDate(<%i()+1%>, new Date(element.get<%name.firstUpper()%>().getTime()));
						<%}else if(type.name == "Integer"){%>
			statement.setInt(<%i()+1%>, element.get<%name.firstUpper()%>());
						<%}%>
					<%}%>
				<%}%>
			<%}%>
			// <%endUserCode%>

			statement.executeUpdate();
		} catch (SQLException e) {
			throw new DaoException("Erreur requete", e);
		} finally {
			try {
				if(statement!=null){statement.close();}
				if(cnx!=null){cnx.close();}
			} catch (SQLException e) {
				throw new DaoException("Erreur de fermeture JDBC", e);
			}
		}
	}
	
	public void delete<%name%>(<%name%> element) throws DaoException {
		Connection cnx = null;
		PreparedStatement statement = null;

		try {
			cnx = <%projectName.firstUpper()%>ConnectionUtils.getInstance().getConnection();
			statement = cnx.prepareStatement(DELETE_QUERY);
			// <%startUserCode%> delete
			<%for (attribute.filterWithStereotype("id")){%>
				<%if (!isDerived){%>
					<%if (upper == 1){%>
						<%if (type.name == "String"){%>
		statement.setString(<%i()+1%>, element.get<%name.firstUpper()%>());
						<%}else if(type.name == "Date"){%>
		statement.setDate(<%i()+1%>, new Date(element.get<%name.firstUpper()%>().getTime()));
						<%}else if(type.name == "Integer"){%>
		statement.setInt(<%i()+1%>, element.get<%name.firstUpper()%>());
						<%}%>
					<%}%>
				<%}%>
			<%}%>
			// <%endUserCode%>


			statement.executeUpdate();
		} catch (SQLException e) {
			throw new DaoException("Erreur requete", e);
		} finally {
			try {
				if(statement!=null){statement.close();}
				if(cnx!=null){cnx.close();}
			} catch (SQLException e) {
				throw new DaoException("Erreur de fermeture JDBC", e);
			}
		}
	}
	
	public Collection<<%name%>> findAll<%name%>s() throws DaoException {
		Connection cnx = null;
		Statement statement = null;
		ResultSet rs = null;

		try {
			cnx = <%projectName.firstUpper()%>ConnectionUtils.getInstance().getConnection();
			statement = cnx.createStatement();
			rs = statement.executeQuery(FIND_ALL_QUERY);

			Collection<<%name%>> result = createList(rs);
			return result;
		} catch (SQLException e) {
			throw new DaoException("Erreur requete", e);
		} finally {
			try {
				if(rs!=null){rs.close();}
				if(statement!=null){statement.close();}
				if(cnx!=null){cnx.close();}
			} catch (SQLException e) {
				throw new DaoException("Erreur de fermeture JDBC", e);
			}
		}
	}	
	
	public <%name%> find<%name%>ById(String id) throws DaoException {
		Connection cnx = null;
		Statement statement = null;
		ResultSet rs = null;

		try {
			cnx = <%projectName.firstUpper()%>ConnectionUtils.getInstance().getConnection();
			statement = cnx.createStatement();
			rs = statement.executeQuery(FIND_BY_ID);

			<%name%> result = new <%name%>();
			<%for (attribute.filterExistProperty("association", false)){%>
				<%if (!isDerived){%>
					<%if (upper == 1){%>
			result.set<%name.firstUpper()%>( rs.get<%genRsType%>(<%name.toUpperCase()%>) );
					<%}%>
				<%}%>
			<%}%>
			return result;
		} catch (SQLException e) {
			throw new DaoException("Erreur requete", e);
		} finally {
			try {
				if(rs!=null){rs.close();}
				if(statement!=null){statement.close();}
				if(cnx!=null){cnx.close();}
			} catch (SQLException e) {
				throw new DaoException("Erreur de fermeture JDBC", e);
			}
		}
	}
	
	<%if (attribute.filterWithStereotype("id").nSize() > 1){%>
		<%for (attribute.filterWithStereotype("id").filter("Property")){%>
	public Collection<<%name%>> find<%name%>sBy<%name%>(<%type.name%> <%name%>) throws DaoException {
		Connection cnx = null;
		Statement statement = null;
		ResultSet rs = null;

		try {
			cnx = <%projectName.firstUpper()%>ConnectionUtils.getInstance().getConnection();
			statement = cnx.createStatement();
			rs = statement.executeQuery(FIND_BY_<%name.toSqlNotation()%>);

			Collection<<%name%>> result = createList(rs);
			return result;
		} catch (SQLException e) {
			throw new DaoException("Erreur requete", e);
		} finally {
			try {
				if(rs!=null){rs.close();}
				if(statement!=null){statement.close();}
				if(cnx!=null){cnx.close();}
			} catch (SQLException e) {
				throw new DaoException("Erreur de fermeture JDBC", e);
			}
		}
	}
		<%}%>
	<%}%>

	
<%-- Generate additional methods d�claration --%>
<%for (ownedOperation){%>
	<%-- Generate methods with find stereotypes --%>
	<%if (hasStereotype("find")){%>
	<%generateJavadoc%>
	public <%returnResult.convertToJavaType%> <%name%>(<%generateParameters%>) throws DaoException {
		// <%startUserCode%> of <%name%>
		return null;
		// <%endUserCode%>
	}
	<%}%>
<%}%>

	//<%startUserCode%>
	//<%endUserCode%>
}

<%script type="Class" name="jdbcPackage"%>
<%daoPackage%>.jdbc

<%script type="Property" name="genComparator"%>
<%name.toSqlNotation()%> = ? 

<%script type="Property" name="genRsType"%>
<%convertToJavaType.firstUpper()%>
