<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
/<%memcachePackage.toPath()%>/MemCache<%name%>Dao.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
package <%memcachePackage%>;

// <%startUserCode%> for import 
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Map;

import fr.obeo.fwk.dao.exception.DaoException;
import <%baseImports%>.<%projectName%>.business.<%package.normalizedName%>.<%name%>;
import <%baseImports%>.<%projectName%>.dao.<%package.normalizedName%>.api.I<%name%>Dao;

// <%endUserCode%> for import 

public class MemCache<%name%>Dao implements I<%name%>Dao {
	
	protected static Map<String, <%name%>> <%name.firstLower()%>sCache = new Hashtable<String, <%name%>>();
	
	public void create<%name%>(<%name%> entity) throws DaoException {
		<%name.firstLower%>sCache.put(entity.getId(), entity);
	}
	
	public void update<%name%>(<%name%> entity) throws DaoException {
		if (!<%name.firstLower%>sCache.containsKey(entity.getId())) {
			throw new DaoException("<%name%> (id : " + entity.getId() + ") to update doesn't exist.");
		}
		<%name.firstLower%>sCache.put(entity.getId(), entity);
	}
	
	public void delete<%name%>(<%name%> entity) throws DaoException {
		<%name.firstLower%>sCache.remove(entity.getId());
	}
	
	public Collection<<%name%>> findAll<%name%>s() throws DaoException {
		Collection<<%name%>> allList = new ArrayList<<%name%>>();
		allList.addAll(<%name.firstLower%>sCache.values());
		return allList;
	}
	
	public <%name%> find<%name%>ById(String id) throws DaoException {
		<%name%> result = <%name.firstLower%>sCache.get(id);
		return result;
	}
	
<%-- Generate additional methods d�claration --%>
<%for (ownedOperation){%>
	<%-- Generate methods with find stereotypes --%>
	<%if (hasStereotype("find")){%>
	<%generateJavadoc%>
	public <%returnResult.convertToJavaType%> <%name%>(<%generateParameters%>) throws DaoException {
		// <%startUserCode%> of <%name%>
		return null;
		// <%endUserCode%>
	}
	<%}%>
<%}%>
}

<%script type="Class" name="memcachePackage"%>
<%daoPackage%>.memcache

<%script type="Class" name="getIds"%>
<%for (attribute){%>
	<%if (hasStereotype("id")){%>
		<%if (type.name == "String"){%>
entity.get<%name.firstUpper()%>()<%}else{%>
String.valueof(entity.get<%name.firstUpper()%>())<%}%>
	<%}%>
<%}%>
