<%--
  Copyright © 2007 Nicolas Deverge - Ekito

  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Only tested with SQLServer 2005 Express Edition
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.sql.services.SqlTypeServices
%>

<%script type="Model" name="genConstraints" file="<%projectName%>-contraints.sql"%>

<%for (getAllInstances("Class")){%>
	<%if (hasStereotype(getProperty("Entity"))){%>
-- Constraints for table <%name.toSqlNotation()%>

		<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
		<%-- n---n --%>
			<%if (opposite == null){%>
			<%-- |n|-->n --%>
				<%if (upper == 1){%>
				<%-- |n|-->1 --%>
<%genForeignConstraint%>
				<%}%>
			<%}else if ( isMainEndPoint() == "true"){%>
			<%-- |n|<-->n --%>
				<%if (upper == 1){%>
				<%-- |n|<-->1 --%>
<%genForeignConstraint%>
				<%}%>
			<%}%>
		<%if (upper != 1 && oppositeAttribute.upper != 1){%>
		<%-- *---* --%>
			<%if (isMainEndPoint() == "true"){%>
IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[dbo].[CST_FK_JOIN_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>;]'))						
ALTER TABLE JOIN_<%type.name.toSqlNotation()%>_<%class.name.toSqlNotation()%>
	DROP CONSTRAINT CST_FK_JOIN_<%type.name.toSqlNotation()%>_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>; 

ALTER TABLE JOIN_<%type.name.toSqlNotation()%>_<%class.name.toSqlNotation()%>
 ADD CONSTRAINT CST_FK_JOIN_<%type.name.toSqlNotation()%>_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>
 FOREIGN KEY (REF_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID)
 REFERENCES <%type.name.toSqlNotation()%> (ID);
			<%}%>
		<%}%>

		<%}%>
		
		<%if (!superClass.isEmpty){%>
IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[dbo].[CST_FK_INHERITS_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>;]'))		
ALTER TABLE <%name.toSqlNotation()%>
DROP CONSTRAINT CST_FK_INHERITS_<%superClass.name.toSqlNotation()%>_ID;	

ALTER TABLE <%name.toSqlNotation()%>
 ADD CONSTRAINT CST_FK_INHERITS_<%superClass.name.toSqlNotation()%>_ID
 FOREIGN KEY (REF_INHERITS_<%superClass.name.toSqlNotation()%>_ID)
 REFERENCES <%superClass.name.toSqlNotation()%> (ID);

		<%}%>
		
	<%}%>
<%}%>

<%script type="Property" name="genForeignConstraint"%>
IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[dbo].[CST_FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>;]'))
ALTER TABLE <%oppositeAttribute().type.name.toSqlNotation()%>
	DROP CONSTRAINT CST_FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>; 

ALTER TABLE <%oppositeAttribute().type.name.toSqlNotation()%>
 ADD CONSTRAINT CST_FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_<%i%>
 FOREIGN KEY (REF_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID)
 REFERENCES <%type.name.toSqlNotation()%> (ID);


<%script type="Property" name="isMainEndPoint"%>
<%if (aggregation == "composite" ||
	 (oppositeAttribute.aggregation != "composite" && 
	 	(compare(class.name, type.name) > 0 || 
	 	 (class == type && compare(name, opposite.name) > 0)
	 	)
	 ))
	 {%>true<%}else{%>false<%}%>
