<%--
  Copyright © 2007 Nicolas Deverge - Ekito
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Only tested with SQLServer 2005 Express Edition
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.sql.services.SqlTypeServices
%>

<%-- 
This template generates database ddl
--%>

<%script type="Model" name="generate" file="<%projectName%>-ddl.sql"%>

<%for (getAllInstances("Class")){%><%if (hasStereotype(getProperty("Entity"))){%>
-- Tables for Entity <%name%> 

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[<%name.toSqlNotation()%>]') AND type in (N'U'))
DROP TABLE <%name.toSqlNotation()%>

CREATE TABLE <%name.toSqlNotation()%>
(
<%-- Class attribute iteration --%>
<%-- attribute.filterExistProperty("association",false) 
COMMENT ON COLUMN--%>
	<%if (superClass.isEmpty){%>
	ID INT IDENTITY(1,1) NOT NULL,
	<%}%>
	<%-- Properties --%>
	<%for (attribute.filterExistProperty("association",false)){%>
		<%-- Array of primitives types are not generated --%>
		<%if (!isDerived && upper == 1){%>
	<%name.toSqlNotation()%> <%type.convertToSqlType%> <%if (lower > 0){%>NOT <%}%>NULL,
		<%}%>
	<%}%>
	<%-- Direct associations --%>
	<%for (getAssociations().oppositeAttributeOf(current())[isNavigable]){%>
	<%-- n---n --%>
		<%if (opposite == null){%>
		<%-- |n|-->n --%>
			<%if (upper == 1){%>
			<%-- |n|-->1 --%>
				<%if (oppositeAttribute.upper == 1){%>
				<%-- |1|-->1 --%>
	<%genForeignKey%> UNIQUE,
	        	<%}else{%>
				<%-- |*|-->1 --%>
	<%genForeignKey%>,
				<%}%>			
			<%}else{%>
			<%-- n-->* --%>
				<%if (oppositeAttribute.upper == 1){%>
				<%-- |1|-->* --%>
	        	<%}else{%>
				<%-- |*|-->* --%>
				<%}%>			
			<%}%>
		<%}else if((oppositeAttribute.upper == -1 || oppositeAttribute.upper > 1) && upper == 1){%>	
			<%-- |*|<-->1 --%>
	<%genForeignKey%>,
		<%}else if ( isMainEndPoint() == "true"){%>
		<%-- |n|<-->n --%>
			<%if (upper == 1 && oppositeAttribute.upper == 1){%>
			<%-- |1|<-->1 --%>
	<%genForeignKey%> UNIQUE,
			<%}%>
		<%}%>
	<%}%>
	<%-- Opposite associations --%>
	<%for (pointedAttribute){%>
	<%-- n---|n| --%>
		<%if (opposite == null){%>
		<%-- n-->|n| --%>
			<%if (upper != 1){%>
			<%-- n-->|*| --%>
				<%if (oppositeAttribute.upper == 1){%>
				<%-- 1-->|*| --%>
	REF_<%oppositeAttribute.type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID INT<%if (lower > 0){%> NOT NULL<%}%>,
				<%}%>
			<%}%>
		<%}%>
	<%}%>
	<%-- Inheritance --%>
	<%if (!superClass.isEmpty){%>
	REF_INHERITS_<%superClass.name.toSqlNotation()%>_ID INT NOT NULL,	
	PRIMARY KEY (REF_INHERITS_<%superClass.name.toSqlNotation()%>_ID)
	<%}else{%>
	PRIMARY KEY (ID)
	<%}%>
);

	<%-- Join table for many to many associations --%>
	<%for (getAssociations().oppositeAttributeOf(current())[isNavigable]){%>
	<%-- n---n --%>
		<%if (upper != 1 && oppositeAttribute.upper != 1){%>
		<%-- *---* --%>
			<%if ( 	opposite == null || 
					isMainEndPoint() == "true"){%>
			<%-- *-->|*| --%>

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[JOIN_<%oppositeAttribute.type.name.toSqlNotation()%>_<%type.name.toSqlNotation()%>]') AND type in (N'U'))
DROP TABLE JOIN_<%oppositeAttribute.type.name.toSqlNotation()%>_<%type.name.toSqlNotation()%>
CREATE TABLE JOIN_<%oppositeAttribute.type.name.toSqlNotation()%>_<%type.name.toSqlNotation()%>
(
	<%oppositeAttribute.type.name.toSqlNotation()%>_ID INT NOT NULL,
	<%type.name.toSqlNotation()%>_ID INT NOT NULL,
	PRIMARY KEY (<%oppositeAttribute.type.name.toSqlNotation()%>_ID, <%type.name.toSqlNotation()%>_ID)
);

			<%}%>
		<%}%>
	<%}%>
<%}%><%}%>

<%script type="Type" name="convertToSqlType"%>
<%-- For ddl generation specific to MySQL --%>
<%getProperty("sql.typeconversion."+name)%>

<%script type="Property" name="genForeignKey"%>
REF_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID INT<%if (lower > 0){%> NOT NULL<%}%>

<%script type="Property" name="isMainEndPoint"%>
<%if (aggregation == "composite" ||
	 ( oppositeAttribute.aggregation != "composite" && 
	 	(compare(class.name, type.name) > 0 || 
	 	 (class == type && compare(name, opposite.name) > 0)
	 	)
	 ))
	 {%>true<%}else{%>false<%}%>
