<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
%>


<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Entity"))){%>
/<%objectsPackage.toPath()%>/I<%name%>DaoTest.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
package <%objectsPackage%>;

// <%startUserCode%> for import 
<%if (attribute.select("type.name == 'Date'")){%>
import java.util.Date;
<%}%>
<%if (attribute..filterExistProperty("association", false).select("upper > 1 || upper == -1")){%>
import java.util.ArrayList;
import java.util.List;
<%}%>
import org.hibernate.Transaction;
import junit.framework.Assert;
import junit.framework.TestCase;

import fr.obeo.fwk.dao.exception.DaoException;
import fr.obeo.fwk.dao.hibernate.HibernateUtil;
import <%baseImports%>.<%projectName%>.dao.<%projectName.firstUpper()%>DaoFactory;
import <%daoPackage%>.api.I<%name%>Dao;
import <%baseImports%>.<%projectName%>.business.<%package.normalizedName%>.<%name%>;
<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%><%if (lower != 0){%>
import <%baseImports%>.<%projectName%>.business.<%type.package.normalizedName%>.<%type.name%>;
<%}%><%}%>

// <%endUserCode%> for import

public class I<%name%>DaoTest extends TestCase {

	private I<%name%>Dao dao;
	private Transaction tx;

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		dao = <%projectName.firstUpper()%>DaoFactory.get<%name%>Dao();
		tx = HibernateUtil.currentSession().beginTransaction();
	}

	@Override
	protected void tearDown() throws Exception {
		super.tearDown();
		tx.commit();
		HibernateUtil.closeSession();
	}

	/**
	 * Test the creation of the entity <%name%>.<br/>
	 * <ul><li>Step 1 : Create an entity</li>
	 * <li>Step 2 : Search the entity and verify it exist</li></ul>
	 */
	public final void testCreate<%name%>() throws DaoException {
        // fill attributes with example values
		<%name%> <%name.firstLower()%> = get<%name%>Example();
		
        // Execute the tested code
		dao.create<%name%>(<%name.firstLower()%>);

		// Verify result
		boolean found = false;
		for(<%name%> current<%name%> : dao.findAll<%name%>s()) {
			if (current<%name%>.equals(<%name.firstLower()%>)) {
				found = true;
			}
		}
		Assert.assertTrue("<%name%> not created", found);
	}

	/**
	 * Test the modification of an entity <%name%>.<br/>
	 * <ul><li>Step 1 : Create an entity</li>
	 * <li>Step 2 : Modify the entity</li>
	 * <li>Step 3 : Search the entity and verify the modified values</li></ul>
	 */
	public final void testUpdate<%name%>() throws DaoException {
        // Initialized the test
		<%name%> <%name.firstLower()%> = get<%name%>Example();
		dao.create<%name%>(<%name.firstLower()%>);

        // Execute the tested code
		<%for (attribute.filterExistProperty("association", false)){%>
			<%if (!hasStereotype(getProperty("id")) && upper == 1 && !isDerived && !isReadOnly){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exampleValues2%>);
			<%}%>
		<%}%>
		dao.update<%name%>(<%name.firstLower()%>);

		// Verify result
		boolean found = false;
		for(<%name%> current<%name%> : dao.findAll<%name%>s()) {
			if (current<%name%>.equals(<%name.firstLower()%>)) {
				found = true;
				<%for (attribute.filterExistProperty("association", false)){%>
					<%if (!hasStereotype(getProperty("id")) && upper == 1 && !isDerived && !isReadOnly){%>
				Assert.assertEquals("Value <%name.firstLower()%> not modified", <%exampleValues2%>, <%featuringClassifier.name.firstLower()%>.get<%name.firstUpper()%>());
					<%}%>
				<%}%>
			}
		}
		Assert.assertTrue("<%name%> not found", found);
	}

	/**
	 * Test the suppression of an entity <%name%>.<br/>
	 * <ul><li>Step 1 : Create an entity</li>
	 * <li>Step 2 : Delete the entity</li>
	 * <li>Step 3 : Search the entity and verify it doesn't exist anymore</li></ul>
	 */
	public final void testDelete<%name%>() throws DaoException {
        // Initialized the test
		<%name%> <%name.firstLower()%> = get<%name%>Example();
		dao.create<%name%>(<%name.firstLower()%>);
		
        // Execute the tested code
		dao.delete<%name%>(<%name.firstLower()%>);
		
		// Verify result
		boolean found = false;
		for(<%name%> current<%name%> : dao.findAll<%name%>s()) {
			if (current<%name%>.equals(<%name.firstLower()%>)) {
				found = true;				
			}
		}
		Assert.assertFalse("<%name%> not deleted", found);
	}

	/**
	 * Test the search of all entities <%name%>.<br/>
	 * <ul><li>Step 1 : Create many entities</li>
	 * <li>Step 2 : Search all entities and verify the entities created are found</li></ul>
	 */
	public final void testFindAll<%name%>s() throws DaoException {
		// Verify number of element before testing
		int before = dao.findAll<%name%>s().size();
		Assert.assertTrue("FindAll must return at least 0", before >= 0);
		
        // Add two elements
		<%name%> <%name.firstLower()%>1 = get<%name%>Example();
		dao.create<%name%>(<%name.firstLower()%>1);
				
		<%name%> <%name.firstLower()%>2 = get<%name%>Example();
		dao.create<%name%>(<%name.firstLower()%>2);

		// Verify result
		int after = dao.findAll<%name%>s().size();
		Assert.assertEquals(
				"FindAll don't find the good number of elements", 
				2,
				after - before);
	}

<%feature.filter("operations").generateTest%>

	/**
	 * Create an example of <%name%>
	 */
	protected <%name%> get<%name%>Example() throws DaoException {
		// fill attributes with example values
		<%name%> <%name.firstLower()%> = new <%name%>();
		<%-- Member attributes --%>
		<%for (attribute.filterExistProperty("association",false)){%>
			<%if (!isDerived && !isReadOnly){%>
				<%if (upper == 1){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exampleValues%>);
				<%}else{%>
		List<<%type.name%>> list<%name.firstUpper()%> = new ArrayList<<%type.name%>>();
		list<%name.firstUpper()%>.add(<%exampleValues%>);
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(list<%name.firstUpper()%>);
				<%}%>
			<%}%>
		<%}%>
		<%-- Composite relation required --%>
		<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
			<%if (lower != 0){%>
			
		// <%startUserCode%> for example of <%type.name%>.<%name%> values
		<%type.name%> <%name.firstLower()%>Example = new <%type.name%>();
				<%if (upper == 1){%>
		<%association.oppositeAttributeOf(current().type).type.name.firstLower()%>.set<%name.firstUpper()%>(<%name.firstLower()%>Example);
				<%}else{%>
		<%association.oppositeAttributeOf(current().type).type.name.firstLower()%>.get<%name.firstUpper()%>().add(<%name.firstLower()%>Example);
				<%}%>
				<%if (opposite != null){%> 
				<%-- for bidirectionnal relation --%>
					<%if (opposite.upper == 1){%>
		<%name.firstLower()%>Example.set<%opposite.name.firstUpper()%>(<%class.name.firstLower()%>);		
					<%}else{%>
		<%name.firstLower()%>Example.get<%opposite.name.firstUpper()%>().add(<%class.name.firstLower()%>);		
					<%}%>
				<%}%>
		<%projectName.firstUpper()%>DaoFactory.get<%type.name%>Dao().create<%type.name%>(<%name.firstLower()%>Example);
		// <%endUserCode%> for example of <%type.name%>.<%name%> values
			<%}%>
		<%}%>
		
		return <%name.firstLower()%>;
	}
	
	/**
	 * Create a second example of <%name%> with other values
	 */
	protected <%name%> get<%name%>Example2() throws DaoException {
		// fill attributes with example values
		<%name%> <%name.firstLower()%> = new <%name%>();
		<%-- Member attributes --%>
		<%for (attribute.filterExistProperty("association",false)){%>
			<%if (!isDerived && !isReadOnly){%>
				<%if (upper == 1){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exampleValues2%>);
				<%}else{%>
		List<<%type.name%>> list<%name.firstUpper()%> = new ArrayList<<%type.name%>>();
		list<%name.firstUpper()%>.add(<%exampleValues2%>);
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(list<%name.firstUpper()%>);
				<%}%>
			<%}%>
		<%}%>
		<%-- Composite relation required --%>
		<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
			<%if (lower != 0){%>			
			
		// <%startUserCode%> for example 2 of <%type.name%>.<%name%> values
		<%type.name%> <%name.firstLower()%>Example = new <%type.name%>();
				<%if (upper == 1){%>
		<%association.oppositeAttributeOf(current().type).type.name.firstLower()%>.set<%name.firstUpper()%>(<%name.firstLower()%>Example);
				<%}else{%>
		<%association.oppositeAttributeOf(current().type).type.name.firstLower()%>.get<%name.firstUpper()%>().add(<%name.firstLower()%>Example);
				<%}%>
				<%if (opposite != null && opposite.lower != 0){%> 
				<%-- for bidirectionnal relation --%>
					<%if (opposite.upper == 1){%>
		<%name.firstLower()%>Example.set<%opposite.name.firstUpper()%>(<%class.name.firstLower()%>);		
					<%}else{%>
		<%name.firstLower()%>Example.get<%opposite.name.firstUpper()%>().add(<%class.name.firstLower()%>);		
					<%}%>
				<%}%>
		<%projectName.firstUpper()%>DaoFactory.get<%type.name%>Dao().create<%type.name%>(<%name.firstLower()%>Example);
		// <%endUserCode%> for example 2 of <%type.name%>.<%name%> values
			<%}%>
		<%}%>
		
		return <%name.firstLower()%>;
	}
	
	// <%startUserCode%> of specific tests
	// <%endUserCode%> of specific tests

}


<%script type="Operation" name="generateTest"%>
<%if (hasStereotype(getProperty("find"))){%>
	<%findTest%>
<%}%>

<%script type="Operation" name="findTest"%>
	/**
	 * Test the operation <%name%>.	 
	 * <!-- <%startUserCode%> of test documentation
	 * <!-- <%endUserCode%> of test documentation
	 */
	public void test<%name.firstUpper()%>() throws DaoException {	
		// <%startUserCode%> of test<%name%>
        // Initialized the test
		
        // Execute the tested code
		<%type.name%> <%type.name.firstLower()%> = dao.<%name%>(<%generateParameterNames%>)		
		
		// Verify result
		Assert.assertNotNull("Result sould not be null", <%type.name.firstLower()%>);
		
		// <%endUserCode%> of test<%name%>
	}

<%script type="Class" name="objectsPackage"%>
<%daoPackage%>.test
	
<%script type="Property" name="exampleValues"%>
<%if (type.name == "Integer"){%><%name.uniqueCode()%><%}else{%>
<%if (type.name == "String"){%>"my<%name.firstUpper()%>"<%}else{%>
<%if (type.name == "Boolean"){%>true<%}else{%>
<%if (type.name == "Date"){%>new Date(0)<%}else{%>
<%if (type.name == "Float"){%><%name.uniqueCode()%>.0<%}else{%>
new <%type.name%>()<%}%><%}%><%}%><%}%><%}%>

<%script type="Property" name="exampleValues2"%>
<%if (type.name == "Integer"){%><%name.uniqueCode()%><%}else{%>
<%if (type.name == "String"){%>"second<%name.firstUpper()%>"<%}else{%>
<%if (type.name == "Boolean"){%>false<%}else{%>
<%if (type.name == "Date"){%>new Date(1)<%}else{%>
<%if (type.name == "Float"){%><%name.uniqueCode()%>.0<%}else{%>
new <%type.name%>()<%}%><%}%><%}%><%}%><%}%>
