<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Entity"))) {%>
/<%hibernatePackage.toPath()%>/Hibernate<%name%>Dao.java
<%}%>

<%script type="Class" name="generateDao" file="<%fullFilePath%>"%>
package <%hibernatePackage%>;

// <%startUserCode%> for import
import java.util.Collection;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;

import fr.obeo.fwk.dao.exception.DaoException;
import fr.obeo.fwk.dao.hibernate.HibernateUtil;
import <%baseImports%>.<%projectName%>.business.<%package.normalizedName%>.<%name%>;
import <%baseImports%>.<%projectName%>.dao.<%package.normalizedName%>.api.I<%name%>Dao;

// <%endUserCode%> for import

public class Hibernate<%name%>Dao implements I<%name%>Dao {
	private final static Log log = LogFactory.getLog(Hibernate<%name%>Dao.class);

	/**
	 * Create a new element
	 * @param <%name.firstLower()%> Element to create.
	 */
	public void create<%name%>(<%name%> <%name.firstLower()%>) throws DaoException {
		log.debug("Create a new <%name%> entity");
	
		try {
			Session session = HibernateUtil.currentSession();
			session.save(<%name.firstLower()%>);

		} catch (HibernateException e) {
			throw new DaoException(e);
		}
	}

	/**
	 * Update an existing element
	 * @param <%name.firstLower()%> Element to update. If the element has an id, it may use it.
	 */
	public void update<%name%>(<%name%> <%name.firstLower()%>) throws DaoException{
		log.debug("Update the entity <%name%> with id =" + <%name.firstLower()%>.getId());
		
		try {
			Session session = HibernateUtil.currentSession();
			session.update(<%name.firstLower()%>);

		} catch (HibernateException e) {
			throw new DaoException(e);
		}
	}

	/**
	 * Delete an element
	 * @param <%name.firstLower()%> Element which will be delete. 
	 * Only id can be used to find which element must be deleted.
	 */
	public void delete<%name%>(<%name%> <%name.firstLower()%>) throws DaoException {
		log.debug("Delete the entity <%name%> with id =" + <%name.firstLower()%>.getId());
		
		try {
			Session session = HibernateUtil.currentSession();
			session.delete(<%name.firstLower()%>);

		} catch (HibernateException e) {
			throw new DaoException(e);
		}
	}

	/**
	 * Find all elements.
	 * @return A list with all elements, without any filter.
	 */
	public Collection<<%name%>> findAll<%name%>s() throws DaoException {
		log.debug("Find all instance of <%name%> entity");
		
		try {
			Session session = HibernateUtil.currentSession();
			Criteria criteria = session.createCriteria(<%name%>.class);
			Collection<<%name%>> resultList = criteria.list();
			
			log.debug("Find " + resultList.size() + " instances of <%name%> entity");
			return resultList;
			
		} catch (HibernateException e) {
			throw new DaoException(e);
		}
	}

	/**
	 * Find one entity by its primary key.
	 * @return The entity found.
	 */
	public <%name%> find<%name%>ById(String id) throws DaoException {
		log.debug("Find one instance of <%name%> entity by id : " + id);
		
		try {
			Session session = HibernateUtil.currentSession();
			Criteria criteria = session.createCriteria(<%name%>.class)
				.add(Restrictions.eq("id", id));
			<%name%> result = (<%name%>)criteria.uniqueResult();
			
			return result;
			
		} catch (HibernateException e) {
			throw new DaoException(e);
		}
	}
	

<%-- Generate additional methods d�claration --%>
<%for (ownedOperation){%>
	<%-- Generate methods with find stereotypes --%>
	<%if (hasStereotype(getProperty("find"))){%>
	<%generateJavadoc%>
	public <%returnResult.convertToJavaType%> <%name%>(<%generateParameters%>) throws DaoException {		
		// <%startUserCode%> for <%name%>
		log.debug("Call <%name%> on <%class.name%> entity");		
		try {
			Session session = HibernateUtil.currentSession();
			// TODO implementation of Hibernate of criteria search
			return null;

		} catch (HibernateException e) {
			throw new DaoException(e);
		}
		// <%endUserCode%> for <%name%>
	}
	<%}%>
<%}%>

	//<%startUserCode%>
	//<%endUserCode%>
}

<%script type="Class" name="hibernatePackage"%>
<%daoPackage%>.hibernate
