<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.sql.services.SqlTypeServices
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype(getProperty("Entity")) && superClass.isEmpty()) {%>
/<%hibernatePackage.toPath()%>/<%name%>.hbm.xml
<%}%>

<%script type="Class" name="hibernatePackage"%>
<%daoPackage%>.hibernate

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?xml version="1.0"?>
<!DOCTYPE hibernate-mapping
    PUBLIC "-//Hibernate/Hibernate Mapping DTD//EN"
    "http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd">

<hibernate-mapping>

    <class 
    	name="<%entityPackage%>.<%name%>" 
    	table="<%name.toSqlNotation()%>"  
    	dynamic-update="true">

		<!-- Technical ID -->
        <id name="id" type="string" unsaved-value="null" column="ID">
            <generator class="uuid"/>
        </id>

		<!-- Properties -->
<%attribute.filterExistProperty("association", false).genProperties%>

		<!-- Associations -->
<%getAssociations().oppositeAttributeOf(current())[isNavigable()].genAssociations%>

		<!-- Inheritance -->
<%nPush()%>
<%subClass.filterWithStereotype(getProperty("Entity")).genInheritance()%>
<%nPop()%>
    </class>

</hibernate-mapping>

<%script type="Property" name="genProperties"%>
	<%if (!isDerived && upper == 1){%>
        <property name="<%name%>">
            <column name="<%name.toSqlNotation()%>"/>
        </property>
	<%}%>
	<%-- for array
		<set name="<%name%>" table="<%_class.name.toSqlNotation()%>_<%name.toSqlNotation()%>">
			<key column="FK_<%_class.name.toSqlNotation()%>_ID"/>
			<element column="<%name.toSqlNotation()%>" type="<%type.name%>"/>
		</set>
		--%>

<%script type="Property" name="genAssociations"%>
	<%-- n---n --%>

	<%if (opposite == null){%>
	<%-- |n|-->n --%>
		<%if (upper == 1){%>
		<%-- |n|-->1 --%>
			<%if (oppositeAttribute.upper == 1){%>
			<%-- |1|-->1 --%>
		<%genDiagram("1 -} 1")%>
		<many-to-one 
			name="<%name%>" 
			class="<%type.entityPackage%>.<%type.name%>" 
			column="FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"
            cascade="persist,merge,save-update<%if (isComposite){%>,delete<%}%>"
			<%if (lower > 0){%>unique="true"<%}%>/>
        	<%}else{%>
			<%-- |*|-->1 --%>
		<%genDiagram("* -} 1")%>
		<many-to-one 
			name="<%name%>" 
			class="<%type.entityPackage%>.<%type.name%>" 
			column="FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"
			/>
        	<%}%>
        <%}else{%>
		<%-- n-->* --%>
			<%if (oppositeAttribute.upper == 1){%>
			<%-- |1|-->* --%>
		<%genDiagram("1 -} *")%>
				<%if (isOrdered){%>
		<list name="<%name%>" lazy="true" cascade="all">
			<key column="FK_<%class.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"/> 	        
	        <index column="IDX"/>	        
	        <one-to-many class="<%type.entityPackage%>.<%type.name%>"/>
	    </list>				
				<%}else{%>	
		<set name="<%name%>" lazy="true" cascade="all"> 
	        <key column="FK_<%class.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"/>	        
	        <one-to-many class="<%type.entityPackage%>.<%type.name%>"/>
	    </set>
	    		<%}%>
        	<%}else{%>
			<%-- |*|-->* --%>
		<%genDiagram("* -} *")%>
				<%if (isOrdered){%>
		<list name="<%name%>" table="<%class.name.toSqlNotation()%>_<%name.toSqlNotation()%>">
			<key column="<%class.name.toSqlNotation()%>_ID"/>
			<index column="IDX"/>
			<many-to-many 				
				class="<%type.entityPackage%>.<%type.name%>"
				column="<%type.name.toSqlNotation()%>_ID"/>
	     </list>				
				<%}else{%>
		<set name="<%name%>" table="<%class.name.toSqlNotation()%>_<%name.toSqlNotation()%>">
			<key column="<%class.name.toSqlNotation()%>_ID"/>
			<many-to-many 				
				class="<%type.entityPackage%>.<%type.name%>"
				column="<%type.name.toSqlNotation()%>_ID"/>
	     </set>
	     		<%}%>
		    <%}%>
		<%}%>
	<%}else{%>
	<%-- n<-->n --%>
		<%if (upper == 1){%>
		<%-- n<-->1 --%>
			<%if (oppositeAttribute.upper == 1){%>
			<%-- 1<-->1 --%>
				<%if (	(lower == 0 && oppositeAttribute.lower == 1) ||
						( 	!(lower == 0 && oppositeAttribute.lower == 1) && 
							isMainEndPoint() == "false"
						)
					){%> <%-- test for recursive --%>
				<%-- |1|<-->1 --%>
		<%genDiagram("1 {-} 1")%>
        <one-to-one 
        	name="<%name%>"         	
        	class="<%type.entityPackage%>.<%type.name%>" 
        	property-ref="<%opposite.name%>"
        	cascade="all"/>
	        	<%}else{%>
				<%-- 1<-->|1| --%>
		<%genDiagram("1 {-} 1")%>
        <many-to-one 
        	name="<%name%>"         	
        	class="<%type.entityPackage%>.<%type.name%>" 
            column="FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"
            cascade="all"
            <%if (lower > 0){%>unique="true"<%}%>/>
        		<%}%>
	        <%}else{%>
			<%-- *<-->1 --%>
				<%--if (	isMainEndPoint()  == "true" || opposite.upper != 1 ){--%>
    			<%-- |*|<-->1 --%>
		<%genDiagram("* {-} 1")%>
		<many-to-one 			
			class="<%type.entityPackage%>.<%type.name%>"
			column="FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"
			name="<%name%>"
			/>
	        	<%-- <%}else{%>
				<%-*<-->|1|-%>
		<%genDiagram("* {-} 1")%>
		<set name="<%name%>" inverse="true">
			<key column="FK_<%type.name.toSqlNotation()%>_<%name.toSqlNotation()%>_ID"/>
			<one-to-many class="<%baseImports%>.<%projectName%>.business.<%type.package.normalizedName%>.<%type.name%>"/>
	     </set> --%>
				<%--}--%>
			<%}%>
		<%}else{%> 
		<%-- n<-->* --%> <%-- the case *<-->1 has already be traited --%>
			<%if (oppositeAttribute.upper == 1){%>
			<%-- |1|<-->* --%>
		<%genDiagram("1 {-} *")%>
		<set name="<%name%>" inverse="true">
			<key column="FK_<%class.name.toSqlNotation()%>_<%opposite.name.toSqlNotation()%>_ID"/>			
			<one-to-many class="<%type.entityPackage%>.<%type.name%>"/>
	     </set>
			<%}else{%>
			<%-- *<-->* --%>
			
				<%if ( isMainEndPoint() == "true"){%>
				<%-- |*|<-->* --%>
		<%genDiagram("* {-} *")%>
		<set name="<%name%>" table="<%name.toSqlNotation()%>_<%opposite.name.toSqlNotation()%>">
			<key column="FK_<%name.toSqlNotation()%>_ID"/>
			<many-to-many 				
				class="<%type.entityPackage%>.<%type.name%>"
				column="<%name.toSqlNotation()%>_ID"/>
	     </set>
				<%}else{%>
				<%-- *<-->|*| --%>
		<%genDiagram("* {-} *")%>
		<set name="<%name%>" inverse="true">
			<key column="FK_<%name.toSqlNotation()%>_ID"/>
			<many-to-many 				
				class="<%type.entityPackage%>.<%type.name%>"
				column="<%name.toSqlNotation()%>_ID"/>
	     </set>
				<%}%>
			<%}%>
		<%}%>
	<%}%>

<%script type="Class" name="genInheritance"%>

		<joined-subclass			
			name="<%entityPackage%>.<%name%>" 
    		table="<%name.toSqlNotation()%>"
    		dynamic-update="true">
    		
    		<key column="FK_INHERITS_<%nPeek().name.toSqlNotation()%>_ID"/>
    		
			<!-- Properties -->
<%attribute.filterExistProperty("association", false).genProperties%>

			<!-- Associations -->
<%getAssociations().oppositeAttributeOf(current())[isNavigable()].genAssociations%>

			<!-- Inheritance -->
<%nPush()%><%subClass.genInheritance()%><%nPop()%>
    	</joined-subclass>

<%script type="Property" name="genDiagram"%>

		<!--  _<%repeat("_", oppositeAttribute().type.name.toSqlNotation().length())%>_     <%repeat(" ", args(0).length)%> _<%repeat("_", type.name.toSqlNotation().length())%>_
			 | <%oppositeAttribute().type.name.toSqlNotation()%> |- <%args(0)%> -| <%type.name.toSqlNotation()%> |
			  _<%repeat("_", oppositeAttribute().type.name.toSqlNotation().length())%>_     <%repeat(" ", args(0).length)%> _<%repeat("_", type.name.toSqlNotation().length())%>_
		-->

<%script type="Property" name="isMainEndPoint"%>
<%if (aggregation == "composite" ||
	 (oppositeAttribute.aggregation != "composite" && 
	 	(compare(class.name, type.name) > 0 || 
	 	 (class == type && compare(name, opposite.name) > 0)
	 	)
	 ))
	 {%>true<%}else{%>false<%}%>
