<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure

%>

<%script type="Class" name="classPackage"%>
<%package.getCompleteName()%>

<%script type="Interface" name="interfacePackage"%>
<%package.getCompleteName()%>


<%script type="NamedElement" name="daoPackage"%>
<%if (getProperty("useDaoPackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%eContainer().normalizedName()%><%}else{%>--%>
<%eContainer().getCompleteName()%><%}else{%>
<%baseImports%>.<%projectName%>.dao.<%eContainer().normalizedName()%>
<%}%>

<%script type="NamedElement" name="servicePackage"%>
<%if (getProperty("useServicePackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%eContainer().normalizedName()%><%}else{%>--%>
<%eContainer().getCompleteName()%><%}else{%>
<%baseImports%>.<%projectName%>.service.<%eContainer().eContainer().normalizedName()%>
<%}%>


<%script type="Class" name="serviceImplPackage"%>
<%if (getProperty("useServicePackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%package.normalizedName%>.impl<%}else{%>--%>
<%package.getCompleteName()%>.impl<%}else{%>
<%baseImports%>.<%projectName%>.service.<%package.normalizedName%>.impl
<%}%>


<%script type="NamedElement" name="uiPackage"%>
<%if (getProperty("useUiPackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%eContainer().normalizedName()%><%}else{%>--%>
<%eContainer().getCompleteName()%><%}else{%>
<%baseImports%>.<%projectName%>.ui.<%eContainer().normalizedName()%>
<%}%>

<%script type="Class" name="uiImplPackage"%>
<%if (getProperty("useUiPackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%package.normalizedName%>.impl<%}else{%>--%>
<%package.getCompleteName()%>.impl<%}else{%>
<%baseImports%>.<%projectName%>.ui.<%package.normalizedName%>.impl
<%}%>

<%script type="NamedElement" name="viewFactoryPackage"%>
<%getRootContainer().getCompleteName()%>.ui

<%script type="NamedElement" name="starterPackage"%>
<%getRootContainer().getCompleteName()%>.lifecycle

<%script type="Class" name="controllerPackage"%>
<%if (getProperty("useControllerPackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%package.normalizedName%><%}else{%>--%>
<%package.getCompleteName()%><%}else{%>
<%baseImports%>.<%projectName%>.controller.<%package.normalizedName%>
<%}%>

<%script type="Class" name="controllerImplPackage"%>
<%if (getProperty("useControllerPackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%package.normalizedName%>.impl<%}else{%>--%>
<%package.getCompleteName()%>.impl<%}else{%>
<%baseImports%>.<%projectName%>.controller.<%package.normalizedName%>.impl
<%}%>

<%script type="NamedElement" name="viewImplPackage"%>
<%if (getProperty("useViewPackage")=="no"){%>
<%--<%baseImports%>.<%projectName%>.<%eContainer().normalizedName()%>.impl<%}else{%>--%>
<%eContainer().getCompleteName()%>.impl<%}else{%>
<%baseImports%>.<%projectName%>.view.<%eContainer().normalizedName()%>.impl
<%}%>

<%script type="Class" name="configPackage"%>
<%package.getCompleteName()%>
<%--
<%if (package.name.length()>0){%>
<%baseImports%>.<%projectName%>.<%package.normalizedName%>
<%}else{%>
	<%baseImports%>.<%projectName%>
<%}%>
--%>

<%script type="Model" name="testPackage"%>
<%name%>

<%script type="Operation" name="genExceptions"%>
<%if (!raisedException.isEmpty){%>, <%raisedException.name.sep(", ")%><%}%>
	    
<%script type="Operation" name="exceptions"%>
<%raisedException.name%>


<%script type="Property" name="exempleValues"%>
<%if (type.filter("Enumeration")!=null){%><%type.name%>.<%type.filter("Enumeration").genEnum%><%}else{%>
<%if (type.name == "Integer"){%><%name.uniqueCode()%><%}else{%>
<%if (type.name == "String"){%>"my<%name.firstUpper()%>"<%}else{%>
<%if (type.name == "Boolean"){%>true<%}else{%>
<%if (type.name == "Date"){%>new Date(0)<%}else{%>
<%if (type.name == "Float"){%>new Float(<%name.uniqueCode()%>.0)<%}else{%>
new <%type.name%>()<%}%><%}%><%}%><%}%><%}%><%}%>

<%script type="Property" name="exempleValues2"%>
<%if (type.filter("Enumeration")!=null){%><%type.name%>.<%type.filter("Enumeration").genEnum%><%}else{%>
<%if (type.name == "Integer"){%><%name.uniqueCode()%><%}else{%>
<%if (type.name == "String"){%>"second<%name.firstUpper()%>"<%}else{%>
<%if (type.name == "Boolean"){%>false<%}else{%>
<%if (type.name == "Date"){%>new Date(1)<%}else{%>
<%if (type.name == "Float"){%>new Float(<%name.uniqueCode()%>.0)<%}else{%>
new <%type.name%>()<%}%><%}%><%}%><%}%><%}%><%}%>

<%script type="Enumeration" name="genEnum"%>
<%ownedLiteral.following().nFirst().name%>

<%script type="Class" name="classAttributes"%>
<%attribute + getAssociations().oppositeAttributeOf(current())[isNavigable]%>

<%script type="Class" name="operationsParameters"%>
<%ownedOperation.ownedParameter%>

<%script type="Class" name="operationsParametersTypes"%>
<%operationsParameters.type.filter("Classifier")[!name.endsWith("String") && !name.endsWith("Integer") && !name.endsWith("Float") && !name.endsWith("Long") && !name.endsWith("Double") && !name.endsWith("Boolean") && !name.startsWith("byte") && !name.endsWith("Object")].nMinimize()%>

<%script type="Class" name="genCollectionImports"%>
<%if (!operationsParameters[ (upper==-1 || upper>1) && isOrdered ].isEmpty){%>
import java.util.List;
<%}%>
<%if (!operationsParameters[ (upper==-1 || upper>1) && (!isOrdered && isUnique) ].isEmpty){%>
import java.util.Set;
<%}%>
<%if (!operationsParameters[ (upper==-1 || upper>1) && (!isOrdered && !isUnique) ].isEmpty){%>
import java.util.Collection;
<%}%>