<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common

import org.acceleo.module.pim.uml21.gen.java.spring.services.uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if (isDao){%><%daoImplPackage.toPath()%>/<%name%>Test.java<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
package <%daoImplPackage%>;

<%getAssociatedBusinessObject().put("entity")%>

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.junit.Test;

import <%baseImports%>.AbstractBusinessLayerTests;

import <%daoPackage%>.I<%name%>;

import <%get("entity").entityPackage%>.<%get("entity").name%>;

import <%get("entity").entityPackage%>.impl.<%get("entity").name%>Helper;

<%get("entity").generateImports%>

// <%startUserCode%> for import 
<%if (attribute.select("type.name == 'Date'")){%>
import java.util.Date;
<%}%>
<%if (attribute.filterExistProperty("association", false)[upper > 1 || upper == -1]){%>
import java.util.ArrayList;
import java.util.List;
<%}%>

<%for (getAssociations().oppositeAttributeOf(current())[isNavigable() && lower !=0]){%>
import <%baseImports%>.<%projectName%>.business.<%type.package.normalizedName%>.<%type.name%>;
<%}%>

// <%endUserCode%> for import

public class <%name%>Test extends AbstractBusinessLayerTests {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(<%name%>Test.class.getName()); 

	private I<%name%> <%name.firstLower()%>;
	
	@Override
	protected void onSetUp() throws Exception {
		super.onSetUp();		
				
		this.<%name.firstLower()%> = get<%name.firstUpper()%>();
		assertNotNull(<%name.firstLower()%>);
		// <%startUserCode%> of onSetUp
		 
		// <%endUserCode%> of onSetUp	 
	}

	@Override
	protected void onTearDown() throws Exception {
		super.onTearDown();
		// <%startUserCode%> of onTearDown
		 
		// <%endUserCode%> of onTearDown
	}
		
	protected I<%name%> get<%name.firstUpper()%>() throws Exception {
		I<%name%> <%name.firstLower()%> = (I<%.name%>)getApplicationContext().getBean("<%name.firstLower()%>");
		assertNotNull(<%name.firstLower()%>);		
		return <%name.firstLower()%>;
	}

	/**
	 * Test the creation of the entity <%name%>.<br/>
	 * <ul><li>Step 1 : Create an entity</li>
	 * <li>Step 2 : Search the entity and verify it exist</li></ul>
	 */
	@Test
	public final void testCreate<%name%>() throws Exception {        
        // fill attributes with exemple values
		<%get("entity").name%> <%get("entity").name.firstLower()%> = <%get("entity").name%>Helper.create<%get("entity").name.firstUpper()%>();
		
        // Execute the tested code
		<%name.firstLower()%>.create(<%get("entity").name.firstLower()%>);
		getSession().flush();

		// Verify result
		boolean found = false;
		for(<%get("entity").name%> current<%get("entity").name.firstUpper()%> : <%name.firstLower()%>.findAll()) {
			if (current<%get("entity").name.firstUpper()%>.equals(<%get("entity").name.firstLower()%>)) {
				found = true;
			}
		}
		assertTrue("<%get("entity").name%> not created", found);
		
	}
	
	/**
	 * Test the modification of an entity <%name%>.<br/>
	 * <ul><li>Step 1 : Create an entity</li>
	 * <li>Step 2 : Modify the entity</li>
	 * <li>Step 3 : Search the entity and verify the modified values</li></ul>
	 */
	@Test
	public final void testSave<%name%>() throws Exception {
        // Initialized the test
		<%get("entity").name%> <%get("entity").name.firstLower()%> = <%get("entity").name%>Helper.create<%get("entity").name.firstUpper()%>();
		<%name.firstLower()%>.create(<%get("entity").name.firstLower()%>);		
		
        // Execute the tested code
        <%-- Member attributes --%>
		<%for (get("entity").attribute.filterExistProperty("association",false)){%>
			<%if (!isDerived && !isReadOnly){%>
				<%if (upper == 1){%>
					<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exempleValues2%>);
				<%}else{%>
					List<<%type.name%>> list<%name.firstUpper()%> = new ArrayList<<%type.name%>>();
					list<%name.firstUpper()%>.add(<%exemple2Values%>);
					<%class.name.firstLower()%>.set<%name.firstUpper()%>(list<%name.firstUpper()%>);
				<%}%>
			<%}%>
		<%}%>
        
		<%-- TODO
		<%for (getAssociationProperties(true)){%>
			<%if (!hasStereotype(getProperty("id")) && upper == 1 && !isDerived && !isReadOnly){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exempleValues2%>);
			<%}%>
		<%}%>
		--%>
		<%name.firstLower()%>.save(<%get("entity").name.firstLower()%>);
		getSession().flush();

		// Verify result
		boolean found = false;
		for(<%get("entity").name%> current<%get("entity").name%> : <%name.firstLower()%>.findAll()) {
			if (current<%get("entity").name%>.equals(<%get("entity").name.firstLower()%>)) {
				found = true;
				<%-- TODO
				<%for (getAssociationProperties(true)){%>
					<%if (!hasStereotype(getProperty("id")) && upper == 1 && !isDerived && !isReadOnly){%>
				assertEquals("Value <%get("entity").name.firstLower()%> not modified", <%exempleValues2%>, <%featuringClassifier.name.firstLower()%>.get<%name.firstUpper()%>());
					<%}%>
				<%}%>
				--%>
			}
		}
		
		assertTrue("<%get("entity").name%> not found", found);
	}
	
	/**
	 * Test the suppression of an entity <%name%>.<br/>
	 * <ul><li>Step 1 : Create an entity</li>
	 * <li>Step 2 : Delete the entity</li>
	 * <li>Step 3 : Search the entity and verify it doesn't exist anymore</li></ul>
	 */
	@Test
	public final void testDelete<%name%>() throws Exception {
        // Initialized the test
		<%get("entity").name%> <%get("entity").name.firstLower()%> = <%get("entity").name%>Helper.create<%get("entity").name.firstUpper()%>();
		<%name.firstLower()%>.create(<%get("entity").name.firstLower()%>);
    	
        // Execute the tested code
		<%name.firstLower()%>.delete(<%get("entity").name.toL1Case()%>);		
		getSession().flush();
		
		// Verify result
		boolean found = false;		
		for(<%get("entity").name%> current<%get("entity").name%> : <%name.firstLower()%>.findAll()) {
			if (current<%get("entity").name%>.equals(<%get("entity").name.firstLower()%>)) {
				found = true;		
			}
		}
		
		assertFalse("<%name%> not deleted", found);
	}
	
	
<%--
	/**
	 * Test the search of all entities <%name%>.<br/>
	 * <ul><li>Step 1 : Create many entities</li>
	 * <li>Step 2 : Search all entities and verify the entities created are found</li></ul>
	 */
	public final void testFindAll<%name%>s() throws DaoException {
		// Verify number of element before testing
		int before = dao.findAll<%name%>s().size();
		assertTrue("FindAll must return at least 0", before >= 0);
		
        // AclassAttributesdd two elements
		<%name%> <%name.firstLower()%>1 = get<%name%>Exemple();
		dao.create<%name%>(<%name.firstLower()%>1);
				
		<%name%> <%name.firstLower()%>2 = get<%name%>Exemple();
		dao.create<%name%>(<%name.firstLower()%>2);

		// Verify result
		int after = dao.findAll<%name%>s().size();
		assertEquals(
				"FindAll don't find the good number of elements", 
				2,
				after - before);
	}

	// feature.filter("operations").generateTest 
	
		// <%startUserCode%> for exemple 2 of <%type.name%>.<%name%> values
		<%type.name%> <%name.firstLower()%>Exemple = new <%type.name%>();
				<%if (upper == 1){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%name.firstLower()%>Exemple);
				<%}else{%>
		<%class.name.firstLower()%>.get<%name.firstUpper()%>().add(<%name.firstLower()%>Exemple);
				<%}%>
				<%if (opposite != null && opposite.lower != 0){%> 
				// for bidirectionnal relation 
					<%if (opposite.upper == 1){%>
		<%name.firstLower()%>Exemple.set<%opposite.name.firstUpper()%>(<%class.name.firstLower()%>);		
					<%}else{%>
		<%name.firstLower()%>Exemple.get<%opposite.name.firstUpper()%>().add(<%class.name.firstLower()%>);		
					<%}%>
				<%}%>
		<%projectName.firstUpper()%>DaoFactory.get<%type.name%>Dao().create<%type.name%>(<%name.firstLower()%>Exemple);
		// <%endUserCode%> for <%type.name%>.<%name%>
			<%}%>
		<%}%>
		
		return <%name.firstLower()%>;
	}
--%>

	// <%startUserCode%> of specific tests
	// <%endUserCode%> of specific tests

}
