<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>
<%script type="Class" name="fullFilePath"%>
<%if (isDao){%><%daoImplPackage.toPath()%>/<%name%>Impl.java<%}%>

<%script type="Class" name="generateDao" file="<%fullFilePath%>"%>
package <%daoImplPackage%>;

<%getAssociatedBusinessObject().put("entity")%>

import java.io.Serializable;
import java.util.Collection;

import org.sharengo.exceptions.TechnicalException;
import org.sharengo.orm.hibernate.AbstractHibernateDAO;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

<%if (operationsParametersTypes.isEmpty()){%>
import <%get("entity").entityPackage%>.<%get("entity").name%>;
<%}else{%>
	<%for (operationsParametersTypes){%>
		<%if (hasStereotype(getProperty("Entity"))){%>
import <%get("entity").entityPackage%>.<%name%>;
		<%}else{%>
import <%getCompleteName()%>;	
		<%}%>
	<%}%>
<%}%>

<%genCollectionImports%>
import <%daoPackage%>.I<%name%>;

<%iocImport("Dao")%>

// <%startUserCode%> for import

// <%endUserCode%> for import

public class <%name%>Impl extends AbstractHibernateDAO<<%get("entity").name%>> implements I<%name%> {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(<%name%>Impl.class.getName()); 
 	
 	<%iocAccessors("Dao")%>
 	
	// Custom operations
	<%for (ownedOperation){%>
	<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) throws TechnicalException{
		// <%startUserCode%> of <%generateReturn%> <%name%>(<%generateParameters%>)
		return <%returnResult().getDefaultValue()%>;
		// <%endUserCode%>
	}
	<%}%>
	
 	// Associations	
	<%getAssociationProperties(true).genAssociations%>
}

<%script type="Property" name="genAssociations"%>
<%if (type.filter("Classifier").isDao){%>

	<%type.name%> <%type.name.firstLower()%>=null;
	public <%type.name%> get<%type.name.firstUpper()%>() {
 		return <%type.name.firstLower()%>;
 	}

 	public void set<%type.name.firstUpper()%>(<%type.name%> <%type.name.firstLower()%>) {
 		this.<%type.name.firstLower()%> = <%type.name.firstLower()%>;
 	} 	
<%}%>
