<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%-- 
This template generate Data Transfert Objects.
It is used for data exchange between UI and Persistence layers
--%>


<%script type="Class" name="fullFilePath"%>
<%if (isDto){%>
<%if (getProperty("useDtoPackage")=="no"){%>
/<%dtoPackage.toPath()%>/<%name%>.java
<%}else{%>
/<%dtoPackage.toPath()%>/<%name%>Dto.java
<%}%>
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- DTO class generation--%>
package <%dtoPackage%>;

import java.io.Serializable;
<%if (classAttributes[(upper == -1 || upper > 1)].nSize() > 0){%>
import java.util.Collections;
	<%if (classAttributes[(upper == -1 || upper > 1) && isOrdered].nSize() > 0){%>
import java.util.List;
import java.util.ArrayList;
	<%}%>
	<%if ( classAttributes[(upper == -1 || upper > 1) && isUnique && !isOrdered].nSize() > 0){%>
import java.util.Set;
import java.util.HashSet;
	<%}%>
	<%if ( classAttributes[(upper == -1 || upper > 1) && !isUnique && !isOrdered].nSize() > 0){%>
import java.util.Collection;
		<%if (classAttributes[(upper == -1 || upper > 1) && isOrdered].nSize() == 0){%>
import java.util.ArrayList;
		<%}%>
	<%}%>	
<%}else if ( ownedOperation.ownedParameter[upper == -1].nSize() > 0){%>
import java.util.Collection;
<%}%>


// <%startUserCode%> for import

// <%endUserCode%>  for import

/**
 * <%ownedComment.body%>
 */
<%if (getProperty("useDtoPackage")=="no"){%>
public class <%name%><%extensions%> {
<%}else{%>
public class <%name%>Dto<%extensions%> {
<%}%>

	// serialVersionUID is used for serialization.
	private static final long serialVersionUID = 1L;

<%-- Generate attributes --%> 
<%for (classAttributes){%>
	protected <%convertToJavaType%> <%name%>;
<%}%>

	/**
	 * Default constructor 
	 */
	public <%name%>() {
		super();
		<%-- initialize list --%>
		<%for (classAttributes){%>
			<%if (upper != 1){%>
				<%if (isOrdered || (!isOrdered && !isUnique)){%>
		this.<%name%> = new ArrayList<<%type.name%>>();
				<%}else{%>
		this.<%name%> = new HashSet<<%type.name%>>();
				<%}%>
			<%}%>
		<%}%>				
	}

<%if (!classAttributes.isEmpty){%>
	/**
	 * Constructor with all parameters initialized
	<%for (classAttributes){%>
	 * @param <%name%> <%ownedComment.body%>
	<%}%>
	 */	
	public <%name%>(<%getConstructorArgs%>) {	
	<%for (classAttributes){%>
		this.<%name%> = <%name%>;
	<%}%>
	}	
<%}%>

<%-- Generate getters and setters --%>
<%for (classAttributes) {%>

<%-- Deals with Lists --%>
	<%if (upper == -1){%>
		<%generateOpForList%>
	<%}else{%>
		<%generateOp%>
	<%}%>
	
<%}%>

<%for (ownedOperation){%>
<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) {
    	// <%startUserCode%> of <%name%>
        	// TODO implement <%name%>
            throw new UnsupportedOperationException("Method not yet implemented");
		// <%endUserCode%>
	}
<%}%>

/** 
 * Equality test based attributes values
 * @param value Value to compare
 */
public boolean equals(Object other) {
	if (this == other) {
		return true;
	}
	if ( ! (other instanceof <%name%>)) {
		return false;
	}
	
	final <%name%> <%name.firstLower()%> = (<%name%>) other;
	
	<%for (attribute.filterExistProperty("association",false)) {%>
		<%if (type.isJavaPrimitiveType() == "true"){%>
	if ( <%name%> != <%class.name.firstLower()%>.get<%name.firstUpper()%>()  ) return false;
		<%}else{%>
	if ( (	<%name%> == null && <%class.name.firstLower()%>.get<%name.firstUpper()%>() != null) || 
		 (	<%name%> != null && !<%name%>.equals(<%class.name.firstLower()%>.get<%name.firstUpper()%>()) ) 
	   ) return false;
		<%}%>
	<%}%>
	
	return true;
}

}

<%script type="Class" name="extensions"%>
<%-- Manage extensions --%>
<%extends%><%implements%>

<%script type="Class" name="extends"%>
<%if (!general.isEmpty){%> extends <%general.name%><%}%>

<%script type="Class" name="implements"%>
 implements Serializable<%if (!interfaceRealization.isEmpty){%>, <%interfaceRealization.supplier.name.sep(", ")%><%}%>

<%script type="Class" name="getConstructorArgs"%>
<%classAttributes.asParameter.sep(", ")%>
 
<%script type="Property" name="asParameter"%>
<%-- Used to render an attribute as a parameter of a method --%>
<%convertToJavaType%> <%name%>

<%script type="Property" name="generateOp"%>
<%-- Manage Getters and Setters --%>
	/**
	 * Return <%name%>
	 * @return <%ownedComment.body%>
	 */
	public <%convertToJavaType%> get<%name.firstUpper()%>() {
		return <%name%>;
	}

	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> <%ownedComment.body%>
	 */
	public void set<%name.firstUpper()%>(<%convertToJavaType%> <%name%>) {
		this.<%name%> = <%name%>;
<%if (opposite != null){%>
		this.<%name%>.set<%featuringClassifier.name%>(this);
<%}%>
	}

<%script type="Property" name="generateOpForList"%>
<%-- Manage Getters and Setters fir List objects --%>
	/**
	 * Return <%name%>
	 * @return A list of <%type%>. <%ownedComment.body%>
	 */
	public <%convertToJavaType%> get<%name.firstUpper()%>() {		
		<%if (isOrdered){%>
		return Collections.unmodifiableList(<%name%>);
		<%}else if(isUnique){%>
		return Collections.unmodifiableSet(<%name%>);
		<%}else{%>
		return Collections.unmodifiableCollection(<%name%>);
		<%}%>		
	}

	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> A list of <%type%>. <%ownedComment.body%>
	 */
	public void set<%name.firstUpper()%>(<%convertToJavaType%> <%name%>) {
		this.<%name%> = <%name%>;
	}
	
	/**
	 * Add an element to the list <%name%>.
	 * @param elementToAdd Element of type <%type%> to add
	 */
	public void add<%name.firstUpper()%>(<%type.convertDtoToJavaType%> elementToAdd) {
		this.<%name%>.add(elementToAdd);
		<%if (opposite != null){%>
			<%if (upper != 1){%>
		elementToAdd.add<%owner%>(this);
			<%}else{%>
		elementToAdd.set<%owner%>(this);
			<%}%>
		<%}%>
	}
	
	/**
	 * Remove an element to the list <%name%>.
	 * @param elementToRevmoe Element of type <%type%> to add
	 */
	public void remove<%name.firstUpper()%>(<%type.convertDtoToJavaType%> elementToRemove) {
		this.<%name%>.remove(elementToRemove);
<%if (opposite != null){%>
			<%if (upper != 1){%>
		elementToAdd.remove<%owner%>(this);
			<%}else{%>
		elementToAdd.set<%owner%>(null);
			<%}%>
		<%}%>
	}
	
<%script type="Class" name="classAttributes"%>
<%attribute + getAssociations().oppositeAttributeOf(current())[isNavigable]%>

<%script type="Type" name="convertDtoToJavaType"%>
<%if ( hasStereotype("Dto") ){%><%name%>Dto<%}else{%>
<%convertToJavaType%><%}%>	
