<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
%>

<%script type="Class" name="fullFilePath"%>
<%if ( isBusinessException ){%>/<%classPackage.toPath()%>/<%name%>.java<%}%>

<%script type="Class" name="generateJavaClass" file="<%fullFilePath%>"%>
package <%classPackage%>;

import org.sharengo.exceptions.BusinessException;

<%for (operationsParametersTypes){%>
import <%getCompleteName()%>;	
<%}%>
<%genCollectionImports%>

// <%startUserCode%> for import

// <%endUserCode%> for import

/**
 * <%ownedComment.body%>
 */
public class <%name%><%extensions%> {

<%-- Generate attributes --%>
<%for (attribute){%>	
	<%visibility%> <%type.convertToJavaType%> <%name%>;
<%}%>

	/**
	 * Default constructor 
	 */
	public <%name%>() {
		super();
	}

<%if (!attribute.isEmpty){%>
	/**
	 * Constructor with all parameters initialized
	<%for (attribute){%>
	 * @param <%name%> <%ownedComment.body%>
	<%}%>
	 */	
	public <%name%>(<%attribute.asParameter.sep(", ")%>) {

	<%for (attribute){%>
		this.<%name%> = <%name%>;
	<%}%>
	}	
<%}%>

<%-- Generate operations --%>
<%for (ownedOperation){%>
<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) {
	    // <%startUserCode%> of <%name%>
	    // TODO implement <%name%>
	    throw new UnsupportedOperationException("Method not yet implemented");
	    // <%endUserCode%> of <%name%>
	}
<%}%>

	// <%startUserCode%> other operations
	
	// <%endUserCode%> other operations

}


<%script type="Class" name="extensions"%>
<%-- Manage extensions --%>
<%extends%><%implements%>

<%script type="Class" name="extends"%>
 extends BusinessException<%if (!general.isEmpty){%>, <%general.name%><%}else{%> <%}%>

<%script type="Class" name="implements"%>
<%if (!interfaceRealization.isEmpty ){%> implements <%interfaceRealization.asClass.sep(", ")%><%}%>

<%script type="InterfaceRealization" name="asClass"%>
<%supplier.name%>

<%script type="Property" name="asParameter"%>
<%-- Used to render an attribute as a parameter of a method --%>
<%type.convertToJavaType%> <%name%>
