<%--
  Copyright © 2007 Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure

%>
<%-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ --%>
<%script type="Classifier" name="isConfig"%>
<%hasStereotype(getProperty("Config"))%>

<%script type="Classifier" name="isDao"%>
<%hasStereotype(getProperty("Dao"))%>

<%script type="Parameter" name="isDto"%>
<%type.isDto%>

<%script type="Parameter" name="isEntity"%>
<%type.isEntity%>

<%script type="Type" name="isDto"%>
<%hasStereotype(getProperty("Dto"))%>

<%script type="Type" name="isEntity"%>
<%hasStereotype(getProperty("Entity"))%>

<%script type="Classifier" name="isController"%>
<%hasStereotype(getProperty("Controller"))%>

<%script type="Classifier" name="isUi"%>
<%hasStereotype(getProperty("Ui"))%>

<%script type="Classifier" name="isView"%>
<%hasStereotype(getProperty("View"))%>

<%script type="Classifier" name="isService"%>
<%hasStereotype(getProperty("Service"))%>

<%script type="Classifier" name="isRemote"%>
<%hasStereotype(getProperty("Remote"))%>

<%script type="Classifier" name="isBusinessException"%>
<%hasStereotype(getProperty("BusinessException"))%>

<%script type="Classifier" name="isException"%>
<%hasStereotype(getProperty("Exception"))%>

<%script type="Operation" name="isRemote"%>
<%hasStereotype(getProperty("Remote"))%>

<%script type="Operation" name="isTransactional"%>
<%hasStereotype(getProperty("Transactional"))%>

<%-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ --%>

<%script type="Model" name="configs"%>
<%eAllContents("Class")[isConfig]%>

<%script type="Model" name="daos"%>
<%eAllContents("Class")[isDao]%>

<%script type="Model" name="entities"%>
<%eAllContents("Class")[isEntity]%>

<%script type="Model" name="controllers"%>
<%eAllContents("Class")[isController]%>

<%script type="Model" name="uis"%>
<%eAllContents("Class")[isUi]%>

<%script type="Model" name="views"%>
<%eAllContents("Class")[isView]%>

<%script type="Model" name="services"%>
<%eAllContents("Class")[isService].filter("Class")%>
 
<%script type="Model" name="webservices"%>
<%eAllContents("Class")[isService && ownedOperation[isRemote].nSize()>0]%>

<%-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ --%>

<%script type="Class" name="viewDependencies"%>
<%clientDependency.supplier.filter("Classifier")[isView]%>

<%script type="Class" name="serviceDependencies"%>
<%clientDependency.supplier.filter("Classifier")[isService]%>

<%script type="Class" name="uiDependencies"%>
<%clientDependency.supplier.filter("Classifier")[isUi]%>

<%script type="Class" name="daoDependencies"%>
<%clientDependency.supplier.filter("Classifier")[isDao]%>

<%-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ --%>
