<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.services.StringServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if ( isService ){%><%serviceImplPackage.toPath()%>/<%name%>Impl.java<%}%>

<%script type="Class" name="generateService" file="<%fullFilePath%>"%>
package <%serviceImplPackage%>;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.sharengo.exceptions.TechnicalException;

import <%servicePackage%>.I<%name%>;

<%if (!ownedOperation[isRemote].isEmpty){%>
import <%servicePackage%>.I<%name%>WebService;
<%}%>

<%for (operationsParametersTypes){%>
	<%if (filter("Classifier").isEntity){%>
import <%entityPackage%>.<%name%>;
	<%}else if (filter("Classifier").isView){%>
import <%viewImplPackage%>.<%name%>;
	<%}else{%>
import <%getCompleteName()%>;	
	<%}%>
<%}%>

<%genCollectionImports%>

<%if (!superClass.isEmpty && superClass.isService){%> 
import <%superClass.serviceImplPackage%>.<%superClass.name%>Impl;
<%}%>

<%for (ownedOperation){%>
	<%for (raisedException){%>
import <%getCompleteName()%>;
	<%}%>
<%}%>

<%iocImport("Dao")%>
<%iocImport("Service")%>
<%iocImport("Config")%>

// <%startUserCode%> for import

// <%endUserCode%> for import

public class <%name%>Impl<%extensions%> {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(<%name%>Impl.class.getName()); 

	<%iocAccessors("Dao")%>
	<%iocAccessors("Service")%>
	<%iocAccessors2("Config")%>
	
	<%for (ownedOperation){%>
	<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) throws TechnicalException<%genExceptions%> {
		// <%startUserCode%> of <%generateReturn%> <%name%>(<%generateParameters%>)
        // TODO implement <%name%>
        throw new UnsupportedOperationException("Method not yet implemented");
        // <%endUserCode%>
        }
        
	<%}%>
	
	// Associations	
	<%--attribute.filterExistProperty("association", true).genAssociations--%>	
	<%getAssociationProperties(true).genAssociations%>
	
	// <%startUserCode%> private methods

	// <%endUserCode%> private methods
		
}

<%script type="Property" name="genAssociations"%>
<%if (type.filter("Classifier").isDao){%>

	I<%type.name%> <%type.name.firstLower()%>=null;
	public I<%type.name%> get<%type.name.firstUpper()%>() {
 		return <%type.name.firstLower()%>;
 	}

 	public void set<%type.name.firstUpper()%>(I<%type.name%> <%type.name.firstLower()%>) {
 		this.<%type.name.firstLower()%> = <%type.name.firstLower()%>;
 	} 	
<%}%>

<%script type="Class" name="extensions"%>
<%extends%><%implements%>

<%script type="Class" name="extends"%>
<%if (!superClass.isEmpty && superClass.isService){%> extends <%superClass.name%>Impl<%}%>

<%script type="Class" name="implements"%>
 implements I<%name%><%if (!ownedOperation[isRemote].isEmpty){%>, I<%name%>WebService<%}%>
