<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
<%if (services){%>META-INF/spring/<%baseImports%>/layer-services.xml<%}%>

<%script type="Model" name="springApplicationContext" file="<%fullFilePath%>"%>
<?xml version="1.0" encoding="UTF-8"?>

<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:aop="http://www.springframework.org/schema/aop"
	xmlns:tx="http://www.springframework.org/schema/tx"
	xmlns:jee="http://www.springframework.org/schema/jee"
	xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
           http://www.springframework.org/schema/aop http://www.springframework.org/schema/aop/spring-aop-2.0.xsd
           http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-2.0.xsd
           http://www.springframework.org/schema/jee http://www.springframework.org/schema/jee/spring-jee-2.0.xsd">

	<%for (services) {%>	
	<bean id="<%computeBeanId()%>" class="<%serviceImplPackage%>.<%name%>Impl">		
		<%iocInjectors("Dao")%>
		<%iocInjectors("Service")%>
		<%iocInjectors("Config")%>
	</bean>
	<%}%>
<%--
	<%if (hasServicesTransactionOperations()){%>
		<bean id="transactionManager"
			class="org.springframework.orm.hibernate3.HibernateTransactionManager">
			<property name="sessionFactory" ref="sessionFactory" />
		</bean>
	<%}%>
--%>

<%for (services) {%>	
	<tx:advice id="txAdvice<%name%>" transaction-manager="transactionManager">
		<tx:attributes>
			<%for (ownedOperation[isTransactional]){%>
			<tx:method name="<%name%>" <%if (isTransactionalPropagationValueSpecified()){%>propagation="<%getTransactionalPropagationValue()%>"<%}%> <%if (isTransactionalIsolationValueSpecified()){%>isolation="<%getTransactionalIsolationValue()%>"<%}%>/>
			<%}%>
			<tx:method name="*" read-only="true"/>
		</tx:attributes>
	</tx:advice>
	<aop:config>
		<aop:advisor pointcut="execution(* *..<%name%>.*(..))" advice-ref="txAdvice<%name%>" />
	</aop:config>
<%}%>
</beans>
