<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common

import org.acceleo.module.pim.uml21.gen.java.spring.services.uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>


<%script type="Class" name="fullFilePath"%>
<%if ( isEntity ){%>
<%daoImplPackage.toPath()%>/<%name%>Helper.java
<%}%>

<%script type="Class" name="generateEntityTestHelper" file="<%fullFilePath%>"%>
package <%daoImplPackage%>;

import <%getCompleteName()%>;

<%generateImports%>

<%if (classAttributes.select("(upper == -1 || upper > 1)").nSize() > 0){%>
	<%if (classAttributes.select("(upper == -1 || upper > 1) && isOrdered").nSize() > 0){%>
import java.util.List;
import java.util.ArrayList;
	<%}%>
	<%if ( classAttributes.select("(upper == -1 || upper > 1) && isUnique && !isOrdered").nSize() > 0){%>
import java.util.Set;
import java.util.HashSet;
	<%}%>
	<%if ( classAttributes.select("(upper == -1 || upper > 1) && !isUnique && !isOrdered").nSize() > 0){%>
import java.util.Collection;
		<%if (classAttributes.select("(upper == -1 || upper > 1) && isOrdered").nSize() == 0){%>
import java.util.HashSet;
		<%}%>
	<%}%>	
<%}%>

// <%startUserCode%> for import 
<%if (attribute[type.name == "Date"]){%>
import java.util.Date;
<%}%>

<%if (attribute.filterExistProperty("association", false)[upper > 1 || upper == -1]){%>
import java.util.ArrayList;
import java.util.List;
<%}%>
// <%endUserCode%> for import

<%put("entity")%>

public class <%name%>Helper {

	/**
	 * Create an example of <%name%>
	 */
	public static <%name%> create<%name.firstUpper()%>() {
		// fill attributes with exemple values
		<%name%> <%name.firstLower()%> = new <%name%>();

		<%-- Member attributes --%>
		<%for (attribute.filterExistProperty("association",false)){%>
			<%if (!isDerived && !isReadOnly){%>
				<%if (upper == 1){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exempleValues%>);
				<%}else{%>		
		<%globalType%><<%type.name%>> list<%name.firstUpper()%> = new <%implType%><<%type.name%>>();
		list<%name.firstUpper()%>.add(<%exempleValues%>);		
		<%parent().name.firstLower()%>.set<%name.firstUpper()%>(list<%name.firstUpper()%>);
				<%}%>
			<%}%>
		<%}%>
		// Composite relation required 
		<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
			<%if (lower != 0){%>
			
		// <%startUserCode%> for example of <%type.name%>.<%name%> values
		<%type.name%> <%name.firstLower()%> = new <%type.name%>();
				<%if (upper == 1){%>
		<%get("entity").name.firstLower()%>.set<%name.firstUpper()%>(<%name.firstLower()%>);
				<%}else{%>
		<%get("entity").name.firstLower()%>.get<%name.firstUpper()%>().add(<%name.firstLower()%>);
				<%}%>
				<%if (opposite != null){%>
				// for bidirectionnal relation 
					<%if (opposite.upper == 1){%>
		<%name.firstLower()%>.set<%opposite.name.firstUpper()%>(<%name.firstLower()%>);		
					<%}else{%>
		<%name.firstLower()%>.get<%opposite.name.firstUpper()%>().add(<%name.firstLower()%>);		
					<%}%>
				<%}%>		
			<%}%>
		// <%endUserCode%> for example of <%type.name%>.<%name%> values
		<%}%>	
		return <%name.firstLower()%>;
	}

<%--	
	/**
	 * Create a second exemple of <%name%> with other values
	 */
	protected <%name%> get<%name%>Exemple2() throws DaoException {
		// fill attributes with exemple values
		<%name%> <%name.firstLower()%> = new <%name%>();
		// Member attributes 
		<%for (attribute.filterExistProperty("association",false)){%>
			<%if (!isDerived && !isReadOnly){%>
				<%if (upper == 1){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%exempleValues2%>);
				<%}else{%>
		List<<%type.name%>> list<%name.firstUpper()%> = new ArrayList<<%type.name%>>();
		list<%name.firstUpper()%>.add(<%exempleValues2%>);
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(list<%name.firstUpper()%>);
				<%}%>
			<%}%>
		<%}%>
		// Composite relation required 
		<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
			<%if (lower != 0){%>			
			
		// <%startUserCode%> for exemple 2 of <%type.name%>.<%name%> values
		<%type.name%> <%name.firstLower()%>Exemple = new <%type.name%>();
				<%if (upper == 1){%>
		<%class.name.firstLower()%>.set<%name.firstUpper()%>(<%name.firstLower()%>Exemple);
				<%}else{%>
		<%class.name.firstLower()%>.get<%name.firstUpper()%>().add(<%name.firstLower()%>Exemple);
				<%}%>
				<%if (opposite != null && opposite.lower != 0){%> 
				// for bidirectionnal relation 
					<%if (opposite.upper == 1){%>
		<%name.firstLower()%>Exemple.set<%opposite.name.firstUpper()%>(<%class.name.firstLower()%>);		
					<%}else{%>
		<%name.firstLower()%>Exemple.get<%opposite.name.firstUpper()%>().add(<%class.name.firstLower()%>);		
					<%}%>
				<%}%>
		<%projectName.firstUpper()%>DaoFactory.get<%type.name%>Dao().create<%type.name%>(<%name.firstLower()%>Exemple);
		// <%endUserCode%> for <%type.name%>.<%name%>
			<%}%>
		<%}%>
		
		return <%name.firstLower()%>;
	}
--%>

	// <%startUserCode%> for others helpers
	// <%endUserCode%> for others helpers

}

<%script type="Class" name="classAttributes"%>
<% attribute + getAssociations().oppositeAttributeOf(current()) %>

<%script type="Property" name="globalType"%>
<%if (isOrdered) {%>List<%}else if (isUnique){%>Set<%}else{%>Collection<%}%>

<%script type="Property" name="implType"%>
<%if (isOrdered) {%>ArrayList<%}else{%>HashSet<%}%>