<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
META-INF/spring/<%baseImports%>/applicationContext-tests.xml

<%script type="Model" name="springApplicationContext" file="<%fullFilePath%>"%>
<?xml version="1.0" encoding="UTF-8"?>

<beans xmlns="http://www.springframework.org/schema/beans"
	     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	     xmlns:jee="http://www.springframework.org/schema/jee"
	     xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
           http://www.springframework.org/schema/jee http://www.springframework.org/schema/jee/spring-jee-2.0.xsd">

	<bean id="dataSource" class="org.springframework.jdbc.datasource.DriverManagerDataSource">
	    <property name="driverClassName" value="org.hsqldb.jdbcDriver"/>
    	<property name="url" value="jdbc:hsqldb:."/>
	    <property name="username" value="sa"/>
    	<property name="password" value=""/>
  	</bean>
  		
	<!-- ========================= HIBERNATE CONFIGURATION ====================== -->

	<bean id="sessionFactory" class="org.springframework.orm.hibernate3.LocalSessionFactoryBean">
		<property name="dataSource" ref="dataSource"/>
		<property name="mappingResources">
			<list>			
			<%for (entities[superClass.isEmpty()]){%>
        		<value><%hibernatePackage.toPath()%>/<%name%>.hbm.xml</value>			
			<%}%>
				<!-- <%startUserCode%> other hbm files-->
				 
				<!-- <%endUserCode%> -->
			</list>
		</property>
		<property name="hibernateProperties">
			<props>
				<prop key="hibernate.dialect">org.hibernate.dialect.HSQLDialect</prop>
				<prop key="hibernate.show_sql">true</prop>
				<prop key="hibernate.generate_statistics">true</prop>
 				<prop key="hibernate.hbm2ddl.auto">create</prop> 
 				<prop key="hibernate.jdbc.batch_size">1</prop>
			</props>
		</property>
	</bean>
	
	<!-- <%startUserCode%> specific test injection-->
	
	<!-- <%endUserCode%> specific test injection -->
	
</beans>

<%script type="Class" name="hibernatePackage"%>
<%daoPackage%>.hibernate