<%--
  Copyright © 2007 Laurent BELMONTE & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Laurent Belmonte <laurent.belmonte@gmail.com>  
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
<%if (controllers){%>META-INF/spring/<%baseImports%>/layer-controllers.xml<%}%>

<%script type="Model" name="springApplicationContext" file="<%fullFilePath%>"%>
<?xml version="1.0" encoding="UTF-8"?>

<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:aop="http://www.springframework.org/schema/aop"
	xmlns:tx="http://www.springframework.org/schema/tx"
	xmlns:jee="http://www.springframework.org/schema/jee"
	xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
           http://www.springframework.org/schema/aop http://www.springframework.org/schema/aop/spring-aop-2.0.xsd
           http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-2.0.xsd
           http://www.springframework.org/schema/jee http://www.springframework.org/schema/jee/spring-jee-2.0.xsd">

<%for (controllers) {%>	
 	<!-- controller -->
 	<bean id="<%name.toL1Case()%>Delegation" class="org.springframework.web.servlet.mvc.multiaction.MultiActionController">
	  <property name="delegate" ref="<%name.toL1Case()%>"/>
	</bean>

	<bean id="<%name.toL1Case()%>" 
		class="<%servicePackage%>.<%name%>">		
	 	<%for (serviceDependencies+uiDependencies){%>
	 	<property name="<%name.firstLower()%>" ref="<%computeBeanId()%>"/>			
	 	<%}%>
	</bean>
<%}%>

<%-- FIXME maybe use PropertiesMethodNameResolver --%>
<bean id="urlMapping"  class="org.springframework.web.servlet.handler.SimpleUrlHandlerMapping">
   <property name="mappings">
      <props>
<%for (controllers) {%>	
        <prop key="/<%name.toL1Case()%>/**"><%name.toL1Case()%>Delegation</prop> 
<%}%>
		<!-- <%startUserCode%> urlMapping mappings -->		
		<!-- <%endUserCode%> urlMapping mappings -->			
      </props>
   </property>   
   <property name="interceptors">
		<list>
			<!-- <%startUserCode%> urlMapping interceptors -->
			<!-- <ref bean="openSessionInViewInterceptor" /> --> 
			<!-- <%endUserCode%> urlMapping interceptors -->			
		</list>
	</property>
	<!-- <%startUserCode%> urlMapping custom --> 
	<!-- <%endUserCode%> urlMapping custom -->	
</bean>

<!-- <%startUserCode%> custom -->
<!-- <%endUserCode%> custom -->
	
</beans>