<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.ui.web.velocity.ui
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if (isUi){%>
	<%uiImplPackage.toPath()%>/<%name%>Impl.java
<%}%>

<%script type="Class" name="generateUi" file="<%fullFilePath%>"%>
package <%uiImplPackage%>;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.sharengo.exceptions.TechnicalException;

import <%uiPackage%>.I<%name%>;

<%if (!superClass.isEmpty && superClass.isUi){%> 
import <%superClass.uiImplPackage%>.<%superClass.name%>Impl;
<%}%>

import java.io.Writer;

<%for (operationsParametersTypes){%>
	<%if (filter("Classifier").isEntity){%>
import <%entityPackage%>.<%name%>;
	<%}else{%>
import <%getCompleteName()%>;	
	<%}%>
<%}%>

<%for (ownedOperation){%>
	<%for (raisedException){%>
import <%getCompleteName()%>;
	<%}%>
<%}%>

<%iocImport("Ui")%>
<%iocImport("Service")%>
<%iocImport("Config")%>

<%for (viewDependencies){%>
import <%viewImplPackage%>.<%name%>;
<%}%>

<%if (viewDependencies){%>
import <%viewFactoryPackage%>.ViewFactory;
<%}%>

// <%startUserCode%> for import
import java.util.Collection;
// <%endUserCode%>

public class <%name%>Impl<%extensions%> implements I<%name%> {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(<%name%>Impl.class.getName()); 

	<%iocAccessors("Ui")%>	
	<%iocAccessors2("Config")%>
	<%iocAccessors("Service")%>

	<%if (viewDependencies){%>
		private ViewFactory viewFactory = null;
		public void setViewFactory(ViewFactory viewFactory){
			this.viewFactory=viewFactory;
		}
		public ViewFactory getViewFactory(){
			return viewFactory;
		}		
		<%for (viewDependencies){%>
		protected <%name%> get<%name%>() {
			return getViewFactory().create<%name.toU1Case()%>();
		}
		<%}%>
	<%}%>
			
	<%for (ownedOperation){%>
	<%generateJavadoc%>	
	public <%generateReturn%> <%name%>(<%generateUiParameters%>) throws TechnicalException<%genExceptions%>{
		// <%startUserCode%> of <%generateReturn%> <%name%>(<%generateUiParameters%>)
        // TODO implement <%name%>
        throw new UnsupportedOperationException("Method not yet implemented");
        // <%endUserCode%>
        }
        
	<%}%>
	
	// <%startUserCode%> private methods

	// <%endUserCode%> private methods
	
}

<%script type="Class" name="extensions"%>
<%if (!superClass.isEmpty && superClass.isUi){%> extends <%superClass.name%>Impl<%}%>

