<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
<%if (uis){%>META-INF/spring/<%baseImports%>/layer-uis.xml<%}%>

<%script type="Model" name="springApplicationContext" file="<%fullFilePath%>"%>
<?xml version="1.0" encoding="UTF-8"?>

<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:aop="http://www.springframework.org/schema/aop"
	xmlns:tx="http://www.springframework.org/schema/tx"
	xmlns:jee="http://www.springframework.org/schema/jee"
	<%if (uis.ownedOperation[isRemote]){%>
	xmlns:dwr="http://www.directwebremoting.org/schema/spring-dwr"
	<%}%>
	xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
		http://www.springframework.org/schema/aop http://www.springframework.org/schema/aop/spring-aop-2.0.xsd
		http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-2.0.xsd
	<%if (uis.ownedOperation[isRemote]){%>
		http://www.directwebremoting.org/schema/spring-dwr http://www.directwebremoting.org/schema/spring-dwr-2.0.xsd
	<%}%>
		http://www.springframework.org/schema/jee http://www.springframework.org/schema/jee/spring-jee-2.0.xsd">		  
    
    <%if (uis.viewDependencies){%>
    <bean id="<%viewFactoryPackage%>.ViewFactory" class="<%viewFactoryPackage%>.ViewFactory">
		<property name="velocityEngine" ref="velocityEngine"/>
    </bean>
    <%}%>

<%for (uis) {%>	
	<bean id="<%computeBeanId()%>" class="<%uiImplPackage%>.<%name%>Impl">
	 	<%if (viewDependencies){%>
		<property name="viewFactory" ref="<%viewFactoryPackage%>.ViewFactory"/>
		<%}%>
		<%for (serviceDependencies+uiDependencies){%>			
		 	<property name="<%name.firstLower()%>" ref="<%computeBeanId()%>"/>			
		<%}%>		
		<%if ( ownedOperation[isRemote] ){%>		
		<dwr:remote javascript="<%computeBeanId()%>">
        	<%--for ( ownedOperation[isRemote && (returnResult().isDto || returnResult().isEntity)] ){--%>
        	<%for ( ownedOperation[isRemote]){%>
			<dwr:include method="<%name%>"/>		
			<!-- <%startUserCode%> <%parent().computeBeanId()%>.<%name%> manual convert -->			
			<dwr:convert type="bean" class="<%returnResult().type.getCompleteName()%>"></dwr:convert>
			<!-- <%endUserCode%> <%parent().computeBeanId()%>.<%name%> manual convert -->
			<%}%>   
        </dwr:remote>		
		<%}%>				
		 
	</bean>
<%}%>

</beans>
