<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if (isView){%><%viewImplPackage.toPath()%>/<%name%>.java<%}%>

<%script type="Class" name="generateUi" file="<%fullFilePath%>"%>
package <%viewImplPackage%>;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;

import org.sharengo.exceptions.TechnicalException;

import java.io.Writer;

<%for (viewDependencies){%>	
import <%viewImplPackage%>.<%name%>;
<%}%>

<%for (attribute){%>
	<%if (type.filter("Classifier").isEntity){%>
import <%type.entityPackage%>.<%type.name%>;
	<%}else{%>
import <%type.getCompleteName()%>;	
	<%}%>
<%}%>

// <%startUserCode%> for import
import java.util.Collection;
// <%endUserCode%> for import

public class <%name%> {	
	<%-- TODO peut-être créer une classe mère VelocityView  --%>
	
	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(<%name%>.class.getName());  

	private VelocityContext velocityContext = null;

	public VelocityContext getVelocityContext() {
		return velocityContext;
	}

	public void setVelocityContext(VelocityContext velocityContext) {
		this.velocityContext = velocityContext;
	}

	private VelocityEngine velocityEngine=null;
		
	public VelocityEngine getVelocityEngine() {
		return velocityEngine;
	}

	public void setVelocityEngine(VelocityEngine velocityEngine) {
		this.velocityEngine = velocityEngine;
	}
	
	<%for (attribute){%>
	public void set<%name.toU1Case()%>(<%convertToJavaType%> <%name.toL1Case()%>){
		// <%startUserCode%> of set<%name.toU1Case()%>(<%convertToJavaType%> <%name.toL1Case()%>)
		velocityContext.put("<%name.toL1Case()%>", <%name.toL1Case()%>);
		// <%endUserCode%>		
	}
	<%}%>
	
	<%iocAccessors2("View")%>
	
	public void show(Writer writer) throws TechnicalException{
		try{
			// <%startUserCode%> of rendering 		
			Template template = velocityEngine.getTemplate("<%name%>.vsl");
			// <%endUserCode%>
			template.merge(velocityContext, writer);
		}catch(Exception e){
			throw new TechnicalException(e);
		}
	}
	<%--
	<%for (ownedOperation){%>
	<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>);
	<%}%>
	--%>
}
