<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.profile
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
%>

<%script type="Model" name="fullFilePath"%>
<%if (!webservices.isEmpty){%>		
<%baseImports.toPath()%>/ws/WSClientFactory.java
<%}%>

<%script type="Model" name="generateXfireWSClientFactory" file="<%fullFilePath%>"%>
package <%baseImports%>.ws;

import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.HashMap;

import org.codehaus.xfire.aegis.AegisBindingProvider;
import org.codehaus.xfire.client.XFireProxyFactory;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.service.binding.ObjectServiceFactory;

<%for (webservices){%>
import <%servicePackage%>.I<%name.toU1Case()%>WebService;
<%}%>

// <%startUserCode%> for import
 
// <%endUserCode%> for import

public class WSClientFactory {

	private static WSClientFactory instance = new WSClientFactory();
	
	private WSClientFactory(){}
	
	public static WSClientFactory getInstance(){
		return instance;
	}
	
	<%for (webservices){%>
	public I<%name.toU1Case()%>WebService create<%name.toU1Case()%>WebService(String address) throws MalformedURLException{
		
		// Create a properties hashmap
		HashMap<String, Object> props = new HashMap<String, Object>();
		props.put(AegisBindingProvider.WRITE_XSI_TYPE_KEY, Boolean.TRUE);		
		ArrayList<String> classes = new ArrayList<String>();			
		<%-- inheritance bindings support --%>
		<%for (getReturnParameterSubClasses){%>	                				 			
			classes.add(<%getCompleteName()%>.class.getName());
		<%}%>
		// <%startUserCode%> <%name.toU1Case()%>WebService bindings
		 
		// <%endUserCode%> <%name.toU1Case()%>WebService bindings	 	
		props.put(AegisBindingProvider.OVERRIDE_TYPES_KEY, classes);
				
		//Create stub factory
		ObjectServiceFactory serviceFactory = new ObjectServiceFactory();
    	Service serviceModel = serviceFactory.create(I<%name.toU1Case()%>WebService.class, props);
    	//Create a client proxy
    	XFireProxyFactory proxyFactory = new XFireProxyFactory();
    	I<%name.toU1Case()%>WebService ws = (I<%name.toU1Case()%>WebService) proxyFactory.create(serviceModel, address);    	
    	return ws;		
	}
	<%}%>
	
}