<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
%>

<%script type="Class" name="fullFilePath"%>
<%if ( !hasStereotype(getProperty("Extern")) && hasStereotype(getProperty("Service"))){%>
	<%if (hasRemoteOperations()){%>
<%serviceImplPackage.toPath()%>/Mock<%name%>WebService.java
	<%}%>
<%}%>

<%script type="Class" name="generateWebService" file="<%fullFilePath%>"%>
package <%serviceImplPackage%>;

<%for (operationsParametersTypes){%>
	<%if (hasStereotype(getProperty("Entity"))=="true"){%>
import <%entityPackage%>.<%name%>;
	<%}else{%>
import <%getCompleteName()%>;	
	<%}%>
<%}%>	

<%if (!superClass.isEmpty && superClass.hasStereotype(getProperty("Service"))=="true"){%> 
	<%if (hasRemoteOperations()){%>
import <%superClass.servicePackage%>.I<%superClass.name%>;
	<%}%>
<%}%>

import <%servicePackage%>.I<%name%>;
import <%servicePackage%>.I<%name%>WebService;

import org.sharengo.exceptions.TechnicalException;

// <%startUserCode%> for import
import java.util.Collection;
// <%endUserCode%> for import

public class Mock<%name%>WebService implements I<%name%> {
	I<%name%>WebService <%name.toL1Case()%>WebService = null;
		
	public Mock<%name%>WebService(I<%name%>WebService process) {
		this.<%name.toL1Case()%>WebService=process;
	}	

	<%getAllOperations().genOperations%>	
	
}

<%script type="Operation" name="genOperations"%>	

<%generateJavadoc%>
public <%generateReturn%> <%name%>(<%generateParameters%>) throws TechnicalException<%genExceptions%>{
	<%if ( hasStereotype(getProperty("Remote"))=="true" ){%>
		<%if (returnResult()!=null){%>return <%}%><%parent().name.toL1Case()%>WebService.<%name%>(<%genParameters%>);
	<%}else{%>
		throw new UnsupportedOperationException("WebService Mock cannot support non remote operation");
	<%}%>						
}

<%script type="Operation" name="genParameters"%>	
<%if (!getRealParameters().isEmpty()){%><%getRealParameters().name.sep(", ")%><%}%>

<%script type="Class" name="extensions"%>
<%if (!superClass.isEmpty && superClass.hasStereotype(getProperty("Service"))=="true" && superClass.hasRemoteOperations()=="true" ){%> extends I<%superClass.name%>WebService<%}%>
