<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
%>

<%script type="Class" name="fullFilePath"%>
<%if ( !hasStereotype(getProperty("Extern")) && hasStereotype(getProperty("Service"))){%>
	<%if (hasRemoteOperations()){%>
<%serviceImplPackage.toPath()%>/<%name%>WebServiceTest.java
	<%}%>
<%}%>

<%script type="Class" name="generateWebServiceTest" file="<%fullFilePath%>"%>
package <%serviceImplPackage%>;

import org.codehaus.xfire.XFire;
import org.codehaus.xfire.XFireFactory;
import org.codehaus.xfire.server.http.XFireHttpServer;
import org.codehaus.xfire.service.ServiceRegistry;
import org.junit.Test;

import <%servicePackage%>.I<%name%>;
import <%servicePackage%>.I<%name%>WebService;

// <%startUserCode%> for import 
// <%endUserCode%> for import

public class <%name%>WebServiceTest extends <%name%>Test{
	
	XFireHttpServer server;	
	
	
	@Override
	protected void onSetUp() throws Exception {
		super.onSetUp();
        setPopulateProtectedVariables(true);
		
		ServiceRegistry registry = (ServiceRegistry) getApplicationContext().getBean("xfire.serviceRegistry");
		assertNotNull(registry);
		assertNotNull(getApplicationContext().getBean("<%name.toL1Case()%>"));
		assertTrue(getApplicationContext().getBean("<%name.toL1Case()%>") instanceof I<%name.toU1Case()%>WebService);
		assertTrue(registry.hasService("I<%name.toU1Case()%>WebService"));
		
		//Register the service in local ServiceRegistry
        XFire xfire = XFireFactory.newInstance().getXFire();
        xfire.getServiceRegistry().register(registry.getService("I<%name.toU1Case()%>WebService"));
        
        /*
        List inHandlers = new ArrayList();
		inHandlers.add(new org.codehaus.xfire.util.dom.DOMInHandler());
		inHandlers.add(new org.codehaus.xfire.util.LoggingHandler());
		xfire.getInHandlers().addAll(inHandlers);
		
		List outHandlers = new ArrayList();
		outHandlers.add(new org.codehaus.xfire.util.dom.DOMOutHandler());
		outHandlers.add(new org.codehaus.xfire.util.LoggingHandler());
		xfire.getOutHandlers().addAll(outHandlers);
		
		List faultHandlers = new ArrayList();
		faultHandlers.add(new org.codehaus.xfire.util.dom.DOMOutHandler());
		faultHandlers.add(new org.codehaus.xfire.util.LoggingHandler());
		xfire.getFaultHandlers().addAll(faultHandlers);
        */
        
        // Start the HTTP server
        this.server = new XFireHttpServer();
        server.setPort(8191);
        server.start(); 
        
        // <%startUserCode%> onSetUp         
        // <%endUserCode%> onSetUp         
	}

	@Override
	protected void onTearDown() throws Exception {
		super.onTearDown();		
		if(server.isStarted()){
			server.stop();
		}
		// <%startUserCode%> onTearDown
         
        // <%endUserCode%> onTearDown   
	}

	@Override
	protected I<%name%> get<%name%>() throws Exception {
	    I<%name%>WebService <%name.toL1Case()%>WebService = get<%name%>WebService();
		assertNotNull(<%name.toL1Case()%>WebService);
		Mock<%name%>WebService mock<%name%> = new Mock<%name%>WebService(<%name.toL1Case()%>WebService);		
		assertTrue(mock<%name%> instanceof I<%name%>);
		I<%name%> <%name.toL1Case()%> = (I<%name%>)mock<%name%>;
		assertNotNull(<%name.toL1Case()%>);		
		return <%name.toL1Case()%>;
	}

	<%for (ownedOperation){%>		
		<%if (hasStereotype(getProperty("Remote"))=="true"){%>
	@Test public void test<%name.toU1Case()%>() throws Exception{
	    // <%startUserCode%> of test<%name.toU1Case()%>
		super.test<%name.toU1Case()%>();
		// <%endUserCode%> of test<%name.toU1Case()%>			
	}
		<%}else{%>
	//no test for non <<Remote>> operation
	@Test public void test<%name.toU1Case()%>() throws Exception{	   
		assertTrue(true);
	}	
		<%}%>				  
	<%}%>
	 
 	// <%startUserCode%> of specific tests
	// <%endUserCode%> of specific tests

}