<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
%>

<%script type="Model" name="fullFilePath"%>
<%if (webservices.nSize()>0){%>META-INF/spring/<%baseImports%>/layer-xfire-services.xml<%}%>

<%script type="Model" name="springApplicationContext" file="<%fullFilePath%>"%>
<?xml version="1.0" encoding="UTF-8"?>

<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:aop="http://www.springframework.org/schema/aop"
	xmlns:tx="http://www.springframework.org/schema/tx"
	xmlns:jee="http://www.springframework.org/schema/jee"
	xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd
           http://www.springframework.org/schema/aop http://www.springframework.org/schema/aop/spring-aop-2.0.xsd
           http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-2.0.xsd
           http://www.springframework.org/schema/jee http://www.springframework.org/schema/jee/spring-jee-2.0.xsd">

<%for (webservices){%>
		<!-- XFire Web Service remoting -->
		<bean id="<%name.toL1Case()%>SessionAware" class="org.springframework.aop.framework.ProxyFactoryBean">
			<property name="proxyInterfaces">
				<list>
					<value><%package.getCompleteName()%>.I<%name%></value>
					<value><%package.getCompleteName()%>.I<%name%>WebService</value>
	      		</list>
	   		</property> 
		 	<property name="interceptorNames">
	      		<list>
	        		<value>hibernateInterceptor</value>
	        		<value><%name.toL1Case()%></value>  
	      		</list>
	    	</property>	
		</bean>
		<bean name="/<%name.toU1Case()%>WebService" parent="xfireServiceTemplate">
			<property name="serviceBean">
				<ref bean="<%name.toL1Case()%>SessionAware"/>
			</property>
			<property name="serviceInterface">					
				<value><%servicePackage%>.I<%name%>WebService</value>
			</property>
			<%-- inheritance bindings support --%>				
			<property name="properties">
				<map>
					<entry key="writeXsiType">
	                	<value type="java.lang.Boolean">true</value>
	                </entry>
            		<entry key="overrideTypesList">
            			<list>                		
            			<%genOverrideTypesList%>
 						</list>
					</entry>
					<!-- <%startUserCode%> I<%name%>WebService bindings -->		 
					<!-- <%endUserCode%> I<%name%>WebService bindings -->                  
    			</map>
    		</property>
    		<!-- <%startUserCode%> I<%name%>WebService custom -->		 
			<!-- <%endUserCode%> I<%name%>WebService custom -->    				
			</bean>			
 <%}%> 	
 	<bean class="org.springframework.web.servlet.handler.SimpleUrlHandlerMapping">			
    	<property name="urlMap">
        	<map>
<%for (webservices){%>
            	<entry key="/I<%name%>WebService">
                	<ref bean="/<%name%>WebService"/>
            	</entry>
<%}%>
        	</map>
    	</property>
    	<property name="interceptors">
		<list>
			<!-- <%startUserCode%> urlMapping interceptors -->
			<!-- <ref bean="openSessionInViewInterceptor" /> --> 
			<!-- <%endUserCode%> urlMapping interceptors -->			
		</list>
		</property>
	</bean>
</beans>

<%script type="Class" name="genOverrideTypesList"%>
<%for ( ownedOperation.returnResult() ){%>
	<%for (type.inheritanceTree){%>
		<value><%getCompleteName()%></value>
	<%}%>
<%}%>

<%script type="Type" name="inheritanceTree"%>
<%getRootContainer().eAllContents("Class")[ clientDependency.filter("InterfaceRealization").supplier.name == current(1).name || superClass.name == current(1).name].nMinimize()%>
