<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.gen.java.struts.common.widgets_mappings
%>

<%-- 
This template deals with regression tests for User Interface
--%>

<%script type="Class" name="fullFilePath"%>
<%-- Only Classes with stereotype Screen--%>
<%if (hasStereotype(getProperty("Screen"))){%>
/<%scenarioPackage.toPath()%>/test/htmlunit/Test<%name%>Action.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- Generate test class--%>
package <%scenarioPackage%>.test.htmlunit;

import java.net.URL;
import java.util.ResourceBundle;
import java.util.List;

import junit.framework.TestCase;

import com.gargoylesoftware.htmlunit.WebClient;
import com.gargoylesoftware.htmlunit.html.*;

/**
 * HtmlUnit testing for <strong><%name%> Form</strong>
 * Scenario : <%package.name%>
 *
 */
public class Test<%name%>Action extends TestCase {

	/**
	 * initialize the TestCase.
	 * 
	 * @throws Exception if the test fails
	 */
	public void setUp() throws Exception {
		super.setUp();
		//<%startUserCode%> for setUp
		//<%endUserCode%>
	}

	/**
	 * terminate the TestCase.
	 * 
	 * @throws Exception if the test fails
	 */
	public void tearDown() throws Exception {
		super.tearDown();
		//<%startUserCode%> for tearDown
		//<%endUserCode%>
	}

	/**
	 * Constructor
	 */
	public Test<%name%>Action(String testName) {
		super(testName);
		//<%startUserCode%> for Constructor
		//<%endUserCode%>
	}
<%-- A test is created for each operation --%>
<%for (ownedOperation){%>
	/**
	  * Regression test for "<%name%>" action of class <%class.name%>Action
	  * @param Nothing
	  * @return Nothing
	  * @throws Exception
	  */
	public void test<%class.name%><%name%>Action() throws Exception {
	    final WebClient webClient = new WebClient();
	    
	    ResourceBundle r = ResourceBundle.getBundle("tests");
	    final URL url = new URL(r.getString("fr.website.url") + "/<%class.name%>Action.do?event=init");
	    final HtmlPage page1 = (HtmlPage)webClient.getPage(url);
	    final HtmlForm form = page1.getFormByName("<%class.name%>Form");
<%--Iterates on each attribute of the class --%>
<%for (class.attribute.filterExistProperty("association",false)){%>
	<%if (!hasStereotype(getProperty("Title")) && !hasStereotype(getProperty("List")) && !hasStereotype(getProperty("Table"))) {%>
		final <%convertToHTMLUnitTypeFromStereotype()%> <%name%> = (<%convertToHTMLUnitTypeFromStereotype()%>)form.get<%convertToHTMLUnitGetterTypeFromStereotype()%>ByName("<%name.firstLower()%>");
	<%}%>
<%}%> 
	    final HtmlSubmitInput <%name%> = (HtmlSubmitInput)form.getInputByName("<%name%>");
	    
	    assertEquals("<%for (class.attribute.filterExistProperty("association",false)){%><%if (hasStereotype(getProperty("Title"))) {%><%name%><%}%><%}%>", page1.getTitleText());

		//<%startUserCode%> for <%name%> action
	    
	    //TODO : initialize form here
	    
	    //Subit the form and get the result page
	    final HtmlPage page2 = (HtmlPage)<%name%>.click();

	    //TODO : validate resulting page
	    
		//<%endUserCode%>
	}
<%}%>
	//<%startUserCode%> for other tests
	//<%endUserCode%>
}

