<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
import org.acceleo.module.pim.uml21.gen.java.struts.common.widgets_mappings
%>

<%-- 
This template deals with Struts forms
--%>

<%script type="Class" name="fullFilePath"%>
<%-- Only Classes with stereotype Screen--%>
<%if (hasStereotype(getProperty("Screen"))){%>
/<%scenarioPackage.toPath()%>/forms/<%name%>Form.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- Generate Struts forms--%>
package <%scenarioPackage%>.forms;

// <%startUserCode%> for import
import java.util.ArrayList;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

// <%endUserCode%> for import

/**
 * Implementation of <strong><%name%> Form</strong>
 * Scenario : <%package.name%>
 *
 */
public class <%name%>Form extends ValidatorForm {
	private static final long serialVersionUID = 1L;

    /**
     * Attributes
     */
<%for (attribute.filterExistProperty("association",false)){%>
	<%if (!hasStereotype(getProperty("Title"))) {%>
		<%if (hasStereotype(getProperty("List")) || hasStereotype(getProperty("Table"))) {%>
	public <%convertToJavaTypeFromStereotype%> <%name.firstLower()%> = new ArrayList();	
		<%}else if (hasStereotype(getProperty("Combobox"))){%>
	public Collection <%name.firstLower()%>Values = new ArrayList();
	public String <%name.firstLower()%> = null;	
		<%}else{%>
	public <%convertToJavaTypeFromStereotype%> <%name.firstLower()%> = null;
		<%}%>
	<%}%>
<%}%>

<%for (attribute.filterExistProperty("association",false)){%>
	<%if (!hasStereotype(getProperty("Title"))) {%>
		<%if (hasStereotype(getProperty("Combobox"))) {%>
	/**
	 * Return <%name%> combobox values
	 * @return all the <%name%> combobox values
	 */
	public Collection get<%name.firstUpper()%>Values() {
		return <%name.firstLower()%>Values;
	}
	
	/**
	 * Set a values to <%name%>.combobox
	 * @param the  <%name%> combobox values
	 */
	 public void set<%name.firstUpper()%>Values(Collection <%name.firstLower()%>Values) {
		this.<%name.firstLower()%>Values = <%name.firstLower()%>Values;
	}	

	/**
	 * Return <%name%>
	 * @return 
	 */
	 public String get<%name.firstUpper()%>() {
		return <%name.firstLower()%>;
	}
	
	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> <%-- ownedComment.body --%>
	 */
	 public void set<%name.firstUpper()%>(String <%name.firstLower()%>) {
		this.<%name.firstLower()%> = <%name.firstLower()%>;
	}
		<%}else{%>
	/**
	 * Return <%name%>
	 * @return <%ownedComment.body%>
	 */
	 public <%convertToJavaTypeFromStereotype%> get<%name.firstUpper()%>() {
		return <%name.firstLower()%>;
	}
	
	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> <%ownedComment.body%>
	 */
	 public void set<%name.firstUpper()%>(<%convertToJavaTypeFromStereotype%> <%name.firstLower()%>) {
		this.<%name.firstLower()%> = <%name.firstLower()%>;
	}
		<%}%>
	<%}%>
<%}%>

	/**
	 * Reset all properties to their default values.
	 *
	 * @param mapping The mapping used to select this instance
	 * @param request The servlet request we are processing
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
<%for (attribute.filterExistProperty("association",false)){%>
	<%if (!hasStereotype(getProperty("Title"))) {%>
		<%if (hasStereotype(getProperty("List")) || hasStereotype(getProperty("Table"))) {%>
		this.<%name.firstLower()%>.clear();
		<%}else if (hasStereotype(getProperty("Combobox"))){%>
		this.<%name.firstLower()%>Values.clear();
		this.<%name.firstLower()%> = null;		
		<%}else{%>
		this.<%name.firstLower()%> = null;
		<%}%>
	<%}%>
<%}%>
	}

// <%startUserCode%> for other methods
// <%endUserCode%>
	
}
