package org.acceleo.sample.demo.spring.ws;

import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.HashMap;

import org.codehaus.xfire.aegis.AegisBindingProvider;
import org.codehaus.xfire.client.XFireProxyFactory;
import org.codehaus.xfire.service.Service;
import org.codehaus.xfire.service.binding.ObjectServiceFactory;

import org.acceleo.sample.demo.spring.services.IProductsServicesWebService;

// Start of user code for import

// End of user code for import

public class WSClientFactory {

	private static WSClientFactory instance = new WSClientFactory();
	
	private WSClientFactory(){}
	
	public static WSClientFactory getInstance(){
		return instance;
	}
	
	public IProductsServicesWebService createProductsServicesWebService(String address) throws MalformedURLException{
		
		// Create a properties hashmap
		HashMap<String, Object> props = new HashMap<String, Object>();
		props.put(AegisBindingProvider.WRITE_XSI_TYPE_KEY, Boolean.TRUE);		
		ArrayList<String> classes = new ArrayList<String>();			
		// Start of user code ProductsServicesWebService bindings

		// End of user code ProductsServicesWebService bindings	 	
		props.put(AegisBindingProvider.OVERRIDE_TYPES_KEY, classes);
				
		//Create stub factory
		ObjectServiceFactory serviceFactory = new ObjectServiceFactory();
    	Service serviceModel = serviceFactory.create(IProductsServicesWebService.class, props);
    	//Create a client proxy
    	XFireProxyFactory proxyFactory = new XFireProxyFactory();
    	IProductsServicesWebService ws = (IProductsServicesWebService) proxyFactory.create(serviceModel, address);    	
    	return ws;		
	}
	
}