package org.acceleo.sample.demo.spring.services.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.junit.Test;
import org.acceleo.sample.demo.spring.AbstractBusinessLayerTests;

import org.acceleo.sample.demo.spring.services.IProductsServices;	

import org.acceleo.sample.demo.spring.entities.Product;
import org.acceleo.sample.demo.spring.entities.impl.ProductHelper;

// Start of user code for import 
import java.util.Collection;

// End of user code for import 

public class ProductsServicesTest extends AbstractBusinessLayerTests {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(ProductsServicesTest.class.getName()); 
	
	@Test
	public void testGetListOfProducts() throws Exception {
		// Start of user code of testGetListOfProducts()
		Collection<Product> products = getProductsServices()
				.getListOfProducts();
		assertNotNull(products);
		int size = products.size();
		createProduct();
		products = getProductsServices().getListOfProducts();
		assertNotNull(products);
		assertEquals(products.size(), size + 1);
		// End of user code of testGetListOfProducts()
	}	
	@Test
	public void testGetProduct() throws Exception {
		// Start of user code of testGetProduct()
		Product product1 = createProduct();
		Product product2 = getProductsServices().getProduct(product1.getId());
		assertEquals(product2, product1);
		// End of user code of testGetProduct()
	}	
	@Test
	public void testAddProduct() throws Exception {
		// Start of user code of testAddProduct()
		createProduct();
		// End of user code of testAddProduct()
	}	
	@Test
	public void testUpdateProduct() throws Exception {
		// Start of user code of testUpdateProduct()
		Product product1 = createProduct();
		String id = product1.getId();
		// get product instance from database
		product1 = getProductsServices().getProduct(id);
		assertNotNull(product1);
		product1.setColor("blue");
		// update
		getProductsServices().updateProduct(product1);
		Product product2 = getProductsServices().getProduct(id);
		// check
		assertEquals(product2, product1);
		// End of user code of testUpdateProduct()
	}	
	@Test
	public void testRemoveProduct() throws Exception {
		// Start of user code of testRemoveProduct()
		Product product1 = createProduct();
		String id = product1.getId();
		// get product instance from database
		product1 = getProductsServices().getProduct(id);
		assertNotNull(product1);
		// remove
		getProductsServices().removeProduct(product1);
		product1 = getProductsServices().getProduct(id);
		assertNull(product1);

		// End of user code of testRemoveProduct()
	}	
	
	// Start of user code of specific tests
	private Product createProduct() throws Exception {
		Product product = ProductHelper.createProduct();
		assertNotNull(product);
		assertNull(product.getId());
		product = getProductsServices().addProduct(product);
		getSession().flush();
		assertNotNull(product.getId());
		return product;
	}

	// End of user code of specific tests
}