package org.acceleo.sample.demo.spring.services.impl;

import org.codehaus.xfire.XFire;
import org.codehaus.xfire.XFireFactory;
import org.codehaus.xfire.server.http.XFireHttpServer;
import org.codehaus.xfire.service.ServiceRegistry;
import org.junit.Test;

import org.acceleo.sample.demo.spring.services.IProductsServices;
import org.acceleo.sample.demo.spring.services.IProductsServicesWebService;

// Start of user code for import 
// End of user code for import

public class ProductsServicesWebServiceTest extends ProductsServicesTest{
	
	XFireHttpServer server;	
	
	
	@Override
	protected void onSetUp() throws Exception {
		super.onSetUp();
        setPopulateProtectedVariables(true);
		
		ServiceRegistry registry = (ServiceRegistry) getApplicationContext().getBean("xfire.serviceRegistry");
		assertNotNull(registry);
		assertNotNull(getApplicationContext().getBean("productsServices"));
		assertTrue(getApplicationContext().getBean("productsServices") instanceof IProductsServicesWebService);
		assertTrue(registry.hasService("IProductsServicesWebService"));
		
		//Register the service in local ServiceRegistry
        XFire xfire = XFireFactory.newInstance().getXFire();
        xfire.getServiceRegistry().register(registry.getService("IProductsServicesWebService"));
        
        /*
        List inHandlers = new ArrayList();
		inHandlers.add(new org.codehaus.xfire.util.dom.DOMInHandler());
		inHandlers.add(new org.codehaus.xfire.util.LoggingHandler());
		xfire.getInHandlers().addAll(inHandlers);
		
		List outHandlers = new ArrayList();
		outHandlers.add(new org.codehaus.xfire.util.dom.DOMOutHandler());
		outHandlers.add(new org.codehaus.xfire.util.LoggingHandler());
		xfire.getOutHandlers().addAll(outHandlers);
		
		List faultHandlers = new ArrayList();
		faultHandlers.add(new org.codehaus.xfire.util.dom.DOMOutHandler());
		faultHandlers.add(new org.codehaus.xfire.util.LoggingHandler());
		xfire.getFaultHandlers().addAll(faultHandlers);
        */
        
        // Start the HTTP server
        this.server = new XFireHttpServer();
        server.setPort(8191);
        server.start(); 
        
        // Start of user code onSetUp         
        // End of user code onSetUp         
	}

	@Override
	protected void onTearDown() throws Exception {
		super.onTearDown();		
		if(server.isStarted()){
			server.stop();
		}
		// Start of user code onTearDown

        // End of user code onTearDown   
	}

	@Override
	protected IProductsServices getProductsServices() throws Exception {
	    IProductsServicesWebService productsServicesWebService = getProductsServicesWebService();
		assertNotNull(productsServicesWebService);
		MockProductsServicesWebService mockProductsServices = new MockProductsServicesWebService(productsServicesWebService);		
		assertTrue(mockProductsServices instanceof IProductsServices);
		IProductsServices productsServices = (IProductsServices)mockProductsServices;
		assertNotNull(productsServices);		
		return productsServices;
	}

	//no test for non <<Remote>> operation
	@Test public void testGetListOfProducts() throws Exception{	   
		assertTrue(true);
	}	
	@Test public void testGetProduct() throws Exception{
	    // Start of user code of testGetProduct
		super.testGetProduct();
		// End of user code of testGetProduct			
	}
	@Test public void testAddProduct() throws Exception{
	    // Start of user code of testAddProduct
		super.testAddProduct();
		// End of user code of testAddProduct			
	}
	//no test for non <<Remote>> operation
	@Test public void testUpdateProduct() throws Exception{	   
		assertTrue(true);
	}	
	//no test for non <<Remote>> operation
	@Test public void testRemoveProduct() throws Exception{	   
		assertTrue(true);
	}	
	 
 	// Start of user code of specific tests
	// End of user code of specific tests

}