<%--
  Copyright � 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
--%>

<%--
 - Generates connection PHP class.
 --%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
%>

<%--
 - Generates generated file path.
 --%>
<%script type="uml.Model" name="filePath" post="trim()"%>
<%name%>/dao/Connection.php5

<%--
 - Main script.
 --%>
<%script type="uml.Model" name="Connection" file="<%filePath%>"%>
<?php
/**
*
*/
/**
* Config manager
*/
require_once(dirname(__FILE__)."/../common/config.php5");
/**
 * This class represents a connection to a database.
 * @version $Id$
 */
class Connection {

	/** 
	* PEAR Database connection. 
	*/
	private $db;
	
	
	private $open;
	
	/**
	 * creates a new connection instance.
	 */
	public function __construct() {
		$this->open = false;
	}

	/**
	 * Open connection
	 * @param boolean $autocommit if true then set autocommit
	 * @link http://pear.php.net/manual/en/package.database.db.db-common.autocommit.php
	 */	
	public function open($autocommit = true) {
		$config = new Config();
		$this->db =& DB::connect($config->getDsn());
		if (PEAR::isError($this->db)) {
		    $cause = "Standard Message  : " . $this->db->getMessage() . "\n" . 
		    		 "User Information  : " . $this->db->getUserInfo() . "\n" .
		    		 "Debug Information : " . $this->db->getDebugInfo() . "\n";
			throw new Exception("impossible to etablish a connection to the database\n" . $cause);
		} else {
			$this->open = true;
			$this->db->autoCommit($autocommit);
		}
	}
	
	/**
	 * Returns true if the connection is open.
	 * @return boolean $res true if the connection is open
	 */
	public function isOpen() {
		return $this->open;
	}
	
	/**
	 * Closes connection.
	 * @return boolean $res true if correctly disconnected
	 */
	public function close() {
		$succeed = $this->db->disconnect();
		$this->db->open = false;
		return $succeed;
	}
	
	/**
	 * commits changes.
	 */
	public function commit() {
		$this->db->commit;
	}
	
	/**
	 * Rollback to last commit.
	 */
	public function rollback() {
		$this->db->rollback();
	}
	
	/**
	 * Returns PEAR DB object.
	 * @return object $db the pear db object
	 */
	public function getDb() {
		return $this->db;
	}
	

}


?>