<%--
  Copyright � 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
  Contributors :
  	- 01/05/2008 - Pierre Alain Bourdil : management of the inheritances.
  	- 01/05/2008 - Yann Mortier : refactoring, correction of the auto update.
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.SqlTypeServices
import org.acceleo.module.pim.uml21.services.UmlServices
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
<%getRootContainer().name%>/dao/<%package.name%>/<%name%>Dao.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>" post="trim()"%>
<?php
/**
* @package <%package.name%>
*/
/**
* <%name%>Factory
*/

require_once(dirname(__FILE__)."/../../entity/<%package.name%>/<%name%>Factory.php5");
<%if (superClass.nSize()==1){%>
/**
* <%superClass.name%>
*/
require_once(dirname(__FILE__)."/<%superClass.name%>Dao.php5");
<%}else{%>
/**
* root class
*/
require_once(dirname(__FILE__)."/../Dao.php5");
require_once(dirname(__FILE__)."/../DaoFactory.php5");
/**
* Connections utils
*/
require_once(dirname(__FILE__)."/../Connection.php5");
<%}%>
<%for getProperties().filter("Property") {%><%if (type.hasStereotype("Entity")) {%>
require_once(dirname(__FILE__)."/../../entity/<%eContainer().package.name%>/<%type.name()%>Factory.php5");
require_once(dirname(__FILE__)."/../../entity/RelationManager.php5");
require_once(dirname(__FILE__)."/<%type.name()%>Dao.php5");
<%}%><%}%>

<%classDocBlocPhpdoc%>
class <%name%>Dao extends Dao{

	<%--
	 - Generation of the constructor.
	--%>
	
	/**
	 * initialise table and log
	 */
	public function __construct() {
		$this->tableName = "<%name.toSqlNotation()%>";
		$this->logger =& Log::singleton('file', dirname(__FILE__).'/../log/dao.log', '<%name%>Dao.class');
		// <%startUserCode%> of constructor
		// <%endUserCode%>
	}
	
	<%--
	 - Generation of the create operation.
	--%>

	/**
	 * Save a <%name%> in its corresponding persistance table 
	 *
	 * save on cascade by calling {@link <%name%>::updateRelations() updateRelations()}
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @param object $<%name.toL1Case()%> the instance
	 * @param array $memory prevents from multiple save of a same instance
	 */
	public function create<%name%>($connection, $<%name.toL1Case()%>, $memory = array()) {
		$this->logger->log('data to be saved [<%name%>'. $<%name.toL1Case()%>->getId() .']', PEAR_LOG_DEBUG);
		if (!in_array('<%name%>' . $<%name.toL1Case()%>->getId(), $memory, false)) {
			$this->logger->log('creating new object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
			// Save the object for each super class.
<%if (superClass.nSize() == 1){%>
			$<%general.name.toL1Case()%>Dao = new <%general.name%>Dao();
			$<%general.name.toL1Case()%>Dao->create<%general.name%>($connection, $<%current(1).name.toL1Case()%>, $memory);
			$id = $<%current(1).name.toL1Case()%>->getId();
<%}else{%>
			$seqName = "<%getSuperClassOfHierarchy().name.toSqlNotation()%>_SEQ";
			$id = $connection->getDb()->nextId($seqName);
<%}%>
			$qry = 	"INSERT INTO " . $this->getTableName()
					. " SET ID = '". $id . "' "
<%if (attribute.nSize() > 0){%>
					<%attribute.genAssignment.sep("\n\t\t\t\t\t")%>.";";<%}else{%>.";";
<%}%>

			$this->executeQuery($connection, $qry);
			$<%name.toL1Case()%>->setId($id);
			array_push($memory, '<%name%>' . $<%name.toL1Case()%>->getId());
			$this->updateRelations($connection, $<%name.toL1Case()%>, $memory);
		}
	}

	<%--
	 - Generation of the update operation.
	--%>

	/**
	 * update a <%name%> in its corresponding persistance table 
	 *
	 * update on cascade by calling {@link <%name%>::updateRelations() updateRelations()}
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance
	 * @param array $memory prevents from multiple save of a same instance
	 * @return false if one of ancestorID is not initialised, true if everything is ok
	 */
	public function update<%name%>($connection, $<%name.toL1Case()%>, $memory = array()) {
		$this->logger->log('data to be saved [<%name%>'. $<%name.toL1Case()%>->getId() .']', PEAR_LOG_DEBUG);
		if (!in_array('<%name%>' . $<%name.toL1Case()%>->getId(), $memory, false)) {
			$this->logger->log('updating object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
			<%if (superClass.nSize() > 0) {%>
			$<%general.name.toL1Case()%>Dao = new <%general.name%>Dao();
			$<%general.name.toL1Case()%>Dao->update<%general.name%>($connection, $<%name.toL1Case()%>, $memory);
			<%}%>
			
<%if attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize>0 {%>
			$qry = 	"UPDATE " . $this->getTableName() .
					" SET " .
					<%for attribute[type.filter("PrimitiveType")].filterWithOutStereotype("id") {%>
						<%if type.name.equalsIgnoreCase("string"){%>
					"<%if i()!=0 {%>,<%}%> <%name.toSqlNotation()%> = '" . $<%current(2).name.toL1Case()%>->get<%name.toU1Case()%>() . "'" .
					<%}else{%>
					"<%if i()!=0 {%>,<%}%> <%name.toSqlNotation()%> = " . $<%current(2).name.toL1Case()%>->get<%name.toU1Case()%>() .
					<%}%>
					<%}%>
					" WHERE " .
					" ID = '" . $<%name.toL1Case()%>->getId() . "'";
			$this->executeQuery($connection, $qry);
			array_push($memory, '<%name%>' . $<%name.toL1Case()%>->getId());
<%}%>		
			$this->updateRelations($connection, $<%name.toL1Case()%>, $memory);
		}	
		return true;
	}
	
	<%--
	 - Generation of the delete operation.
	--%>
	
	/**
	 * delete an instance from database
	 *
	 * logs at PEAR_LOG_DEBUG level
	 * do NOT delete on cascade
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance
	 */
	public function delete<%name%>($connection, $<%name.toL1Case()%>) {
		$this->logger->log('deleting object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
		$qry = 	"DELETE FROM " . $this->getTableName() .
				" WHERE " .
				" ID = '" . $<%name.toL1Case()%>->getId() . "'";
		$this->executeQuery($connection, $qry);
		<%if general.nSize() == 1 {%>
		$<%general.name.toL1Case()%>Dao = new <%general.name%>Dao();
		$<%general.name.toL1Case()%>Dao->delete<%general.name%>($connection, $<%name.toL1Case()%>);
		<%}%>
		// TODO $<%name.toL1Case()%>->setId(-1);
	}
	
	<%--
	 - Generation of the creation operation.
	--%>
	
	/**
	 * retrieve a <%name%> from Id. This operation search the <%name%> in the inheritance tree.
	 *
	 * if <%name.toL1Case()%>->$id is not initialised, returns a empty instance. Only primitive type attribute are initialised.
	 * logs at PEAR_LOG_DEBUG level.
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance 
	 * @return <%name%> $current a <%name%> instance
	 */
	public function findById($connection, $<%name.toL1Case()%><%if getRootContainer().eAllContents("Class")[superClass == current(1)].nSize() != 0 {%>, $result = null<%}%>) {
		if ($<%name.toL1Case()%> == null) {
			throw new Exception("The null arg is illegal");
		}
		<%-- The smart find by id --%>
		<%for (getRootContainer().eAllContents("Class")[superClass == current(1)]) {%>
		if (!isset($result)) {
			//
			// The object can be a <%name%>
			$<%name.toL1Case()%>Factory = new <%name%>Factory();
			$<%name.toL1Case()%> = $<%name.toL1Case()%>Factory->create<%name%>($<%current(1).name.toL1Case()%>->getId());
			$<%name.toL1Case()%>Dao = new <%name%>Dao();
			$result = $<%name%>Dao->findById($connection, $<%name.toL1Case()%>);
		}
		<%}%>
		//
		// The query to find the object.
		$qry = 	"SELECT * FROM " . $this->getTableName() . " WHERE ID = '". $<%name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		<%if getRootContainer().eAllContents("Class")[superClass == current(1)].nSize() != 0 {%>
		if (!isset($result)) {
			$factory = new <%name%>Factory();
			$result = $factory->create<%name%>();
		}
		<%}else{%>
		$factory = new <%name%>Factory();
		$result = $factory->create<%name%>();
		<%}%>
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$result->setId($row['ID']);
		<%for getProperties().filter("Property"){%><%if (type.filter("PrimitiveType") != null) {%>
			$result->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
		<%}%><%}%>
			$this->logger->log('found object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
		} else {
			$res->free();
			return null;
		}
		<%if (superClass.nSize() == 1) {%>
		// load super class attributes.
		$<%general.name.toL1Case()%>Dao = new <%general.name.toL1Case()%>Dao();
		$<%general.name.toL1Case()%>Dao->findById($connection, $result, $result);
		<%}%>
		$res->free();
		return $result;
	}
	
	/** 
	 * retrieve all the <%name%> instance
	 *
	 * only the primitive type attribute are initialised in each instance
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @return array $<%name.toL1Case()%>List a list of instance
	 */
	public function findAll<%name%>s($connection) {
	<%-- TODO inheritance management. --%>
		$qry = 	"SELECT * FROM " . $this->getTableName();
		$res = $this->executeQuery($connection, $qry);
		$<%name.toL1Case()%>List = array();
		$row = array();
		$factory = new <%name%>Factory();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			$current = $factory->create<%name%>($row['ID']);
<%for getProperties().filter("Property"){%><%if (type.filter("PrimitiveType") != null) {%>
			$current->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
<%}%><%}%>
			$this->logger->log('found object : ' . $current->getSimpleString() ,PEAR_LOG_DEBUG);
			array_push($<%name.toL1Case()%>List, $current);
			$this->logger->log('found object : ' . $current->getSimpleString() ,PEAR_LOG_DEBUG);
		}
		$res->free();
		return $<%name.toL1Case()%>List;
	}
	
	<%--
	 - Generate the operation that is able to load an association.
	 --%>
	
<%for getProperties().filter("Property") {%><%if (type.hasStereotype("Entity")) {%>
	/**
	 * load class linked with <%eContainer().name()%> on <%name.toU1Case()%>, if <%name.toU1Case()%> is an associationEnd
	 */
	public function load<%if (upper == 1) {%><%name.toU1Case()%><%}else{%><%name.toU1Case().toPluriel()%><%}%>($connection, $<%inverse().type.name.toL1Case()%>) {
<%--	
	One To Many
--%>
<%if (upper != 1 && inverse().filter("Property").upper == 1) {%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> " .
				"WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " .
				$<%inverse().type.name.toL1Case()%>->getId() ;
		$res = $this->executeQuery($connection, $qry);
		$<%name.toL1Case().toPluriel()%> = array();
		$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
		$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
		$row = array();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			if ($row['ID'] >= 0) {
				$current<%name.toL1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($row['ID']);
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $current<%name.toU1Case()%>);
				// TODO $current<%name.toU1Case()%>->set<%inverse().name.toU1Case()%>($current<%name.toU1Case()%>);
				if ($current<%name.toU1Case()%> != null && $current<%name.toU1Case()%>->getId() >= 0) {
					array_push($<%name.toL1Case().toPluriel()%>, $current<%name.toU1Case()%>);
				}
			}
		}
		$res->free();
		return $<%name.toL1Case().toPluriel()%>;
<%--	
	Many To One
--%>
<%}else if (inverse().upper != 1 && upper == 1 ) {%>
		$qry =  "SELECT a.* FROM <%type.name.toSqlNotation()%> a, <%inverse().type.name.toSqlNotation()%> b " .
				"WHERE b.ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = a.ID ".
				"AND b.ID = '" . $<%inverse().type.name.toL1Case()%>->getId() . "' ";
		$res = $this->executeQuery($connection, $qry);
		$current<%name.toL1Case()%> = null;
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
			$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
			if ($row['ID'] >= 0) {
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($row['ID']);
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $current<%name.toU1Case()%>);
			}
		}
		$res->free();
		return $current<%name.toL1Case()%>;
<%--	
	0..1 To One
--%>
<%}else if (upper == 1 && lower == 0 && inverse().upper == 1 && inverse().lower == 1) {%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> " .
				"WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
				$<%inverse().type.name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		$current<%name.toL1Case()%> = null;
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
			$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
			if ($row['ID'] >= 0) {
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($row['ID']);
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $current<%name.toU1Case()%>);
			}
		}
		$res->free();
		return $current<%name.toL1Case()%>;
<%--	
	One to 0..1
--%>
<%}else if(inverse().upper == 1 && inverse().lower == 0 && upper == 1 && lower == 1) {%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> " .
				"WHERE ID_<%type.name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
				$<%inverse().type.name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		$current<%name.toL1Case()%> = null;
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
			$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
			if ($row['ID'] >= 0) {
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($row['ID']);
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $current<%name.toU1Case()%>);
			}
		}
		$res->free();
		return $current<%name.toL1Case()%>;
<%--	
	Many To Many
--%>
<%}else if (upper != 1 && inverse().upper != 1) {%>
		$qry =  "SELECT a.* FROM <%type.name.toSqlNotation()%> a, <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> b " .
				"WHERE a.ID = b.ID_<%type.name.toSqlNotation()%> " .
				"AND b.ID_<%inverse().type.name.toSqlNotation()%> = '" . 
				$<%inverse().type.name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		$row = array();
		$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
		$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
		$<%name.toL1Case().toPluriel()%> = array();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			if ($row['ID'] >= 0) {
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($row['ID']);
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $current<%name.toU1Case()%>);
				// TODO $current<%name.toU1Case()%>->set<%inverse().name.toU1Case()%>($current<%name.toU1Case()%>);
				array_push($<%name.toL1Case().toPluriel()%>, $current<%name.toU1Case()%>);
			}
		}
		$res->free();
		return $<%name.toL1Case().toPluriel()%>;
<%--
	a..1 To a..1
--%>
<%}else if (upper == 1 && inverse().upper == 1 && lower == inverse().lower) {%>
	<%if (association.memberEnd.nGet(1) == current()) {%>
		$qry = 	"SELECT a.* FROM <%type.name.toSqlNotation()%> a, <%inverse().type.name.toSqlNotation()%> b " .
				"WHERE b.ID = '" . $<%inverse().type.name.toL1Case()%>->getId() . "' " .
				"AND a.ID = b.ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>";
	<%}else{%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" . 
				$<%inverse().type.name.toL1Case()%>->getId() . "' ";
	<%}%>
		$res = $this->executeQuery($connection, $qry);
		$current<%name.toL1Case()%> = null;
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
			$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
			if ($row['ID'] >= 0) {
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($row['ID']);
				$current<%name.toU1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $current<%name.toU1Case()%>);
			}
		}
		$res->free();
		return $current<%name.toL1Case()%>;
<%}%>
	}
<%}%><%}%>
	
<%for (ownedOperation.filterWithStereotype("find")){%>
	/**
	 *
	 */
	public function <%name%><%name%>($connection, <%generateParameters%>) {
		// <%startUserCode%> of search method <%name%>
		$<%returnResult.name.toL1Case()%> = null;
		
		// TODO write the business code for <%name%> operation
		
		return $<%returnResult.name.toL1Case()%>;
		// <%endUserCode%>
	}
<%}%>

	<%--
	- Generation of the update raltions operation
	--%>

	/**
	 * Update the relations of <%name.toL1Case()%>.
	 * @param object $connection 
	 * @param object $<%name.toL1Case()%> the instance
	 * @param array $memory prevents from multiple save of a same instance
	 */
	public function updateRelations($connection, $<%name.toL1Case()%>, $memory = array()) {
<%if (superClass.nSize() == 1) {%>
		$<%general.name.toL1Case()%>Dao = new <%general.name%>Dao();
		$<%general.name.toL1Case()%>Dao->updateRelations($connection, $<%name.toL1Case()%>, $memory);
<%}%>
<%for getProperties().filter("Property") {%>
	<%if (type.hasStereotype("Entity")) {%>
		$<%name%> = $<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>(false); // no lazy loading.
		if (isset( $<%name%>)) {
			<%updateRelation%>
		}
		$updateSQL = false;
		if ($<%current(2).name.toL1Case()%> instanceof RelationManager) {
			$updateSQL = $<%current(2).name.toL1Case()%>->isRelationLoaded("<%name%>");
		}
		$updateSQL = $updateSQL || isset($<%name%>);
		if ($updateSQL) {
			<%updateRelation2%>
		}
	<%}%>
<%}%>
	}
	
	public function create($connection, $entity, $memory = array()) {
		$this->create<%name%>($connection, $entity, $memory);
	}
	
	public function update($connection, $entity, $memory = array()) {
		$this->update<%name%>($connection, $entity, $memory);
	}
	
}

?>

<%--
 - generate an operation that deletes all references to an entity.
 --%>
<%script type="uml.Class" name="deleteInverseReference" post="trim()"%>
public function deleteInverseReferences($connection, $<%name.toL1Case()%>) {
<%if (superClass.nSize() ==1) {%>
	<%general.name.toL1Case()%>Dao = new <%general.name%>Dao();
	<%general.name.toL1Case()%>Dao->deleteInverseReferences($connection, $<%name.toL1Case()%>);
<%}%>
<%for getProperties().filter("Property")[type.hasStereotype("Entity")] {%>

<%}%>
}


<%script type="Property" name="genAssignment" post="trim()"%>
<%if (type.filter("PrimitiveType") != null) {%> 
. ", <%name.toSqlNotation()%> = '" . $<%class.name.toL1Case()%>->get<%name.toU1Case()%>() . "'"
<%}%>

<%script type="Operation" name="generateParameters"%>
<%-- Generates parameters with types for a method --%>
<%getRealParameters().genDeclare.sep(", ")%>

<%script type="Parameter" name="genDeclare"%>
<%-- Generates parameters with types for a method --%>
$<%name.toL1Case()%>

<%-- create or update the property contents. --%>
<%script type="Property" name="updateRelation" post="trim()"%>

<%-- collection --%>
$daoFactory = new DaoFactory();
<%if (upper != 1) {%>
foreach ($<%name%> as $<%name%>Var) {
	// search the DAO to use.
	$dao = $daoFactory->createDaoFromEntity($<%name%>Var);
	if ($<%name%>Var->getId() >= 0) {
		$dao->update($connection, $<%name%>Var, $memory);
	} else {
		$dao->create($connection, $<%name%>Var, $memory);
	}
}

<%-- simple attribute --%>
<%}else{%>
$dao = $daoFactory->createDaoFromEntity($<%name%>);
if ($<%name%>->getId() >= 0) {
	$dao->update($connection, $<%name%>, $memory);
} else {
	$dao->create($connection, $<%name%>, $memory);
}
<%}%>


<%-- update ids  --%>
<%script type="Property" name="updateRelation2"%>
<%--?..* -- ?..1--%><%if (upper != 1 && inverse().filter("Property").upper == 1) {%>
if (isset($<%name.toL1Case()%>) && $<%inverse().type.name.toL1Case()%>->getSizeOf<%name.toU1Case()%>() != 0) {
	$list = "";
	$first = true;
	foreach ($<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>() as $<%name.toL1Case()%>Var) {
		if ($first) {
			$first = false;
		} else {
			$list = $list . ", ";
		}
		//
		$list = $list . $<%name.toL1Case()%>Var->getId();
	}
	$qry = 	"UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
			$<%inverse().type.name.toL1Case()%>->getId() . "' WHERE ID IN (" . $list . ")";
	$this->executeQuery($connection, $qry);
	$qry = "UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = NULL" .
		   " WHERE ID NOT IN (" . $list . ") AND ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" . $<%inverse().type.name.toL1Case()%>->getId() . "'";
	$this->executeQuery($connection, $qry);
} else {
	$qry = "UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = NULL" .
		   " WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" . $<%inverse().type.name.toL1Case()%>->getId() . "'";
	$this->executeQuery($connection, $qry);
}

<%--one to many --%><%}else if (inverse().upper != 1 && upper == 1) {%>
if (isset($<%name.toL1Case()%>)) {
	$id = $<%name.toL1Case()%>->getId();
	$qry = "UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = '" .
			$id . "' WHERE ID = '" . $<%inverse().type.name.toL1Case()%>->getId() . "'";
	$this->executeQuery($connection, $qry);
} else {
	$id = $<%inverse().type.name.toL1Case()%>->getId();
	// unset in database
	$qry = "UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = NULL" .
		   " WHERE ID = '" . $id . "'";
	$this->executeQuery($connection, $qry);		   
}

<%--1,1 -> 0,1 --%><%}else if (upper == 1 && lower == 0 && inverse().upper == 1 && inverse().lower == 1) {%>
if (isset($<%name.toL1Case()%>)) {
	$qry = "UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
			$<%inverse().type.name.toL1Case()%>->getId() . "' WHERE ID = '" . $<%name.toL1Case()%>->getId() . "'";
	$this->executeQuery($connection, $qry);
} else {
	// unset in database.
	$qry = "UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = NULL" .
		   " WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" . $<%inverse().type.name.toL1Case()%>->getId() . "'";
	$this->executeQuery($connection, $qry);
}

<%--0,1 -> 1,1 --%><%}else if(inverse().upper == 1 && inverse().lower == 0 && upper == 1 && lower == 1) {%>
if (isset($<%name.toL1Case()%>)) {
	$qry = "UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = " .
			$<%name.toL1Case()%>->getId().
			" WHERE ID = ".$<%inverse().type.name.toL1Case()%>->getId();
	$this->executeQuery($connection, $qry);
} else {
	// unset in database.
	$qry = "UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = NULL" .
		   " WHERE ID = " . $<%inverse().type.name.toL1Case()%>->getId();
	$this->executeQuery($connection, $qry);
}

<%--many to many --%><%}else if (upper != 1 && inverse().upper != 1) {%>
if (isset($<%name.toL1Case()%>) && $<%inverse().type.name.toL1Case()%>->getSizeOf<%name.toU1Case()%>() != 0) {
	$list = "-1";
	foreach ($<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>() as $<%name.toL1Case()%>Var) {
		$select = 	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " .
				"WHERE ID_<%type.name.toSqlNotation()%> =  '" . $<%name.toL1Case()%>Var->getId() . "' " .
				"AND ID_<%inverse().type.name.toSqlNotation()%> = '" . $<%inverse().type.name.toL1Case()%>->getId() . "'";
		$result = $this->executeQuery($connection, $select);
		if ($result->numRows() == 0) {
			$nextId = $connection->getDb()->nextId("<%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%>_SEQ");
			$insert =	"INSERT INTO <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " .
				"(ID, ID_<%inverse().type.name.toSqlNotation()%>, ID_<%type.name.toSqlNotation()%>) VALUES ( '". $nextId ."', '" .
				$<%inverse().type.name.toL1Case()%>->getId() . "', '" . $<%name.toL1Case()%>Var->getId() . "' )";
			$this->executeQuery($connection, $insert);
			$list = $list . ", " . $<%name.toL1Case()%>Var->getId();
		} else {
			$row = array();
			while ($result->fetchInto($row, DB_FETCHMODE_ASSOC)) {
				$list = $list . ", " . $row["ID_<%type.name.toSqlNotation()%>"];
			}
		}
		$result->free();
	}
	// delete removed elements :
	$delete = "DELETE FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%>" .
			  " WHERE ID_<%inverse().type.name.toSqlNotation()%> = " . $<%inverse().type.name.toL1Case()%>->getId() .
			  " AND ID_<%type.name.toSqlNotation()%> NOT IN (" . $list .")";
	$this->executeQuery($connection, $delete);
} else {
	// remove all
	$deleteAll = "DELETE FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%>" .
				 " WHERE ID_<%inverse().type.name.toSqlNotation()%> = " . $<%inverse().type.name.toL1Case()%>->getId();
	$this->executeQuery($connection, $deleteAll);
}

<%-- 0,1 <-> 0,1 && 1,1 <-> 1,1 --%><%}else if (upper == 1 && inverse().upper == 1 && lower == inverse().lower) {%>
if (isset($<%name.toL1Case()%>)) {
	<%if (association.memberEnd.nGet(1) == current()) {%>
	$qry = 	"UPDATE <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = '" .
			$<%name.toL1Case()%>->getId() . "' WHERE ID = '" .
			$<%inverse().type.name.toL1Case()%>->getId() ."' ";
	<%}else{%>
	$qry =	"UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
			$<%inverse().type.name.toL1Case()%>->getId() ."' WHERE ID = '" .
			$<%name.toL1Case()%>->getId() . "' ";
	<%}%>
	$this->executeQuery($connection, $qry);
} else {
	// unset in database.
	<%if (association.memberEnd.nGet(1) == current()) {%>
	$qry = 	"UPDATE <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = NULL" .
			" WHERE ID = '" . $<%inverse().type.name.toL1Case()%>->getId() ."' ";
	<%}else{%>
	$qry =	"UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> = NULL" .
			" WHERE ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
			$<%inverse().type.name.toL1Case()%>->getId() . "' ";
	<%}%>
	$this->executeQuery($connection, $qry);
}
<%}%>
