<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.SqlTypeServices
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
<%getRootContainer().name%>/dao/<%package.name%>/<%name%>Dao.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* @package <%package.name%>
*/
/**
* <%name%>Factory
*/

require_once(dirname(__FILE__)."/../../entity/<%package.name%>/<%name%>Factory.php5");
<%if (superClass.nSize()==1){%>
/**
* <%superClass.name%>
*/
require_once(dirname(__FILE__)."/<%superClass.name%>Dao.php5");
<%}else{%>
/**
* root class
*/
require_once(dirname(__FILE__)."/../Dao.php5");
/**
* Connections utils
*/
require_once(dirname(__FILE__)."/../Connection.php5");
<%}%>
<%for getProperties().filter("Property") {%><%if (type.hasStereotype("Entity")) {%>
require_once(dirname(__FILE__)."/../../entity/<%eContainer().package.name%>/<%type.name()%>Factory.php5");
require_once(dirname(__FILE__)."/<%type.name()%>Dao.php5");
<%}%><%}%>

<%classDocBlocPhpdoc%>
class <%name%>Dao extends Dao{

	
	
	/**
	 * initialise table and log
	 */
	public function __construct() {
		$this->tableName = "<%name.toSqlNotation()%>";
		$this->logger =& Log::singleton('file', dirname(__FILE__).'/../log/dao.log', '<%name%>Dao.class');
		// <%startUserCode%> of constructor
		// <%endUserCode%>
	}

	/**
	 * Save a <%name%> in its corresponding persistance table 
	 *
	 * save on cascade by calling {@link <%name%>::updateRelations() updateRelations()}
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance
	 * @param array $memory prevents from multiple save of a same instance
	 */
	public function create<%name%>($connection, $<%name.toL1Case()%>, $memory = array()) {
		$this->logger->log('data to be saved [<%name%>'. $<%name.toL1Case()%>->getId() .']', PEAR_LOG_DEBUG);
		foreach ($memory as $data) {
			$this->logger->log('saved data [' . $data . ']', PEAR_LOG_DEBUG);
		}
		
		if (!in_array('<%name%>' . $<%name.toL1Case()%>->getId(), $memory, false)) {
			$seqName="<%name.toSqlNotation()%>_SEQ";
			<%if superClass.nSize()==0 {%> $currentNextId = $connection->getDb()->nextId($seqName);<%}%>
			
			$this->logger->log('creating new object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
<%current().push()%>
<%for (getAncestor().nReverse()){%>
	<%if i()==0 {%>
			$seqName="<%name.toSqlNotation()%>_SEQ";
			$currentNextId = $connection->getDb()->nextId($seqName);
	<%}%>
			$nextId = $connection->getDb()->nextId($seqName);
			$p=new <%name%>Dao();
			$qry = 	"INSERT INTO " . $p->getTableName() .
					" SET ID = '". $nextId . "'"
	<%if (superClass.nSize()==1){%>.", <%general.name.toSqlNotation()%>_ID = '$<%general.name.toL1Case()%>Id'"<%}%>
	<%for attribute {%>
		<%if (type.filter("PrimitiveType") != null) {%>
				<%if type.equalsIgnoreCase("string"){%>
					.", <%name.toSqlNotation()%> = '".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>()."'"
				<%}else{%>
					.",<%name.toSqlNotation()%> = ".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>().""
				<%}%>	
		<%}%>
	<%}%>
					.", isA = '<%peek().name.toU1Case()%>', isAId = $currentNextId".";";
			$this->executeQuery($connection, $qry);	
			$<%name.toL1Case()%>Id=$nextId;
			$<%peek().name.toL1Case()%>->set<%name%>Id($nextId);
<%}%>
			
			
			$qry = 	"INSERT INTO " . $this->getTableName() .
					" SET ID = '". $currentNextId . "' "
<%if superClass.nSize()==1{%>
					.", <%general.name.toSqlNotation()%>_ID = '".$<%general.name.toL1Case()%>Id."' "
<%}%>
<%if (attribute.nSize() > 0){%>
					<%attribute.genAssignment.sep("\n\t\t\t\t\t")%>.";";<%}else{%>.";";
<%}%>
				
			$this->executeQuery($connection, $qry);
			$<%name.toL1Case()%>->setId($nextId);
			array_push($memory, '<%name%>' . $<%name.toL1Case()%>->getId());
			$this->updateRelations($connection, $<%name.toL1Case()%>, $memory);
		}
	}
<%pop()%>	
	 /**
	 * update a <%name%> in its corresponding persistance table 
	 *
	 * update on cascade by calling {@link <%name%>::updateRelations() updateRelations()}
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance
	 * @param array $memory prevents from multiple save of a same instance
	 * @return false if one of ancestorID is not initialised, true if everything is ok
	 */
	public function update<%name%>($connection, $<%name.toL1Case()%>, $memory = array()) {
<%current.push()%>
<%for getAncestor(){%>
		if($<%peek().name.toL1Case()%>->get<%name.toU1Case()%>Id()==null){
			throw new Exception("Inconsistent inheritance mappings: <%name.toU1Case()%> must be created before update");
		}
<%}%>
		$this->logger->log('data to be saved [<%name%>'. $<%name.toL1Case()%>->getId() .']', PEAR_LOG_DEBUG);
		foreach ($memory as $data) {
			$this->logger->log('saved data [' . $data . ']', PEAR_LOG_DEBUG);
		}
		if (!in_array('<%name%>' . $<%name.toL1Case()%>->getId(), $memory, false)) {
			$this->logger->log('updating object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
<%if attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize>0 {%>
			$qry = 	"UPDATE " . $this->getTableName() .
					" SET " .
					<%for attribute[type.filter("PrimitiveType")].filterWithOutStereotype("id") {%>
						<%if type.equalsIgnoreCase("string"){%>
	<%if i()!=0 {%>",".<%}%>" <%name.toSqlNotation()%> = '".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>()."'".
					<%}else{%>
	<%if i()!=0 {%>",".<%}%>" <%name.toSqlNotation()%> = ".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>().
					<%}%>
				
					<%}%>
					" WHERE " .
					" ID = '" . $<%name.toL1Case()%>->getId() . "'";
			$this->executeQuery($connection, $qry);
			array_push($memory, '<%name%>' . $<%name.toL1Case()%>->getId());
			
<%}%>		
			$this->updateRelations($connection, $<%peek().name.toL1Case()%>, $memory);
<%for getAncestor(){%>
	<%if attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize>0 {%>
			
		    $tmp=new <%name%>Dao();
		   	$table=$tmp->getTableName();
			$qry = 	"UPDATE " . $table .
					" SET ". 
		<%for attribute{%>
					<%--attribute.filterWithOutStereotype("id").genAssignment.sep(".\",\".\n\t\t\t\t")--%>
				<%if (type.filter("PrimitiveType") != null) {%> 
					<%if type.equalsIgnoreCase("string"){%>
	<%if i()!=0 {%>",".<%}%>" <%name.toSqlNotation()%> = '".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>()."'".
					<%}else{%>
	<%if i()!=0 {%>",".<%}%>" <%name.toSqlNotation()%> = ".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>().
					<%}%>
				<%}%>
		<%}%>
					" WHERE " .
					" ID = '" . $<%peek().name.toL1Case()%>->get<%name%>Id() . "'";
			$this->executeQuery($connection, $qry);
			$tmp->updateRelations($connection, $tmp, $memory);
	<%}%>
	
<%}%>
		}	
<%pop()%>
		return true;
	}
	
	/**
	 * delete an instance from database
	 *
	 * logs at PEAR_LOG_DEBUG level
	 * do NOT delete on cascade
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance
	 */
	public function delete<%name%>($connection, $<%name.toL1Case()%>) {
		$this->logger->log('deleting object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
		$qry = 	"DELETE FROM " . $this->getTableName() .
				" WHERE " .
				" ID = '" . $<%name.toL1Case()%>->getId() . "'";
		$this->executeQuery($connection, $qry);
		$<%name.toL1Case()%>->setId(-1);
	<%current.push()%>
<%for getAncestor(){%>
	<%if attribute.filterWithOutStereotype("id").nSize>0{%>
		    $tmp=new <%name%>Dao();
		    $table=$tmp->getTableName();
			$qry = 	"DELETE FROM " . $table .
					" WHERE " .
					" ID = '" . $<%peek().name.toL1Case()%>->get<%name%>Id() . "'";
			$this->executeQuery($connection, $qry);
	<%}%>
<%}%>
	<%pop()%>
	}
	
	/**
	 * retrieve a <%name%>from Id
	 *
	 * if <%name.toL1Case()%>->$id is not initialised, returns a empty instance. Only primitive type attribute are initialised
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @param string $<%name.toL1Case()%> the instance 
	 * @return <%name%> $current a <%name%> instance
	 */
	public function findById($connection, $<%name.toL1Case()%>) {
		$qry = 	"SELECT * FROM " . $this->getTableName() . " WHERE ID = '". $<%name.toL1Case()%>->getId() . "'";				
		$res = $this->executeQuery($connection, $qry);
		$factory = new <%name%>Factory();
		$current = $factory->create<%name%>();
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$current->setId($row['ID']);
		<%for getProperties().filter("Property"){%><%if (type.filter("PrimitiveType") != null) {%>
			$current->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
		<%}%><%}%>
		<%if (superClass.nSize()==1){%>
			$current->set<%general.name.toU1Case()%>Id($row['<%general.name.toSqlNotation()%>_ID']);	
		<%}%>
			$this->logger->log('found object : ' . $<%name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
		}
		$res->free();
		<%current.push()%>
<%for getAncestor(){%>
		 $tmp=new <%name%>Dao();
		 $table=$tmp->getTableName();
		 $qry = 	"SELECT * FROM " . $table .
					" WHERE " .
					" ID = '" . $current->get<%name%>Id() . "'";
		$res= $this->executeQuery($connection, $qry);
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
<%for getProperties().filter("Property"){%><%if (type.filter("PrimitiveType") != null) {%>
			$current->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
<%}%><%}%>
		<%if (superClass.nSize()==1){%>
			$current->set<%general.name.toU1Case()%>Id($row['<%general.name.toSqlNotation()%>_ID']);
		<%}%>
		}
		$this->logger->log('found object : ' . $<%peek().name.toL1Case()%>->getSimpleString() ,PEAR_LOG_DEBUG);
<%}%>
	<%pop()%>
		return $current;
	}
	
	/** 
	 * retrieve all the <%name%> instance
	 *
	 * only the primitive type attribute are initialised in each instance
	 * logs at PEAR_LOG_DEBUG level
	 * @param object $connection 
	 * @return array $<%name.toL1Case()%>List a list of instance
	 */
	public function findAll<%name%>s($connection) {
		$qry = 	"SELECT * FROM " . $this->getTableName();				
		$res = $this->executeQuery($connection, $qry);
		$<%name.toL1Case()%>List = array();
		$row = array();
		$factory = new <%name%>Factory();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			$current = $factory->create<%name%>($row['ID']);
<%for getProperties().filter("Property"){%><%if (type.filter("PrimitiveType") != null) {%>
			$current->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
<%}%><%}%>
<%if (superClass.nSize()>=1){%>
			$current->set<%general.name.toU1Case()%>Id($row['<%general.name.toSqlNotation()%>_ID']);	
<%}%>
<%current.push()%>
<%for getAncestor(){%>
		 	$tmp=new <%name%>Dao();
		 	$table=$tmp->getTableName();
		 	$qry = 	"SELECT * FROM " . $table .
					" WHERE " .
					" ID = '" . $current->get<%name%>Id() . "'";
			$res_2=$this->executeQuery($connection, $qry);
			$row_2 = array();
			while ($res_2->fetchInto($row_2, DB_FETCHMODE_ASSOC)) {
	<%for getProperties().filter("Property"){%><%if (type.filter("PrimitiveType") != null) {%>
				$current->set<%name.toU1Case()%>($row_2['<%name.toSqlNotation()%>']);
	<%}%><%}%>
	<%if (superClass.nSize()>=1){%>
			$current->set<%general.name.toU1Case()%>Id($row_2['<%general.name.toSqlNotation()%>_ID']);	
	<%}%>
			}
			$res_2->free();
			$this->logger->log('found object : ' . $current->getSimpleString() ,PEAR_LOG_DEBUG);
<%}%>
<%pop()%>
			array_push($<%name.toL1Case()%>List, $current);
			$this->logger->log('found object : ' . $current->getSimpleString() ,PEAR_LOG_DEBUG);
		}
		$res->free();
		
		return $<%name.toL1Case()%>List;
	}
<%push()%>
<%for getProperties().filter("Property") + getAncestor().getProperties().filter("Property"){%><%if (type.hasStereotype("Entity")) {%>
	/**
	 * load class linked with <%eContainer().name()%> on <%name.toU1Case()%>, if <%name.toU1Case()%> is an associationEnd
	 */
	public function load<%name.toU1Case()%>($connection, $<%inverse().type.name.toL1Case()%>) {
<%if (upper != 1 && inverse().filter("Property").upper == 1) {%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> " .
				"WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " .
				$<%inverse().type.name.toL1Case()%>-><%getId(peek())%> ;
		$res = $this->executeQuery($connection, $qry);
		$<%name.toL1Case()%> = array();
		$row = array();
		
		
		
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			$runtimeType=$row['isA'];
			if($runtimeType == null) {
				$tmp=new <%type.name%>Dao();
				$current<%name.toU1Case()%> = $tmp->findById($row['ID'])
			}else{
				$rowDescendant=array();
				switch($runtimeType){
	<%push()%>
	<%for getRootContainer().eAllContents("Class").nReverse()[(getAncestor() && peek().type).nSize() > 0] + peek().type  {%>
					case "<%name%>":
						$factory = new <%name.toU1Case()%>Factory();
						//get the correct ID
						$qry2 = "SELECT ID from <%name.toSqlNotation()%> where ID = ".$row['isAId']; 
						$resDescendant = $this->executeQuery($connection,$qry2);
						if($resDescendant->numRow() == 1){
							$resDescendant->fetchInto($rowDescendant,DB_FETCHMODE_ASSOC);
							$tmp=new <%name.toU1Case()%>Dao();
							$current<%peek().name.toU1Case()%>=$tmp->findById($rowDescendant['ID']);
							$resDescendant->free();
						}else
							throw new Exception("Invalid inheritance structure, ".$row['isA']." id=".$row['isAId']);
						
						break;
	<%}%><%pop()%>
				}
			}
	<%push()%>
	<%for (type.filter("Classifier").attribute) {%>
		<%if (type.filter("PrimitiveType") != null) {%> 
			$current<%peek().name.toU1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
		<%}%>
	<%}%><%pop()%>
			$current<%name.toU1Case()%>->set<%inverse().name.toU1Case()%>($<%inverse().type.name.toL1Case()%>);
	<%push()%>
	<%if type.filter("Class").superClass.nSize()>0 {%>
			$current<%name.toU1Case()%>->set<%type.filter("Class").superClass.name.toU1Case()%>Id($row["<% type.filter("Class").superClass.name.toSqlNotation()%>_ID"]);
	<%}%>
	<%for type.filter("Class").getAncestor() {%>
			$qry =  "SELECT * FROM <%name.toSqlNotation()%> ".
					"WHERE ID = ".$current<%peek().name.toU1Case()%>->get<%name.toU1Case()%>Id();		
			$res_ancestor = $this->executeQuery($connection, $qry);	
			$row_ancestor=array();
			while ($res_ancestor->fetchInto($row_ancestor,DB_FETCHMODE_ASSOC)){
		<%for (attribute) {%>
			<%if (type.filter("PrimitiveType") != null) {%> 
				$current<%peek().name.toU1Case()%>->set<%name.toU1Case()%>($row_ancestor['<%name.toSqlNotation()%>']);
			<%}%>
		<%}%>
		<%if superClass.nSize()> 0 {%>
				$current<%peek().name.toU1Case()%>->set<%superClass.name.toU1Case()%>Id($row_ancestor["ID"]);
		<%}%>
			}	
			$res_ancestor->free();
	<%}%>
	<%pop()%>
			array_push($<%name.toL1Case()%>, $current<%name.toU1Case()%>);
		}
		$res->free();
<%}else if (inverse().upper != 1 && upper == 1 ) {%>
	<%push()%>
		$qry =  "SELECT a.* FROM <%type.name.toSqlNotation()%> a, <%inverse().type.name.toSqlNotation()%> b " .
				"WHERE b.ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = a.ID ".
				"AND b.ID = '" . $<%inverse().type.name.toL1Case()%>-><%getId(peek().type)%> . "' ";
		$res = $this->executeQuery($connection, $qry);
	<%pop()%>
		<%push()%>
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
						$runtimeType=$row['isA'];
			if($runtimeType == null) {
				$factory = new <%type.name%>Factory();
				$<%name.toL1Case()%> = $factory->create<%type.name%>($row['ID']);
				$<%name.toL1Case()%>->add<%inverse().name.toU1Case()%>($<%inverse().type.name.toL1Case()%>);
			}else{
				$rowDescendant=array();
				switch($runtimeType){
	<%push()%>
	<%for getRootContainer().eAllContents("Class").nReverse()[(getAncestor() && peek().type).nSize() > 0] + peek().type  {%>
					case "<%name%>":
						$factory = new <%name.toU1Case()%>Factory();
						//get the correct ID
						$qry2 = "SELECT ID from <%name.toSqlNotation()%> where ID = ".$row['isAId']; 
						$resDescendant = $this->executeQuery($connection,$qry2);
						if($resDescendant->numRow() == 1){
							$resDescendant->fetchInto($rowDescendant,DB_FETCHMODE_ASSOC);
							$<%peek().name.toL1Case()%>=$factory->create<%name.toU1Case()%>($rowDescendant['ID']);
							$<%peek().name.toL1Case()%>->add<%peek().inverse().name.toU1Case()%>($<%peek().inverse().type.name.toL1Case()%>);
							$resDescendant->free();
						}else
							throw new Exception("Invalid inheritance structure, ".$row['isA']." id=".$row['isAId']);
						
						break;
	<%}%><%pop()%>
				}
			
			
			<%--$<%name.toL1Case()%>->setId($row['ID']);--%>
	<%for (type.filter("Classifier").attribute) {%><%if (type.filter("PrimitiveType") != null) {%> 
			$<%peek().name.toL1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
	<%}%><%}%><%pop%>
	<%type.push()%>
	<%for type.filter("Class").getAncestor() {%>
			$qry =  "SELECT * FROM <%name.toSqlNotation()%> ".
					"WHERE ID = ".$current<%peek().name.toU1Case()%>->get<%name.toU1Case()%>Id();		
			$res_ancestor = $this->executeQuery($connection, $qry);	
			$row_ancestor=array();
			while ($res_ancestor->fetchInto($row_ancestor,DB_FETCHMODE_ASSOC)){
		<%for (attribute) {%>
			<%if (type.filter("PrimitiveType") != null) {%> 
				$current<%peek().name.toU1Case()%>->set<%name.toU1Case()%>($row_ancestor['<%name.toSqlNotation()%>']);
			<%}%>
		<%}%>
		<%if superClass.nSize()> 0 {%>
				$current<%peek().name.toU1Case()%>->set<%superClass.name.toU1Case()%>Id($row_ancestor["ID"]);
		<%}%>
			}	
			$res_ancestor->free();
	<%}%>
	<%pop()%>
		}
		$res->free();
<%}else if (upper == 1 && lower == 0 && inverse().upper == 1 && inverse().lower == 1) {%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> " .
				"WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
				$<%inverse().type.name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		$factory = new <%type.name%>Factory();
		$<%name.toL1Case()%> = $factory->create<%type.name%>();<%push()%>
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%name.toL1Case()%>->setId($row['ID']);
		<%for (type.filter("Classifier").attribute) {%><%if (type.filter("PrimitiveType") != null) {%> 
			$<%peek().name.toL1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
		<%}%><%}%><%pop()%>
		}
		$res->free();
<%}else if(inverse().upper == 1 && inverse().lower == 0 && upper == 1 && lower == 1) {%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> " .
				"WHERE ID_<%type.name.toSqlNotation()%> = '" .
				$<%inverse().type.name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		$factory = new <%type.name%>Factory();
		$<%name.toL1Case()%> = $factory->create<%type.name%>();<%push()%>
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%name.toL1Case()%>->setId($row['ID']);
		<%for (type.filter("Classifier").attribute) {%><%if (type.filter("PrimitiveType") != null) {%> 
			$<%peek().name.toL1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
		<%}%><%}%><%pop()%>
		}
		$res->free();
<%}else if (upper != 1 && inverse().upper != 1) {%>
		$qry =  "SELECT a.* FROM <%type.name.toSqlNotation()%> a, <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> b " .
				"WHERE a.ID = b.ID_<%type.name.toSqlNotation()%> " .
				"AND b.ID_<%inverse().type.name.toSqlNotation()%> = '" . 
				$<%inverse().type.name.toL1Case()%>->getId() . "'";
		$res = $this->executeQuery($connection, $qry);
		$row = array();
		$factory = new <%type.name%>Factory();
		$<%name.toL1Case()%> = array();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			$current<%name.toU1Case()%> = $factory->create<%type.name%>($row['ID']);<%push()%>
			<%for (type.filter("Classifier").attribute) {%><%if (type.filter("PrimitiveType") != null) {%> 
			$current<%peek().name.toU1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
			<%}%><%}%><%pop()%>
			array_push($<%name.toL1Case()%>, $current<%name.toU1Case()%>);
		}
		$res->free();
<%}else if (upper == 1 && inverse().upper == 1 && lower == inverse().lower) {%>
	<%if (association.memberEnd.nGet(1) == current()) {%>
		$qry = 	"SELECT a.* FROM <%type.name.toSqlNotation()%> a, <%inverse().type.name.toSqlNotation()%> b " .
				"WHERE b.ID = '" . $<%inverse().type.name.toL1Case()%>-><%getId(peek())%> . "' " .
				"AND a.ID = b.ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>";
		$res = $this->executeQuery($connection, $qry);
		$row = array();
		$factory = new <%type.name.toU1Case()%>Factory();
		$<%name.toL1Case()%> = $factory->create<%type.name.toU1Case()%>();
		<%push()%>
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%name.toL1Case()%>->setId($row['ID']);
			<%for (type.filter("Classifier").attribute) {%><%if (type.filter("PrimitiveType") != null) {%> 
			$<%peek().name.toL1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
			<%}%><%}%><%pop()%>
		}
		$res->free();
	<%}else{%>
		$qry =  "SELECT * FROM <%type.name.toSqlNotation()%> WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" . 
				$<%inverse().type.name.toL1Case()%>-><%getId(peek())%> . "' ";
		$res = $this->executeQuery($connection, $qry);
		$row = array();
		$factory = new <%type.name.toU1Case()%>Factory();
		$<%name.toL1Case()%> = $factory->create<%type.name.toU1Case()%>();
		<%push()%>
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
			$<%name.toL1Case()%>->setId($row['ID']);
			<%for (type.filter("Classifier").attribute) {%><%if (type.filter("PrimitiveType") != null) {%> 
			$<%peek().name.toL1Case()%>->set<%name.toU1Case()%>($row['<%name.toSqlNotation()%>']);
			<%}%><%}%><%pop()%>
		<%push()%>
		<%for type.filter("Class").getAncestor() {%>
			$qry =  "SELECT * FROM <%name.toSqlNotation()%> ".
					"WHERE ID = ".$<%peek().name.toL1Case()%>->get<%name.toU1Case()%>Id();		
			$res_ancestor = $this->executeQuery($connection, $qry);	
			$row_ancestor=array();
			while ($res_ancestor->fetchInto($row_ancestor,DB_FETCHMODE_ASSOC)){
			<%for (attribute) {%>
				<%if (type.filter("PrimitiveType") != null) {%> 
				$<%peek().name.toL1Case()%>->set<%name.toU1Case()%>($row_ancestor['<%name.toSqlNotation()%>']);
				<%}%>
			<%}%>
			<%if superClass.nSize()> 0 {%>
				$<%peek().name.toL1Case()%>->set<%superClass.name.toU1Case()%>Id($row_ancestor["ID"]);
			<%}%>
			}	
			$res_ancestor->free();
	<%}%>
	<%pop()%>
			
		}
		$res->free();
	<%}%>
<%}%>
		return $<%name.toL1Case()%>;
	}
<%}%><%}%>
<%pop%>
	
<%for (ownedOperation.filterWithStereotype("find")){%>
	/**
	 *
	 */
	public function <%name%><%name%>($connection, <%generateParameters%>) {
		// <%startUserCode%> of search method <%name%>
		$<%returnResult.name.toL1Case()%> = null;
		
		// TODO write the business code for <%name%> operation
		
		return $<%returnResult.name.toL1Case()%>;
		// <%endUserCode%>
	}
<%}%>


	protected function updateRelations($connection, $<%name.toL1Case()%>, $memory = array()) {
<%push()%>
<%for getProperties().filter("Property") + getAncestor().getProperties().filter("Property") {%>
	<%if (type.hasStereotype("Entity")) {%>
		$<%inverse().type.name.toL1Case()%>=$<%peek().name.toL1Case()%>;
		$<%name%> = $<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>();
		<%if (upper == 1) {%>
		if (isset( $<%name%>)) {
			<%updateRelation.indentTab().indentTab().indentTab()%>
			<%updateRelation2.indentTab().indentTab().indentTab()%>
		}
		<%}else{%>
			<%updateRelation.indentTab().indentTab()%>
			<%updateRelation2.indentTab().indentTab()%>
		<%}%>
	<%}%>	
<%}%>
	
	
	
	}
	
}

?>
<%script type="Property" name="genAssignment" post="trim()"%>
<%if (type.filter("PrimitiveType") != null) {%> 
.","." <%name.toSqlNotation()%> = '".$<%class.name.toL1Case()%>->get<%name.toU1Case()%>()."'"
<%}%>

<%script type="Operation" name="generateParameters"%>
<%-- Generates parameters with types for a method --%>
<%getRealParameters().genDeclare.sep(", ")%>

<%script type="Parameter" name="genDeclare"%>
<%-- Generates parameters with types for a method --%>
$<%name.toL1Case()%>

<%script type="Property" name="updateRelation"%>
<%if (upper != 1) {%>
foreach ($<%name%> as $<%name%>Var) {
<%push()%>
<%for getRootContainer().eAllContents("Class").nReverse()[(getAncestor() && peek().type).nSize() > 0] + peek().type  {%>
<%if i()!=0 {%>}else<%}%>if($<%peek().name%>Var instanceof '<%name%>'){
		$<%peek().type.name.toL1Case()%>Dao = new <%name%>Dao();
		if ($<%peek().name%>Var->getId() >= 0) {
			$<%peek().type.name.toL1Case()%>Dao->update<%name%>($connection, $<%peek().name%>Var, $memory);
		} else {
			$<%peek().type.name.toL1Case()%>Dao->create<%name%>($connection, $<%peek().name%>Var, $memory);
		}
	}
	<%}%>
<%pop()%>
}
<%}else{%>
<%push()%>
<%for getRootContainer().eAllContents("Class").nReverse()[(getAncestor() && peek().type).nSize() > 0] + peek().type {%>
<%if i()!=0 {%>}else<%}%>if($<%peek().name%> instanceof '<%name%>'){
		$<%name.toL1Case()%>Dao = new <%name%>Dao();
		if ($<%peek().name%>->getId() >= 0) {
			$<%name.toL1Case()%>Dao->update<%name%>($connection, $<%peek().name%>, $memory);
		} else {
			$<%name.toL1Case()%>Dao->create<%name%>($connection, $<%peek().name%>, $memory);
		}
	}
	<%}%>
<%pop()%>
<%}%>
<%script type="Property" name="updateRelation2"%>
<%--?..* -- ?..1--%><%if (upper != 1 && inverse().filter("Property").upper == 1) {%>
$list = "";
$first = true;
foreach ($<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>() as $<%name.toL1Case()%>Var) {
	if ($first) {
		$first = false;
	} else {
		$list = $list . ", ";
	}

	if($<%name%>Var instanceof '<%type.name%>'){
		$list = $list . $<%name.toL1Case()%>Var->getId();
	}else{	
		$list = $list . $<%name.toL1Case()%>Var->get<%type.name.toU1Case()%>Id();
	}
}
$qry = 	"UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
		$<%inverse().type.name.toL1Case()%>-><%getId(peek())%> . "' WHERE ID IN (" . $list . ")";
		
$this->executeQuery($connection, $qry);
<%--one to many --%><%}else if (inverse().upper != 1 && upper == 1) {%>
if($<%name%>Var instanceof '<%type.name%>'){
		$id = $<%name.toL1Case()%>Var->getId();
	}else{	
		$id = $<%name.toL1Case()%>Var->get<%type.name.toU1Case()%>Id();
	}
$qry = "UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = '" .
		$id . "' WHERE ID = '" . $<%inverse().type.name.toL1Case()%>-><%getId(peek())%> . "'";
$this->executeQuery($connection, $qry);
<%--1,1 -> 0,1 --%><%}else if (upper == 1 && lower == 0 && inverse().upper == 1 && inverse().lower == 1) {%>
$qry = "UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
		$<%inverse().type.name.toL1Case()%>->getId() . "' WHERE ID = '" . $<%name.toL1Case()%>-><%getId(peek())%> . "'";
$this->executeQuery($connection, $qry);
<%--0,1 -> 1,1 --%><%}else if(inverse().upper == 1 && inverse().lower == 0 && upper == 1 && lower == 1) {%>
$qry = "UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = " .
		$<%name.toL1Case()%>->getId().
		" WHERE ID = ".$<%inverse().type.name.toL1Case()%>-><%getId(peek())%>;
$this->executeQuery($connection, $qry);
<%--many to many --%><%}else if (upper != 1 && inverse().upper != 1) {%>
foreach ($<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>() as $<%name.toL1Case()%>Var) {
	$select = 	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " .
			"WHERE ID_<%type.name.toSqlNotation()%> =  '" . $<%name.toL1Case()%>Var->getId() . "' " .
			"AND ID_<%inverse().type.name.toSqlNotation()%> = '" . $<%inverse().type.name.toL1Case()%>-><%getId(peek())%> . "'";
	$result = $this->executeQuery($connection, $select);
	if ($result->numRows() == 0) {
		$nextId = $connection->getDb()->nextId("<%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%>_SEQ");
		$insert =	"INSERT INTO <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " .
			"(ID, ID_<%inverse().type.name.toSqlNotation()%>, ID_<%type.name.toSqlNotation()%>) VALUES ( '". $nextId ."', '" .
			$<%inverse().type.name.toL1Case()%>-><%getId(peek())%> . "', '" . $<%name.toL1Case()%>Var->getId() . "' )";
		$this->executeQuery($connection, $insert);
	}
	$result->free();
}
<%-- 0,1 <-> 0,1 && 1,1 <-> 1,1 --%><%}else if (upper == 1 && inverse().upper == 1 && lower == inverse().lower) {%>
	<%if (association.memberEnd.nGet(1) == current()) {%>
<%--$qry = 	"UPDATE <%inverse().type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .--%>
	$qry = 	"UPDATE <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> SET ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> = '" .
		$<%name.toL1Case()%>->getId() . "' WHERE ID = '" .
		$<%inverse().type.name.toL1Case()%>-><%getId(peek())%> ."' ";
	<%}else{%>
	$qry =	"UPDATE <%type.name.toSqlNotation()%> SET ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
		$<%inverse().type.name.toL1Case()%>->getId() ."' WHERE ID = '" .
		$<%name.toL1Case()%>-><%getId(peek())%> . "' ";
	<%}%>
$this->executeQuery($qry);
<%}%>
