<%--
  Copyright � 2007 Pierre Alain Bourdil
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Pierre Alain Bourdil
  Contributors :
  	- 01/05/2008 - Yann Mortier : implementation of update, delete, load. 
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.services.SqlTypeServices
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
import org.acceleo.module.pim.uml21.gen.php.common.static
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
<%getRootContainer().name%>/test/<%package.name%>/<%name%>DaoTest.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* @package test
* @subpackage test.<%name%>
* @version $Id$
*/
/**
* utilise PHPUnit
*/
require_once 'PHPUnit/Framework.php';
require_once 'PHPUnit/Framework/TestCase.php';
/**
* include test class {@see <%name%> <%name%>}
*/
require_once(dirname(__FILE__)."/../../dao/<%package.name%>/<%name.toU1Case()%>Dao.php5");
/**
* include class {@see <%name%> <%name%>}
*/
require_once(dirname(__FILE__)."/../../entity/<%package.name%>/<%name%>.php5");
require_once(dirname(__FILE__)."/../../entity/<%package.name%>/<%name%>Factory.php5");
/**
* Classe de test unitaire de la classe {@link <%name%> <%name%>}
* @package test
* @subpackage test.<%name%>
* @version $Id$
*/
class <%name%>DaoTest extends PHPUnit_Framework_TestCase
{

 	var $_fixture;
 	
 	private $daoUnderTest;
 	
 	private $entityFactory;
 	
 	public function __construct() {
 		$this->daoUnderTest = new <%name%>Dao();
 		$this->entityFactory = new <%name%>Factory();
 	}

    function setUp(){
    	// <%startUserCode%> of setUp
		// TODO write the business code for <%name%>Test setUp operation
		
		// clean the table.
		$connection = new Connection();
		$connection->open();
		$query = "delete from <%name.toSqlNotation()%>";
		$connection->getDb()->execute($query);
		$connection->close();
		// <%endUserCode%> of setUp
    }
    
    
    <%--
    - CREATE
    --%>

	function testCreate<%name%>(){
		$connection = new Connection();
		$connection->open(true);
	
		// check primitive attributes.
<%if attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize() + getAncestor.attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize() > 0 {%>
		$tmp = $this->entityFactory->create<%name%>();
<%for attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id") + getAncestor.attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id"){%>
	<%if type.name.equalsIgnoreCase("String") {%>
		$tmp->set<%name.toU1Case()%>("<%name.toLowerCase()%>");
	<%}else{%>
		$tmp->set<%name.toU1Case()%>(28);
	<%}%>		
<%}%>
		$this->daoUnderTest->create<%name.toU1Case()%>($connection,$tmp);
		
		$query="select <%(attribute + getAncestor.attribute)[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").name.toSqlNotation().sep(",")%> from <%name.toSqlNotation()%><%if (general.nSize() == 1) {%>, <%getAncestor.name.toSqlNotation().sep(", ")%><%}%> where <%name.toSqlNotation()%>.ID=".$tmp->getId()<%for (getAncestor) {%> . " and <%name.toSqlNotation()%>.ID = <%current(1).name.toSqlNotation()%>.ID"<%}%>;
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
<%for attribute[type.filter("PrimitiveType")].filterWithOutStereotype("id") + getAncestor.attribute[type.filter("PrimitiveType")].filterWithOutStereotype("id") {%>
		$this->assertSame((<%type.name%>)$row["<%name.toSqlNotation()%>"],$tmp->get<%name.toU1Case()%>());
<%}%>
		$res->free();
<%}%>

<%for getProperties().filter("Property")[type.filter("PrimitiveType")==null] + getAncestor().getProperties().filter("Property")[type.filter("PrimitiveType")==null]{%>
		// check association <%name%>.
<%--many to one --%><%if upper==1 && inverse().upper != 1 {%>
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->set<%name.toU1Case()%>(new <%type.name%>());
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		
		$query="select ID from " . <%type.name.toSqlNotation()%> . " where ID=".$tmp->get<%name.toU1Case()%>()->getId();
		$res = $this->query($connection, $query, 1);
		$res->free();
		
		$query = "select ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> from <%inverse().type.name.toSqlNotation()%>" .
				 " where ID=" . $tmp->getId() . ";";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
		$res->free();
		
<%-- one to many --%><%}else if upper != 1 && inverse().upper == 1 {%>
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->add<%name.toU1Case()%>(new <%type.name%>());
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		
		$query="select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID"], $tmp->get<%name.toU1Case()%>At(0)->getId());
		$res->free();
<%--many to many --%><%}else if (upper != 1 && inverse().upper != 1) {%>
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->add<%name.toU1Case()%>(new <%type.name.toU1Case()%>());
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'"
				. " AND ID_<%type.name.toSqlNotation()%> ='".$tmp->get<%name.toU1Case()%>At(0)->getId()."'";
		$res = $this->query($connection, $query, 1);
		$res->free();
<%--1,1 -> 0,1 --%><%}else if (upper == 1 && lower == 0 && inverse().upper == 1 && inverse().lower == 1) {%>
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->set<%name.toU1Case()%>(new <%type.name%>());
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		
		$query= "SELECT ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> WHERE ID = '" . $tmp->get<%name.toU1Case()%>()->getId() . "'";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%>"],$tmp->getId());
		$res->free();
<%--0,1 -> 1,1 --%><%}else if(inverse().upper == 1 && inverse().lower == 0 && upper == 1 && lower == 1) {%>
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->set<%name.toU1Case()%>(new <%type.name%>());
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
			
		$query= "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%inverse().type.name.toSqlNotation()%>" . " WHERE ID = ".$tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"],$tmp->get<%name.toU1Case()%>()->getId());
		$res->free();
<%-- 0,1 <-> 0,1 && 1,1 <-> 1,1 --%><%}else if (upper == 1 && inverse().upper == 1 && lower == inverse().lower) {%>
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->set<%name.toU1Case()%>(new <%type.name%>());
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		
<%if (association.memberEnd.nGet(1) == current()) {%>
		$query = "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> "
				 . " WHERE ID = '" . $tmp->getId() ."' ";
<%}else{%>
		$query = "SELECT ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> "
				." WHERE ID = '" .
				$tmp->get<%name.toU1Case()%>()->getId() . "' ";
<%}%> 
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
<%if (association.memberEnd.nGet(1) == current()) {%>
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
<%}else{%>
		$this->assertEquals($row["ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%>"], $tmp->getId());
<%}%>
		$res->free();
<%}%><%}%>
		$connection->close();
		// <%startUserCode%> testCreate<%name%>
		
		// <%endUserCode%> testCreate<%name%>
	}
	
	<%--
    - UPDATE
    --%>
	
	function testUpdate<%name%>(){
		$connection = new Connection();
		$connection->open(true);
		
		$tmp = $this->entityFactory->create<%name%>();
		<%for attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id") + getAncestor.attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id") {%>
			<%if type.name.equalsIgnoreCase("String") {%>
		$tmp->set<%name.toU1Case()%>("<%name.toLowerCase()%>");
			<%}else{%>
		$tmp->set<%name.toU1Case()%>(28);
			<%}%>		
		<%}%>
		$<%name.toL1Case()%>Dao=new <%name.toU1Case()%>Dao();
		$<%name.toL1Case()%>Dao->create<%name.toU1Case()%>($connection,$tmp);
		<%for attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id") + getAncestor.attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id") {%>
			<%if type.name.equalsIgnoreCase("String") {%>
		$tmp->set<%name.toU1Case()%>("<%name.toLowerCase()%>_updated");
			<%}else{%>
		$tmp->set<%name.toU1Case()%>(82);
			<%}%>
		<%}%>
		$<%name.toL1Case()%>Dao->update<%name.toU1Case()%>($connection,$tmp);
		
<%if attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize() + getAncestor.attribute[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").nSize() > 0 {%>
		$query="select <%(attribute + getAncestor.attribute)[type.filter("PrimitiveType")!=null].filterWithOutStereotype("id").name.toSqlNotation().sep(",")%> from <%name.toSqlNotation()%><%if (general.nSize() == 1) {%>, <%getAncestor.name.toSqlNotation().sep(", ")%><%}%> where <%name.toSqlNotation()%>.ID=".$tmp->getId()<%for (getAncestor) {%> . " and <%name.toSqlNotation()%>.ID = <%current(1).name.toSqlNotation()%>.ID"<%}%>;
		$res =& $connection->getDb()->query($query);
		if (PEAR::isError($res)) {
		    echo 'Message Standard         : ' . $res->getMessage() . "\n";
		    echo 'Message DBMS/Utilisateur : ' . $res->getUserInfo() . "\n";
		    echo 'Message DBMS/D&eacute;bogage   : ' . $res->getDebugInfo() . "\n";
		}
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		}
<%for attribute[type.filter("PrimitiveType")].filterWithOutStereotype("id") + getAncestor.attribute[type.filter("PrimitiveType")].filterWithOutStereotype("id") {%>
		$this->assertSame((<%type.name%>)$row["<%name.toSqlNotation()%>"],$tmp->get<%name.toU1Case()%>());
<%}%>
<%}%>	

<%for getProperties().filter("Property")[type.filter("PrimitiveType")==null] + getAncestor().getProperties().filter("Property")[type.filter("PrimitiveType")==null]{%>
		// check association <%name%>.
<%--many to one --%><%if upper==1 && inverse().upper != 1 {%>
		// create
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		$query="select ID from " . <%type.name.toSqlNotation()%> . " where ID=".$tmp->get<%name.toU1Case()%>()->getId();
		$res = $this->query($connection, $query, 1);
		$res->free();
		$query = "select ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> from <%inverse().type.name.toSqlNotation()%>" .
				 " where ID=" . $tmp->getId() . ";";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
		$res->free();
		
		// update
		$<%name.toL1Case()%>2 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>2);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$this->assertNotEquals($<%name.toL1Case()%>2->getId(), $<%name.toL1Case()%>1->getId());
		$this->assertEquals($tmp->get<%name.toU1Case()%>()->getId(), $<%name.toL1Case()%>2->getId());
		$this->assertTrue($tmp->get<%name.toU1Case()%>()->getId() >= 0);
		$query = "select ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> from <%inverse().type.name.toSqlNotation()%>" .
				 " where ID=" . $tmp->getId() . ";";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
		$res->free();
		
		// remove the attribute.
		$tmp->set<%name.toU1Case()%>(null);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query = "select ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> from <%inverse().type.name.toSqlNotation()%>" .
				 " where ID=" . $tmp->getId() . ";";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertNull($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], "The property <%name%> can't be unsetted");
		
<%-- one to many --%><%}else if upper != 1 && inverse().upper == 1 {%>
		// create
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->add<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		
		$query = "select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID"], $tmp->get<%name.toU1Case()%>At(0)->getId());
		$res->free();
		
		// add an element.
		$<%name.toL1Case()%>2 = new <%type.name%>();
		$tmp->add<%name.toU1Case()%>($<%name.toL1Case()%>2);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query = "select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 2);
		$find1 = false;
		$find2 = false;
		$row = array();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			if ($row["ID"] == $<%name.toL1Case()%>1->getId()) {
				$find1 = true;
			}
			if ($row["ID"] == $<%name.toL1Case()%>2->getId()) {
				$find2 = true;
			}
		}
		$this->assertTrue($find1, "The first element is not in the database.");
		$this->assertTrue($find2, "The second element is not in the database.");
		$this->assertNotEquals($<%name.toL1Case()%>1->getId(), $<%name.toL1Case()%>2->getId());
		$this->assertTrue($<%name.toL1Case()%>1->getId() >= 0);
		$this->assertTrue($<%name.toL1Case()%>2->getId() >= 0);
		$res->free();
		
		// remove the first element
		$tmp->remove<%name.toU1Case()%>At(0);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query = "select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID"], $tmp->get<%name.toU1Case()%>At(0)->getId());
		$this->assertEquals($tmp->get<%name.toU1Case()%>At(0)->getId(), $<%name.toL1Case()%>2->getId());
		$res->free();
		
		// clear the list
		$tmp->remove<%name.toU1Case()%>At(0);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query = "select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 0);
		$res->free();
		
		// add an element
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->add<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query = "select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID"], $tmp->get<%name.toU1Case()%>At(0)->getId());
		$res->free();
		
		// unset the list.
		$tmp->set<%name.toU1Case()%>(null);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query = "select ID from <%type.name.toSqlNotation()%> where ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = " . $tmp->getId();
		$res = $this->query($connection, $query, 0);
		$res->free();
		
<%--many to many --%><%}else if (upper != 1 && inverse().upper != 1) {%>
		// create
		$<%name.toL1Case()%>1 = new <%type.name.toU1Case()%>();
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$tmp->add<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'"
				. " AND ID_<%type.name.toSqlNotation()%> ='".$tmp->get<%name.toU1Case()%>At(0)->getId()."'";
		$res = $this->query($connection, $query, 1);
		$res->free();
		
		// add an element
		$<%name.toL1Case()%>2 = new <%type.name.toU1Case()%>();
		$tmp->add<%name.toU1Case()%>($<%name.toL1Case()%>2);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'";
		$res = $this->query($connection, $query, 2);
		$find1 = false;
		$find2 = false;
		$goodId = true;
		$row = array();
		while ($res->fetchInto($row, DB_FETCHMODE_ASSOC)) {
			if ($row["ID_<%type.name.toSqlNotation()%>"] == $<%name.toL1Case()%>1->getId()) {
				$find1 = true;
			}
			if ($row["ID_<%type.name.toSqlNotation()%>"] == $<%name.toL1Case()%>2->getId()) {
				$find2 = true;
			}
		}
		$this->assertTrue($find1, "The first element is not in the database.");
		$this->assertTrue($find2, "The second element is not in the database.");
		$this->assertNotEquals($<%name.toL1Case()%>1->getId(), $<%name.toL1Case()%>2->getId());
		$this->assertTrue($<%name.toL1Case()%>1->getId() >= 0);
		$this->assertTrue($<%name.toL1Case()%>2->getId() >= 0);
		$res->free();
		
		// remove the first element
		$tmp->remove<%name.toU1Case()%>At(0);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>At(0)->getId());
		$this->assertEquals($tmp->get<%name.toU1Case()%>At(0)->getId(), $<%name.toL1Case()%>2->getId());
		$res->free();
		
		// clear the list
		$tmp->remove<%name.toU1Case()%>At(0);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'";
		$res = $this->query($connection, $query, 0);
		$res->free();
		
		// add an element
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->add<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>At(0)->getId());
		$res->free();
		
		// unset the list.
		$tmp->set<%name.toU1Case()%>(null);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query=	"SELECT * FROM <%association.memberEnd.nGet(0).name.toSqlNotation()%>_<%association.memberEnd.nGet(1).name.toSqlNotation()%> " 
				. " WHERE ID_<%inverse().type.name.toSqlNotation()%>='".$tmp->getId()."'";
		$res = $this->query($connection, $query, 0);
		$res->free();
		
<%--1,1 -> 0,1 --%><%}else if (upper == 1 && lower == 0 && inverse().upper == 1 && inverse().lower == 1) {%>
		// create
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		$query= "SELECT ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> WHERE ID = '" . $tmp->get<%name.toU1Case()%>()->getId() . "'";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%>"],$tmp->getId());
		$res->free();
		
		// update
		$<%name.toL1Case()%>2 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>2);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$this->assertNotEquals($<%name.toL1Case()%>2->getId(), $<%name.toL1Case()%>1->getId());
		$this->assertEquals($tmp->get<%name.toU1Case()%>()->getId(), $<%name.toL1Case()%>2->getId());
		$this->assertTrue($tmp->get<%name.toU1Case()%>()->getId() >= 0);
		$query= "SELECT ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> WHERE ID = '" . $tmp->get<%name.toU1Case()%>()->getId() . "'";
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%>"], $tmp->getId());
		$res->free();
		
		// unset the attribute.
		$tmp->set<%name.toU1Case()%>(null);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query= "SELECT ID FROM <%type.name.toSqlNotation()%> WHERE ID_<%name.toSqlNotation()%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" . $tmp->getId() . "'";
		$res = $this->query($connection, $query, 0);
		$res->free();
		
<%--0,1 -> 1,1 --%><%}else if(inverse().upper == 1 && inverse().lower == 0 && upper == 1 && lower == 1) {%>
		// create
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
		$query= "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%inverse().type.name.toSqlNotation()%>" . " WHERE ID = ".$tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"],$tmp->get<%name.toU1Case()%>()->getId());
		$res->free();
		
		// update
		$<%name.toL1Case()%>2 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>2);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$this->assertNotEquals($<%name.toL1Case()%>2->getId(), $<%name.toL1Case()%>1->getId());
		$this->assertEquals($tmp->get<%name.toU1Case()%>()->getId(), $<%name.toL1Case()%>2->getId());
		$this->assertTrue($tmp->get<%name.toU1Case()%>()->getId() >= 0);
		$query= "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%inverse().type.name.toSqlNotation()%>" . " WHERE ID = ".$tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
		$res->free();
		
		// unset the attribute.
		$tmp->set<%name.toU1Case()%>(null);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$query= "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%inverse().type.name.toSqlNotation()%>" . " WHERE ID = ".$tmp->getId();
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		$this->assertNull($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], "The property <%name%> can't be unsetted");
		
<%-- 0,1 <-> 0,1 && 1,1 <-> 1,1 --%><%}else if (upper == 1 && inverse().upper == 1 && lower == inverse().lower) {%>
		// create
		$tmp = $this->entityFactory->create<%current(2).name%>();
		$<%name.toL1Case()%>1 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>1);
		$this->daoUnderTest->create<%current(2).name.toU1Case()%>($connection,$tmp);
<%if (association.memberEnd.nGet(1) == current()) {%>
		$query = "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> "
				 . " WHERE ID = '" . $tmp->getId() ."' ";
<%}else{%>
		$query = "SELECT ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> "
				." WHERE ID = '" .
				$tmp->get<%name.toU1Case()%>()->getId() . "' ";
<%}%> 
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
<%if (association.memberEnd.nGet(1) == current()) {%>
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
<%}else{%>
		$this->assertEquals($row["ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%>"], $tmp->getId());
<%}%>
		$res->free();
		
		// update
		$<%name.toL1Case()%>2 = new <%type.name%>();
		$tmp->set<%name.toU1Case()%>($<%name.toL1Case()%>2);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
		$this->assertNotEquals($<%name.toL1Case()%>2->getId(), $<%name.toL1Case()%>1->getId());
		$this->assertEquals($tmp->get<%name.toU1Case()%>()->getId(), $<%name.toL1Case()%>2->getId());
		$this->assertTrue($tmp->get<%name.toU1Case()%>()->getId() >= 0);
<%if (association.memberEnd.nGet(1) == current()) {%>
		$query = "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> "
				 . " WHERE ID = '" . $tmp->getId() ."' ";
<%}else{%>
		$query = "SELECT ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> "
				." WHERE ID = '" .
				$tmp->get<%name.toU1Case()%>()->getId() . "' ";
<%}%>
		$res = $this->query($connection, $query, 1);
		$row = array();
		$res->fetchInto($row, DB_FETCHMODE_ASSOC);
<%if (association.memberEnd.nGet(1) == current()) {%>
		$this->assertEquals($row["ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%>"], $tmp->get<%name.toU1Case()%>()->getId());
<%}else{%>
		$this->assertEquals($row["ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%>"], $tmp->getId());
<%}%>
		$res->free();
		
		
		// unset the attribute.
		$tmp->set<%name.toU1Case()%>(null);
		$this->daoUnderTest->update<%current(2).name.toU1Case()%>($connection,$tmp);
<%if (association.memberEnd.nGet(1) == current()) {%>
		$query = "SELECT ID_<%inverse().name.toSqlNotation()%>_FROM_<%type.name.toSqlNotation()%> FROM <%association.memberEnd.nGet(0).type.name.toSqlNotation()%> "
				 . " WHERE ID = '" . $tmp->getId() ."' ";
<%}else{%>
		$query = "SELECT ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> FROM <%type.name.toSqlNotation()%> "
				." WHERE ID_<%name.toSqlNotation%>_FROM_<%inverse().type.name.toSqlNotation()%> = '" .
				$tmp->getId() . "' ";
		$res = $this->query($connection, $query, 0);
		$res->free();
<%}%>
		
<%}%><%}%>
		$connection->close();
		// <%startUserCode%> testUpdate<%name%>
		
		// <%endUserCode%> testUpdate<%name%>
	}
	
	/*function testDelete<%name%>(){
		// <%startUserCode%> testDelete<%name%>
		
		// add a data
		$insert = "insert into <%name.toSqlNotation()%> SET ID = '". 1 . "' "
<%if (attribute.nSize() > 0){%>
					<%attribute.genAssignment.sep("\n\t\t\t\t\t")%>.";";<%}else{%>.";";
<%}%>
		
		
		// <%endUserCode%> testDelete<%name%>
	}*/
	
	function testFindById(){
		// <%startUserCode%> testFindById
		
		// <%endUserCode%> testFindById
	}
	
	function testFindAll<%name%>s(){
		// <%startUserCode%> testFindAll
		// <%endUserCode%> testFindAll
	}
	
	function testLoad<%name.toU1Case()%>(){
		// <%startUserCode%> testLoad
		
		// <%endUserCode%> testLoad
	}
	
	function test<%name.toU1Case()%><%name%>(){
		// <%startUserCode%> test<%name.toU1Case()%><%name%>
		
		// <%endUserCode%> test<%name.toU1Case()%><%name%>
	}
	
	function testUpdateRelations(){
		// <%startUserCode%> testUpdateRelations
		
		// <%endUserCode%> testUpdateRelations
	}
	
	private function query($connection, $query, $expectedReturnRowCount) {
		$res =& $connection->getDb()->query($query);
		if (PEAR::isError($res)) {
			$failMsg =	"Message     : " . $res->getMessage() . "\n" .
						"User Info   : " . $res->getUserInfo() . "\n" .
						"Debug Info  : " . $res->getDebugInfo() . "\n";
		    $this->fail($failMsg);
		}
		$this->assertEquals($res->numRows(), $expectedReturnRowCount, "Expected " . $expectedReturnRowCount . " row(s). Found " . 
							$res->numRows() . " row(s). QUERY={" . $query . "}");
		return $res;	
	}
}

<%script type="Property" name="genAssignment" post="trim()"%>
<%if (type.filter("PrimitiveType") != null) {%> 
. ", <%name.toSqlNotation()%> = '" . $<%class.name.toL1Case()%>->get<%name.toU1Case()%>() . "'"
<%}%>
