<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
<%getRootContainer().name%>/entity/<%name%>.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php


/***************************/
/*	Class <%name%> */     
 * <%ownedComment.body%> */
/***************************/

class <%name%> <%extensions%>{

<%for (getProperties().filter("Property")){%>
	<%if (ownedComment){%>
	// <%ownedComment.body%>
	<%}%>
	var $<%name%>;
<%}%>

	function <%name%>() {
		// <%startUserCode%> of constructor
		// <%endUserCode%>
	}
	
	<%--
		Getters/Setters
		des attributs.
		Ne gnre pas de setters si l'attribut est
		en lecture seul.
	--%>
<%for (getProperties().filter("Property")) {%>
	/**
	 * Return <%name%> value.
	 * Type : <%type.name%>
	 *
	 * @return <%ownedComment.body%>
	 */
	public function get<%name.toU1Case()%>() {
		return $this-><%name%>;
	}

<%if (!isReadOnly()) {%>
	/**
	 * Setting of <%name%> value.
	 * Type : <%type.name%>
	 * 
	 * @param <%name%> <%ownedComment.body%>
	 */
	public function set<%name.toU1Case()%>($<%name%>) {
		$this-><%name%> = $<%name%>;
	}
<%}%>
		
<%}%>

	<%--
		Oprations sur les collections.
	--%>
<%for (getProperties().filter("Property")){%><%if (upper != 1) {%>
	
	<%-- Ajout dans la collection --%>
	/**
	 * Add a <%type.name%> inside <%name%>.
	 *
	 */
	public function add<%name.toU1Case()%>($<%type.name.toU1Case()%>) {
		$this-><%name%>[$this->getNb<%name.toU1Case()%>()] = $<%type.name.toL1Case()%>;
	}
	
	<%-- Compte le nombre d'lments dans la collection. --%>
	/**
	 * Return the number of <%type.name%> in <%name%>.
	 *
	 */
	public function getSizeOf<%name.toU1Case()%>() {
		return count($this-><%name%>);
	}
	
	<%-- Return an element. i() --%>
	/**
	 * Return an element <%type.name%> of <%name%>
	 */
	public function get<%name.toU1Case()%>At($i) {
		return $this-><%name%>[$i];
	}
<%}%><%}%>

	
<%for (ownedOperation){%>
	/**
	 * Operation <%name%>
	 *
	 * <%ownedComment.body%>
	 * 
<%if (ownedParameter.nSize()>0){%>
	 * Parameters : 
<%}%>
<%for (ownedParameter){%>
	 *		<%type.name%> <%name%> : <%ownedComment.body%>
<%}%>
     * 
<%if (returnResult.nSize()>0){%>
     * Return : 
     * 		<%returnResult.type.name%> <%returnResult.name%> : <%returnResult.ownedComment.body%>
<%}%>
     *
	 */
	function <%name%>(<%generateParameters%>) {
		// <%startUserCode%> of business method <%name%>
		$<%returnResult.name.toL1Case()%> = null;
		
		// TODO write the business code for <%name%> operation
		
		return $<%returnResult.name.toL1Case()%>;
		// <%endUserCode%>
	}
	
<%}%>

	<%-- Mthodes toString() --%>
	/**
	 * Return an HTML description of the current object.
	 *
	 */
	public function __toString() {
		$ret = "<table border=\"4\">";
<%for (attribute){%>
	<%if (isComposite){%>
		$ret = $ret."<tr><td>";
		$ret = $ret . "<table border=\"2\">";
		for ($i = 0; $i<$this->getSizeOf<%name.toU1Case()%>(); $i++) {
			$ret = $ret."<tr><td>".stripslashes("<%ownedComment.body%>")." n $i</td><td>";
		<%if (type!=null && (type.hasStereotype("Entity"))){%>
			$ret = $ret . $this->get<%name.toU1Case()%>At($i)->__toString();
		<%}else{%>
			$ret = $ret. striplslashes($this->get<%name.toU1Case()%>A($i));
		<%}%>
			$ret = $ret."</td></tr>";
		}
		$ret = $ret . "</table>";
		$ret = $ret . "</td></tr>"; 
	<%}else{%>
		$ret = $ret."<tr><td>".stripslashes("<%ownedComment.body%>")."</td>";
		$ret = $ret . "<td>";
		<%if (type!=null && (type.hasStereotype("Entity"))){%>
		$ret = $ret . $this->get<%name.toU1Case()%>()->__toString();
		<%}else{%>
		$ret = $ret. stripslashes($this->get<%name.toU1Case()%>());
		<%}%>
		$ret = $ret . "</td></tr>"; 
	<%}%>
<%}%>
	
		$ret = $ret."</table>";
		return $ret;
	}
	
	public function getSimpleString() {
		$desc =	'<%name%> : [id=' . $this->getId() . '] '
<%for (attribute) {%><%if (type.filter("PrimitiveType") != null && upper == 1) {%>
				. '[<%name%>=' . $this->get<%name.toL1Case()%>() . '] '
<%}%><%}%>;

	}

}
?>

<%script type="Class" name="extensions"%>
<%if (superClass.nSize() == 1){%> extends <%general.name%><%}else{%> <%}%>

<%script type="Operation" name="generateParameters"%>
<%-- Generates parameters with types for a method --%>
<%getRealParameters().genDeclare.sep(", ")%>

<%script type="Parameter" name="genDeclare"%>
<%-- Generates parameters with types for a method --%>
$<%name.toL1Case()%>
