<%--
  Copyright � 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
import org.acceleo.module.pim.uml21.gen.php.common.static
import org.acceleo.module.pim.uml21.gen.php.entity.entity-base
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
<%getRootContainer().name%>/entity/<%package.name%>/<%name%>.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* @package <%package.name%>
*/

<%if (superClass.nSize()==1){%>
require_once(dirname(__FILE__).'/<%general.name%>.php5');
<%}else{%>
require_once(dirname(__FILE__).'/../Entity.php5');
<%}%>

<%for (attribute[association == null && type.eClass().name == "Enumeration" ]) {%>
require_once(dirname(__FILE__)."/../../dao/enumeration/<%name.toU1Case()%>EnumerationDao.php5");
<%}%>

<%for getProperties.filter("Property")[type!=null && type.filter("PrimitiveType") == null && type.filter("Enumeration") == null ] {%>
require_once(dirname(__FILE__)."/<%type.name%>.php5");
<%}%>
<%classDocBlocPhpdoc%>
class <%name%> <%extensions%>{

<%for (getProperties().filter("Property")){%>
	<%if (ownedComment){%>
	/**
	*<%ownedComment.body%>
	*@var <%type.name%>
	*/
	<%}%>
	<%visibility%><%if (isStatic) {%> static<%}%> $<%name.toL1Case()%>;
<%}%>


	/**
	 * Empty constuctor
	 * 
	 */
	public function __construct($id = -1<%ancestorConstructorParameters.trim()%><%relationParameters.trim()%>) {
		parent::__construct($id<%ancestorConstructorCall%>);
		$this->logger =& Log::singleton('file', dirname(__FILE__).'/../log/entity.log',PEAR_LOG_DEBUG);
		// <%startUserCode%> of constructor
		// <%endUserCode%> of constructor
	}

<%--
	Genere les getter/setter de cle etrangere des ancetres
--%>
<%ancestorIdGetterSetter%>
	<%--
		Getters/Setters
		des attributs.
		Ne g�n�re pas de setters si l'attribut est
		en lecture seul.
	--%>
	
<%for (getProperties().filter("Property")) {%>
	/**
	 * Return <%name%> value.
	 * Type : <%type.name%>
	 *
	 * @return <%ownedComment.body%>
	 */
	public<%if (isStatic) {%> static<%}%> function get<%name.toU1Case()%>($lazyloading = true) {
		return $this-><%name%>;
	}

	
	/**
	 * Setting of <%name%> value.
	 * Type : <%type.name%>
	 * 
	 * @param <%name%> <%ownedComment.body%>
	 */
	<%if (!isReadOnly()) {%>public<%}else{%>protected<%}%><%if (isStatic) {%> static<%}%> function set<%name.toU1Case()%>($<%name%>) {
		$this-><%name%> = $<%name%>;
	}

	<%if (upper != 1){%>
	<%-- Ajout dans la collection --%>
	/**
	 * Add a <%type.name%> inside <%name%>.
	 *
	 */
	public<%if (isStatic) {%> static<%}%> function add<%name.toU1Case()%>($<%type.name.toL1Case()%>) {
		if (!isset($this-><%name%>)) {
			$this->logger->log("{add<%name.toU1Case()%>} You should not use an alter operation while the array is not initialized.", PEAR_LOG_WARNING);
			$this-><%name%> = array();
		}
		array_push($this-><%name%>, $<%type.name.toL1Case()%>);
	}
	
	<%-- Suppression dans la collection --%>
	/**
	 * Remove a <%type.name%> from <%name%>.
	 *
	 */
	public<%if (isStatic) {%> static<%}%> function remove<%name.toU1Case()%>At($i) {
	$this->logger->log("Before remove the array : " . $this->getSizeOf<%name.toU1Case()%>(), PEAR_LOG_DEBUG);
		if (!isset($this-><%name%>)) {
			$this->logger->log("{remove<%name.toU1Case()%>} You should not use an alter operation while the array is not initialized.", PEAR_LOG_WARNING);
			$this-><%name%> = array();
		}
		array_splice($this-><%name%>, $i, 1);
		$this->logger->log("After remove the array : " . $this->getSizeOf<%name.toU1Case()%>(), PEAR_LOG_DEBUG);
	}
	
	<%-- Compte le nombre d'�l�ments dans la collection. --%>
	/**
	 * Return the number of <%type.name%> in <%name%>.
	 *
	 */
	public<%if (isStatic) {%> static<%}%> function getSizeOf<%name.toU1Case()%>() {
		if (!isset($this-><%name%>)) {
			$this-><%name%> = array();
		}
		return count($this-><%name%>);
	}
	
	<%-- Return an element. i() --%>
	/**
	 * Return an element <%type.name%> of <%name%>
	 */
	public<%if (isStatic) {%> static<%}%> function get<%name.toU1Case()%>At($i) {
		if (!isset($this-><%name%>)) {
			$this-><%name%> = array();
		}
		return $this-><%name%>[$i];
	}
	<%}%>
		
<%}%>

	
<%for (ownedOperation){%>
	/**
	 * Operation <%name%>
	 *
	 * <%ownedComment.body%>
	 * 
<%if (ownedParameter.nSize()>0){%>
	 * Parameters : 
<%}%>
<%for (ownedParameter){%>
	 *		<%type.name%> <%name%> : <%ownedComment.body%>
<%}%>
     * 
<%if (returnResult.nSize()>0){%>
     * Return : 
     * 		<%returnResult.type.name%> <%returnResult.name%> : <%returnResult.ownedComment.body%>
<%}%>
     *
	 */
	<%visibility%> <%if isStatic(){%>static<%}%> function <%name%>(<%generateParameters%>) {
		// <%startUserCode%> of business method <%name%>
		$<%returnResult.name.toL1Case()%> = null;
		
		// TODO write the business code for <%name%> operation
		
		return $<%returnResult.name.toL1Case()%>;
		// <%endUserCode%>
	}
	
<%}%>

	<%-- M�thodes toString() --%>
	/**
	 * Return an HTML description of the current object.
	 *
	 */
	public function __toString() {
		$ret = "<table border=\"4\">";
<%for (getProperties()){%>
	<%if (upper != 1){%>
		$ret = $ret."<tr><td>";
		$ret = $ret . "<table border=\"2\">";
		for ($i = 0; $i<$this->getSizeOf<%name.toU1Case()%>(); $i++) {
			$ret = $ret."<tr><td>".stripslashes("<%ownedComment.body%>")." n� $i</td><td>";
		<%if (type!=null && (type.hasStereotype("Entity"))){%>
			$ret = $ret . $this->get<%name.toU1Case()%>At($i)->__toString();
		<%}else{%>
			$ret = $ret. striplslashes($this->get<%name.toU1Case()%>At($i));
		<%}%>
			$ret = $ret."</td></tr>";
		}
		$ret = $ret . "</table>";
		$ret = $ret . "</td></tr>"; 
	<%}else{%>
		$ret = $ret."<tr><td>".stripslashes("<%ownedComment.body%>")."</td>";
		$ret = $ret . "<td>";
		<%if (type!=null && (type.hasStereotype("Entity"))){%>
		$ret = $ret . $this->get<%name.toU1Case()%>()->__toString();
		<%}else{%>
		$ret = $ret. stripslashes($this->get<%name.toU1Case()%>());
		<%}%>
		$ret = $ret . "</td></tr>"; 
	<%}%>
<%}%>
	
		$ret = $ret."</table>";
		return $ret;
	}
	
	/**
	 * Returns a string which describes this <%name%> object. Util for logging.
	 *
	 * @return String $desc a string which describes this <%name%> object.
	 */
	public function getSimpleString() {
		$desc =	'<%name%> : [id=' . $this->getId() . '] '
<%for (attribute) {%><%if (type.filter("PrimitiveType") != null && upper == 1) {%>
				. '[<%name%>=' . $this->get<%name.toL1Case()%>() . '] '
<%}%><%}%>
				;
		return $desc;
	}
	
	/**
	 * Return the factory that has created this object.
	 *
	 * @return string the factory that has created this object.
	 */
	public function getFactory() {
		return new <%name%>Factory();
	}

}
?>
<%script type="Class" name="extensions"%>
<%if (superClass.nSize() == 1){%> extends <%general.name%><%}else{%> extends Entity<%}%>

<%script type="Operation" name="generateParameters"%>
<%-- Generates parameters with types for a method --%>
<%getRealParameters().genDeclare.sep(", ")%>

<%script type="Parameter" name="genDeclare"%>
<%-- Generates parameters with types for a method --%>
$<%name.toL1Case()%>




		




