package org.acceleo.module.pim.uml21.services;

import java.util.Iterator;

import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterDirectionKind;

import fr.obeo.acceleo.ecore.factories.FactoryException;
import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;
import fr.obeo.acceleo.gen.template.eval.ENodeList;

public class Operations {

	/**
	 * Return a list of parameters of an operation without the return type
	 * @param node
	 * @return
	 * @throws ENodeCastException
	 * @throws FactoryException
	 */
	public ENodeList getRealParameters(ENode node) throws ENodeCastException, FactoryException {
		ENodeList parListFiltered = new ENodeList();
		if (node.getEObject() instanceof Operation){
			Operation op = (Operation)node.getEObject();
		
			EList parList = op.getOwnedParameters();
			for (Iterator iterPar = parList.iterator(); iterPar.hasNext();) {
				Parameter par = (Parameter) iterPar.next();
				if (!par.getDirection().equals(ParameterDirectionKind.RETURN_LITERAL))
					parListFiltered.add(new ENode(par, node));
			}
		}
		return parListFiltered;		
	}
}
