/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package wisss.data.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import wisss.data.Attribute;
import wisss.data.DataFactory;
import wisss.data.DataPackage;
import wisss.type.TypeFactory;

/**
 * This is the item provider adapter for a {@link wisss.data.Attribute} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AttributeItemProvider
	extends ItemProviderAdapter
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AttributeItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addRequiredPropertyDescriptor(object);
			addUniquePropertyDescriptor(object);
			addArrayPropertyDescriptor(object);
			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Required feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addRequiredPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Attribute_required_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Attribute_required_feature", "_UI_Attribute_type"),
				 DataPackage.Literals.ATTRIBUTE__REQUIRED,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Unique feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addUniquePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Attribute_unique_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Attribute_unique_feature", "_UI_Attribute_type"),
				 DataPackage.Literals.ATTRIBUTE__UNIQUE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Array feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addArrayPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Attribute_array_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Attribute_array_feature", "_UI_Attribute_type"),
				 DataPackage.Literals.ATTRIBUTE__ARRAY,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Attribute_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Attribute_name_feature", "_UI_Attribute_type"),
				 DataPackage.Literals.ATTRIBUTE__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(DataPackage.Literals.ATTRIBUTE__TYPE);
		}
		return childrenFeatures;
	}

	/**
	 * This returns Attribute.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Attribute"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((Attribute)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Attribute_type") :
			getString("_UI_Attribute_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Attribute.class)) {
			case DataPackage.ATTRIBUTE__REQUIRED:
			case DataPackage.ATTRIBUTE__UNIQUE:
			case DataPackage.ATTRIBUTE__ARRAY:
			case DataPackage.ATTRIBUTE__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case DataPackage.ATTRIBUTE__TYPE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 DataFactory.eINSTANCE.createClass()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createString()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createEmail()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createInteger()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createFloat()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createDouble()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createText()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createDatetime()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createUser()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createFile()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createBoolean()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createDate()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createGroup()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createTime()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createPicture()));

		newChildDescriptors.add
			(createChildParameter
				(DataPackage.Literals.ATTRIBUTE__TYPE,
				 TypeFactory.eINSTANCE.createIdentifier()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return WisssEditPlugin.INSTANCE;
	}

}
