<?php
require_once ('Zend/Loader.php') ;
require_once ('Zend/Registry.php') ;

/**
 * class Wisss_Dao_Factory_Abstract
 * @package Wisss
 */
abstract class Wisss_Dao_Factory_Abstract
{
    /**
     * returns a dao for the specified class regarding the persistence set
     * in the config file for this class
     *
     * @param string $class_name
     * @return Wisss_Dao_Interface
     */
    public static function getDao($class_name)
    {
    	$persistence = Zend_Registry::get('config')->persistence->$class_name ;
        $dao_class_name = str_replace('_Dto_','_Dao_'.$persistence.'_',$class_name) ;
        Zend_Loader::loadClass($dao_class_name,array('modules-available'));
        return new $dao_class_name() ;
    }
}
?>