<?php
require_once('Zend/Validate.php') ;
require_once('Zend/Validate/Int.php') ;
require_once('lib/Wisss/Observable.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;
require_once('lib/Wisss/ChangeRecorder.php') ;
require_once('lib/Wisss/Dto/Registry/Abstract.php') ;

/**
 * class Wisss_Dto_Abstract
 * @package Mc
 */
abstract class Wisss_Dto_Abstract extends Wisss_Observable
{
    protected $__id ;
    protected $__loaded ;
    
    public function __construct()
    {
    	parent::__construct() ;
    	$this->__id = null ;
    	$this->__loaded = array() ;
    }

	public function __destruct()
	{
		parent::__construct() ;
	}

	public abstract function __setToLoaded() ;
	public abstract function __setToNotLoaded() ;

	public function __getUid()
	{
		return spl_object_hash($this) ;
	}

    public function getId()
    {
        return $this->__id ;
    }

    public function setId($id)
    {
        $validatorChain = new Zend_Validate();
        $validatorChain->addValidator(new Zend_Validate_Int()) ;

        if ($validatorChain->isValid($id)) {
            $this->__id = $id ;
        } else {
            throw new Exception('Invalid id') ;
        }
        Wisss_Dto_Registry_Abstract::register($this) ;
    }
    
    public function unsetId()
    {
    	Wisss_Dto_Registry_Abstract::unregister($this) ;
    	$this->__id = null ;
    }
    
    /**
     * returns true if $o is the same object or if it has a common parent classes and the same id
     */
    public function __sameAs(Wisss_Dto_Abstract $o)
    {
    	if($this === $o || ($this->__id != null && $this->__id == $o->getId())) {
    		return true ;
    	}
   		return false ;
    }
    
    
    /**
     * __save triggers the saving processus on the object
     */
    public function __save()
    {
    	$dao = Wisss_Dao_Factory_Abstract::getDao(get_class($this)) ;
    	$dao->save($this) ;
    }
    
    /**
     * __load triggers the loading processus on the object
     */
    public function __load()
    {
    	$dao = Wisss_Dao_Factory_Abstract::getDao(get_class($this)) ;
    	$dao->load($this) ;
    }
    
    /**
     * __delete triggers the deleting processus on the object
     */
    public function __delete()
    {
    	$dao = Wisss_Dao_Factory_Abstract::getDao(get_class($this)) ;
    	$dao->delete($this) ;
    }
}