<?php
abstract class Wisss_Observable
{
	protected $__observers ;
	protected $__hasChanged ;
	
	public function __construct()
	{
		$this->__observers = array() ;
		$this->__hasChanged = false ;
	}
	
	public function __destruct()
	{
	
	}
	
	public function addObserver(Wisss_Observer $o)
	{
		$this->__observers[] = $o ;
	}
	
	protected function clearChanged()
	{
		$this->__hasChanged = false ;
	}
	
	public function countObservers()
	{
		return array_count($this->__observers) ;
	}
	
	public function deleteObserver(Wisss_Observer $o)
	{
		$key = array_search($o) ;
		if(isset($key)) {
			unset($this->__observers[$o]) ;
		}
	}
	
	public function deleteObservers()
	{
		$this->__observers = array() ;
	}
	
	public function hasChanged()
	{
		return $this->__hasChanged ;
	}
	
	public function notifyObservers($args=null)
	{
		if($this->__hasChanged) {
			foreach($this->__observers as $observer) {
				$observer->update($this,$args) ;
			}
		}
		$this->clearChanged() ;
	}
	
	protected function setChanged()
	{
		$this->__hasChanged = true ;
	}
}