<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;
require_once('lib/Wisss/Dto/Registry/Abstract.php') ;

class testmodule_Dao_Mysql_A implements Wisss_Dao_Interface
{
	protected $attributes = array('atta' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' testmodule_a.__id,' ;
		}
		/* simple attributes */
		$query .= ' testmodule_a.atta ' ;
		/* reference ids for lazy loading */
		$query .= ',testmodule_a.roleb_in_asso_1_1, testmodule_a.roleb_in_asso_1_1_wa, testmodule_a.rolebc_in_asso_11_11_11, testmodule_a.rolebc_in_asso_n1_n1_n1, testmodule_a.rolebc_in_asso_11_11_1n, testmodule_a.rolebc_in_asso_11_11_n1, testmodule_a.rolebc_in_asso_11_11_nn, testmodule_a.rolebc_in_asso_n1_n1_11, testmodule_a.rolebc_in_asso_n1_n1_1n, testmodule_a.rolebc_in_asso_n1_n1_nn, testmodule_a.rolebc_in_asso_11_1n_n1, testmodule_a.rolebc_in_asso_11_1n_nn, testmodule_a.rolebc_in_asso_11_n1_nn ' ;
		/* base class table */
		$query .= 'FROM testmodule_a testmodule_a' ;
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE testmodule_a.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	public function loadRolebInAsso11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_B') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebInAsso11(false))) ;
		$o->setRolebInAsso11($dto_list[0],true,false) ;
	}
	
	public function loadRolebInAsso1N(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_B') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_1_n' => $o->getId())) ;
		$o->setListOfRolebInAsso1N($dto_list,true,false) ;
	}
	
	public function loadRolebInAssoNN(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_B') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_n_n' => $o->getId()),'testmodule_asso_n_n','roleb_in_asso_n_n') ;
		$o->setListOfRolebInAssoNN($dto_list,true,false) ;
	}
	
	public function loadRolebInCompo11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_B') ;
		$dto_list = $dao->findBy(array('rolea_in_compo_1_1' => $o->getId())) ;
		$o->setRolebInCompo11($dto_list[0],true,false) ;
	}
	
	public function loadRolebInCompo1N(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_B') ;
		$dto_list = $dao->findBy(array('rolea_in_compo_1_n' => $o->getId())) ;
		$o->setListOfRolebInCompo1N($dto_list,true,false) ;
	}
	
	public function loadRolebcInAsso111111(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111111') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso111111(false))) ;
		$o->setRolebcInAsso111111($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso1n1n1n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1n1n') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_1n_1n_1n' => $o->getId())) ;
		$o->setListOfRolebcInAsso1n1n1n($dto_list,true,false) ;
	}
	
	public function loadRolebcInAssoN1N1N1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N1N1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAssoN1N1N1(false))) ;
		$o->setRolebcInAssoN1N1N1($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAssoNnNnNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNnNn') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_nn_nn_nn' => $o->getId()),'testmodule_asso_nn_nn_nn_a','rolebc_in_asso_nn_nn_nn') ;
		$o->setListOfRolebcInAssoNnNnNn($dto_list,true,false) ;
	}
	
	public function loadRolebcInAsso11111n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso11111n') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso11111n(false))) ;
		$o->setRolebcInAsso11111n($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso1111N1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1111N1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso1111N1(false))) ;
		$o->setRolebcInAsso1111N1($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso1111Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1111Nn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso1111Nn(false))) ;
		$o->setRolebcInAsso1111Nn($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso1n1n11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1n11') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_1n_1n_11' => $o->getId())) ;
		$o->setListOfRolebcInAsso1n1n11($dto_list,true,false) ;
	}
	
	public function loadRolebcInAsso1n1nN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1nN1') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_1n_1n_n1' => $o->getId())) ;
		$o->setListOfRolebcInAsso1n1nN1($dto_list,true,false) ;
	}
	
	public function loadRolebcInAsso1n1nNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1nNn') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_1n_1n_nn' => $o->getId())) ;
		$o->setListOfRolebcInAsso1n1nNn($dto_list,true,false) ;
	}
	
	public function loadRolebcInAssoN1N111(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N111') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAssoN1N111(false))) ;
		$o->setRolebcInAssoN1N111($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAssoN1N11n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N11n') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAssoN1N11n(false))) ;
		$o->setRolebcInAssoN1N11n($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAssoN1N1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N1Nn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAssoN1N1Nn(false))) ;
		$o->setRolebcInAssoN1N1Nn($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAssoNnNn11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNn11') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_nn_nn_11' => $o->getId()),'testmodule_asso_nn_nn_11_a','rolebc_in_asso_nn_nn_11') ;
		$o->setListOfRolebcInAssoNnNn11($dto_list,true,false) ;
	}
	
	public function loadRolebcInAssoNnNn1n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNn1n') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_nn_nn_1n' => $o->getId()),'testmodule_asso_nn_nn_1n_a','rolebc_in_asso_nn_nn_1n') ;
		$o->setListOfRolebcInAssoNnNn1n($dto_list,true,false) ;
	}
	
	public function loadRolebcInAssoNnNnN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNnN1') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_nn_nn_n1' => $o->getId()),'testmodule_asso_nn_nn_n1_a','rolebc_in_asso_nn_nn_n1') ;
		$o->setListOfRolebcInAssoNnNnN1($dto_list,true,false) ;
	}
	
	public function loadRolebcInAsso111nN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111nN1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso111nN1(false))) ;
		$o->setRolebcInAsso111nN1($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso111nNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111nNn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso111nNn(false))) ;
		$o->setRolebcInAsso111nNn($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso11N1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso11N1Nn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebcInAsso11N1Nn(false))) ;
		$o->setRolebcInAsso11N1Nn($dto_list[0],true,false) ;
	}
	
	public function loadRolebcInAsso1nN1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1nN1Nn') ;
		$dto_list = $dao->findBy(array('rolea_in_asso_1n_n1_nn' => $o->getId())) ;
		$o->setListOfRolebcInAsso1nN1Nn($dto_list,true,false) ;
	}
	
	public function loadRolebcInXasso(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Xasso') ;
		$dto_list = $dao->findBy(array('rolea_in_xasso' => $o->getId())) ;
		$o->setListOfRolebcInXasso($dto_list,true,false) ;
	}
	
	
	/**
	 * Find testmodule_Dto_A where $column_value pairs matches
	 */
	public function findBy(array $column_value, $join_table=null,$join_column=null)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		if(isset($join_table) && isset($join_column)) {
			$query .= ' JOIN '.$join_table.' '.$join_table.' ON '.$join_table.'.'.$join_column.'=testmodule_a.__id' ;
		}
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY testmodule_a.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('wisss_dto',$where) ;
		$object->unsetId() ;
	}
	
	protected function insert(testmodule_Dto_A $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		if($change_recorder->hasBeenSet($object,'roleb_in_asso_1_1')) {
			$changed_reference = $change_recorder->getSet($object,'roleb_in_asso_1_1') ;
			$change_recorder->clear($object,'roleb_in_asso_1_1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_1_1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleb_in_asso_1_1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleb_in_asso_1_1')) {
			$changed_references['roleb_in_asso_1_1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleb_in_asso_1_1_wa')) {
			$changed_reference = $change_recorder->getSet($object,'roleb_in_asso_1_1_wa') ;
			$change_recorder->clear($object,'roleb_in_asso_1_1_wa') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_1_1_wa') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleb_in_asso_1_1_wa'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleb_in_asso_1_1_wa')) {
			$changed_references['roleb_in_asso_1_1_wa'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_11')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_11') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_11') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_11') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_11'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_11')) {
			$changed_references['rolebc_in_asso_11_11_11'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_n1')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_n1') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_n1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_n1')) {
			$changed_references['rolebc_in_asso_n1_n1_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_1n')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_1n') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_1n') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_1n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_1n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_1n')) {
			$changed_references['rolebc_in_asso_11_11_1n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_n1')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_n1') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_n1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_n1')) {
			$changed_references['rolebc_in_asso_11_11_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_nn')) {
			$changed_references['rolebc_in_asso_11_11_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_11')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_11') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_11') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_11') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_11'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_11')) {
			$changed_references['rolebc_in_asso_n1_n1_11'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_1n')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_1n') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_1n') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_1n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_1n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_1n')) {
			$changed_references['rolebc_in_asso_n1_n1_1n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_nn')) {
			$changed_references['rolebc_in_asso_n1_n1_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_1n_n1')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_1n_n1') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_1n_n1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_1n_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_1n_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_1n_n1')) {
			$changed_references['rolebc_in_asso_11_1n_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_1n_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_1n_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_1n_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_1n_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_1n_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_1n_nn')) {
			$changed_references['rolebc_in_asso_11_1n_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_n1_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_n1_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_n1_nn')) {
			$changed_references['rolebc_in_asso_11_n1_nn'] = null ;
		}
		
		$db->insert('wisss_dto',array()) ;
		$id = $db->lastInsertId('wisss_dto');
		$object->setId($id,false) ;
		
		/* manage primitive attributes */
		$values = array() ;
		
		if($change_recorder->hasBeenSet($object,'atta')) {
			$values['atta'] = $change_recorder->getSet($object,'atta') ;
			$change_recorder->clear($object,'atta') ;
		}
		
		/* add id of object if it has been obtained by inheritance saving process */
		$values['__id'] = $id ;
		
		/* manage array attributes */
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do insert */
		$db->insert('testmodule_a',$values) ;
		
		$change_recorder->clear($object,'roleb_in_asso_1_n') ;
		$change_recorder->clear($object,'roleb_in_compo_1_1') ;
		$change_recorder->clear($object,'roleb_in_compo_1_n') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_1n') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_11') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_n1') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_nn') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_n1_nn') ;
		$change_recorder->clear($object,'rolebc_in_xasso') ;
		
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_n_n')) {
			$where = $db->quoteInto('rolea_in_asso_n_n = ?', $object->getId());
			$db->delete('testmodule_asso_n_n',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_n_n' => $object->getId(), 'roleb_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_n_n')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_n_n' => $object->getId(), 'roleb_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_n_n')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_n_n = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_n_n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_n_n') ;
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_1_1_wa')) {
			$where = $db->quoteInto('rolea_in_asso_1_1_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_1_1_wa' => $object->getId(), 'roleb_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_1_1_wa')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_1_1_wa' => $object->getId(), 'roleb_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_1_1_wa')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_1_1_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_1_1_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_1_1_wa') ;
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_1_n_wa')) {
			$where = $db->quoteInto('rolea_in_asso_1_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_1_n_wa' => $object->getId(), 'roleb_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_1_n_wa')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_1_n_wa' => $object->getId(), 'roleb_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_1_n_wa')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_1_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_1_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_1_n_wa') ;
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_n_n_wa')) {
			$where = $db->quoteInto('rolea_in_asso_n_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_n_n_wa' => $object->getId(), 'roleb_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_n_n_wa')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_n_n_wa' => $object->getId(), 'roleb_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_n_n_wa')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_n_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_n_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_n_n_wa') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_nn')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_nn = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_nn_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_nn' => $object->getId(), 'rolebc_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_nn' => $object->getId(), 'rolebc_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_nn_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_nn') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_11')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_11 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_11_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_11' => $object->getId(), 'rolebc_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_11')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_11' => $object->getId(), 'rolebc_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_11')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_11 = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_11 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_11_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_11') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_1n')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_1n = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_1n_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_1n' => $object->getId(), 'rolebc_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_1n' => $object->getId(), 'rolebc_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_1n = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_1n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_1n_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_1n') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_n1')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_n1 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_n1_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_n1' => $object->getId(), 'rolebc_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_n1' => $object->getId(), 'rolebc_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_n1 = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_n1 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_n1_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_n1') ;
	}
	
	protected function update(testmodule_Dto_A $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		if($change_recorder->hasBeenSet($object,'roleb_in_asso_1_1')) {
			$changed_reference = $change_recorder->getSet($object,'roleb_in_asso_1_1') ;
			$change_recorder->clear($object,'roleb_in_asso_1_1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_1_1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleb_in_asso_1_1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleb_in_asso_1_1')) {
			$changed_references['roleb_in_asso_1_1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleb_in_asso_1_1_wa')) {
			$changed_reference = $change_recorder->getSet($object,'roleb_in_asso_1_1_wa') ;
			$change_recorder->clear($object,'roleb_in_asso_1_1_wa') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_1_1_wa') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleb_in_asso_1_1_wa'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleb_in_asso_1_1_wa')) {
			$changed_references['roleb_in_asso_1_1_wa'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_11')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_11') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_11') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_11') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_11'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_11')) {
			$changed_references['rolebc_in_asso_11_11_11'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_n1')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_n1') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_n1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_n1')) {
			$changed_references['rolebc_in_asso_n1_n1_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_1n')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_1n') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_1n') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_1n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_1n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_1n')) {
			$changed_references['rolebc_in_asso_11_11_1n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_n1')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_n1') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_n1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_n1')) {
			$changed_references['rolebc_in_asso_11_11_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_11_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_11_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_11_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_11_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_11_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_11_nn')) {
			$changed_references['rolebc_in_asso_11_11_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_11')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_11') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_11') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_11') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_11'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_11')) {
			$changed_references['rolebc_in_asso_n1_n1_11'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_1n')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_1n') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_1n') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_1n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_1n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_1n')) {
			$changed_references['rolebc_in_asso_n1_n1_1n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_n1_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_n1_n1_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_n1_n1_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_n1_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_n1_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_n1_n1_nn')) {
			$changed_references['rolebc_in_asso_n1_n1_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_1n_n1')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_1n_n1') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_1n_n1') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_1n_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_1n_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_1n_n1')) {
			$changed_references['rolebc_in_asso_11_1n_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_1n_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_1n_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_1n_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_1n_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_1n_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_1n_nn')) {
			$changed_references['rolebc_in_asso_11_1n_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolebc_in_asso_11_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'rolebc_in_asso_11_n1_nn') ;
			$change_recorder->clear($object,'rolebc_in_asso_11_n1_nn') ;
			$change_recorder->clear($changed_reference,'rolea_in_asso_11_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolebc_in_asso_11_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolebc_in_asso_11_n1_nn')) {
			$changed_references['rolebc_in_asso_11_n1_nn'] = null ;
		}
		
				
		/* manage primitive attributes */
		$values = array() ;
		
		if($change_recorder->hasBeenSet($object,'atta')) {
			$values['atta'] = $change_recorder->getSet($object,'atta') ;
			$change_recorder->clear($object,'atta') ;
		}
		
		/* manage array attributes */
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('testmodule_a',$values,$where) ;
		}
		
		$change_recorder->clear($object,'roleb_in_asso_1_n') ;
		$change_recorder->clear($object,'roleb_in_compo_1_1') ;
		$change_recorder->clear($object,'roleb_in_compo_1_n') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_1n') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_11') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_n1') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_1n_nn') ;
		$change_recorder->clear($object,'rolebc_in_asso_1n_n1_nn') ;
		$change_recorder->clear($object,'rolebc_in_xasso') ;
		
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_n_n')) {
			$where = $db->quoteInto('rolea_in_asso_n_n = ?', $object->getId());
			$db->delete('testmodule_asso_n_n',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_n_n' => $object->getId(), 'roleb_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_n_n')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_n_n' => $object->getId(), 'roleb_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_n_n')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_n_n = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_n_n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_n_n') ;
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_1_1_wa')) {
			$where = $db->quoteInto('rolea_in_asso_1_1_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_1_1_wa' => $object->getId(), 'roleb_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_1_1_wa')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_1_1_wa' => $object->getId(), 'roleb_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_1_1_wa')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_1_1_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_1_1_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_1_1_wa') ;
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_1_n_wa')) {
			$where = $db->quoteInto('rolea_in_asso_1_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_1_n_wa' => $object->getId(), 'roleb_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_1_n_wa')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_1_n_wa' => $object->getId(), 'roleb_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_1_n_wa')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_1_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_1_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_1_n_wa') ;
		if($change_recorder->hasBeenListset($object,'roleb_in_asso_n_n_wa')) {
			$where = $db->quoteInto('rolea_in_asso_n_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'roleb_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_n_n_wa' => $object->getId(), 'roleb_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleb_in_asso_n_n_wa')) {
			foreach($change_recorder->getAdded($object,'roleb_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_n_n_wa' => $object->getId(), 'roleb_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleb_in_asso_n_n_wa')) {
			foreach($change_recorder->getRemoved($object,'roleb_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_n_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('roleb_in_asso_n_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'roleb_in_asso_n_n_wa') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_nn')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_nn = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_nn_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_nn' => $object->getId(), 'rolebc_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_nn' => $object->getId(), 'rolebc_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_nn_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_nn') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_11')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_11 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_11_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_11' => $object->getId(), 'rolebc_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_11')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_11' => $object->getId(), 'rolebc_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_11')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_11 = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_11 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_11_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_11') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_1n')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_1n = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_1n_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_1n' => $object->getId(), 'rolebc_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_1n' => $object->getId(), 'rolebc_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_1n = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_1n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_1n_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_1n') ;
		if($change_recorder->hasBeenListset($object,'rolebc_in_asso_nn_nn_n1')) {
			$where = $db->quoteInto('rolea_in_asso_nn_nn_n1 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_n1_a',$where) ;
			foreach($change_recorder->getListset($object,'rolebc_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolea_in_asso_nn_nn_n1' => $object->getId(), 'rolebc_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_a',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolebc_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getAdded($object,'rolebc_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolea_in_asso_nn_nn_n1' => $object->getId(), 'rolebc_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_a',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolebc_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getRemoved($object,'rolebc_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'rolea_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolea_in_asso_nn_nn_n1 = ?', $object->getId()));
				$where[] = $db->quoteInto('rolebc_in_asso_nn_nn_n1 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_n1_a',$where) ;
			}
		}
		$change_recorder->clear($object,'rolebc_in_asso_nn_nn_n1') ;
	}

	public static function fillObject(array $results,testmodule_Dto_A $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = Wisss_Dto_Registry_Abstract::getDto('testmodule','A',$line['__id']) ;
				self::fillObjectFromLine($line,$object) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object)
	{
		$object->setAtta((string) $line['atta'],false) ;
		$object->setRolebInAsso11($line['roleb_in_asso_1_1'],false,false) ;
		$object->setRolebcInAsso111111($line['rolebc_in_asso_11_11_11'],false,false) ;
		$object->setRolebcInAssoN1N1N1($line['rolebc_in_asso_n1_n1_n1'],false,false) ;
		$object->setRolebcInAsso11111n($line['rolebc_in_asso_11_11_1n'],false,false) ;
		$object->setRolebcInAsso1111N1($line['rolebc_in_asso_11_11_n1'],false,false) ;
		$object->setRolebcInAsso1111Nn($line['rolebc_in_asso_11_11_nn'],false,false) ;
		$object->setRolebcInAssoN1N111($line['rolebc_in_asso_n1_n1_11'],false,false) ;
		$object->setRolebcInAssoN1N11n($line['rolebc_in_asso_n1_n1_1n'],false,false) ;
		$object->setRolebcInAssoN1N1Nn($line['rolebc_in_asso_n1_n1_nn'],false,false) ;
		$object->setRolebcInAsso111nN1($line['rolebc_in_asso_11_1n_n1'],false,false) ;
		$object->setRolebcInAsso111nNn($line['rolebc_in_asso_11_1n_nn'],false,false) ;
		$object->setRolebcInAsso11N1Nn($line['rolebc_in_asso_11_n1_nn'],false,false) ;
		
	}
}