<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;

class testmodule_Dao_Mysql_AssoNnNnNn implements Wisss_Dao_Interface
{
	protected $attributes = array('' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' testmodule_asso_nn_nn_nn.__id,' ;
		}
		/* simple attributes */
		$query .= '  ' ;
		/* reference ids for lazy loading */
		$query .= ' ' ;
		/* base class table */
		$query .= 'FROM testmodule_asso_nn_nn_nn testmodule_asso_nn_nn_nn' ;
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE testmodule_asso_nn_nn_nn.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	public function loadRoleaInAssoNnNnNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_A') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleaInAssoNnNnNn(false))) ;
		$o->setListOfRoleaInAssoNnNnNn($dto_list,true,false) ;
	}
	
	public function loadRolebInAssoNnNnNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_B') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolebInAssoNnNnNn(false))) ;
		$o->setListOfRolebInAssoNnNnNn($dto_list,true,false) ;
	}
	
	public function loadRolecInAssoNnNnNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_C') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRolecInAssoNnNnNn(false))) ;
		$o->setListOfRolecInAssoNnNnNn($dto_list,true,false) ;
	}
	
	
	/**
	 * Find testmodule_Dto_AssoNnNnNn where $column_value pairs matches
	 */
	public function findBy(array $column_value)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY testmodule_asso_nn_nn_nn.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('testmodule_asso_nn_nn_nn',$where) ;
	}
	
	protected function insert(testmodule_Dto_AssoNnNnNn $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$set_attributes = $change_recorder->getSetAttributes($object,'testmodule_Dto_AssoNnNnNn') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$ref_stored_in_object_table = array('' => '') ;
		$changed_references = array_intersect_key($set_attributes,$ref_stored_in_object_table) ;
		foreach($changed_references as $attribute => $value) {
			$value->__save() ;
		}
		
		$id = $object->getId() ;
		
		/* manage primitive attributes */
		$values = array_intersect_key($set_attributes,$this->attributes) ;
		if(isset($id)) {
			$values['__id'] = $id ;
		}
		
		/* manage array attributes */
		$modified_arrays = $change_recorder->getModifiedArrays($object,'testmodule_Dto_AssoNnNnNn') ;
		foreach($this->attributes as $key => $value) {
			if(in_array($key,$modified_arrays)) {
				$method = 'getListOf'.ucfirst($key) ;
				$values[$key] = serialize($object->$method(false)) ;
			}
		}
		
		/* add references id in insert clause */
		foreach($changed_references as $attribute => $value) {
			$values[$attribute] = $value->getId() ;
		}
		
		/* do insert */
		$db->insert('testmodule_asso_nn_nn_nn',$values) ;
		if(!isset($id)) {
			$id = $db->lastInsertId('testmodule_asso_nn_nn_nn');
			$object->setId($id) ;
		}
		
		$ref_stored_in_reference_table = array('rolea_in_asso_nn_nn_nn', 'roleb_in_asso_nn_nn_nn', 'rolec_in_asso_nn_nn_nn') ;
		$changed_references = array_intersect($modified_arrays,$ref_stored_in_reference_table) ;
		$set_lists = $change_recorder->getSetLists($object,'testmodule_Dto_AssoNnNnNn') ;
		foreach($set_lists as $attribute => $values) {
			if(in_array($attribute,$changed_references)) {
				foreach($values as $value) {
					$value->__save() ;
				}
			}
		}
	}
	
	protected function update(testmodule_Dto_AssoNnNnNn $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		$changed_attributes = $change_recorder->getSetAttributes($object,'testmodule_Dto_AssoNnNnNn') ;
		
		/* first save referenced object */
		$ref_stored_in_object_table = array('' => '') ;
		$changed_references = array_intersect_key($changed_attributes,$ref_stored_in_object_table) ;
		foreach($changed_references as $attribute => $value) {
			$value->__save() ;
		}
		
				
		/* manage primitive attributes */
		$values = array_intersect_key($changed_attributes,$this->attributes) ;
		
		/* manage array attributes */
		$modified_arrays = $change_recorder->getModifiedArrays($object,'testmodule_Dto_AssoNnNnNn') ;
		foreach($this->attributes as $key => $value) {
			if(in_array($key,$modified_arrays)) {
				$method = 'getListOf'.ucfirst($key) ;
				$values[$key] = serialize($object->$method(false)) ;
			}
		}
		
		/* add references id in insert clause */
		foreach($changed_references as $attribute => $value) {
			$values[$attribute] = $value->getId() ;
		}
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('testmodule_asso_nn_nn_nn',$values,$where) ;
		}
	}
	
	public static function queryUpdate($values,$where)
	{
		$db = Zend_Registry::get('db') ;
		$db->update('testmodule_asso_nn_nn_nn',$values,$where) ;
	}
	
	public static function fillObject(array $results,testmodule_Dto_AssoNnNnNn $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = self::fillObjectFromLine($line) ;
				$object->setId($line['__id']) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object=null)
	{
		if(!isset($object)) {
			$object = Wisss_Dto_Factory_Abstract::getDto('testmodule','AssoNnNnNn') ;
		}
		
		
		return $object ;
	}
}