<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;
require_once('lib/Wisss/Dto/Registry/Abstract.php') ;

class testmodule_Dao_Mysql_B implements Wisss_Dao_Interface
{
	protected $attributes = array('attb' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' testmodule_b.__id,' ;
		}
		/* simple attributes */
		$query .= ' testmodule_b.attb ' ;
		/* reference ids for lazy loading */
		$query .= ',testmodule_b.rolea_in_asso_1_n, testmodule_b.rolea_in_compo_1_1, testmodule_b.rolea_in_compo_1_n, testmodule_b.roleac_in_asso_n1_n1_n1, testmodule_b.roleac_in_asso_n1_n1_11, testmodule_b.roleac_in_asso_n1_n1_1n, testmodule_b.roleac_in_asso_n1_n1_nn, testmodule_b.roleac_in_asso_11_n1_nn, testmodule_b.roleac_in_asso_1n_n1_nn ' ;
		/* base class table */
		$query .= 'FROM testmodule_b testmodule_b' ;
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE testmodule_b.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	public function loadRoleaInAsso11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_A') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_1_1' => $o->getId())) ;
		$o->setRoleaInAsso11($dto_list[0],true,false) ;
	}
	
	public function loadRoleaInAsso1N(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_A') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleaInAsso1N(false))) ;
		$o->setRoleaInAsso1N($dto_list[0],true,false) ;
	}
	
	public function loadRoleaInAssoNN(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_A') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_n_n' => $o->getId()),'testmodule_asso_n_n','rolea_in_asso_n_n') ;
		$o->setListOfRoleaInAssoNN($dto_list,true,false) ;
	}
	
	public function loadRoleaInCompo11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_A') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleaInCompo11(false))) ;
		$o->setRoleaInCompo11($dto_list[0],true,false) ;
	}
	
	public function loadRoleaInCompo1N(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_A') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleaInCompo1N(false))) ;
		$o->setRoleaInCompo1N($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAsso111111(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111111') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_11_11_11' => $o->getId())) ;
		$o->setRoleacInAsso111111($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAsso1n1n1n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1n1n') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_1n_1n_1n' => $o->getId())) ;
		$o->setListOfRoleacInAsso1n1n1n($dto_list,true,false) ;
	}
	
	public function loadRoleacInAssoN1N1N1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N1N1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleacInAssoN1N1N1(false))) ;
		$o->setRoleacInAssoN1N1N1($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAssoNnNnNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNnNn') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_nn_nn_nn' => $o->getId()),'testmodule_asso_nn_nn_nn_b','roleac_in_asso_nn_nn_nn') ;
		$o->setListOfRoleacInAssoNnNnNn($dto_list,true,false) ;
	}
	
	public function loadRoleacInAsso11111n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso11111n') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_11_11_1n' => $o->getId())) ;
		$o->setRoleacInAsso11111n($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAsso1111N1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1111N1') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_11_11_n1' => $o->getId())) ;
		$o->setRoleacInAsso1111N1($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAsso1111Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1111Nn') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_11_11_nn' => $o->getId())) ;
		$o->setRoleacInAsso1111Nn($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAsso1n1n11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1n11') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_1n_1n_11' => $o->getId())) ;
		$o->setListOfRoleacInAsso1n1n11($dto_list,true,false) ;
	}
	
	public function loadRoleacInAsso1n1nN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1nN1') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_1n_1n_n1' => $o->getId())) ;
		$o->setListOfRoleacInAsso1n1nN1($dto_list,true,false) ;
	}
	
	public function loadRoleacInAsso1n1nNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1nNn') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_1n_1n_nn' => $o->getId())) ;
		$o->setListOfRoleacInAsso1n1nNn($dto_list,true,false) ;
	}
	
	public function loadRoleacInAssoN1N111(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N111') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleacInAssoN1N111(false))) ;
		$o->setRoleacInAssoN1N111($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAssoN1N11n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N11n') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleacInAssoN1N11n(false))) ;
		$o->setRoleacInAssoN1N11n($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAssoN1N1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N1Nn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleacInAssoN1N1Nn(false))) ;
		$o->setRoleacInAssoN1N1Nn($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAssoNnNn11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNn11') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_nn_nn_11' => $o->getId()),'testmodule_asso_nn_nn_11_b','roleac_in_asso_nn_nn_11') ;
		$o->setListOfRoleacInAssoNnNn11($dto_list,true,false) ;
	}
	
	public function loadRoleacInAssoNnNn1n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNn1n') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_nn_nn_1n' => $o->getId()),'testmodule_asso_nn_nn_1n_b','roleac_in_asso_nn_nn_1n') ;
		$o->setListOfRoleacInAssoNnNn1n($dto_list,true,false) ;
	}
	
	public function loadRoleacInAssoNnNnN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNnN1') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_nn_nn_n1' => $o->getId()),'testmodule_asso_nn_nn_n1_b','roleac_in_asso_nn_nn_n1') ;
		$o->setListOfRoleacInAssoNnNnN1($dto_list,true,false) ;
	}
	
	public function loadRoleacInAsso111nN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111nN1') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_11_1n_n1' => $o->getId())) ;
		$o->setListOfRoleacInAsso111nN1($dto_list,true,false) ;
	}
	
	public function loadRoleacInAsso111nNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111nNn') ;
		$dto_list = $dao->findBy(array('roleb_in_asso_11_1n_nn' => $o->getId())) ;
		$o->setListOfRoleacInAsso111nNn($dto_list,true,false) ;
	}
	
	public function loadRoleacInAsso11N1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso11N1Nn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleacInAsso11N1Nn(false))) ;
		$o->setRoleacInAsso11N1Nn($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInAsso1nN1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1nN1Nn') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleacInAsso1nN1Nn(false))) ;
		$o->setRoleacInAsso1nN1Nn($dto_list[0],true,false) ;
	}
	
	public function loadRoleacInXasso(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Xasso') ;
		$dto_list = $dao->findBy(array('roleb_in_xasso' => $o->getId())) ;
		$o->setRoleacInXasso($dto_list[0],true,false) ;
	}
	
	
	/**
	 * Find testmodule_Dto_B where $column_value pairs matches
	 */
	public function findBy(array $column_value, $join_table=null,$join_column=null)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		if(isset($join_table) && isset($join_column)) {
			$query .= ' JOIN '.$join_table.' '.$join_table.' ON '.$join_table.'.'.$join_column.'=testmodule_b.__id' ;
		}
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY testmodule_b.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('wisss_dto',$where) ;
		$object->unsetId() ;
	}
	
	protected function insert(testmodule_Dto_B $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		if($change_recorder->hasBeenSet($object,'rolea_in_asso_1_n')) {
			$changed_reference = $change_recorder->getSet($object,'rolea_in_asso_1_n') ;
			$change_recorder->clear($object,'rolea_in_asso_1_n') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_1_n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolea_in_asso_1_n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolea_in_asso_1_n')) {
			$changed_references['rolea_in_asso_1_n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolea_in_compo_1_1')) {
			$changed_reference = $change_recorder->getSet($object,'rolea_in_compo_1_1') ;
			$change_recorder->clear($object,'rolea_in_compo_1_1') ;
			$change_recorder->clear($changed_reference,'roleb_in_compo_1_1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolea_in_compo_1_1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolea_in_compo_1_1')) {
			$changed_references['rolea_in_compo_1_1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolea_in_compo_1_n')) {
			$changed_reference = $change_recorder->getSet($object,'rolea_in_compo_1_n') ;
			$change_recorder->clear($object,'rolea_in_compo_1_n') ;
			$change_recorder->clear($changed_reference,'roleb_in_compo_1_n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolea_in_compo_1_n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolea_in_compo_1_n')) {
			$changed_references['rolea_in_compo_1_n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_n1') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_n1') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_n1')) {
			$changed_references['roleac_in_asso_n1_n1_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_11')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_11') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_11') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_11') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_11'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_11')) {
			$changed_references['roleac_in_asso_n1_n1_11'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_1n')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_1n') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_1n') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_1n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_1n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_1n')) {
			$changed_references['roleac_in_asso_n1_n1_1n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_nn') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_nn') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_nn')) {
			$changed_references['roleac_in_asso_n1_n1_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_11_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_11_n1_nn') ;
			$change_recorder->clear($object,'roleac_in_asso_11_n1_nn') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_11_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_11_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_11_n1_nn')) {
			$changed_references['roleac_in_asso_11_n1_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_1n_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_1n_n1_nn') ;
			$change_recorder->clear($object,'roleac_in_asso_1n_n1_nn') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_1n_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_1n_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_1n_n1_nn')) {
			$changed_references['roleac_in_asso_1n_n1_nn'] = null ;
		}
		
		$db->insert('wisss_dto',array()) ;
		$id = $db->lastInsertId('wisss_dto');
		$object->setId($id,false) ;
		
		/* manage primitive attributes */
		$values = array() ;
		
		if($change_recorder->hasBeenSet($object,'attb')) {
			$values['attb'] = $change_recorder->getSet($object,'attb') ;
			$change_recorder->clear($object,'attb') ;
		}
		
		/* add id of object if it has been obtained by inheritance saving process */
		$values['__id'] = $id ;
		
		/* manage array attributes */
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do insert */
		$db->insert('testmodule_b',$values) ;
		
		$change_recorder->clear($object,'rolea_in_asso_1_1') ;
		$change_recorder->clear($object,'rolea_in_asso_1_1_wa') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_11') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_1n') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_1n') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_n1') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_nn') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_11') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_n1') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_nn') ;
		$change_recorder->clear($object,'roleac_in_asso_11_1n_n1') ;
		$change_recorder->clear($object,'roleac_in_asso_11_1n_nn') ;
		$change_recorder->clear($object,'roleac_in_xasso') ;
		
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_n_n')) {
			$where = $db->quoteInto('roleb_in_asso_n_n = ?', $object->getId());
			$db->delete('testmodule_asso_n_n',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_n_n' => $object->getId(), 'rolea_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_n_n')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_n_n' => $object->getId(), 'rolea_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_n_n')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_n_n = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_n_n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_n_n') ;
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_1_1_wa')) {
			$where = $db->quoteInto('roleb_in_asso_1_1_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_1_1_wa' => $object->getId(), 'rolea_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_1_1_wa')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_1_1_wa' => $object->getId(), 'rolea_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_1_1_wa')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_1_1_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_1_1_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_1_1_wa') ;
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_1_n_wa')) {
			$where = $db->quoteInto('roleb_in_asso_1_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_1_n_wa' => $object->getId(), 'rolea_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_1_n_wa')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_1_n_wa' => $object->getId(), 'rolea_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_1_n_wa')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_1_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_1_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_1_n_wa') ;
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_n_n_wa')) {
			$where = $db->quoteInto('roleb_in_asso_n_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_n_n_wa' => $object->getId(), 'rolea_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_n_n_wa')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_n_n_wa' => $object->getId(), 'rolea_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_n_n_wa')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_n_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_n_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_n_n_wa') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_nn')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_nn = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_nn_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_nn' => $object->getId(), 'roleac_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_nn' => $object->getId(), 'roleac_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_nn_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_nn') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_11')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_11 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_11_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_11' => $object->getId(), 'roleac_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_11')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_11' => $object->getId(), 'roleac_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_11')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_11 = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_11 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_11_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_11') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_1n')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_1n = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_1n_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_1n' => $object->getId(), 'roleac_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_1n' => $object->getId(), 'roleac_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_1n = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_1n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_1n_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_1n') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_n1')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_n1 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_n1_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_n1' => $object->getId(), 'roleac_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_n1' => $object->getId(), 'roleac_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_n1 = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_n1 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_n1_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_n1') ;
	}
	
	protected function update(testmodule_Dto_B $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		if($change_recorder->hasBeenSet($object,'rolea_in_asso_1_n')) {
			$changed_reference = $change_recorder->getSet($object,'rolea_in_asso_1_n') ;
			$change_recorder->clear($object,'rolea_in_asso_1_n') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_1_n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolea_in_asso_1_n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolea_in_asso_1_n')) {
			$changed_references['rolea_in_asso_1_n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolea_in_compo_1_1')) {
			$changed_reference = $change_recorder->getSet($object,'rolea_in_compo_1_1') ;
			$change_recorder->clear($object,'rolea_in_compo_1_1') ;
			$change_recorder->clear($changed_reference,'roleb_in_compo_1_1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolea_in_compo_1_1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolea_in_compo_1_1')) {
			$changed_references['rolea_in_compo_1_1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'rolea_in_compo_1_n')) {
			$changed_reference = $change_recorder->getSet($object,'rolea_in_compo_1_n') ;
			$change_recorder->clear($object,'rolea_in_compo_1_n') ;
			$change_recorder->clear($changed_reference,'roleb_in_compo_1_n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['rolea_in_compo_1_n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'rolea_in_compo_1_n')) {
			$changed_references['rolea_in_compo_1_n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_n1') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_n1') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_n1')) {
			$changed_references['roleac_in_asso_n1_n1_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_11')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_11') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_11') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_11') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_11'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_11')) {
			$changed_references['roleac_in_asso_n1_n1_11'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_1n')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_1n') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_1n') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_1n') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_1n'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_1n')) {
			$changed_references['roleac_in_asso_n1_n1_1n'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_n1_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_n1_n1_nn') ;
			$change_recorder->clear($object,'roleac_in_asso_n1_n1_nn') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_n1_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_n1_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_n1_n1_nn')) {
			$changed_references['roleac_in_asso_n1_n1_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_11_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_11_n1_nn') ;
			$change_recorder->clear($object,'roleac_in_asso_11_n1_nn') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_11_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_11_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_11_n1_nn')) {
			$changed_references['roleac_in_asso_11_n1_nn'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleac_in_asso_1n_n1_nn')) {
			$changed_reference = $change_recorder->getSet($object,'roleac_in_asso_1n_n1_nn') ;
			$change_recorder->clear($object,'roleac_in_asso_1n_n1_nn') ;
			$change_recorder->clear($changed_reference,'roleb_in_asso_1n_n1_nn') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleac_in_asso_1n_n1_nn'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleac_in_asso_1n_n1_nn')) {
			$changed_references['roleac_in_asso_1n_n1_nn'] = null ;
		}
		
				
		/* manage primitive attributes */
		$values = array() ;
		
		if($change_recorder->hasBeenSet($object,'attb')) {
			$values['attb'] = $change_recorder->getSet($object,'attb') ;
			$change_recorder->clear($object,'attb') ;
		}
		
		/* manage array attributes */
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('testmodule_b',$values,$where) ;
		}
		
		$change_recorder->clear($object,'rolea_in_asso_1_1') ;
		$change_recorder->clear($object,'rolea_in_asso_1_1_wa') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_11') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_1n') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_1n') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_n1') ;
		$change_recorder->clear($object,'roleac_in_asso_11_11_nn') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_11') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_n1') ;
		$change_recorder->clear($object,'roleac_in_asso_1n_1n_nn') ;
		$change_recorder->clear($object,'roleac_in_asso_11_1n_n1') ;
		$change_recorder->clear($object,'roleac_in_asso_11_1n_nn') ;
		$change_recorder->clear($object,'roleac_in_xasso') ;
		
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_n_n')) {
			$where = $db->quoteInto('roleb_in_asso_n_n = ?', $object->getId());
			$db->delete('testmodule_asso_n_n',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_n_n' => $object->getId(), 'rolea_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_n_n')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_n_n' => $object->getId(), 'rolea_in_asso_n_n' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_n_n')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_n_n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_n_n = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_n_n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_n_n') ;
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_1_1_wa')) {
			$where = $db->quoteInto('roleb_in_asso_1_1_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_1_1_wa' => $object->getId(), 'rolea_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_1_1_wa')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_1_1_wa' => $object->getId(), 'rolea_in_asso_1_1_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_1_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_1_1_wa')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_1_1_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_1_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_1_1_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_1_1_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_1_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_1_1_wa') ;
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_1_n_wa')) {
			$where = $db->quoteInto('roleb_in_asso_1_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_1_n_wa' => $object->getId(), 'rolea_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_1_n_wa')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_1_n_wa' => $object->getId(), 'rolea_in_asso_1_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_1_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_1_n_wa')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_1_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_1_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_1_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_1_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_1_n_wa') ;
		if($change_recorder->hasBeenListset($object,'rolea_in_asso_n_n_wa')) {
			$where = $db->quoteInto('roleb_in_asso_n_n_wa = ?', $object->getId());
			$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			foreach($change_recorder->getListset($object,'rolea_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_n_n_wa' => $object->getId(), 'rolea_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'rolea_in_asso_n_n_wa')) {
			foreach($change_recorder->getAdded($object,'rolea_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_n_n_wa' => $object->getId(), 'rolea_in_asso_n_n_wa' => $value->getId()) ;
				$db->insert('testmodule_asso_n_n_with_attributes',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'rolea_in_asso_n_n_wa')) {
			foreach($change_recorder->getRemoved($object,'rolea_in_asso_n_n_wa') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_n_n_wa') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_n_n_wa = ?', $object->getId()));
				$where[] = $db->quoteInto('rolea_in_asso_n_n_wa = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n_n_with_attributes',$where) ;
			}
		}
		$change_recorder->clear($object,'rolea_in_asso_n_n_wa') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_nn')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_nn = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_nn_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_nn' => $object->getId(), 'roleac_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_nn' => $object->getId(), 'roleac_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_nn_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_nn') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_11')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_11 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_11_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_11' => $object->getId(), 'roleac_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_11')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_11' => $object->getId(), 'roleac_in_asso_nn_nn_11' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_11_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_11')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_11') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_11') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_11 = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_11 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_11_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_11') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_1n')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_1n = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_1n_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_1n' => $object->getId(), 'roleac_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_1n' => $object->getId(), 'roleac_in_asso_nn_nn_1n' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_1n_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_1n')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_1n') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_1n') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_1n = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_1n = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_1n_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_1n') ;
		if($change_recorder->hasBeenListset($object,'roleac_in_asso_nn_nn_n1')) {
			$where = $db->quoteInto('roleb_in_asso_nn_nn_n1 = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_n1_b',$where) ;
			foreach($change_recorder->getListset($object,'roleac_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('roleb_in_asso_nn_nn_n1' => $object->getId(), 'roleac_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_b',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleac_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getAdded($object,'roleac_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('roleb_in_asso_nn_nn_n1' => $object->getId(), 'roleac_in_asso_nn_nn_n1' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_n1_b',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleac_in_asso_nn_nn_n1')) {
			foreach($change_recorder->getRemoved($object,'roleac_in_asso_nn_nn_n1') as $value) {
				$change_recorder->clear($value,'roleb_in_asso_nn_nn_n1') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('roleb_in_asso_nn_nn_n1 = ?', $object->getId()));
				$where[] = $db->quoteInto('roleac_in_asso_nn_nn_n1 = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_n1_b',$where) ;
			}
		}
		$change_recorder->clear($object,'roleac_in_asso_nn_nn_n1') ;
	}

	public static function fillObject(array $results,testmodule_Dto_B $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = Wisss_Dto_Registry_Abstract::getDto('testmodule','B',$line['__id']) ;
				self::fillObjectFromLine($line,$object) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object)
	{
		$object->setAttb((int) $line['attb'],false) ;
		$object->setRoleaInAsso1N($line['rolea_in_asso_1_n'],false,false) ;
		$object->setRoleaInCompo11($line['rolea_in_compo_1_1'],false,false) ;
		$object->setRoleaInCompo1N($line['rolea_in_compo_1_n'],false,false) ;
		$object->setRoleacInAssoN1N1N1($line['roleac_in_asso_n1_n1_n1'],false,false) ;
		$object->setRoleacInAssoN1N111($line['roleac_in_asso_n1_n1_11'],false,false) ;
		$object->setRoleacInAssoN1N11n($line['roleac_in_asso_n1_n1_1n'],false,false) ;
		$object->setRoleacInAssoN1N1Nn($line['roleac_in_asso_n1_n1_nn'],false,false) ;
		$object->setRoleacInAsso11N1Nn($line['roleac_in_asso_11_n1_nn'],false,false) ;
		$object->setRoleacInAsso1nN1Nn($line['roleac_in_asso_1n_n1_nn'],false,false) ;
		
	}
}