<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;
require_once('lib/Wisss/Dto/Registry/Abstract.php') ;

class testmodule_Dao_Mysql_C implements Wisss_Dao_Interface
{
	protected $attributes = array('attc' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' testmodule_c.__id,' ;
		}
		/* simple attributes */
		$query .= ' testmodule_c.attc ' ;
		/* reference ids for lazy loading */
		$query .= ',testmodule_c.roleab_in_asso_n1_n1_n1, testmodule_c.roleab_in_asso_11_11_n1, testmodule_c.roleab_in_asso_1n_1n_n1, testmodule_c.roleab_in_asso_nn_nn_n1, testmodule_c.roleab_in_asso_11_1n_n1 ' ;
		/* base class table */
		$query .= 'FROM testmodule_c testmodule_c' ;
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE testmodule_c.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	public function loadRoleabInAsso111111(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111111') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_11_11_11' => $o->getId())) ;
		$o->setRoleabInAsso111111($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAsso1n1n1n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1n1n') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_1n_1n_1n' => $o->getId())) ;
		$o->setListOfRoleabInAsso1n1n1n($dto_list,true,false) ;
	}
	
	public function loadRoleabInAssoN1N1N1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N1N1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleabInAssoN1N1N1(false))) ;
		$o->setRoleabInAssoN1N1N1($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAssoNnNnNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNnNn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_nn_nn_nn' => $o->getId()),'testmodule_asso_nn_nn_nn_c','roleab_in_asso_nn_nn_nn') ;
		$o->setListOfRoleabInAssoNnNnNn($dto_list,true,false) ;
	}
	
	public function loadRoleabInAsso11111n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso11111n') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_11_11_1n' => $o->getId())) ;
		$o->setListOfRoleabInAsso11111n($dto_list,true,false) ;
	}
	
	public function loadRoleabInAsso1111N1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1111N1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleabInAsso1111N1(false))) ;
		$o->setRoleabInAsso1111N1($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAsso1111Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1111Nn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_11_11_nn' => $o->getId()),'testmodule_asso_11_11_nn_c','roleab_in_asso_11_11_nn') ;
		$o->setListOfRoleabInAsso1111Nn($dto_list,true,false) ;
	}
	
	public function loadRoleabInAsso1n1n11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1n11') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_1n_1n_11' => $o->getId())) ;
		$o->setRoleabInAsso1n1n11($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAsso1n1nN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1nN1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleabInAsso1n1nN1(false))) ;
		$o->setRoleabInAsso1n1nN1($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAsso1n1nNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1n1nNn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_1n_1n_nn' => $o->getId()),'testmodule_asso_1n_1n_nn_c','roleab_in_asso_1n_1n_nn') ;
		$o->setListOfRoleabInAsso1n1nNn($dto_list,true,false) ;
	}
	
	public function loadRoleabInAssoN1N111(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N111') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_n1_n1_11' => $o->getId())) ;
		$o->setRoleabInAssoN1N111($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAssoN1N11n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N11n') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_n1_n1_1n' => $o->getId())) ;
		$o->setListOfRoleabInAssoN1N11n($dto_list,true,false) ;
	}
	
	public function loadRoleabInAssoN1N1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoN1N1Nn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_n1_n1_nn' => $o->getId()),'testmodule_asso_n1_n1_nn_c','roleab_in_asso_n1_n1_nn') ;
		$o->setListOfRoleabInAssoN1N1Nn($dto_list,true,false) ;
	}
	
	public function loadRoleabInAssoNnNn11(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNn11') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_nn_nn_11' => $o->getId())) ;
		$o->setRoleabInAssoNnNn11($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAssoNnNn1n(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNn1n') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_nn_nn_1n' => $o->getId())) ;
		$o->setListOfRoleabInAssoNnNn1n($dto_list,true,false) ;
	}
	
	public function loadRoleabInAssoNnNnN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_AssoNnNnN1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleabInAssoNnNnN1(false))) ;
		$o->setRoleabInAssoNnNnN1($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAsso111nN1(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111nN1') ;
		$dto_list = $dao->findBy(array('__id' => $o->getRoleabInAsso111nN1(false))) ;
		$o->setRoleabInAsso111nN1($dto_list[0],true,false) ;
	}
	
	public function loadRoleabInAsso111nNn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso111nNn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_11_1n_nn' => $o->getId()),'testmodule_asso_11_1n_nn_c','roleab_in_asso_11_1n_nn') ;
		$o->setListOfRoleabInAsso111nNn($dto_list,true,false) ;
	}
	
	public function loadRoleabInAsso11N1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso11N1Nn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_11_n1_nn' => $o->getId()),'testmodule_asso_11_n1_nn_c','roleab_in_asso_11_n1_nn') ;
		$o->setListOfRoleabInAsso11N1Nn($dto_list,true,false) ;
	}
	
	public function loadRoleabInAsso1nN1Nn(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Asso1nN1Nn') ;
		$dto_list = $dao->findBy(array('rolec_in_asso_1n_n1_nn' => $o->getId()),'testmodule_asso_1n_n1_nn_c','roleab_in_asso_1n_n1_nn') ;
		$o->setListOfRoleabInAsso1nN1Nn($dto_list,true,false) ;
	}
	
	public function loadRoleabInXasso(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('testmodule_Dto_Xasso') ;
		$dto_list = $dao->findBy(array('rolec_in_xasso' => $o->getId())) ;
		$o->setRoleabInXasso($dto_list[0],true,false) ;
	}
	
	
	/**
	 * Find testmodule_Dto_C where $column_value pairs matches
	 */
	public function findBy(array $column_value, $join_table=null,$join_column=null)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		if(isset($join_table) && isset($join_column)) {
			$query .= ' JOIN '.$join_table.' '.$join_table.' ON '.$join_table.'.'.$join_column.'=testmodule_c.__id' ;
		}
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY testmodule_c.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('wisss_dto',$where) ;
		$object->unsetId() ;
	}
	
	protected function insert(testmodule_Dto_C $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_n1_n1_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_n1_n1_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_n1_n1_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_n1_n1_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_n1_n1_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_n1_n1_n1')) {
			$changed_references['roleab_in_asso_n1_n1_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_11_11_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_11_11_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_11_11_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_11_11_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_11_11_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_11_11_n1')) {
			$changed_references['roleab_in_asso_11_11_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_1n_1n_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_1n_1n_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_1n_1n_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_1n_1n_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_1n_1n_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_1n_1n_n1')) {
			$changed_references['roleab_in_asso_1n_1n_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_nn_nn_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_nn_nn_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_nn_nn_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_nn_nn_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_nn_nn_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_nn_nn_n1')) {
			$changed_references['roleab_in_asso_nn_nn_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_11_1n_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_11_1n_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_11_1n_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_11_1n_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_11_1n_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_11_1n_n1')) {
			$changed_references['roleab_in_asso_11_1n_n1'] = null ;
		}
		
		$db->insert('wisss_dto',array()) ;
		$id = $db->lastInsertId('wisss_dto');
		$object->setId($id,false) ;
		
		/* manage primitive attributes */
		$values = array() ;
		
		
		/* add id of object if it has been obtained by inheritance saving process */
		$values['__id'] = $id ;
		
		/* manage array attributes */
		if($change_recorder->hasBeenListset($object,'attc')
			|| $change_recorder->hasBeenAdded($object,'attc')
			|| $change_recorder->hasBeenRemoved($object,'attc')) {
			$values['attc'] = serialize($object->getListOfAttc(false)) ;
			$change_recorder->clear($object,'attc') ;
		}
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do insert */
		$db->insert('testmodule_c',$values) ;
		
		$change_recorder->clear($object,'roleab_in_asso_11_11_11') ;
		$change_recorder->clear($object,'roleab_in_asso_1n_1n_1n') ;
		$change_recorder->clear($object,'roleab_in_asso_11_11_1n') ;
		$change_recorder->clear($object,'roleab_in_asso_1n_1n_11') ;
		$change_recorder->clear($object,'roleab_in_asso_n1_n1_11') ;
		$change_recorder->clear($object,'roleab_in_asso_n1_n1_1n') ;
		$change_recorder->clear($object,'roleab_in_asso_nn_nn_11') ;
		$change_recorder->clear($object,'roleab_in_asso_nn_nn_1n') ;
		$change_recorder->clear($object,'roleab_in_xasso') ;
		
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_nn_nn_nn')) {
			$where = $db->quoteInto('rolec_in_asso_nn_nn_nn = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_nn_nn_nn' => $object->getId(), 'roleab_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_nn_nn_nn' => $object->getId(), 'roleab_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_nn_nn_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_nn_nn_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_nn_nn_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_11_11_nn')) {
			$where = $db->quoteInto('rolec_in_asso_11_11_nn = ?', $object->getId());
			$db->delete('testmodule_asso_11_11_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_11_11_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_11_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_11_11_nn' => $object->getId(), 'roleab_in_asso_11_11_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_11_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_11_11_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_11_11_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_11_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_11_11_nn' => $object->getId(), 'roleab_in_asso_11_11_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_11_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_11_11_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_11_11_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_11_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_11_11_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_11_11_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_11_11_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_11_11_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_1n_1n_nn')) {
			$where = $db->quoteInto('rolec_in_asso_1n_1n_nn = ?', $object->getId());
			$db->delete('testmodule_asso_1n_1n_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_1n_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_1n_1n_nn' => $object->getId(), 'roleab_in_asso_1n_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_1n_1n_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_1n_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_1n_1n_nn' => $object->getId(), 'roleab_in_asso_1n_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_1n_1n_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_1n_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_1n_1n_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_1n_1n_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1n_1n_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_1n_1n_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_n1_n1_nn')) {
			$where = $db->quoteInto('rolec_in_asso_n1_n1_nn = ?', $object->getId());
			$db->delete('testmodule_asso_n1_n1_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_n1_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_n1_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_n1_n1_nn' => $object->getId(), 'roleab_in_asso_n1_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_n1_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_n1_n1_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_n1_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_n1_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_n1_n1_nn' => $object->getId(), 'roleab_in_asso_n1_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_n1_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_n1_n1_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_n1_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_n1_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_n1_n1_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_n1_n1_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n1_n1_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_n1_n1_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_11_1n_nn')) {
			$where = $db->quoteInto('rolec_in_asso_11_1n_nn = ?', $object->getId());
			$db->delete('testmodule_asso_11_1n_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_11_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_11_1n_nn' => $object->getId(), 'roleab_in_asso_11_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_11_1n_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_11_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_11_1n_nn' => $object->getId(), 'roleab_in_asso_11_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_11_1n_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_11_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_11_1n_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_11_1n_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_11_1n_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_11_1n_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_11_n1_nn')) {
			$where = $db->quoteInto('rolec_in_asso_11_n1_nn = ?', $object->getId());
			$db->delete('testmodule_asso_11_n1_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_11_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_11_n1_nn' => $object->getId(), 'roleab_in_asso_11_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_11_n1_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_11_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_11_n1_nn' => $object->getId(), 'roleab_in_asso_11_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_11_n1_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_11_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_11_n1_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_11_n1_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_11_n1_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_11_n1_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_1n_n1_nn')) {
			$where = $db->quoteInto('rolec_in_asso_1n_n1_nn = ?', $object->getId());
			$db->delete('testmodule_asso_1n_n1_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_1n_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_1n_n1_nn' => $object->getId(), 'roleab_in_asso_1n_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_1n_n1_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_1n_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_1n_n1_nn' => $object->getId(), 'roleab_in_asso_1n_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_1n_n1_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_1n_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_1n_n1_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_1n_n1_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1n_n1_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_1n_n1_nn') ;
	}
	
	protected function update(testmodule_Dto_C $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_n1_n1_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_n1_n1_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_n1_n1_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_n1_n1_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_n1_n1_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_n1_n1_n1')) {
			$changed_references['roleab_in_asso_n1_n1_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_11_11_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_11_11_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_11_11_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_11_11_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_11_11_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_11_11_n1')) {
			$changed_references['roleab_in_asso_11_11_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_1n_1n_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_1n_1n_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_1n_1n_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_1n_1n_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_1n_1n_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_1n_1n_n1')) {
			$changed_references['roleab_in_asso_1n_1n_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_nn_nn_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_nn_nn_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_nn_nn_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_nn_nn_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_nn_nn_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_nn_nn_n1')) {
			$changed_references['roleab_in_asso_nn_nn_n1'] = null ;
		}
		if($change_recorder->hasBeenSet($object,'roleab_in_asso_11_1n_n1')) {
			$changed_reference = $change_recorder->getSet($object,'roleab_in_asso_11_1n_n1') ;
			$change_recorder->clear($object,'roleab_in_asso_11_1n_n1') ;
			$change_recorder->clear($changed_reference,'rolec_in_asso_11_1n_n1') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['roleab_in_asso_11_1n_n1'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'roleab_in_asso_11_1n_n1')) {
			$changed_references['roleab_in_asso_11_1n_n1'] = null ;
		}
		
				
		/* manage primitive attributes */
		$values = array() ;
		
		
		/* manage array attributes */
		if($change_recorder->hasBeenListset($object,'attc')
			|| $change_recorder->hasBeenAdded($object,'attc')
			|| $change_recorder->hasBeenRemoved($object,'attc')) {
			$values['attc'] = serialize($object->getListOfAttc(false)) ;
			$change_recorder->clear($object,'attc') ;
		}
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('testmodule_c',$values,$where) ;
		}
		
		$change_recorder->clear($object,'roleab_in_asso_11_11_11') ;
		$change_recorder->clear($object,'roleab_in_asso_1n_1n_1n') ;
		$change_recorder->clear($object,'roleab_in_asso_11_11_1n') ;
		$change_recorder->clear($object,'roleab_in_asso_1n_1n_11') ;
		$change_recorder->clear($object,'roleab_in_asso_n1_n1_11') ;
		$change_recorder->clear($object,'roleab_in_asso_n1_n1_1n') ;
		$change_recorder->clear($object,'roleab_in_asso_nn_nn_11') ;
		$change_recorder->clear($object,'roleab_in_asso_nn_nn_1n') ;
		$change_recorder->clear($object,'roleab_in_xasso') ;
		
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_nn_nn_nn')) {
			$where = $db->quoteInto('rolec_in_asso_nn_nn_nn = ?', $object->getId());
			$db->delete('testmodule_asso_nn_nn_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_nn_nn_nn' => $object->getId(), 'roleab_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_nn_nn_nn' => $object->getId(), 'roleab_in_asso_nn_nn_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_nn_nn_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_nn_nn_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_nn_nn_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_nn_nn_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_nn_nn_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_nn_nn_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_nn_nn_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_nn_nn_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_11_11_nn')) {
			$where = $db->quoteInto('rolec_in_asso_11_11_nn = ?', $object->getId());
			$db->delete('testmodule_asso_11_11_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_11_11_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_11_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_11_11_nn' => $object->getId(), 'roleab_in_asso_11_11_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_11_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_11_11_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_11_11_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_11_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_11_11_nn' => $object->getId(), 'roleab_in_asso_11_11_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_11_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_11_11_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_11_11_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_11_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_11_11_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_11_11_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_11_11_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_11_11_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_1n_1n_nn')) {
			$where = $db->quoteInto('rolec_in_asso_1n_1n_nn = ?', $object->getId());
			$db->delete('testmodule_asso_1n_1n_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_1n_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_1n_1n_nn' => $object->getId(), 'roleab_in_asso_1n_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_1n_1n_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_1n_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_1n_1n_nn' => $object->getId(), 'roleab_in_asso_1n_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_1n_1n_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_1n_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_1n_1n_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_1n_1n_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1n_1n_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_1n_1n_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_n1_n1_nn')) {
			$where = $db->quoteInto('rolec_in_asso_n1_n1_nn = ?', $object->getId());
			$db->delete('testmodule_asso_n1_n1_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_n1_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_n1_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_n1_n1_nn' => $object->getId(), 'roleab_in_asso_n1_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_n1_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_n1_n1_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_n1_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_n1_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_n1_n1_nn' => $object->getId(), 'roleab_in_asso_n1_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_n1_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_n1_n1_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_n1_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_n1_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_n1_n1_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_n1_n1_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_n1_n1_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_n1_n1_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_11_1n_nn')) {
			$where = $db->quoteInto('rolec_in_asso_11_1n_nn = ?', $object->getId());
			$db->delete('testmodule_asso_11_1n_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_11_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_11_1n_nn' => $object->getId(), 'roleab_in_asso_11_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_11_1n_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_11_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_11_1n_nn' => $object->getId(), 'roleab_in_asso_11_1n_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_1n_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_11_1n_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_11_1n_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_1n_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_11_1n_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_11_1n_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_11_1n_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_11_1n_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_11_n1_nn')) {
			$where = $db->quoteInto('rolec_in_asso_11_n1_nn = ?', $object->getId());
			$db->delete('testmodule_asso_11_n1_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_11_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_11_n1_nn' => $object->getId(), 'roleab_in_asso_11_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_11_n1_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_11_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_11_n1_nn' => $object->getId(), 'roleab_in_asso_11_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_11_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_11_n1_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_11_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_11_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_11_n1_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_11_n1_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_11_n1_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_11_n1_nn') ;
		if($change_recorder->hasBeenListset($object,'roleab_in_asso_1n_n1_nn')) {
			$where = $db->quoteInto('rolec_in_asso_1n_n1_nn = ?', $object->getId());
			$db->delete('testmodule_asso_1n_n1_nn_c',$where) ;
			foreach($change_recorder->getListset($object,'roleab_in_asso_1n_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('rolec_in_asso_1n_n1_nn' => $object->getId(), 'roleab_in_asso_1n_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'roleab_in_asso_1n_n1_nn')) {
			foreach($change_recorder->getAdded($object,'roleab_in_asso_1n_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('rolec_in_asso_1n_n1_nn' => $object->getId(), 'roleab_in_asso_1n_n1_nn' => $value->getId()) ;
				$db->insert('testmodule_asso_1n_n1_nn_c',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'roleab_in_asso_1n_n1_nn')) {
			foreach($change_recorder->getRemoved($object,'roleab_in_asso_1n_n1_nn') as $value) {
				$change_recorder->clear($value,'rolec_in_asso_1n_n1_nn') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('rolec_in_asso_1n_n1_nn = ?', $object->getId()));
				$where[] = $db->quoteInto('roleab_in_asso_1n_n1_nn = ?', $value->getId()) ;
				$db->delete('testmodule_asso_1n_n1_nn_c',$where) ;
			}
		}
		$change_recorder->clear($object,'roleab_in_asso_1n_n1_nn') ;
	}

	public static function fillObject(array $results,testmodule_Dto_C $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = Wisss_Dto_Registry_Abstract::getDto('testmodule','C',$line['__id']) ;
				self::fillObjectFromLine($line,$object) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object)
	{
		$object->setListOfAttc(unserialize($line['attc']),false) ;
		$object->setRoleabInAssoN1N1N1($line['roleab_in_asso_n1_n1_n1'],false,false) ;
		$object->setRoleabInAsso1111N1($line['roleab_in_asso_11_11_n1'],false,false) ;
		$object->setRoleabInAsso1n1nN1($line['roleab_in_asso_1n_1n_n1'],false,false) ;
		$object->setRoleabInAssoNnNnN1($line['roleab_in_asso_nn_nn_n1'],false,false) ;
		$object->setRoleabInAsso111nN1($line['roleab_in_asso_11_1n_n1'],false,false) ;
		
	}
}