<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;
require_once('lib/Wisss/Dto/Registry/Abstract.php') ;

class testmodule_Dao_Mysql_D implements Wisss_Dao_Interface
{
	protected $attributes = array('attrd' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' testmodule_d.__id,' ;
		}
		/* simple attributes */
		$query .= ' testmodule_d.attrd,testmodule_a.atta ' ;
		/* reference ids for lazy loading */
		$query .= ',testmodule_a.roleb_in_asso_1_1, testmodule_a.roleb_in_asso_1_1_wa, testmodule_a.rolebc_in_asso_11_11_11, testmodule_a.rolebc_in_asso_n1_n1_n1, testmodule_a.rolebc_in_asso_11_11_1n, testmodule_a.rolebc_in_asso_11_11_n1, testmodule_a.rolebc_in_asso_11_11_nn, testmodule_a.rolebc_in_asso_n1_n1_11, testmodule_a.rolebc_in_asso_n1_n1_1n, testmodule_a.rolebc_in_asso_n1_n1_nn, testmodule_a.rolebc_in_asso_11_1n_n1, testmodule_a.rolebc_in_asso_11_1n_nn, testmodule_a.rolebc_in_asso_11_n1_nn ' ;
		/* base class table */
		$query .= 'FROM testmodule_d testmodule_d' ;
		/* inherited tables */
		$query .= ' JOIN testmodule_a testmodule_a ON testmodule_a.__id = testmodule_d.__id ' ;
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE testmodule_d.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	
	/**
	 * Find testmodule_Dto_D where $column_value pairs matches
	 */
	public function findBy(array $column_value, $join_table=null,$join_column=null)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		if(isset($join_table) && isset($join_column)) {
			$query .= ' JOIN '.$join_table.' '.$join_table.' ON '.$join_table.'.'.$join_column.'=testmodule_d.__id' ;
		}
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY testmodule_d.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('wisss_dto',$where) ;
		$object->unsetId() ;
	}
	
	protected function insert(testmodule_Dto_D $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		
		/* delegate to dao of parent class for saving inherited data */
		$dao_of_parent = Wisss_Dao_Factory_Abstract::getDao(get_parent_class($object)) ;
		$dao_of_parent->save($object) ;
		$id = $object->getId() ;
		
		/* manage primitive attributes */
		$values = array() ;
		
		if($change_recorder->hasBeenSet($object,'attrd')) {
			$values['attrd'] = $change_recorder->getSet($object,'attrd') ;
			$change_recorder->clear($object,'attrd') ;
		}
		
		/* add id of object if it has been obtained by inheritance saving process */
		$values['__id'] = $id ;
		
		/* manage array attributes */
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do insert */
		$db->insert('testmodule_d',$values) ;
		
		
	}
	
	protected function update(testmodule_Dto_D $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		
		
		/* delegate to dao of parent class for saving inherited data */
		$dao_of_parent = Wisss_Dao_Factory_Abstract::getDao(get_parent_class($object)) ;
		$dao_of_parent->save($object) ;
				
		/* manage primitive attributes */
		$values = array() ;
		
		if($change_recorder->hasBeenSet($object,'attrd')) {
			$values['attrd'] = $change_recorder->getSet($object,'attrd') ;
			$change_recorder->clear($object,'attrd') ;
		}
		
		/* manage array attributes */
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('testmodule_d',$values,$where) ;
		}
		
		
	}

	public static function fillObject(array $results,testmodule_Dto_D $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = Wisss_Dto_Registry_Abstract::getDto('testmodule','D',$line['__id']) ;
				self::fillObjectFromLine($line,$object) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object)
	{
		$object->setAttrd( $line['attrd'],false) ;
		
		/* filling attributes of inherited classes */
		testmodule_Dao_Mysql_A::fillObjectFromLine($line,$object) ;
	}
}