<?php
set_include_path(get_include_path() . PATH_SEPARATOR . '.');
require_once 'PHPUnit/Framework.php';
require_once 'PHPUnit/TextUI/TestRunner.php';
require_once 'tests/dao/dao.php' ;
require_once ('Zend/Registry.php') ;
require_once ('Zend/Config/Ini.php');
require_once ('Zend/Db.php') ;
require_once ('lib/Wisss/ChangeRecorder.php') ;

class DaoTestSuite extends PHPUnit_Framework_TestSuite
{
	public static function main()
    {
        PHPUnit_TextUI_TestRunner::run(self::suite());
    }
    
    protected function setUp()
    {
		$config = new Zend_Config_Ini('tests/test.conf',null);
		Zend_Registry::set('config',$config) ;
		$recorder = Wisss_ChangeRecorder::getInstance() ;
		Zend_Registry::set('changeRecorder',$recorder) ;
		$db = Zend_Db::factory($config->database);
		Zend_Registry::set('db',$db) ;
   		
		$queries = explode(';',file_get_contents('install/mysql_uninstall.sql')) ;
		foreach($queries as $query) {
		$escaped_query = trim($query) ;
			if(!empty($escaped_query)) {
				$db->query($escaped_query) ;
			}
		}
		
		$queries = explode(';',file_get_contents('install/mysql_install.sql')) ;
		foreach($queries as $query) {
		$escaped_query = trim($query) ;
			if(!empty($escaped_query)) {
				$db->query($escaped_query) ;
			}
		}
    }
 
 	public static function suite()
 	{
 		$suite = new DaoTestSuite('DaoTest') ;
		return $suite ;
 	}
 
    protected function tearDown()
    {
    	/*$db = Zend_Registry::get('db') ;
    	$queries = explode(';',file_get_contents('install/mysql_uninstall.sql')) ;
		foreach($queries as $query) {
		$escaped_query = trim($query) ;
			if(!empty($escaped_query)) {
				$db->query($escaped_query) ;
			}
		}*/
    }
}

DaoTestSuite::main() ;
?>