<?php
require_once 'PHPUnit/Framework.php';
require_once('modules-available/testmodule/Dto/A.php') ;
require_once('modules-available/testmodule/Dto/B.php') ;
require_once('modules-available/testmodule/Dto/C.php') ;
require_once('modules-available/testmodule/Dto/D.php') ;
require_once('modules-available/testmodule/Dto/Asso_11_11_11.php') ;
require_once('modules-available/testmodule/Dto/Asso_1n_1n_1n.php') ;
require_once('modules-available/testmodule/Dto/Asso_n1_n1_n1.php') ;
require_once('modules-available/testmodule/Dto/Asso_nn_nn_nn.php') ;

class DtoTest extends PHPUnit_Framework_TestCase
{
	public function testInstance()
	{
		$instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_a->setAtta('test value') ;
		$this->assertSame($instance_of_a->getId(),1) ;
		$this->assertSame($instance_of_a->getAtta(),'test value') ;
	}
	
	public function testInheritance()
	{
		$instance_of_d = new testmodule_Dto_D() ;
		$instance_of_d->setId(1) ;
		$instance_of_d->setAtta('test value') ;
		$instance_of_d->setAttrd('21/12/2007') ;
		$this->assertSame($instance_of_d->getId(),1) ;
		$this->assertSame($instance_of_d->getAtta(),'test value') ;
		$this->assertSame($instance_of_d->getAttrd(),'21/12/2007') ;
	}
	
	public function testAssociation1_1()
	{
	    $instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(2) ;
		
		$instance_of_a->setRoleb_in_asso_1_1($instance_of_b) ;
		$this->assertSame($instance_of_b,$instance_of_a->getRoleb_in_asso_1_1()) ;
		$this->assertSame($instance_of_a,$instance_of_b->getRolea_in_asso_1_1()) ;
	}
	
	public function testAddFor1_n()
	{
	    $instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(2) ;
		
		$instance_of_a->addRoleb_in_asso_1_n($instance_of_b) ;
		$this->assertEquals(array($instance_of_b),$instance_of_a->getListOfRoleb_in_asso_1_n()) ;
		$this->assertSame($instance_of_a,$instance_of_b->getRolea_in_asso_1_n()) ;
	}
	
	public function testSetListOfFor1_n()
	{
	    $instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(2) ;
		
		$instance_of_a->setListOfRoleb_in_asso_1_n(array($instance_of_b)) ;
		$this->assertEquals(array($instance_of_b),$instance_of_a->getListOfRoleb_in_asso_1_n()) ;
		$this->assertSame($instance_of_a,$instance_of_b->getRolea_in_asso_1_n()) ;
	}
	
	public function testRemoveFor1_n()
	{
	    $instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(2) ;
		
		$instance_of_a->addRoleb_in_asso_1_n($instance_of_b) ;
		$this->assertEquals(array($instance_of_b),$instance_of_a->getListOfRoleb_in_asso_1_n()) ;
		$this->assertSame($instance_of_a,$instance_of_b->getRolea_in_asso_1_n()) ;
		$instance_of_a->removeRoleb_in_asso_1_n($instance_of_b) ;
		$this->assertEquals(array(),$instance_of_a->getListOfRoleb_in_asso_1_n()) ;
		$this->assertNull($instance_of_b->getRolea_in_asso_1_n()) ;
	}
	
	public function testUnsetFor1_n()
	{
	    $instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$array = array(new testmodule_Dto_B(),new testmodule_Dto_B(),new testmodule_Dto_B()) ;
		
		$instance_of_a->setListOfRoleb_in_asso_1_n($array) ;
		$instance_of_a->unsetRoleb_in_asso_1_n() ;
		$this->assertEquals(array(),$instance_of_a->getListOfRoleb_in_asso_1_n()) ;
		$this->assertNull($array[0]->getRolea_in_asso_1_n()) ;
		$this->assertNull($array[1]->getRolea_in_asso_1_n()) ;
		$this->assertNull($array[2]->getRolea_in_asso_1_n()) ;
	}
	
	public function testAsso11_11_11()
	{
    	$instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(1) ;
		$instance_of_c = new testmodule_Dto_C() ;
		$instance_of_c->setId(1) ;
		$instance_of_asso_11_11_11 = new testmodule_Dto_Asso_11_11_11() ;
		$instance_of_asso_11_11_11->setRolea_in_asso_11_11_11($instance_of_a) ;
		$instance_of_asso_11_11_11->setRoleb_in_asso_11_11_11($instance_of_b) ;
		$instance_of_asso_11_11_11->setRolec_in_asso_11_11_11($instance_of_c) ;
		
		$this->assertSame($instance_of_a->getRolebc_in_asso_11_11_11(),$instance_of_asso_11_11_11) ;
		$this->assertSame($instance_of_b->getRoleac_in_asso_11_11_11(),$instance_of_asso_11_11_11) ;
		$this->assertSame($instance_of_c->getRoleab_in_asso_11_11_11(),$instance_of_asso_11_11_11) ;
	}
	
	public function testAsso1n_1n_1n()
	{
    	$instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(1) ;
		$instance_of_c = new testmodule_Dto_C() ;
		$instance_of_c->setId(1) ;
		$instance_of_asso_1n_1n_1n = new testmodule_Dto_Asso_1n_1n_1n() ;
		$instance_of_asso_1n_1n_1n->setRolea_in_asso_1n_1n_1n($instance_of_a) ;
		$instance_of_asso_1n_1n_1n->setRoleb_in_asso_1n_1n_1n($instance_of_b) ;
		$instance_of_asso_1n_1n_1n->setRolec_in_asso_1n_1n_1n($instance_of_c) ;
		
		$this->assertSame($instance_of_a->getListOfRolebc_in_asso_1n_1n_1n(),array($instance_of_asso_1n_1n_1n)) ;
		$this->assertSame($instance_of_b->getListOfRoleac_in_asso_1n_1n_1n(),array($instance_of_asso_1n_1n_1n)) ;
		$this->assertSame($instance_of_c->getListOfRoleab_in_asso_1n_1n_1n(),array($instance_of_asso_1n_1n_1n)) ;
	}
	
	public function testAsson1_n1_n1()
	{
    	$instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(1) ;
		$instance_of_c = new testmodule_Dto_C() ;
		$instance_of_c->setId(1) ;
		$instance_of_asso_n1_n1_n1 = new testmodule_Dto_Asso_n1_n1_n1() ;
		$instance_of_asso_n1_n1_n1->addRolea_in_asso_n1_n1_n1($instance_of_a) ;
		$instance_of_asso_n1_n1_n1->addRoleb_in_asso_n1_n1_n1($instance_of_b) ;
		$instance_of_asso_n1_n1_n1->addRolec_in_asso_n1_n1_n1($instance_of_c) ;
		
		$this->assertSame($instance_of_a->getRolebc_in_asso_n1_n1_n1(),$instance_of_asso_n1_n1_n1) ;
		$this->assertSame($instance_of_b->getRoleac_in_asso_n1_n1_n1(),$instance_of_asso_n1_n1_n1) ;
		$this->assertSame($instance_of_c->getRoleab_in_asso_n1_n1_n1(),$instance_of_asso_n1_n1_n1) ;
	}
	
public function testAssonn_nn_nn()
	{
    	$instance_of_a = new testmodule_Dto_A() ;
		$instance_of_a->setId(1) ;
		$instance_of_b = new testmodule_Dto_B() ;
		$instance_of_b->setId(1) ;
		$instance_of_c = new testmodule_Dto_C() ;
		$instance_of_c->setId(1) ;
		$instance_of_asso_nn_nn_nn = new testmodule_Dto_Asso_nn_nn_nn() ;
		$instance_of_asso_nn_nn_nn->addRolea_in_asso_nn_nn_nn($instance_of_a) ;
		$instance_of_asso_nn_nn_nn->addRoleb_in_asso_nn_nn_nn($instance_of_b) ;
		$instance_of_asso_nn_nn_nn->addRolec_in_asso_nn_nn_nn($instance_of_c) ;
		
		$this->assertSame($instance_of_a->getListOfRolebc_in_asso_nn_nn_nn(),array($instance_of_asso_nn_nn_nn)) ;
		$this->assertSame($instance_of_b->getListOfRoleac_in_asso_nn_nn_nn(),array($instance_of_asso_nn_nn_nn)) ;
		$this->assertSame($instance_of_c->getListOfRoleab_in_asso_nn_nn_nn(),array($instance_of_asso_nn_nn_nn)) ;
	}
}
?>