<%
metamodel http://www.acceleo.org/module/wisss/data

import services.NamingServices
import services.AssociationServices
import services.SqlServices
import data.storage.install.mysql_type
%>

<%script type="Class" name="mysql_table"%>
CREATE TABLE <%SqlTableName()%> (
	<%-- columns for class attributes --%>
	<%for (attributes[!array]){%>
	`<%SqlColumnName()%>` <%type.mysql_type%> <%script::unique%> <%script::required%>,
	<%}%>
	<%-- columns for array attributes --%>
	<%for (attributes[array]){%>
	`<%SqlColumnName()%>` <%type.mysql_array_type%> <%script::unique%> <%script::required%>,
	<%}%>
	<%-- columns for association foreign keys --%>
	<%for (association_ends){%>
	<%if (implyForeignKeyForAssoc()){%>
	`<%getOppositeEnd().SqlColumnName()%>` INT(11) UNSIGNED<%if (getOppositeEnd().lower_bound!=0){%> NOT NULL<%}%>, FOREIGN KEY (`<%getOppositeEnd().SqlColumnName()%>`) REFERENCES `<%getOppositeEnd().type.SqlTableName()%>`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	<%}%>
	<%}%>
	<%if (subclasses){%>
	`__subclass` VARCHAR(255),
	<%}%>
	<%id_column.trim()%>
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

<%script type="Attribute" name="mysql_table"%>
CREATE TABLE <%SqlTableName()%> (
	`__object` INT(11) UNSIGNED, FOREIGN KEY (`__object`) REFERENCES `<%class.SqlTableName()%>`(`__id`) ON UPDATE CASCADE ON DELETE CASCADE,
	`<%SqlColumnName()%>` <%type.mysql_type%>
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

<%script type="Attribute" name="required"%>
<%if (metamodel::required){%>NOT NULL<%}%>

<%script type="Attribute" name="unique"%>
<%if (metamodel::unique && type != "Text"){%>UNIQUE<%}%>

<%script type="BinaryAssociation" name="mysql_table"%>
CREATE TABLE <%SqlTableName()%> (
	<%association_ends.column_in_join_table.sep(",\n")%> <%if (attributes){%>,<%}%>	
	<%attributes.column_in_join_table.sep(",\n")%>
	,UNIQUE (<%association_ends.SqlColumnName().sep(",")%>)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

<%script type="MultipleAssociation" name="mysql_table"%>
CREATE TABLE <%SqlTableName()%> (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	<%for (association_ends.getOppositeEnd()[upper_bound==1]){%>
	,<%column_in_join_table%>
	<%}%>
	
	<%for (attributes){%>
	,<%column_in_join_table%>
	<%}%>
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

<%script type="AssociationEnd" name="column_in_join_table"%>
`<%SqlColumnName()%>` INT(11) UNSIGNED <%if (getOppositeEnd().upper_bound == 1){%> UNIQUE<%}%>, FOREIGN KEY (`<%SqlColumnName()%>`) REFERENCES `<%type.SqlTableName()%>`(`__id`) ON DELETE CASCADE

<%script type="Attribute" name="column_in_join_table"%>
`<%SqlColumnName()%>` <%type.mysql_type%> <%script::unique%> <%script::required%>

<%script type="Class" name="id_column"%>
<%if (superclass){%>
`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `<%superclass.SqlTableName()%>`(`__id`) ON DELETE CASCADE
<%}else{%>
`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
<%}%>
