<%
metamodel http://www.acceleo.org/module/wisss/webapp
%>

<%script type="webapp.Webapp" name="change_recorder" file="lib/Wisss/ChangeRecorder.php"%>
<?php
require_once('lib/Wisss/Observer.php') ;

class Wisss_Change
{
	const OPERATION_SET = 0 ;
	const OPERATION_SETLIST = 1 ;
	const OPERATION_ADD = 2 ;
	const OPERATION_REMOVE = 3 ;
	const OPERATION_UNSET = 4 ;
	
	<%--protected $class ;--%>
	protected $attribute ;
	protected $old ;
	protected $new ;
	protected $operation ;
	
	public function __construct(<%--$class=null,--%>$attribute=null,$old=null,$new=null,$operation=null)
	{
		<%--$this->class = $class ;--%>
		$this->attribute = $attribute ;
		$this->old = $old ;
		$this->new = $new ;
		$this->operation = $operation ;
	}
	
	<%--public function setClass($class)
	{
		$this->class = $class ;
	}
	
	public function getClass()
	{
		return $this->class ;
	}--%>
	
	public function setAttribute($attribute)
	{
		$this->attribute = $attribute ;
	}
	
	public function getAttribute()
	{
		return $this->attribute ;
	}
	
	public function setOld($old)
	{
		$this->old = $old ;
	}
	
	public function getOld()
	{
		return $this->old ;
	}
	
	public function setNew($new)
	{
		$this->new = $new ;
	}
	
	public function getNew()
	{
		return $this->new ;
	}
	
	public function setOperation($operation)
	{
		$this->operation = $operation ;
	}
	
	public function getOperation()
	{
		return $this->operation ;
	}
}

class Wisss_ChangeRecorder implements Wisss_Observer
{
	protected static $instance = null ;
	protected $changes ;
	
	protected function __construct()
	{
		$this->changes = array(
			Wisss_Change::OPERATION_SET => array(),
			Wisss_Change::OPERATION_SETLIST => array(),
			Wisss_Change::OPERATION_ADD => array(),
			Wisss_Change::OPERATION_REMOVE => array(),
			Wisss_Change::OPERATION_UNSET => array()) ;
	}
	
	public static function getInstance()
	{
		if(!isset(self::$instance)) {
			self::$instance = new Wisss_ChangeRecorder() ;
		}
		return self::$instance ;
	}

	public function update(Wisss_Observable $o, $change)
	{
		$operation = $change->getOperation() ;
		<%--$class = $change->getClass();--%>
		<%--if(!array_key_exists($class,$this->changes[$operation])) {
			$this->changes[$operation][$class] = array() ;
		}--%>
		$uid = $o->__getUid() ;
		if(!array_key_exists($uid,$this->changes[$operation])) {
			$this->changes[$operation][$uid] = array() ;
		}
		$attribute = $change->getAttribute();
		if(!array_key_exists($attribute,$this->changes[$operation][$uid])) {
			$this->changes[$operation][$uid][$attribute] = array() ;
		}
		if($operation == Wisss_Change::OPERATION_SET
			|| $operation == Wisss_Change::OPERATION_SETLIST
			|| $operation == Wisss_Change::OPERATION_UNSET) {
			$this->changes[$operation][$uid][$attribute]['old_value'] = $change->getOld() ;
			$this->changes[$operation][$uid][$attribute]['new_value'] = $change->getNew() ;
			unset($this->changes[Wisss_Change::OPERATION_ADD][$uid][$attribute]) ;
			unset($this->changes[Wisss_Change::OPERATION_REMOVE][$uid][$attribute]) ;
		} else if($operation == Wisss_Change::OPERATION_ADD) {
			$removed_attributes = $this->getRemovedAttributes($o) ;
			if(array_key_exists($attribute,$removed_attributes)) {
				$key = array_search($change->getNew(),$removed_attributes[$attribute],true) ;
			} else {
				$key = false ;
			}
			if($key !== false) {
				unset($this->changes[Wisss_Change::OPERATION_REMOVE][$uid][$attribute][$key]) ;
			} else {
				$this->changes[$operation][$uid][$attribute][] = $change->getNew() ;
			}
		} else if($operation == Wisss_Change::OPERATION_REMOVE) {
			$set_attributes = $this->getSetLists($o) ;
			if(array_key_exists($attribute,$set_attributes)) {
				$key = array_search($change->getOld(),$set_attributes[$attribute],true) ;
				if($key !== false) {
					unset($this->changes[Wisss_Change::OPERATION_SETLIST][$uid][$attribute]['new_value'][$key]) ;
				} else {
					$added_attributes = $this->getAddedAttributes($o) ;
					if(array_key_exists($attribute,$added_attributes)) {
						$key = array_search($change->getOld(),$added_attributes[$attribute]) ;
					} else {
						$key = false ;
					}
					if($key !== false) {
						unset($this->changes[Wisss_Change::OPERATION_ADD][$uid][$attribute][$key]) ;
					} else {
						$this->changes[$operation][$uid][$attribute][] = $change->getOld() ;
					}
				}
			} else {
				$this->changes[$operation][$uid][$attribute][] = $change->getOld() ;
			}
		}
	}
	
	/**
	 * returns true if the object is synchronized with the database
	 */
	 public function isSync(Wisss_Dto_Abstract $o) {
	 	$id = $o->getId() ;
	 	if(empty($id)) {
	 		return false ;
	 	}
	 	if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SET])
	 		&& !empty($this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()])) {
	 			return false;
 		}
	 	if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SETLIST])
	 		&& !empty($this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()])) {
	 			return false;
 		}
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_ADD])
	 		&& !empty($this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()])) {
	 			return false;
 		}
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_REMOVE])
	 		&& !empty($this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()])) {
 				return false;
 		}
 		return true ;
	 }
	
	/**
	 * returns true if it has changed, false otherwise
	 */
	 public function hasBeenSet(Wisss_Dto_Abstract $o,$attribute)
	 {
	 	if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SET])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()])) {
	 			return true ;
 		}
 		return false ;
 	}
 	
 	public function hasBeenUnset(Wisss_Dto_Abstract $o, $attribute)
	 {
	 	if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_UNSET])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_UNSET][$o->__getUid()])) {
	 			return true ;
 		}
 		return false ;
 	}
 	
 	public function hasBeenListset(Wisss_Dto_Abstract $o, $attribute)
 	{
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SETLIST])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()])) {
	 			return true ;
 		}
 		return false ;
 	}
 	
 	public function hasBeenAdded(Wisss_Dto_Abstract $o, $attribute)
 	{
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_ADD])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()])) {
	 			return true ;
 		}
 		return false ;
 	}
 	
 	public function hasBeenRemoved(Wisss_Dto_Abstract $o, $attribute)
 	{
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_REMOVE])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()])) {
	 			return true ;
 		}
 		return false ;
	 }
	
	/**
	 * returns an associative array containing attributes as key and new value as value
	 * @returns array
	 */
	public function getSet(Wisss_Dto_Abstract $o, $attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SET])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()])) {
	 			return $this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()][$attribute]['new_value'] ;
 		}
 		return null ;
	}
	
	/**
	 * returns an associative array containing attributes as key and new value as value
	 * @returns array
	 */
	public function getUnset(Wisss_Dto_Abstract $o, $attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_UNSET])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_UNSET][$o->__getUid()])) {
	 			return $this->changes[Wisss_Change::OPERATION_UNSET][$o->__getUid()][$attribute]['old_value'] ;
 		}
 		return null ;
	}
	
	/**
	 * returns an associative array containing attributes as key and new value as value
	 * @returns array
	 */
	public function getOld(Wisss_Dto_Abstract $o, $attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SET])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()])) {
	 			return $this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()][$attribute]['old_value'] ;
 		}
 		return null ;
	}
	
	/**
	 * clear changes concerning the attribute in parameter
	 */
	public function clear(Wisss_Dto_Abstract $o, $attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SET])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()])) {
	 		unset($this->changes[Wisss_Change::OPERATION_SET][$o->__getUid()][$attribute]) ;
 		}
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SETLIST])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()])) {
	 		unset($this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()][$attribute]) ;
 		}
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_ADD])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()])) {
	 		unset($this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()][$attribute]) ;
 		}
 		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_REMOVE])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()])) {
	 		unset($this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()][$attribute]) ;
 		}
	}
	
	/**
	 * returns an associative array containing attributes as key and array of new values as value
	 * @returns array
	 */
	public function getListset(Wisss_Dto_Abstract $o,$attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SETLIST])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()])) {
	 			return $this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()][$attribute]['new_value'] ;
 		}
 		return null ;
	}
	
	/**
	 * returns an associative array containing attributes as key and array of new values as value
	 * @returns array
	 */
	public function getAdded(Wisss_Dto_Abstract $o, $attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_ADD])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()])) {
	 			return $this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()][$attribute] ;
 		}
 		return null ;
	}
	
	/**
	 * returns an associative array containing attributes as key and array of new values as value
	 * @returns array
	 */
	public function getRemoved(Wisss_Dto_Abstract $o, $attribute)
	{
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_REMOVE])
	 		&& array_key_exists($attribute,$this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()])) {
	 			return $this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()][$attribute] ;
 		}
 		return null ;
	}
	
	protected function getSetLists(Wisss_Dto_Abstract $o)
	{
		$modified_attribute = array() ;
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SETLIST])) {
			foreach($this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()] as $attribute => $values) {
				$modified_attribute[$attribute] = $values['new_value'] ;
			}
		}
		return $modified_attribute ;
	}
	
	protected function getAddedAttributes(Wisss_Dto_Abstract $o)
	{
		$modified_attribute = array() ;
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_ADD])) {
			$modified_attribute = $this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()] ;
		}
		return $modified_attribute ;
	}
	
	protected function getRemovedAttributes(Wisss_Dto_Abstract $o)
	{
		$modified_attribute = array() ;
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_REMOVE])) {
			$modified_attribute = $this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()] ;
		}
		return $modified_attribute ;
	}
	
	/**
	 * returns which attributes have been modified for a specific object
	 */
	public function getModifiedArrays(Wisss_Dto_Abstract $o)
	{
		$modified_attributes = array() ;
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_REMOVE])) {
			$modified_attributes = array_merge($modified_attributes,array_keys($this->changes[Wisss_Change::OPERATION_REMOVE][$o->__getUid()])) ;
		}
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_ADD])) {
			$modified_attributes = array_merge($modified_attributes,array_keys($this->changes[Wisss_Change::OPERATION_ADD][$o->__getUid()])) ;
		}
		if(array_key_exists($o->__getUid(),$this->changes[Wisss_Change::OPERATION_SETLIST])) {
			$modified_attributes = array_merge($modified_attributes,array_keys($this->changes[Wisss_Change::OPERATION_SETLIST][$o->__getUid()])) ;
		}
		return $modified_attributes ;
	}
}