<%
metamodel http://www.acceleo.org/module/wisss/data
import services.NamingServices
import services.ClassServices
import services.SqlServices
import services.AssociationServices
import general.type
%>

<%script type="MultipleAssociation" name="asso_dao_mysql" file="modules-available/<%module.DirName()%>/Dao/Mysql/<%FileName()%>.php"%>
<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;

class <%PhpDaoClassName("Mysql")%> implements Wisss_Dao_Interface
{
	protected $attributes = array('<%attributes.AttributeName().sep("' => '', '")%>' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' <%SqlTableName()%>.__id,' ;
		}
		/* simple attributes */
		$query .= ' <%attribute_list_for_select%> ' ;
		/* reference ids for lazy loading */
		$query .= '<%reference_list_for_select%> ' ;
		/* base class table */
		$query .= 'FROM <%SqlTableName()%> <%SqlTableName()%>' ;
		<%--<%if (superclass){%>
		/* inherited tables */
		<%for (inheritanceTreeBottomUp){%>
		<%if (superclass){%>
		$query .= ' JOIN <%superclass.SqlTableName()%> <%superclass.SqlTableName()%> ON <%superclass.SqlTableName()%>.__id = <%SqlTableName()%>.__id ' ;
		<%}%>
		<%}%>
		<%}%>--%>
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE <%SqlTableName()%>.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	<%for (association_ends[hasNoAttribute()].getOppositeEnd()){%>
	public function load<%AttributeName().toCamelCase()%>(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('<%type.PhpDtoClassName()%>') ;
		<%if (implyForeignKeyForAssoc()){%>
		$dto_list = $dao->findBy(array('<%getOppositeEnd().SqlColumnName()%>' => $o->getId())) ;
		<%}else{%>
		$dto_list = $dao->findBy(array('__id' => $o->get<%name.toCamelCase()%>(false))) ;
		<%}%>
		<%if (upper_bound == 1){%>
		$o->set<%name.toCamelCase()%>($dto_list[0],true,false) ;
		<%}else{%>
		$o->setListOf<%name.toCamelCase()%>($dto_list,true,false) ;
		<%}%>
	}
	
	<%}%>
	
	/**
	 * Find <%PhpDtoClassName%> where $column_value pairs matches
	 */
	public function findBy(array $column_value)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY <%SqlTableName()%>.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		<%for (association_ends.getOppositeEnd()[implyForeignKeyForAssoc()].type.nMinimize()){%>
		$dao_<%name.toLowerCase()%> = Wisss_Dao_Factory_Abstract::getDao('<%PhpDtoClassName()%>') ;
		<%}%>
		<%for (association_ends.getOppositeEnd()[implyForeignKeyForAssoc()]) {%>
		$dao_<%name.toLowerCase()%>->queryUpdate(array('<%getOppositeEnd().SqlColumnName()%>' => null),$db->quoteInto('<%getOppositeEnd().SqlColumnName()%> = ?', $object->getId())) ;
		<%}%>
		
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('<%SqlTableName()%>',$where) ;
	}
	
	protected function insert(<%PhpDtoClassName()%> $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$set_attributes = $change_recorder->getSetAttributes($object,'<%PhpDtoClassName()%>') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$ref_stored_in_object_table = array('<%association_ends[implyForeignKeyForAssoc()].getOppositeEnd().AttributeName().sep("' => '', '")%>' => '') ;
		$changed_references = array_intersect_key($set_attributes,$ref_stored_in_object_table) ;
		foreach($changed_references as $attribute => $value) {
			$value->__save() ;
		}
		
		<%--<%if (superclass){%>
		/* delegate to dao of parent class for saving inherited data */
		$dao_of_parent = Wisss_Dao_Factory_Abstract::getDao(get_parent_class($object)) ;
		$dao_of_parent->save($object) ;
		<%}%>--%>
		$id = $object->getId() ;
		
		/* manage primitive attributes */
		$values = array_intersect_key($set_attributes,$this->attributes) ;
		if(isset($id)) {
			$values['__id'] = $id ;
		}
		
		/* manage array attributes */
		$modified_arrays = $change_recorder->getModifiedArrays($object,'<%PhpDtoClassName()%>') ;
		foreach($this->attributes as $key => $value) {
			if(in_array($key,$modified_arrays)) {
				$method = 'getListOf'.ucfirst($key) ;
				$values[$key] = serialize($object->$method(false)) ;
			}
		}
		
		/* add references id in insert clause */
		foreach($changed_references as $attribute => $value) {
			$values[$attribute] = $value->getId() ;
		}
		
		/* do insert */
		$db->insert('<%SqlTableName()%>',$values) ;
		if(!isset($id)) {
			$id = $db->lastInsertId('<%SqlTableName()%>');
			$object->setId($id) ;
		}
		
		$ref_stored_in_reference_table = array('<%association_ends[!implyForeignKeyForAssoc()].getOppositeEnd().AttributeName().sep("', '")%>') ;
		$changed_references = array_intersect($modified_arrays,$ref_stored_in_reference_table) ;
		$set_lists = $change_recorder->getSetLists($object,'<%PhpDtoClassName()%>') ;
		foreach($set_lists as $attribute => $values) {
			if(in_array($attribute,$changed_references)) {
				foreach($values as $value) {
					$value->__save() ;
				}
			}
		}
	}
	
	protected function update(<%PhpDtoClassName()%> $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		$changed_attributes = $change_recorder->getSetAttributes($object,'<%PhpDtoClassName()%>') ;
		
		/* first save referenced object */
		$ref_stored_in_object_table = array('<%association_ends[implyForeignKeyForAssoc()].getOppositeEnd().AttributeName().sep("' => '', '")%>' => '') ;
		$changed_references = array_intersect_key($changed_attributes,$ref_stored_in_object_table) ;
		foreach($changed_references as $attribute => $value) {
			$value->__save() ;
		}
		
		<%--<%if (superclass){%>
		/* delegate to dao of parent class for saving inherited data */
		$dao_of_parent = Wisss_Dao_Factory_Abstract::getDao(get_parent_class($object)) ;
		$dao_of_parent->save($object) ;
		<%}%>--%>
				
		/* manage primitive attributes */
		$values = array_intersect_key($changed_attributes,$this->attributes) ;
		
		/* manage array attributes */
		$modified_arrays = $change_recorder->getModifiedArrays($object,'<%PhpDtoClassName()%>') ;
		foreach($this->attributes as $key => $value) {
			if(in_array($key,$modified_arrays)) {
				$method = 'getListOf'.ucfirst($key) ;
				$values[$key] = serialize($object->$method(false)) ;
			}
		}
		
		/* add references id in insert clause */
		foreach($changed_references as $attribute => $value) {
			$values[$attribute] = $value->getId() ;
		}
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('<%SqlTableName()%>',$values,$where) ;
		}
	}
	
	public static function queryUpdate($values,$where)
	{
		$db = Zend_Registry::get('db') ;
		$db->update('<%SqlTableName()%>',$values,$where) ;
	}
	
	public static function fillObject(array $results,<%PhpDtoClassName()%> $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = self::fillObjectFromLine($line) ;
				$object->setId($line['__id']) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object=null)
	{
		if(!isset($object)) {
			$object = Wisss_Dto_Factory_Abstract::getDto('<%ModuleName()%>','<%ClassName()%>') ;
		}
		<%for (attributes[!array]){%>
		$object->set<%name.toCamelCase()%>(<%type.castType.trim()%> $line['<%SqlColumnName()%>'],false) ;
		<%}%>
		<%for (attributes[array]){%>
		$object->setListOf<%name.toCamelCase()%>(unserialize($line['<%SqlColumnName()%>']),false) ;
		<%}%>
		<%for (association_ends[implyForeignKeyForAssoc() && hasNoAttribute()].getOppositeEnd()){%>
		$object->set<%name.toCamelCase()%>($line['<%SqlColumnName()%>'],false,false) ;
		<%}%>
		
		<%--<%if (superclass){%>
		/* filling attributes of inherited classes */
		<%}%>--%>
		<%--<%for (inheritanceTreeBottomUpWithoutBaseClass()){%>
		<%PhpDaoClassName("Mysql")%>::fillObjectFromLine($line,$object) ;
		<%}%>--%>
		
		return $object ;
	}
}

<%script type="MultipleAssociation" name="attribute_list_for_select"%>
<%attributes.SqlColumnQualifiedName().sep(",")%>

<%script type="MultipleAssociation" name="reference_list_for_select"%>
<%if (association_ends[implyForeignKeyForAssoc()].getOppositeEnd()){%>,<%}%><%association_ends[implyForeignKeyForAssoc()].getOppositeEnd().SqlColumnQualifiedName().sep(", ")%>

<%script type="MultipleAssociation" name="array_attribute_join_clause"%>
<%attributes[array].array_attribute_join_clause%>

<%script type="Attribute" name="array_attribute_join_clause"%>
 JOIN <%SqlTableName()%> <%SqlTableName()%> ON <%SqlTableName()%>.__object = <%class.SqlTableName()%>.__id 