<%
metamodel http://www.acceleo.org/module/wisss/data
import services.NamingServices
import services.ClassServices
import services.SqlServices
import services.AssociationServices
import general.type
%>

<%script type="data.Class" name="class_dao_mysql" file="modules-available/<%module.DirName()%>/Dao/Mysql/<%FileName()%>.php"%>
<?php
require_once('lib/Wisss/Dao/Interface.php') ;
require_once('lib/Wisss/Dao/Factory/Abstract.php') ;
require_once('lib/Wisss/Dto/Registry/Abstract.php') ;

class <%PhpDaoClassName("Mysql")%> implements Wisss_Dao_Interface
{
	protected $attributes = array('<%attributes.AttributeName().sep("' => '', '")%>' => '') ;
	
	protected function buildSelectQuery($retrieve_id=false)
	{
		$query = 'SELECT' ;
		if($retrieve_id) {
			$query .= ' <%SqlTableName()%>.__id,' ;
		}
		/* simple attributes */
		$query .= ' <%attribute_list_for_select%> ' ;
		/* reference ids for lazy loading */
		$query .= '<%reference_list_for_select%> ' ;
		/* base class table */
		$query .= 'FROM <%SqlTableName()%> <%SqlTableName()%>' ;
		<%if (superclass){%>
		/* inherited tables */
		<%for (inheritanceTreeBottomUp){%>
		<%if (superclass){%>
		$query .= ' JOIN <%superclass.SqlTableName()%> <%superclass.SqlTableName()%> ON <%superclass.SqlTableName()%>.__id = <%SqlTableName()%>.__id ' ;
		<%}%>
		<%}%>
		<%}%>
		return $query ;
	}
	
	public function load(Wisss_Dto_Abstract $object, $lock=false)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery() ;
		$query .= ' WHERE <%SqlTableName()%>.__id = :id' ;
		$results = $db->fetchAll($query,array('id' => $object->getId())) ;
		
		/* filling attributes of the base class */
		$this->fillObject($results,$object) ;
	}
	
	<%for (association_ends[hasNoAttribute()].getOppositeEnd()){%>
	public function load<%AttributeName().toCamelCase()%>(Wisss_Dto_Abstract $o)
	{
		$dao = Wisss_Dao_Factory_Abstract::getDao('<%type.PhpDtoClassName()%>') ;
		<%if (implyForeignKeyForAssoc()){%>
		$dto_list = $dao->findBy(array('<%getOppositeEnd().SqlColumnName()%>' => $o->getId())) ;
		<%}else{%>
			<%if (getOppositeEnd().implyForeignKeyForAssoc()){%>
		$dto_list = $dao->findBy(array('__id' => $o->get<%name.toCamelCase()%>(false))) ;
			<%}else{%>
		$dto_list = $dao->findBy(array('<%getOppositeEnd().SqlColumnName()%>' => $o->getId()),'<%association.SqlTableName()%>','<%SqlColumnName()%>') ;
			<%}%>
		<%}%>
		<%if (upper_bound == 1){%>
		$o->set<%name.toCamelCase()%>($dto_list[0],true,false) ;
		<%}else{%>
		$o->setListOf<%name.toCamelCase()%>($dto_list,true,false) ;
		<%}%>
	}
	
	<%}%>
	
	/**
	 * Find <%PhpDtoClassName%> where $column_value pairs matches
	 */
	public function findBy(array $column_value, $join_table=null,$join_column=null)
	{
		$db = Zend_Registry::get('db') ;
		$query = $this->buildSelectQuery(true) ;
		if(isset($join_table) && isset($join_column)) {
			$query .= ' JOIN '.$join_table.' '.$join_table.' ON '.$join_table.'.'.$join_column.'=<%SqlTableName()%>.__id' ;
		}
		$query .= ' WHERE 1' ;
		foreach(array_keys($column_value) as $key) {
			$query .= ' AND '.$key.' = :'.$key ;
		}
		$query .= ' ORDER BY <%SqlTableName()%>.__id' ;
		$results = $db->fetchAll($query,$column_value) ;
		
		/* filling attributes of the base class */
		return $this->fillObject($results) ;
	}
	
	public function save(Wisss_Dto_Abstract $object)
	{
		$id = $object->getId() ;
		if(isset($id)) {
			$this->update($object) ;
		} else {
			$this->insert($object) ;
		}
	}
	
	public function delete(Wisss_Dto_Abstract $object)
	{
		$db = Zend_Registry::get('db') ;
		$where = $db->quoteInto('__id = ?', $object->getId());
		$db->delete('wisss_dto',$where) ;
		$object->unsetId() ;
	}
	
	protected function insert(<%PhpDtoClassName()%> $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		<%push()%>
		<%for (association_ends[implyForeignKeyForAssoc()].getOppositeEnd()) {%>
		if($change_recorder->hasBeenSet($object,'<%AttributeName()%>')) {
			$changed_reference = $change_recorder->getSet($object,'<%AttributeName()%>') ;
			$change_recorder->clear($object,'<%AttributeName()%>') ;
			$change_recorder->clear($changed_reference,'<%getOppositeEnd().AttributeName()%>') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['<%AttributeName()%>'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'<%AttributeName()%>')) {
			$changed_references['<%AttributeName()%>'] = null ;
		}
		<%}%>
		
		<%if (superclass){%>
		/* delegate to dao of parent class for saving inherited data */
		$dao_of_parent = Wisss_Dao_Factory_Abstract::getDao(get_parent_class($object)) ;
		$dao_of_parent->save($object) ;
		$id = $object->getId() ;
		<%}else{%>
		$db->insert('wisss_dto',array()) ;
		$id = $db->lastInsertId('wisss_dto');
		$object->setId($id,false) ;
		<%}%>
		
		/* manage primitive attributes */
		$values = array() ;
		
		<%for (attributes[!array]) {%>
		if($change_recorder->hasBeenSet($object,'<%AttributeName()%>')) {
			$values['<%AttributeName()%>'] = $change_recorder->getSet($object,'<%AttributeName()%>') ;
			$change_recorder->clear($object,'<%AttributeName()%>') ;
		}
		<%}%>
		
		/* add id of object if it has been obtained by inheritance saving process */
		$values['__id'] = $id ;
		
		/* manage array attributes */
		<%for (attributes[array]) {%>
		if($change_recorder->hasBeenListset($object,'<%AttributeName()%>')
			|| $change_recorder->hasBeenAdded($object,'<%AttributeName()%>')
			|| $change_recorder->hasBeenRemoved($object,'<%AttributeName()%>')) {
			$values['<%AttributeName()%>'] = serialize($object->getListOf<%name.toCamelCase()%>(false)) ;
			$change_recorder->clear($object,'<%AttributeName()%>') ;
		}
		<%}%>
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do insert */
		$db->insert('<%SqlTableName()%>',$values) ;
		
		<%for (association_ends[!implyForeignKeyForAssoc()].getOppositeEnd()[implyForeignKeyForAssoc()]) {%>
		$change_recorder->clear($object,'<%AttributeName()%>') ;
		<%}%>
		
		<%for (association_ends[association.implyJoinTableForAssoc()].getOppositeEnd()) {%>
		if($change_recorder->hasBeenListset($object,'<%AttributeName()%>')) {
			$where = $db->quoteInto('<%getOppositeEnd().SqlColumnName()%> = ?', $object->getId());
			$db->delete('<%association.SqlTableName()%>',$where) ;
			foreach($change_recorder->getListset($object,'<%AttributeName()%>') as $value) {
				$change_recorder->clear($value,'<%getOppositeEnd().AttributeName()%>') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('<%getOppositeEnd().SqlColumnName()%>' => $object->getId(), '<%SqlColumnName()%>' => $value->getId()) ;
				$db->insert('<%association.SqlTableName()%>',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'<%AttributeName()%>')) {
			foreach($change_recorder->getAdded($object,'<%AttributeName()%>') as $value) {
				$change_recorder->clear($value,'<%getOppositeEnd().AttributeName()%>') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('<%getOppositeEnd().SqlColumnName()%>' => $object->getId(), '<%SqlColumnName()%>' => $value->getId()) ;
				$db->insert('<%association.SqlTableName()%>',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'<%AttributeName()%>')) {
			foreach($change_recorder->getRemoved($object,'<%AttributeName()%>') as $value) {
				$change_recorder->clear($value,'<%getOppositeEnd().AttributeName()%>') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('<%getOppositeEnd().SqlColumnName()%> = ?', $object->getId()));
				$where[] = $db->quoteInto('<%SqlColumnName()%> = ?', $value->getId()) ;
				$db->delete('<%association.SqlTableName()%>',$where) ;
			}
		}
		$change_recorder->clear($object,'<%AttributeName()%>') ;
		<%}%>
	}
	
	protected function update(<%PhpDtoClassName()%> $object)
	{
		$change_recorder = Zend_Registry::get('changeRecorder') ;
		$db = Zend_Registry::get('db') ;
		
		/* first save referenced object */
		$changed_references = array() ;
		<%push()%>
		<%for (association_ends[implyForeignKeyForAssoc()].getOppositeEnd()) {%>
		if($change_recorder->hasBeenSet($object,'<%AttributeName()%>')) {
			$changed_reference = $change_recorder->getSet($object,'<%AttributeName()%>') ;
			$change_recorder->clear($object,'<%AttributeName()%>') ;
			$change_recorder->clear($changed_reference,'<%getOppositeEnd().AttributeName()%>') ;
			$ref_id = $changed_reference->getId() ;
			if(empty($ref_id)) {
				$changed_reference->__save() ;
			}
			$changed_references['<%AttributeName()%>'] = $changed_reference->getId() ;
		}
		if($change_recorder->hasBeenUnset($object,'<%AttributeName()%>')) {
			$changed_references['<%AttributeName()%>'] = null ;
		}
		<%}%>
		
		<%if (superclass){%>
		/* delegate to dao of parent class for saving inherited data */
		$dao_of_parent = Wisss_Dao_Factory_Abstract::getDao(get_parent_class($object)) ;
		$dao_of_parent->save($object) ;
		<%}%>
				
		/* manage primitive attributes */
		$values = array() ;
		
		<%for (attributes[!array]) {%>
		if($change_recorder->hasBeenSet($object,'<%AttributeName()%>')) {
			$values['<%AttributeName()%>'] = $change_recorder->getSet($object,'<%AttributeName()%>') ;
			$change_recorder->clear($object,'<%AttributeName()%>') ;
		}
		<%}%>
		
		/* manage array attributes */
		<%for (attributes[array]) {%>
		if($change_recorder->hasBeenListset($object,'<%AttributeName()%>')
			|| $change_recorder->hasBeenAdded($object,'<%AttributeName()%>')
			|| $change_recorder->hasBeenRemoved($object,'<%AttributeName()%>')) {
			$values['<%AttributeName()%>'] = serialize($object->getListOf<%name.toCamelCase()%>(false)) ;
			$change_recorder->clear($object,'<%AttributeName()%>') ;
		}
		<%}%>
		
		/* add references id in insert clause */
		$values = array_merge($values,$changed_references) ;
		
		/* do update */
		$where = $db->quoteInto('__id = ?',$object->getId()) ;
		if(!empty($values)) {
			$db->update('<%SqlTableName()%>',$values,$where) ;
		}
		
		<%for (association_ends[!implyForeignKeyForAssoc()].getOppositeEnd()[implyForeignKeyForAssoc()]) {%>
		$change_recorder->clear($object,'<%AttributeName()%>') ;
		<%}%>
		
		<%for (association_ends[association.implyJoinTableForAssoc()].getOppositeEnd()) {%>
		if($change_recorder->hasBeenListset($object,'<%AttributeName()%>')) {
			$where = $db->quoteInto('<%getOppositeEnd().SqlColumnName()%> = ?', $object->getId());
			$db->delete('<%association.SqlTableName()%>',$where) ;
			foreach($change_recorder->getListset($object,'<%AttributeName()%>') as $value) {
				$change_recorder->clear($value,'<%getOppositeEnd().AttributeName()%>') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values = array('<%getOppositeEnd().SqlColumnName()%>' => $object->getId(), '<%SqlColumnName()%>' => $value->getId()) ;
				$db->insert('<%association.SqlTableName()%>',$values) ;
			}
		}
		if($change_recorder->hasBeenAdded($object,'<%AttributeName()%>')) {
			foreach($change_recorder->getAdded($object,'<%AttributeName()%>') as $value) {
				$change_recorder->clear($value,'<%getOppositeEnd().AttributeName()%>') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$values =array('<%getOppositeEnd().SqlColumnName()%>' => $object->getId(), '<%SqlColumnName()%>' => $value->getId()) ;
				$db->insert('<%association.SqlTableName()%>',$values) ;
			}
		}
		if($change_recorder->hasBeenRemoved($object,'<%AttributeName()%>')) {
			foreach($change_recorder->getRemoved($object,'<%AttributeName()%>') as $value) {
				$change_recorder->clear($value,'<%getOppositeEnd().AttributeName()%>') ;
				$value_id = $value->getId() ;
				if(empty($value_id)) {
					$value->__save() ;
				}
				$where = array($db->quoteInto('<%getOppositeEnd().SqlColumnName()%> = ?', $object->getId()));
				$where[] = $db->quoteInto('<%SqlColumnName()%> = ?', $value->getId()) ;
				$db->delete('<%association.SqlTableName()%>',$where) ;
			}
		}
		$change_recorder->clear($object,'<%AttributeName()%>') ;
		<%}%>
	}

	public static function fillObject(array $results,<%PhpDtoClassName()%> $object=null)
	{
		if(isset($object)) {
			return self::fillObjectFromLine($results[0],$object) ;
		} else {
			$objects = array() ;
			foreach($results as $line) {
				$object = Wisss_Dto_Registry_Abstract::getDto('<%ModuleName()%>','<%ClassName()%>',$line['__id']) ;
				self::fillObjectFromLine($line,$object) ;
				$objects[] = $object ;
			}
			return $objects ;
		}
	}
	
	public static function fillObjectFromLine(array $line,$object)
	{
		<%for (attributes[!array]){%>
		$object->set<%name.toCamelCase()%>(<%type.castType.trim()%> $line['<%SqlColumnName()%>'],false) ;
		<%}%>
		<%for (attributes[array]){%>
		$object->setListOf<%name.toCamelCase()%>(unserialize($line['<%SqlColumnName()%>']),false) ;
		<%}%>
		<%for (association_ends[implyForeignKeyForAssoc() && hasNoAttribute()].getOppositeEnd()){%>
		$object->set<%name.toCamelCase()%>($line['<%SqlColumnName()%>'],false,false) ;
		<%}%>
		
		<%if (superclass){%>
		/* filling attributes of inherited classes */
		<%}%>
		<%for (inheritanceTreeBottomUpWithoutBaseClass()){%>
		<%PhpDaoClassName("Mysql")%>::fillObjectFromLine($line,$object) ;
		<%}%>
	}
}

<%script type="Class" name="attribute_list_for_select"%>
<%attributes.SqlColumnQualifiedName().sep(",")%><%if (superclass){%>,<%superclass.attribute_list_for_select%><%}%>

<%script type="Class" name="reference_list_for_select"%>
<%if (association_ends[implyForeignKeyForAssoc()].getOppositeEnd()){%>,<%}%><%association_ends[implyForeignKeyForAssoc()].getOppositeEnd().SqlColumnQualifiedName().sep(", ")%><%superclass.reference_list_for_select%>

<%script type="Class" name="array_attribute_join_clause"%>
<%attributes[array].array_attribute_join_clause%>

<%script type="Attribute" name="array_attribute_join_clause"%>
 JOIN <%SqlTableName()%> <%SqlTableName()%> ON <%SqlTableName()%>.__object = <%class.SqlTableName()%>.__id 