<%
metamodel http://www.acceleo.org/module/wisss/data

import services.NamingServices
import services.AssociationServices
import general.class_type
import general.type
%>

<%script type="data.Class" name="dto" file="modules-available/<%module.DirName()%>/Dto/<%FileName()%>.php"%>
<?php
require_once('lib/Wisss/Dto/Abstract.php') ;
require_once('lib/Wisss/array_func.php') ;
/**
 * <%PhpDtoClassName()%>
 * @package <%module%>
 */
class <%PhpDtoClassName()%> extends <%parentClass%>
{
	/**
     * information from model
     */
    const CLASS_NAME = '<%ClassName()%>';
    const MODULE_NAME = '<%module.ModuleName()%>';
    
	<%for (attributes){%>
	/**
	 * @var <%type.phpType%>
	 */
	protected $<%AttributeName()%> ;
	<%}%>
	<%for (association_ends[hasNoAttribute()]){%>
	/**
	 * @var <%getOppositeEnd().type.phpType%>
	 */
	protected $<%getOppositeEnd().AttributeName()%> ;
	<%}%>
	
	public function __construct()
	{
		parent::__construct() ;
		$this->__setToLoaded() ;
	}
	
	public function __destruct()
	{
		parent::__destruct() ;
	}
	
	public function __setToLoaded()
	{
		<%for (association_ends[hasNoAttribute()]){%>
		$this->__loaded['<%getOppositeEnd().AttributeName()%>'] = true ;
		<%}%>
	}
	
	public function __setToNotLoaded()
	{
		<%for (association_ends[hasNoAttribute()]){%>
		$this->__loaded['<%getOppositeEnd().AttributeName()%>'] = false ;
		<%}%>
	}
	
	public function setId($id,$reset_loading=true)
	{
		parent::setId($id) ;
		if($reset_loading) {
			$this->__setToNotLoaded() ;
		}
	}
	
	<%for (attributes){%>
	<%setter%>
	
	<%getter%>
	<%}%>
	
	<%for (association_ends[hasNoAttribute()]){%>
	<%setter_for_association_end%>
	
	<%getter_for_association_end%>
	<%}%>
}

<%script type="Class" name="parentClass"%>
<%if (superclass){%><%superclass.PhpDtoClassName()%><%}else{%>Wisss_Dto_Abstract<%}%>

<%script type="Attribute" name="setter"%>
<%if (array){%>
/**
 * setListOf<%name.toCamelCase()%>
 */
public function setListOf<%name.toCamelCase()%>(<%toPhpVariable%>, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes->setOld($this-><%AttributeName()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_SETLIST) ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		$changes->setNew(<%toPhpVariable()%>) ;
		<%afterChange%>
	}
}

/**
 * add<%name.toCamelCase()%>
 */
public function add<%name.toCamelCase()%>(<%toPhpVariable%>, $notify=true)
{
	if($notify) {
	<%beforeChange%>
	$changes->setOld($this-><%AttributeName()%>) ;
	$changes->setOperation(Wisss_Change::OPERATION_ADD) ;
	}
	$this-><%AttributeName()%>[] = <%toPhpVariable()%> ;
	if($notify) {
		$changes->setNew(<%toPhpVariable()%>) ;
		<%afterChange%>
	}
}

/**
 * remove first element found
 */
public function remove<%name.toCamelCase()%>(<%toPhpVariable%>, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes->setOld(<%toPhpVariable()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_REMOVE) ;
	}
	array_removeFirstSameAs(<%toPhpVariable()%>,$this-><%AttributeName()%>) ;
	if($notify) {
		$changes->setNew($this-><%AttributeName()%>) ;
		<%afterChange%>
	}
}

/**
 * remove all elements found
 */
public function removeAll<%name.toCamelCase()%>(<%toPhpVariable%>, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes->setOld(<%toPhpVariable()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_REMOVE) ;
	}
	array_removeAllSameAs(<%toPhpVariable()%>,$this-><%AttributeName()%>) ;
	if($notify) {
		$changes->setNew($this-><%AttributeName()%>) ;
		<%afterChange%>
	}
}
<%}else{%>
/**
 * set<%name.toCamelCase()%>
 */
public function set<%name.toCamelCase()%>(<%toPhpVariable%>, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes->setOld($this-><%AttributeName()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_SET) ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		$changes->setNew(<%toPhpVariable()%>) ;
		<%afterChange%>
	}
}
<%}%>

<%script type="AssociationEnd" name="setter_for_association_end"%>
<%for (getOppositeEnd()[upper_bound !=1]){%>
/**
 * setListOf<%name.toCamelCase()%>
 */
public function setListOf<%name.toCamelCase()%>(array <%toPhpVariable%>, $backref=true, $notify=true, $is_loaded=false)
{
	if($backref && isset($this-><%AttributeName()%>)) {
		foreach($this-><%AttributeName()%> as $item) {
			<%if (getOppositeEnd().upper_bound == 1){%>
			$item->unset<%getOppositeEnd().name.toCamelCase()%>(false,$notify,true) ;
			<%}else{%>
			$item->remove<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
			<%}%>
		}
	}
	if($notify) {
		<%beforeChange%>
		$changes->setOld($this-><%AttributeName()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_SETLIST) ;
	}
	if($notify || $is_loaded) {
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		$changes->setNew(<%toPhpVariable()%>) ;
		<%afterChange%>
	}
	if($backref && isset($this-><%AttributeName()%>)) {
		foreach($this-><%AttributeName()%> as $item) {
			<%if (getOppositeEnd().upper_bound == 1){%>
			$item->set<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify,true) ;
			<%}else{%>
			$item->add<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
			<%}%>
		}
	}
}

/**
 * add<%name.toCamelCase()%>
 */
public function add<%name.toCamelCase()%>(<%toPhpVariable%>, $backref=true, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes->setOld($this-><%AttributeName()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_ADD) ;
	}
	$this-><%AttributeName()%>[] = <%toPhpVariable()%> ;
	if($notify) {
		$changes->setNew(<%toPhpVariable()%>) ;
		<%afterChange%>
	}
	if($backref && is_object(<%toPhpVariable%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		<%toPhpVariable%>->set<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify,true) ;
		<%}else{%>
		<%toPhpVariable%>->add<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
		<%}%>
	}
}

/**
 * remove all element found
 */
public function remove<%name.toCamelCase()%>(<%toPhpVariable%>, $backref=true, $notify=true)
{
	if($backref && is_object(<%toPhpVariable%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		<%toPhpVariable%>->unset<%getOppositeEnd().name.toCamelCase()%>(false,$notify,true) ;
		<%}else{%>
		<%toPhpVariable%>->remove<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
		<%}%>
	}
	if($notify) {
		<%beforeChange%>
		$changes->setOld(<%toPhpVariable()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_REMOVE) ;
	}
	array_removeAllSameAs(<%toPhpVariable()%>,$this-><%AttributeName()%>) ;
	if($notify) {
		$changes->setNew($this-><%AttributeName()%>) ;
		<%afterChange%>
	}
}

/**
 * unset<%name.toCamelCase()%>
 */
public function unset<%name.toCamelCase()%>($backref=true, $notify=true,$is_loaded=false)
{
	if($backref && isset($this-><%AttributeName()%>)) {
		foreach($this-><%AttributeName()%> as $item) {
			<%if (getOppositeEnd().upper_bound == 1){%>
			$item->unset<%getOppositeEnd().name.toCamelCase()%>(false,$notify,true) ;
			<%}else{%>
			$item->remove<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
			<%}%>
		}
	}
	if($notify) {
		<%beforeChange%>
		$changes->setOperation(Wisss_Change::OPERATION_UNSET) ;
	}
	if($notify || $is_loaded) {
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	$this-><%AttributeName()%> = array() ;
	if($notify) {
		<%afterChange%>
	}
}
<%}%><%for (getOppositeEnd()[upper_bound ==1]){%>
/**
 * set<%name.toCamelCase()%>
 */
public function set<%name.toCamelCase()%>(<%toPhpVariable%>, $backref=true, $notify=true, $is_loaded=false)
{
	if($backref && is_object($this-><%AttributeName()%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		$this-><%AttributeName()%>->unset<%getOppositeEnd().name.toCamelCase()%>(false,$notify,true) ;
		<%}else{%>
		$this-><%AttributeName()%>->remove<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
		<%}%>
	}
	if($notify) {
		<%beforeChange%>
		$changes->setOld($this-><%AttributeName()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_SET) ;
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	if($notify || $is_loaded) {
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		$changes->setNew(<%toPhpVariable()%>) ;
		<%afterChange%>
	}
	if($backref && is_object($this-><%AttributeName()%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		$this-><%AttributeName()%>->set<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify,true) ;
		<%}else{%>
		$this-><%AttributeName()%>->add<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
		<%}%>
	}
}

/**
 * unset<%name.toCamelCase()%>
 */
public function unset<%name.toCamelCase()%>($backref=true, $notify=true, $is_loaded=false)
{
	if($backref && is_object($this-><%AttributeName()%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		$this-><%AttributeName()%>->unset<%getOppositeEnd().name.toCamelCase()%>(false,$notify,true) ;
		<%}else{%>
		$this-><%AttributeName()%>->remove<%getOppositeEnd().name.toCamelCase()%>($this,false,$notify) ;
		<%}%>
	}
	if($notify) {
		<%beforeChange%>
		$changes->setOld($this-><%AttributeName()%>) ;
		$changes->setOperation(Wisss_Change::OPERATION_UNSET) ;
	}
	if($notify || $is_loaded) {
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	$this-><%AttributeName()%> = null ;
	if($notify) {
		$changes->setNew(null) ;
		<%afterChange%>
	}
}
<%}%>

<%script type="Attribute" name="beforeChange"%>
$changes = new Wisss_Change() ;
$changes->setAttribute('<%AttributeName()%>') ;
<%script type="Attribute" name="afterChange"%>
$this->setChanged() ;
$this->notifyObservers($changes) ;

<%script type="AssociationEnd" name="beforeChange"%>
$changes = new Wisss_Change() ;
$changes->setAttribute('<%AttributeName()%>') ;
<%script type="AssociationEnd" name="afterChange"%>
$this->setChanged() ;
$this->notifyObservers($changes) ;

<%script type="Attribute" name="getter"%>
<%if (array){%>
/**
 * getListOf<%name.toCamelCase()%>
 */
public function getListOf<%name.toCamelCase()%>()
{
	return $this-><%AttributeName()%> ;
}
<%}else{%>
/**
 * <%type.getterName%><%name.toCamelCase()%>
 */
public function <%type.getterName%><%name.toCamelCase()%>()
{
	return $this-><%AttributeName()%> ;
}
<%}%>

<%script type="AssociationEnd" name="getter_for_association_end"%>
<%for (getOppositeEnd()[upper_bound !=1]){%>
/**
 * getListOf<%name.toCamelCase()%>
 */
public function getListOf<%name.toCamelCase()%>($lazyload=true)
{
	if($lazyload && !$this->__loaded['<%AttributeName()%>']) {
		$dao = Wisss_Dao_Factory_Abstract::getDao(get_class($this)) ;
		$dao->load<%name.toCamelCase()%>($this) ;
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	return $this-><%AttributeName()%> ;
}
<%}%>
<%for (getOppositeEnd()[upper_bound ==1]){%>
/**
 * <%type.getterName%><%name.toCamelCase()%>
 */
public function get<%name.toCamelCase()%>($lazyload=true)
{
	if($lazyload && !$this->__loaded['<%AttributeName()%>']) {
		$dao = Wisss_Dao_Factory_Abstract::getDao(get_class($this)) ;
		$dao->load<%name.toCamelCase()%>($this) ;
		$this->__loaded['<%AttributeName()%>'] = true ;
	}
	return $this-><%AttributeName()%> ;
}
<%}%>