<%
metamodel http://www.acceleo.org/module/wisss/data

import services.NamingServices
import services.AssociationServices
import general.class_type
import general.type
import modules.dto.class_dto
%>

<%script type="data.MultipleAssociation" name="dto" file="modules-available/<%module.DirName()%>/Dto/<%FileName()%>.php"%>
<?php
/**
 * <%PhpDtoClassName()%>
 * @package <%module%>
 */
class <%PhpDtoClassName()%> extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = '<%ClassName()%>';
    const MODULE_NAME = '<%module.ModuleName()%>';
    
    <%for (association_ends.getOppositeEnd()){%>
    /**
	 * @var <%type.phpType%>
	 */
	protected $<%AttributeName()%> ;
    <%}%>
    
	<%for (attributes){%>
	/**
	 * @var <%type.phpType%>
	 */
	protected $<%AttributeName()%> ;
	<%}%>
	
	<%for (association_ends.getOppositeEnd()){%>
	<%setter%>
	
	<%getter%>
	<%}%>
	
	<%for (attributes){%>
	<%setter%>
	
	<%getter%>
	<%}%>
}

<%script type="AssociationEnd" name="setter"%>
<%if (upper_bound !=1) {%>
/**
 * setListOf<%name.toCamelCase()%>
 */
public function setListOf<%name.toCamelCase()%>(<%toPhpVariable%>, $backref=true, $notify=true)
{
	if($backref && isset($this-><%AttributeName()%>)) {
		foreach($this-><%AttributeName()%> as $item) {
			<%if (getOppositeEnd().upper_bound == 1){%>
			$item->unset<%getOppositeEnd().name.toCamelCase()%>(false) ;
			<%}else{%>
			$item->remove<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
			<%}%>
		}
	}
	if($notify) {
		<%beforeChange%>
		$changes['operation'] = 'setlist' ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		<%afterChange%>
	}
	if($backref) {
		foreach($this-><%AttributeName()%> as $item) {
			<%if (getOppositeEnd().upper_bound == 1){%>
			$item->set<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
			<%}else{%>
			$item->add<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
			<%}%>
		}
	}
}

/**
 * add<%name.toCamelCase()%>
 */
public function add<%name.toCamelCase()%>(<%toPhpVariable%>, $backref=true, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes['operation'] = 'add' ;
	}
	$this-><%AttributeName()%>[] = <%toPhpVariable()%> ;
	if($notify) {
		<%afterChange%>
	}
	if($backref) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		<%toPhpVariable%>->set<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
		<%}else{%>
		<%toPhpVariable%>->add<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
		<%}%>
	}
}

/**
 * remove<%name.toCamelCase()%>
 */
public function remove<%name.toCamelCase()%>(<%toPhpVariable%>, $backref=true, $notify=true)
{
	if($backref && isset($this-><%AttributeName()%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		<%toPhpVariable%>->unset<%getOppositeEnd().name.toCamelCase()%>(false) ;
		<%}else{%>
		<%toPhpVariable%>->remove<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
		<%}%>
	}
	if($notify) {
		<%beforeChange%>
		$changes['operation'] = 'remove' ;
	}
	foreach($this-><%AttributeName()%> as $key=>$item) {
		if($item->__sameAs(<%toPhpVariable%>)) {
			unset($this-><%AttributeName()%>[$key]) ;
		}
	}
	if($notify) {
		<%afterChange%>
	}
}

/**
 * unset<%name.toCamelCase()%>
 */
public function unset<%name.toCamelCase()%>($backref=true, $notify=true)
{
	if($backref && isset($this-><%AttributeName()%>)) {
		foreach($this-><%AttributeName()%> as $item) {
			<%if (getOppositeEnd().upper_bound == 1){%>
			$item->unset<%getOppositeEnd().name.toCamelCase()%>(false) ;
			<%}else{%>
			$item->remove<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
			<%}%>
		}
	}
	if($notify) {
		<%beforeChange%>
		$changes['operation'] = 'unset' ;
	}
	$this-><%AttributeName()%> = array() ;
	if($notify) {
		<%afterChange%>
	}
}
<%}else{%>
/**
 * set<%name.toCamelCase()%>
 */
public function set<%name.toCamelCase()%>(<%toPhpVariable%>,$backref=true, $notify=true)
{
	if($backref && isset($this-><%AttributeName()%>)) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		$this-><%AttributeName()%>->unset<%getOppositeEnd().name.toCamelCase()%>(false) ;
		<%}else{%>
		$this-><%AttributeName()%>->remove<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
		<%}%>
	}
	if($notify) {
		<%beforeChange%>
		$changes['operation'] = 'set' ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		<%afterChange%>
	}
	if($backref) {
		<%if (getOppositeEnd().upper_bound == 1){%>
		$this-><%AttributeName()%>->set<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
		<%}else{%>
		$this-><%AttributeName()%>->add<%getOppositeEnd().name.toCamelCase()%>($this,false) ;
		<%}%>
	}
}
<%}%>

<%script type="AssociationEnd" name="beforeChange"%>
$changes = array() ;
$changes['attribute'] = '<%AttributeName()%>' ;
$changes['old_value'] = $this-><%AttributeName()%> ;
<%script type="AssociationEnd" name="afterChange"%>
$changes['new_value'] = $this-><%AttributeName()%> ;
$this->setChanged() ;
$this->notifyObservers($changes) ;

<%script type="AssociationEnd" name="getter"%>
/**
 * get<%name.toCamelCase()%>
 */
public function get<%name.toCamelCase()%>()
{
	return $this-><%AttributeName()%> ;
}
