/*
  Copyright © 2007 Makina Corpus
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
  You can apply any license to the files generated with this template
  and Acceleo.

@author  Francois Gaudin <francois.gaudin@makina-corpus.com> 
*/

package services;

import java.util.Iterator;

import wisss.data.AssociationEnd;
import wisss.data.BinaryAssociation;
import wisss.data.MultipleAssociation;


public class AssociationServices {
	public AssociationEnd getOppositeEnd(AssociationEnd end) {
		Iterator it = end.getAssociation().getAssociation_ends().iterator() ;
		while(it.hasNext()) {
			AssociationEnd el = (AssociationEnd) it.next();
			if(el != end) {
				return el ;
			}
		}
		return null ;
	}
	
	public boolean hasNoAttribute(AssociationEnd end) {
		if(end.getAssociation().getAttributes().size() == 0) {
			return true ;
		}
		return false ;
	}
	
	public boolean inMultipleAssociation(BinaryAssociation asso) {
		if(((AssociationEnd)asso.getAssociation_ends().get(0)).getType() instanceof MultipleAssociation || ((AssociationEnd)asso.getAssociation_ends().get(1)).getType() instanceof MultipleAssociation) {
			return true ;
		}
		return false ;
	}
}