/*
  Copyright © 2007 Makina Corpus
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
  You can apply any license to the files generated with this template
  and Acceleo.

@author  Francois Gaudin <francois.gaudin@makina-corpus.com> 
*/

package services;

import java.util.Collections;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import wisss.data.Class;


public class ClassServices {
	public EList inheritanceTreeBottomUp(Class cl) {
		EList list = new BasicEList() ;
		Class current = cl ;
		do {
			list.add(current) ;
			current = current.getSuperclass() ;
		} while(current != null) ;
		return list ;
	}
	
	public EList inheritanceTreeBottomUpWithoutBaseClass(Class cl) {
		EList list = new BasicEList() ;
		Class current = cl.getSuperclass() ;
		while(current != null) {
			list.add(current) ;
			current = current.getSuperclass() ;
		}
		return list ;
	}
	
	public EList inheritanceTreeTopDown(Class cl) {
		EList list = this.inheritanceTreeBottomUp(cl) ;
		Collections.reverse(list) ;
		return list ;
	}
}