package fr.obeo.weblog.business.blog;

// Start of user code for import
import java.io.Serializable;

// End of user code

/**
 * 
 */
public class User implements Serializable {

	// serialVersionUID is used for serialization.
	private static final long serialVersionUID = 1L;

	public final static String PROP_ID = "id";
	public final static String PROP_EMAIL = "email";
	public final static String PROP_FIRSTNAME = "firstName";
	public final static String PROP_LASTNAME = "lastName";
	public final static String PROP_LOGIN = "login";
	public final static String PROP_PASSWORD = "password";

	private String id;
	protected String email;
	protected String firstName;
	protected String lastName;
	protected String login;
	protected String password;

	/**
	 * Default constructor 
	 */
	public User() {
		super();
	}
	
	/**
	 * Return the identifier
	 * @return Id
	 */
	public String getId() {
		return this.id;
	}

	/**
	 * Set a value to parameter Id
	 * @param id Value of the identifier
	 */
	public void setId(String id) {
		this.id = id;
	}
	

	/**
	 * Constructor with all parameters initialized
	 * @param email 
	 * @param firstName 
	 * @param lastName 
	 * @param login 
	 * @param password 
	 */
	public User(String email, String firstName, String lastName, String login, String password) {
		this.email = email;
		this.firstName = firstName;
		this.lastName = lastName;
		this.login = login;
		this.password = password;
	}	

	/**
	 * Return email
	 * @return 
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * Set a value to parameter email.
	 * @param email 
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * Return firstName
	 * @return 
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * Set a value to parameter firstName.
	 * @param firstName 
	 */
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	/**
	 * Return lastName
	 * @return 
	 */
	public String getLastName() {
		return lastName;
	}

	/**
	 * Set a value to parameter lastName.
	 * @param lastName 
	 */
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	/**
	 * Return login
	 * @return 
	 */
	public String getLogin() {
		return login;
	}

	/**
	 * Set a value to parameter login.
	 * @param login 
	 */
	public void setLogin(String login) {
		this.login = login;
	}

	/**
	 * Return password
	 * @return 
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * Set a value to parameter password.
	 * @param password 
	 */
	public void setPassword(String password) {
		this.password = password;
	}


	
	/** 
	 * Equality test based attributes values
	 * @param value Value to compare
	 */
	public boolean equals(Object other) {
		if (this == other) {
			return true;
		}
		if ( ! (other instanceof User)) {
			return false;
		}
		
		final User castedOther = (User) other;
		
		if ( id != null && castedOther.getId() != null ) {
			return id.equals( castedOther.getId() );
		}
		
		if ( (	email == null && castedOther.getEmail() != null) || 
			 (	email != null && !email.equals(castedOther.getEmail()) ) 
		   ) return false;
		if ( (	firstName == null && castedOther.getFirstName() != null) || 
			 (	firstName != null && !firstName.equals(castedOther.getFirstName()) ) 
		   ) return false;
		if ( (	lastName == null && castedOther.getLastName() != null) || 
			 (	lastName != null && !lastName.equals(castedOther.getLastName()) ) 
		   ) return false;
		if ( (	login == null && castedOther.getLogin() != null) || 
			 (	login != null && !login.equals(castedOther.getLogin()) ) 
		   ) return false;
		if ( (	password == null && castedOther.getPassword() != null) || 
			 (	password != null && !password.equals(castedOther.getPassword()) ) 
		   ) return false;
		
		return true;
	}

	/** 
	 * HashTable code based on attributes hashcodes
	 * @return hash value
	 */
	public int hashCode() {
		int result = 0;
		if (id != null) result = id.hashCode();
		if (email != null) result = 29 * result + email.hashCode();
		if (firstName != null) result = 29 * result + firstName.hashCode();
		if (lastName != null) result = 29 * result + lastName.hashCode();
		if (login != null) result = 29 * result + login.hashCode();
		if (password != null) result = 29 * result + password.hashCode();
		return result;
	}
   
	// Start of user code for private methods
	// End of user code
   
}