package fr.obeo.weblog.dto;

import java.text.DateFormat;
import java.util.Date;

import fr.obeo.weblog.business.blog.BlogEntry;
import fr.obeo.weblog.business.blog.User;

public class BlogEntryDto {
	
	private BlogEntry blog;
	
	public BlogEntryDto() {	
	}
		
	public String getAuthor() {
		User user = blog.getAuthorUser();
		if (user != null)
			return user.getFirstName() + " " + user.getLastName();
		else 
			return "anonymous";
	}
	
	public String getCreationDateAsText() {
		Date date = blog.getCreationDate();
		DateFormat df = DateFormat.getDateInstance();
		return df.format(date);
	}
	
	public String getCreationTimeAsText() {
		Date date = blog.getCreationDate();
		DateFormat df = DateFormat.getTimeInstance();
		return df.format(date);
	}
	
	// delegateurs
	
	public BlogEntryDto(BlogEntry blog) {
		this.blog = blog;
	}

	public User getAuthorUser() {
		return blog.getAuthorUser();
	}

	public String getContent() {
		return blog.getContent();
	}

	public Date getCreationDate() {
		return blog.getCreationDate();
	}

	public String getId() {
		return blog.getId();
	}

	public String getTitle() {
		return blog.getTitle();
	}

	public void setAuthorUser(User authorUser) {
		blog.setAuthorUser(authorUser);
	}

	public void setContent(String content) {
		blog.setContent(content);
	}

	public void setCreationDate(Date creationDate) {
		blog.setCreationDate(creationDate);
	}

	public void setTitle(String title) {
		blog.setTitle(title);
	}
}
