package fr.obeo.weblog.ui.main.actions;

// Start of user code for import
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import fr.obeo.fwk.dao.exception.DaoException;
import fr.obeo.weblog.business.blog.BlogEntry;
import fr.obeo.weblog.business.blog.User;
import fr.obeo.weblog.dao.blog.api.IBlogEntryDao;
import fr.obeo.weblog.dao.WeblogDaoFactory;
import fr.obeo.weblog.dto.BlogEntryDto;
import fr.obeo.weblog.ui.UiConstants;
import fr.obeo.weblog.ui.main.forms.ViewLogsForm;
// End of user code for import

/**
 * Implementation of <strong>ViewLogs Action</strong>
 * Scenario : main
 *
 */
public class ViewLogsAction extends org.apache.struts.actions.DispatchAction {
    /**
     * Commons Logging instance.
     */
	private static final Log log = LogFactory.getLog(ViewLogsAction.class);

    /**
     * Forward codes.
     */
	public final static String PAGE_SELF = "self"; //$NON-NLS-1$
	public final static String PAGE_CREATELOG = "createLog"; //$NON-NLS-1$
	public final static String PAGE_EDITACCOUNT = "editAccount"; //$NON-NLS-1$
	public final static String PAGE_LOGIN = "login"; //$NON-NLS-1$

    /**
     * Process the specified HTTP request for <strong>init</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward init(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		ViewLogsForm viewLogsForm = (ViewLogsForm)form;

		//Start of user code method init
		this.getLogs(viewLogsForm);
		
		User user= (User)request.getSession().getAttribute(UiConstants.CURRENT_USER);
		if (user != null) 
			viewLogsForm.setUser(user.getFirstName() +" " + user.getLastName());

		//End of user code
	
		return mapping.findForward(returnCode);
	} 

    /**
     * Process the specified HTTP request for <strong>createLog</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward createLog(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		ViewLogsForm viewLogsForm = (ViewLogsForm)form;
		//Start of user code method createLog
		User user= (User)request.getSession().getAttribute(UiConstants.CURRENT_USER);
		if (user != null) 
			returnCode = PAGE_CREATELOG;
		else
			this.getLogs(viewLogsForm);			
		//End of user code
		return mapping.findForward(returnCode);
	}
    /**
     * Process the specified HTTP request for <strong>logout</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward logout(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		ViewLogsForm viewLogsForm = (ViewLogsForm)form;
		//Start of user code method logout
		request.getSession().setAttribute(UiConstants.CURRENT_USER, null);
		viewLogsForm.setUser(null);
		this.getLogs(viewLogsForm);
		//End of user code
		return mapping.findForward(returnCode);
	}
    /**
     * Process the specified HTTP request for <strong>editAccount</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward editAccount(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		ViewLogsForm viewLogsForm = (ViewLogsForm)form;
		//Start of user code method editAccount
		User user= (User)request.getSession().getAttribute(UiConstants.CURRENT_USER);
		if (user != null) 
			returnCode = PAGE_EDITACCOUNT;
		else
			this.getLogs(viewLogsForm);
		//End of user code
		return mapping.findForward(returnCode);
	}
    /**
     * Process the specified HTTP request for <strong>login</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward login(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		ViewLogsForm viewLogsForm = (ViewLogsForm)form;
		//Start of user code method login
		returnCode = PAGE_LOGIN;
		//End of user code
		return mapping.findForward(returnCode);
	}
    /**
     * Process the specified HTTP request for <strong>reload</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward reload(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		ViewLogsForm viewLogsForm = (ViewLogsForm)form;
		//Start of user code method reload
		this.init(mapping, form, request,response);
		//End of user code
		return mapping.findForward(returnCode);
	}

//Start of user code user methods
	private void getLogs(ViewLogsForm viewLogsForm) throws DaoException{
		try {
			// Recuperation DAO sur table Users
			IBlogEntryDao dao = WeblogDaoFactory.getBlogEntryDao();
			Collection<BlogEntry> listBlogs = dao.findAllBlogEntrys();
			List<BlogEntryDto> listBlogDtos = new ArrayList<BlogEntryDto>(listBlogs.size());
			
			for (BlogEntry blog : listBlogs) {
				BlogEntryDto blogDto = new BlogEntryDto(blog);
				listBlogDtos.add(blogDto);
			}
			viewLogsForm.setLogs(listBlogDtos);

		} catch (DaoException e) {
			// Gestion des exceptions techniques
			log.error(e);
			// aucun log ne sera affich�
		}
	}
//End of user code

}