package org.acceleo.sample.demo.spring.services.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.sharengo.exceptions.TechnicalException;

import org.acceleo.sample.demo.spring.services.IProductsServices;

import org.acceleo.sample.demo.spring.services.IProductsServicesWebService;

import org.acceleo.sample.demo.spring.entities.Product;

import java.util.Collection;




import org.acceleo.sample.demo.spring.daos.IProductsDao;



// Start of user code for import

// End of user code for import

public class ProductsServicesImpl implements IProductsServices, IProductsServicesWebService {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(ProductsServicesImpl.class.getName()); 

	private IProductsDao productsDao = null;

	public void setProductsDao(IProductsDao productsDao) {
		this.productsDao = productsDao;
	}
	
	public IProductsDao getProductsDao() {
		return this.productsDao;
	}

	
	
	
		/**
	 * 
	 * @return 
	 */
	public Collection<Product> getListOfProducts() throws TechnicalException {
		// Start of user code of Collection<Product> getListOfProducts()
		return getProductsDao().findAll();
        // End of user code
        }
        
		/**
	 * 
	 * @param id 
	 * @return 
	 */
	public Product getProduct(String id) throws TechnicalException {
		// Start of user code of Product getProduct(String id)
		return getProductsDao().find(id);
        // End of user code
        }
        
		/**
	 * 
	 * @param product 
	 * @return 
	 */
	public Product addProduct(Product product) throws TechnicalException {
		// Start of user code of Product addProduct(Product product)
		getProductsDao().create(product);
		return product;
        // End of user code
        }
        
		/**
	 * 
	 * @param product 
	 */
	public void updateProduct(Product product) throws TechnicalException {
		// Start of user code of void updateProduct(Product product)
		getProductsDao().update(product);
        // End of user code
        }
        
		/**
	 * 
	 * @param product 
	 */
	public void removeProduct(Product product) throws TechnicalException {
		// Start of user code of void removeProduct(Product product)
		getProductsDao().delete(product);
        // End of user code
        }
        
	
	// Associations	
	
	
	// Start of user code private methods

	// End of user code private methods
		
}